##  ===========================================================================
##  Author: Roberto Cavada <cavada@fbk.eu>
##
##  Copyright (c) 2005 by FBK 
##
##  This is free software; you can redistribute it and/or
##  modify it under the terms of the GNU Lesser General Public
##  License as published by the Free Software Foundation; either
##  version 2 of the License, or (at your option) any later version.
##
##  This software is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public
##  License along with this library; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.
##
##  For more information about this software see <http://rat.fbk.eu>
##  or email to the RAT Team <rat@fbk.eu>.
##  Please report bugs to <rat@fbk.eu>.
##
##  ===========================================================================


import utils.globals
import gtk
import os.path


def load_resources():
    """Top level function that loads general application's resources"""
    __load_icons()
    return


def __load_icons():
    """Here all the application's stock icons are set"""
    iconfactory = gtk.IconFactory()
    stocks = gtk.stock_list_ids()

    icons = [
        ('gtk-edit', os.path.join(utils.globals.IMAGES_DIR, "buttons/gtk-edit.svg")),
        ('rat-stock-trace', os.path.join(utils.globals.IMAGES_DIR, "buttons/trace.png")),
        ('rat-stock-checked', os.path.join(utils.globals.IMAGES_DIR, "buttons/checked.png")),
        ('rat-stock-unchecked', os.path.join(utils.globals.IMAGES_DIR, "buttons/unchecked.png")),
        ('rat-stock-aborted', os.path.join(utils.globals.IMAGES_DIR, "buttons/gtk-error.png")),
        ]
    for icon in icons:
        if icon[0] not in stocks:
            pxbf = gtk.gdk.pixbuf_new_from_file(icon[1])
            iconset = gtk.IconSet(pxbf)
            iconfactory.add(icon[0], iconset)
            pass
        pass

    iconfactory.add_default()    
    return

def get_version():
    """Return a triple of integers represeting the application version
    numbers"""
    return utils.globals.APPL_VERSION

def get_version_string(): return ".".join(map(str, get_version()))
def get_short_version_string(): return ".".join(map(str, get_version()[0:2]))
