##  ===========================================================================
##  Author: Roberto Cavada <cavada@fbk.eu>
##
##  Copyright (c) 2005 by FBK 
##
##  This is free software; you can redistribute it and/or
##  modify it under the terms of the GNU Lesser General Public
##  License as published by the Free Software Foundation; either
##  version 2 of the License, or (at your option) any later version.
##
##  This software is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public
##  License along with this library; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.
##
##  For more information about this software see <http://rat.fbk.eu>
##  or email to the RAT Team <rat@fbk.eu>.
##  Please report bugs to <rat@fbk.eu>.
##
##  ===========================================================================


from gtkmvc.view import View
import utils.globals 

import os.path
import gtk

## ----------------------------------------------------------------------
class EntriesView (View):
    """A generic view class for an editable entry"""

    GLADE_FILE = os.path.join(utils.globals.GLADE_DIR, "entries.glade")

    def __init__(self, ctrl):
        View.__init__(self, ctrl, self.GLADE_FILE, "sw_tree")
        return

    pass # end of class


## ----------------------------------------------------------------------
class SignalsView (EntriesView):
    """View of the Signals frame"""
    def __init__(self, ctrl):
        EntriesView.__init__(self, ctrl)
        return

    pass # end of class


## ----------------------------------------------------------------------
class RequirementsView (EntriesView):
    """View of the Requirements frame"""
    def __init__(self, ctrl):
        EntriesView.__init__(self, ctrl)
        return
    
    pass # end of class


## ----------------------------------------------------------------------
class PossibilitiesView (RequirementsView):
    """View of the Possibility frame"""
    def __init__(self, ctrl):
        RequirementsView.__init__(self, ctrl)
        return
    pass # end of class


## ----------------------------------------------------------------------
class AssertionsView (RequirementsView):
    """View of the Assertions frame"""
    def __init__(self, ctrl):
        RequirementsView.__init__(self, ctrl)
        return
    pass # end of class
