# =============================================================================
#  This file is part of the ``HASDEL'' Toolset.
#  Copyright (C) 2014 by Fondazione Bruno Kessler
#  Copyright (C) 2014 by RWTH Aachen University
#
#
#  The HASDEL Toolset can be copied, modified and/or redistributed
#  under the terms of the HASDEL General Public License, either
#  version 1 of the License, or (at your option) any later version.
#
#  You should have received a copy of the HASDEL General Public
#  License along with this software. If not, please contact the
#  copyright owners.
#
#  The HASDEL Toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  HASDEL General Public License for more details.
#
#  For more information on the HASDEL Project see the Project Web
#  site at <http://compassinternal.informatik.rwth-aachen.de/hasdel-site/> 
#  or email to <hasdel-support@lists.rwth-aachen.de>.  
#
#  Please report bugs to <hasdel-support@lists.rwth-aachen.de>.
# =============================================================================


# this module is imported by scripts inside runscripts package for
# setting up all required system paths

import sys
import os.path

if sys.argv[0]:
    top_dir = os.path.dirname(os.path.abspath(os.path.join(sys.argv[0], ".."))) 
else: top_dir = os.path.abspath(".")

sys.path.append(os.path.abspath(top_dir))
sys.path.append(os.path.join(top_dir, '../resources/antlr/antlr-python-runtime-3.1.1/'))
sys.path.insert(0, os.path.join(top_dir, '../resources/'))

# this is usable outside
TOP_DIR = top_dir
