# =============================================================================
#  This file is part of the ``HASDEL'' Toolset.
#  Copyright (C) 2014 by Fondazione Bruno Kessler
#  Copyright (C) 2014 by RWTH Aachen University
#
#
#  The HASDEL Toolset can be copied, modified and/or redistributed
#  under the terms of the HASDEL General Public License, either
#  version 1 of the License, or (at your option) any later version.
#
#  You should have received a copy of the HASDEL General Public
#  License along with this software. If not, please contact the
#  copyright owners.
#
#  The HASDEL Toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  HASDEL General Public License for more details.
#
#  For more information on the HASDEL Project see the Project Web
#  site at <http://compassinternal.informatik.rwth-aachen.de/hasdel-site/> 
#  or email to <hasdel-support@lists.rwth-aachen.de>.  
#
#  Please report bugs to <hasdel-support@lists.rwth-aachen.de>.
# =============================================================================


""" Exceptions used by the SLIM compiler """

from antlr3.exceptions import RecognitionException

class UnsupportedFeatureException(RecognitionException):
    def __init__(self, feature, input):
        RecognitionException.__init__(self, input)
        self.feature = feature
        
class InvalidExpressionException(Exception):
    def __init__(self, error_collector):
        self.error_collector = error_collector
        
    def __str__(self):
        return self.error_collector.__str__()

class SLIMParserException(RecognitionException):
    """
    kind of a catch-all exception for custom parser error messages
    """
    def __init__(self, message, input):
        RecognitionException.__init__(self, input)
        self.message = message
