// This file has been generated by slim2promela.



// ----- Message Types ----------------------------------------------------------------------------

mtype = { update, invalidate, trymultiway, activate, deactivate, reset };



// ----- MACROs for ensuring atomicity of transitions ---------------------------------------------

bool gflagGoNextTransition = true;  // initially true for Environment proctype

#define nT(guard) d_step { \
	guard && !gflagGoNextTransition; \
	gflagGoNextTransition = true; \
	printf("### (%d) ### Process %d is allowed to take its next transition!\n", _pid, _pid) }
#define fT d_step { \
	gflagGoNextTransition = false; \
	printf("### (%d) ### Process %d returned right to take next transition!\n", _pid, _pid); \
	printf("NEW GLOBAL STATE: root.sensors.sensor1.output=%d, root.sensors.sensor1.XerrorSubcomponentX0.mode=%d, root.sensors.sensor1.XerrorSubcomponentX0.XerrorStateX0=%d, root.sensors.sensor1.XerrorStateX0=%d, root.mode=%d, root.sensors.mode=%d, root.sensors.sensor1.mode=%d\n", odpStore_root_sensors_sensor1_output, nominalMode_root_sensors_sensor1_XerrorSubcomponentX0, odpStore_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0, odpStore_root_sensors_sensor1_XerrorStateX0, nominalMode_root, nominalMode_root_sensors, nominalMode_root_sensors_sensor1) }



// ----- DEFINE integer type & constants for enum data types --------------------------------------

#define enumIntType byte
#define enum__Dead 5
#define enum__OK 4
#define enum__Glitched 2
#define enum__Drifted1 3
#define enum__Drifted2 1



// ----- DEFINE integer type & constants for nominal modes ----------------------------------------

#define modeIntType byte
#define modeID_Drifted2 3
#define modeID_Drifted1 5
#define modeID_OK 6
#define modeID__SlicedSinkMode 1
#define modeID_Glitched 4
#define modeID_Dead 7
#define modeID_Cycle 2



// ----- DEFINE placeholders with atomic propositions ---------------------------------------------
// Note: Defined names for enums/modes cannot be used in properties as CPP does not replace text in later #defines.

#define atomicProposition_P (nominalMode_root_sensors_sensor1_XerrorSubcomponentX0) == (7)






// ================================================================================================






// ----- Global Variable Declarations for storing Components' Data --------------------------------

// *** root : SlicedSlimSpecification::root.Implementation ***
chan chan_root = [0] of { mtype, int };
modeIntType nominalMode_root;

// *** root_sensors : SlicedSlimSpecification::root_sensors.Implementation ***
chan chan_root_sensors = [0] of { mtype, int };
modeIntType nominalMode_root_sensors;

// *** root_sensors_sensor1 : SlicedSlimSpecification::root_sensors_sensor1.Implementation ***
chan chan_root_sensors_sensor1 = [0] of { mtype, int };
modeIntType nominalMode_root_sensors_sensor1;
int odpStore_root_sensors_sensor1_output; int odpNew_root_sensors_sensor1_output;
enumIntType odpStore_root_sensors_sensor1_XerrorStateX0; enumIntType odpNew_root_sensors_sensor1_XerrorStateX0;

// *** root_sensors_sensor1_XerrorSubcomponentX0 : SlicedSlimSpecification::root_sensors_sensor1_XerrorSubcomponentX0.Implementation ***
chan chan_root_sensors_sensor1_XerrorSubcomponentX0 = [0] of { mtype, int };
modeIntType nominalMode_root_sensors_sensor1_XerrorSubcomponentX0;
enumIntType odpStore_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0; enumIntType odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0;






// ================================================================================================






// ----- Environment ------------------------------------------------------------------------------

active proctype Environment()
{
	printf("### ENV(%d) ### Environment started.\n", _pid);


	// *** Activate & Update root component ***
	chan_root!activate, 0;
	chan_root?activate, _;

	// For tests: manipulate root's input data port variables here

	chan_root!update, 0;
	chan_root?update, _;

	fT;  // Allow components to take transitions (initially nT reserved for Environment)



	// *** React to Messages from root component ***
	do

	// Invalidate: react with update
	:: chan_root?invalidate, _ ->
		chan_root!update, 0;
		chan_root?update, _;
		fT;  // Environment responsible for fT after invalidate-update-cycle!

	// Trymultiway: respond 0 partners
	:: chan_root?trymultiway, _ ->
		chan_root!trymultiway, 0;

	od;
}






// ================================================================================================






// ----- root : SlicedSlimSpecification::root.Implementation --------------------------------------------------

inline inlineUpdateMode_SlicedSinkMode_root()
{
	// Update active subcomponent sensors
	chan_root_sensors!update, 0;
	chan_root_sensors?update, _;
}


active proctype process_root()
{
	printf("### root(%d) ### started\n", _pid);
	int eventSum, eventInt;   // initially: 0 (SPIN default)



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root?activate, _;
	d_step {

		// Initialize Own Data Ports

		// Initialize Data Subcomponents (only those active in start mode)

		// Initialize Mode Info
		nominalMode_root = modeID__SlicedSinkMode;
	}

	// Activate Non-Data Subcomponents (only those active in start mode)
	chan_root_sensors!activate, 0;
	chan_root_sensors?activate, _;

	// Activation completed
	printf("### root(%d) ### activated\n", _pid);
	chan_root!activate, 0;
	goto mode__SlicedSinkMode;



	// *** Run as automaton & React to messages ***


	// --- Mode: _SlicedSinkMode ---
mode__SlicedSinkMode:
	printf("### root(%d) ### enters state '_SlicedSinkMode'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateMode_SlicedSinkMode_root();

		// Update active subcomponents: No Fixpoint Iteration needed since no active subcomponent has out data ports!

		// Update own out data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_sensors?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_sensors!deactivate, 0;
		chan_root_sensors?deactivate, _;
		printf("### root(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_sensors!activate, 0;
		chan_root_sensors?activate, _;
		printf("### root(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_sensors!reset, 0;
		chan_root_sensors?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: _SlicedSinkMode ---

}



// ----- root_sensors : SlicedSlimSpecification::root_sensors.Implementation --------------------------------------------------

inline inlineUpdateMode_SlicedSinkMode_root_sensors()
{
	// Update active subcomponent sensor1
	chan_root_sensors_sensor1!update, 0;
	chan_root_sensors_sensor1?update, _;
}


active proctype process_root_sensors()
{
	printf("### root_sensors(%d) ### started\n", _pid);
	int eventSum, eventInt;   // initially: 0 (SPIN default)



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_sensors?activate, _;
	d_step {

		// Initialize Own Data Ports

		// Initialize Data Subcomponents (only those active in start mode)

		// Initialize Mode Info
		nominalMode_root_sensors = modeID__SlicedSinkMode;
	}

	// Activate Non-Data Subcomponents (only those active in start mode)
	chan_root_sensors_sensor1!activate, 0;
	chan_root_sensors_sensor1?activate, _;

	// Activation completed
	printf("### root_sensors(%d) ### activated\n", _pid);
	chan_root_sensors!activate, 0;
	goto mode__SlicedSinkMode;



	// *** Run as automaton & React to messages ***


	// --- Mode: _SlicedSinkMode ---
mode__SlicedSinkMode:
	printf("### root_sensors(%d) ### enters state '_SlicedSinkMode'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: chan_root_sensors?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateMode_SlicedSinkMode_root_sensors();

		// Update active subcomponents: Fixpoint Iteration
		do
		:: d_step { !(odpStore_root_sensors_sensor1_output == odpNew_root_sensors_sensor1_output && odpStore_root_sensors_sensor1_XerrorStateX0 == odpNew_root_sensors_sensor1_XerrorStateX0) ->
			odpStore_root_sensors_sensor1_output = odpNew_root_sensors_sensor1_output; odpStore_root_sensors_sensor1_XerrorStateX0 = odpNew_root_sensors_sensor1_XerrorStateX0; }
			inlineUpdateMode_SlicedSinkMode_root_sensors();
		:: else -> break;
		od;

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_sensors(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root_sensors!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_sensors_sensor1?invalidate, _ ->
		chan_root_sensors!invalidate, 0;

	// Incomming Message: deactivate (from parent) - reset mode history
	:: chan_root_sensors?deactivate, _ ->
		// reset active subcomponents
		chan_root_sensors_sensor1!reset, 0;
		chan_root_sensors_sensor1?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm deactivation
		printf("### root_sensors(%d) ### was deactivated (without mode history)\n", _pid);
		chan_root_sensors!deactivate, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors?reset, _ ->
		// reset active subcomponents
		chan_root_sensors_sensor1!reset, 0;
		chan_root_sensors_sensor1?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: _SlicedSinkMode ---

}



// ----- root_sensors_sensor1 : SlicedSlimSpecification::root_sensors_sensor1.Implementation --------------------------------------------------

inline inlineUpdateModeCycle_root_sensors_sensor1()
{
	// Update active subcomponent XerrorSubcomponentX0
	chan_root_sensors_sensor1_XerrorSubcomponentX0!update, 0;
	chan_root_sensors_sensor1_XerrorSubcomponentX0?update, _;
}


active proctype process_root_sensors_sensor1()
{
	printf("### root_sensors_sensor1(%d) ### started\n", _pid);
	int eventSum, eventInt;   // initially: 0 (SPIN default)



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_sensors_sensor1?activate, _;
	d_step {

		// Initialize Own Data Ports
		odpNew_root_sensors_sensor1_output = 1; odpStore_root_sensors_sensor1_output = 1;
		odpNew_root_sensors_sensor1_XerrorStateX0 = enum__OK; odpStore_root_sensors_sensor1_XerrorStateX0 = enum__OK;

		// Initialize Data Subcomponents (only those active in start mode)

		// Initialize Mode Info
		nominalMode_root_sensors_sensor1 = modeID_Cycle;
	}

	// Activate Non-Data Subcomponents (only those active in start mode)
	chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;
	chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;

	// Activation completed
	printf("### root_sensors_sensor1(%d) ### activated\n", _pid);
	chan_root_sensors_sensor1!activate, 0;
	goto mode_Cycle;



	// *** Run as automaton & React to messages ***


	// --- Mode: Cycle ---
mode_Cycle:
	printf("### root_sensors_sensor1(%d) ### enters state 'Cycle'\n", _pid);
	do

	// Proactive Transition (w/o event): Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Drifted2)) then (output) := ((output) + (2)); ]-> Cycle
	:: nT(((odpStore_root_sensors_sensor1_output) < (5)) && ((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted2))) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (2);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Drifted2)) then (output) := ((output) + (2)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Glitched)) then (output) := ((output) + (10)); ]-> Cycle
	:: nT(((odpStore_root_sensors_sensor1_output) < (5)) && ((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Glitched))) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (10);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Glitched)) then (output) := ((output) + (10)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Drifted1)) then (output) := ((output) + (1)); ]-> Cycle
	:: nT(((odpStore_root_sensors_sensor1_output) < (5)) && ((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted1))) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (1);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Drifted1)) then (output) := ((output) + (1)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_OK)) then (output) := ((output) + (1)); ]-> Cycle
	:: nT(((odpStore_root_sensors_sensor1_output) < (5)) && ((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__OK))) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (1);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_OK)) then (output) := ((output) + (1)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Dead)) then (output) := (50); ]-> Cycle
	:: nT(((odpStore_root_sensors_sensor1_output) < (5)) && ((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Dead))) -> d_step {
		odpNew_root_sensors_sensor1_output = 50;
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when ((output) < (5)) and ((XerrorStateX0) = (_Dead)) then (output) := (50); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when (XerrorStateX0) = (_Drifted2) then (output) := ((output) + (2)); ]-> Cycle
	:: nT((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted2)) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (2);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when (XerrorStateX0) = (_Drifted2) then (output) := ((output) + (2)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when (XerrorStateX0) = (_Glitched) then (output) := ((output) + (10)); ]-> Cycle
	:: nT((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Glitched)) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (10);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when (XerrorStateX0) = (_Glitched) then (output) := ((output) + (10)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when (XerrorStateX0) = (_Drifted1) then (output) := ((output) + (1)); ]-> Cycle
	:: nT((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted1)) -> d_step {
		odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (1);
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when (XerrorStateX0) = (_Drifted1) then (output) := ((output) + (1)); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when (XerrorStateX0) = (_OK) then EmptyExpressionList]-> Cycle
	:: nT((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__OK)) -> d_step {
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when (XerrorStateX0) = (_OK) then EmptyExpressionList]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// Proactive Transition (w/o event): Cycle -[when (XerrorStateX0) = (_Dead) then (output) := (50); ]-> Cycle
	:: nT((odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Dead)) -> d_step {
		odpNew_root_sensors_sensor1_output = 50;
		nominalMode_root_sensors_sensor1 = modeID_Cycle; }
		printf("### root_sensors_sensor1(%d) ### takes proactive transition: Cycle -[when (XerrorStateX0) = (_Dead) then (output) := (50); ]-> Cycle\n", _pid);
		chan_root_sensors_sensor1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_Cycle;

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#glitch when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF7490> then (output) := ((output) + (10)); ]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#drift1 when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF7738> then (output) := ((output) + (1)); ]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#die when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF79E0> then (output) := (50); ]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#glitch when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF7BE8> then EmptyExpressionList]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#dieByGlitch when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF7D00> then (output) := (50); ]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#drift2 when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF7F30> then (output) := ((output) + (2)); ]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#dieByDrift1 when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF9210> then (output) := (50); ]-> Cycle

	// No proactive/master transition: Cycle -[XerrorSubcomponentX0.#dieByDrift2 when <slim_compiler.src.dataStructure.expressions.BinaryOperatorTreeNode instance at 0x01DF9418> then (output) := (50); ]-> Cycle

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #die (2) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 2 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#die (No. 2)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#die when (XerrorStateX0) = (_OK) then (output) := (50); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__OK) ->
				odpNew_root_sensors_sensor1_output = 50;
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#die when (XerrorStateX0) = (_OK) then (output) := (50); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #dieByDrift1 (3) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 3 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#dieByDrift1 (No. 3)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#dieByDrift1 when (XerrorStateX0) = (_Drifted1) then (output) := (50); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted1) ->
				odpNew_root_sensors_sensor1_output = 50;
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#dieByDrift1 when (XerrorStateX0) = (_Drifted1) then (output) := (50); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #dieByDrift2 (4) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 4 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#dieByDrift2 (No. 4)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#dieByDrift2 when (XerrorStateX0) = (_Drifted2) then (output) := (50); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted2) ->
				odpNew_root_sensors_sensor1_output = 50;
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#dieByDrift2 when (XerrorStateX0) = (_Drifted2) then (output) := (50); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #dieByGlitch (5) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 5 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#dieByGlitch (No. 5)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#dieByGlitch when (XerrorStateX0) = (_Glitched) then (output) := (50); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Glitched) ->
				odpNew_root_sensors_sensor1_output = 50;
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#dieByGlitch when (XerrorStateX0) = (_Glitched) then (output) := (50); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #drift1 (6) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 6 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#drift1 (No. 6)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#drift1 when (XerrorStateX0) = (_OK) then (output) := ((output) + (1)); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__OK) ->
				odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (1);
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#drift1 when (XerrorStateX0) = (_OK) then (output) := ((output) + (1)); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #drift2 (7) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 7 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#drift2 (No. 7)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#drift2 when (XerrorStateX0) = (_Drifted1) then (output) := ((output) + (2)); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Drifted1) ->
				odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (2);
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#drift2 when (XerrorStateX0) = (_Drifted1) then (output) := ((output) + (2)); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent XerrorSubcomponentX0: #glitch (8) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 8 ->
		printf("### root_sensors_sensor1(%d) ### receives trymultiway request for XerrorSubcomponentX0.#glitch (No. 8)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#glitch when (XerrorStateX0) = (_OK) then (output) := ((output) + (10)); ]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__OK) ->
				odpNew_root_sensors_sensor1_output = (odpStore_root_sensors_sensor1_output) + (10);
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#glitch when (XerrorStateX0) = (_OK) then (output) := ((output) + (10)); ]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// Reactive Transition (subcomponent's out event): Cycle -[XerrorSubcomponentX0.#glitch when (XerrorStateX0) = (_Glitched) then EmptyExpressionList]-> Cycle
			:: d_step { (odpStore_root_sensors_sensor1_XerrorStateX0) == (enum__Glitched) ->
				nominalMode_root_sensors_sensor1 = modeID_Cycle; }
			printf("### root_sensors_sensor1(%d) ### takes reactive transition: Cycle -[XerrorSubcomponentX0.#glitch when (XerrorStateX0) = (_Glitched) then EmptyExpressionList]-> Cycle\n", _pid);
				// Answer to trymultiway
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root_sensors_sensor1!invalidate, 0;
				goto mode_Cycle;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				printf("### root_sensors_sensor1(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_sensors_sensor1?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors_sensor1(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateModeCycle_root_sensors_sensor1();

		// Update active subcomponents: Fixpoint Iteration
		do
		:: d_step { !(odpStore_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 == odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0) ->
			odpStore_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0; }
			inlineUpdateModeCycle_root_sensors_sensor1();
		:: else -> break;
		od;

		// Update own out data ports
		skip; // skip necessary as break cannot jump to d_step
		d_step {
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_sensors_sensor1_XerrorStateX0 = odpStore_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0;
		// b) Via Flows from own in data ports
		}

		// Display text message: output parameters
		printf("### root_sensors_sensor1(%d) ### update finally lead to new output values: output=%d, XerrorStateX0=%d\n", _pid, odpNew_root_sensors_sensor1_output, odpNew_root_sensors_sensor1_XerrorStateX0);

		// Send update acknowledge to parent
		chan_root_sensors_sensor1!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?invalidate, _ ->
		chan_root_sensors_sensor1!invalidate, 0;

	// Incomming Message: deactivate (from parent) - reset mode history
	:: chan_root_sensors_sensor1?deactivate, _ ->
		// reset active subcomponents
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm deactivation
		printf("### root_sensors_sensor1(%d) ### was deactivated (without mode history)\n", _pid);
		chan_root_sensors_sensor1!deactivate, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors_sensor1?reset, _ ->
		// reset active subcomponents
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors_sensor1(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors_sensor1!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: Cycle ---

}



// ----- root_sensors_sensor1_XerrorSubcomponentX0 : SlicedSlimSpecification::root_sensors_sensor1_XerrorSubcomponentX0.Implementation --------------------------------------------------


active proctype process_root_sensors_sensor1_XerrorSubcomponentX0()
{
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### started\n", _pid);
	int eventSum, eventInt;   // initially: 0 (SPIN default)



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;
	d_step {

		// Initialize Own Data Ports
		odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__OK; odpStore_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__OK;

		// Initialize Data Subcomponents (only those active in start mode)

		// Initialize Mode Info
		nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_OK;
	}

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### activated\n", _pid);
	chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;
	goto mode_OK;



	// *** Run as automaton & React to messages ***


	// --- Mode: Drifted2 ---
mode_Drifted2:
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### enters state 'Drifted2'\n", _pid);
	do

	// Master Transition (own out event): Drifted2 -[#dieByDrift2 when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 4;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Dead;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Dead; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: Drifted2 -[#dieByDrift2 when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Dead;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// No proactive/master transition: Drifted2 -[resetEvent when None then EmptyExpressionList]-> Drifted2

	// Incomming Message: trymultiway (from parent: resetEvent (1) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 1 ->
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### receives trymultiway request for resetEvent (No. 1)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway!

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): Drifted2 -[resetEvent when EmptyExpression then EmptyExpressionList]-> Drifted2
			:: d_step { true ->
				nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Drifted2; }
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes reactive transition: Drifted2 -[resetEvent when EmptyExpression then EmptyExpressionList]-> Drifted2\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				goto mode_Drifted2;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update finally lead to new output values: XerrorStateX0=%d\n", _pid, odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0);

		// Send update acknowledge to parent
		chan_root_sensors_sensor1_XerrorSubcomponentX0!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!deactivate, 0;
		// reactivate
		chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: Drifted2 ---


	// --- Mode: Glitched ---
mode_Glitched:
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### enters state 'Glitched'\n", _pid);
	do

	// Master Transition (own out event): Glitched -[#glitch when EmptyExpression then (XerrorStateX0) := (_OK); ]-> OK
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 8;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__OK;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_OK; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: Glitched -[#glitch when EmptyExpression then (XerrorStateX0) := (_OK); ]-> OK\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_OK;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): Glitched -[#dieByGlitch when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 5;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Dead;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Dead; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: Glitched -[#dieByGlitch when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Dead;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// No proactive/master transition: Glitched -[resetEvent when None then EmptyExpressionList]-> Glitched

	// Incomming Message: trymultiway (from parent: resetEvent (1) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 1 ->
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### receives trymultiway request for resetEvent (No. 1)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway!

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): Glitched -[resetEvent when EmptyExpression then EmptyExpressionList]-> Glitched
			:: d_step { true ->
				nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Glitched; }
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes reactive transition: Glitched -[resetEvent when EmptyExpression then EmptyExpressionList]-> Glitched\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				goto mode_Glitched;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update finally lead to new output values: XerrorStateX0=%d\n", _pid, odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0);

		// Send update acknowledge to parent
		chan_root_sensors_sensor1_XerrorSubcomponentX0!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!deactivate, 0;
		// reactivate
		chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: Glitched ---


	// --- Mode: Drifted1 ---
mode_Drifted1:
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### enters state 'Drifted1'\n", _pid);
	do

	// Master Transition (own out event): Drifted1 -[#drift2 when EmptyExpression then (XerrorStateX0) := (_Drifted2); ]-> Drifted2
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 7;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Drifted2;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Drifted2; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: Drifted1 -[#drift2 when EmptyExpression then (XerrorStateX0) := (_Drifted2); ]-> Drifted2\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Drifted2;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): Drifted1 -[#dieByDrift1 when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 3;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Dead;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Dead; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: Drifted1 -[#dieByDrift1 when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Dead;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// No proactive/master transition: Drifted1 -[resetEvent when None then EmptyExpressionList]-> Drifted1

	// Incomming Message: trymultiway (from parent: resetEvent (1) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 1 ->
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### receives trymultiway request for resetEvent (No. 1)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway!

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): Drifted1 -[resetEvent when EmptyExpression then EmptyExpressionList]-> Drifted1
			:: d_step { true ->
				nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Drifted1; }
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes reactive transition: Drifted1 -[resetEvent when EmptyExpression then EmptyExpressionList]-> Drifted1\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				goto mode_Drifted1;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update finally lead to new output values: XerrorStateX0=%d\n", _pid, odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0);

		// Send update acknowledge to parent
		chan_root_sensors_sensor1_XerrorSubcomponentX0!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!deactivate, 0;
		// reactivate
		chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: Drifted1 ---


	// --- Mode: OK ---
mode_OK:
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### enters state 'OK'\n", _pid);
	do

	// Master Transition (own out event): OK -[#glitch when EmptyExpression then (XerrorStateX0) := (_Glitched); ]-> Glitched
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 8;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Glitched;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Glitched; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: OK -[#glitch when EmptyExpression then (XerrorStateX0) := (_Glitched); ]-> Glitched\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Glitched;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): OK -[#drift1 when EmptyExpression then (XerrorStateX0) := (_Drifted1); ]-> Drifted1
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 6;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Drifted1;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Drifted1; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: OK -[#drift1 when EmptyExpression then (XerrorStateX0) := (_Drifted1); ]-> Drifted1\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Drifted1;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): OK -[#die when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead
	:: nT(true) ->
		chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, 2;
		chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, eventInt;
		if
		:: d_step { eventInt > 0 ->
			eventInt = 0;   // Reset after usage => 0 outside and for next trymultiway
			odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0 = enum__Dead;
			nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Dead; }
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes master transition: OK -[#die when EmptyExpression then (XerrorStateX0) := (_Dead); ]-> Dead\n", _pid);
			chan_root_sensors_sensor1_XerrorSubcomponentX0!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_Dead;
		:: eventInt == 0 -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// No proactive/master transition: OK -[resetEvent when None then EmptyExpressionList]-> OK

	// Incomming Message: trymultiway (from parent: resetEvent (1) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 1 ->
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### receives trymultiway request for resetEvent (No. 1)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway!

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): OK -[resetEvent when EmptyExpression then EmptyExpressionList]-> OK
			:: d_step { true ->
				nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_OK; }
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes reactive transition: OK -[resetEvent when EmptyExpression then EmptyExpressionList]-> OK\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				goto mode_OK;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update finally lead to new output values: XerrorStateX0=%d\n", _pid, odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0);

		// Send update acknowledge to parent
		chan_root_sensors_sensor1_XerrorSubcomponentX0!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!deactivate, 0;
		// reactivate
		chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: OK ---


	// --- Mode: Dead ---
mode_Dead:
	printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### enters state 'Dead'\n", _pid);
	do

	// No proactive/master transition: Dead -[resetEvent when None then EmptyExpressionList]-> Dead

	// Incomming Message: trymultiway (from parent: resetEvent (1) )
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?trymultiway, 1 ->
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### receives trymultiway request for resetEvent (No. 1)\n", _pid);
		// We know: eventSum == 0, since reset after every trymultiway!

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): Dead -[resetEvent when EmptyExpression then EmptyExpressionList]-> Dead
			:: d_step { true ->
				nominalMode_root_sensors_sensor1_XerrorSubcomponentX0 = modeID_Dead; }
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### takes reactive transition: Dead -[resetEvent when EmptyExpression then EmptyExpressionList]-> Dead\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum+1);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum+1;
				goto mode_Dead;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### answers to trymultiway: %d\n", _pid, eventSum);
				chan_root_sensors_sensor1_XerrorSubcomponentX0!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?update, _ ->

		// Display text message: input parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### update finally lead to new output values: XerrorStateX0=%d\n", _pid, odpNew_root_sensors_sensor1_XerrorSubcomponentX0_XerrorStateX0);

		// Send update acknowledge to parent
		chan_root_sensors_sensor1_XerrorSubcomponentX0!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!deactivate, 0;
		// reactivate
		chan_root_sensors_sensor1_XerrorSubcomponentX0?activate, _;
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_sensors_sensor1_XerrorSubcomponentX0?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		printf("### root_sensors_sensor1_XerrorSubcomponentX0(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_sensors_sensor1_XerrorSubcomponentX0!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: Dead ---

}
