// This file has been generated by slim2promela, based on SLIM-Input: examples\Negator.slim



// ----- Message Types ----------------------------------------------------------------------------

mtype = { update, invalidate, trymultiway, activate, deactivate, reset };



// ----- MACROs for ensuring atomicity of transitions ---------------------------------------------

bool gflagGoNextTransition = false;

#define nT(guard) d_step { \
	guard && !gflagGoNextTransition; \
	gflagGoNextTransition = true; \
	printf("### (%d) ### Process %d is allowed to take its next transition!\n", _pid, _pid) }

#define fT d_step { \
	gflagGoNextTransition = false; \
	printf("### (%d) ### Process %d returned right to take next transition!\n", _pid, _pid) }



// ----- DEFINE integer constants for enum data types ---------------------------------------------







// ================================================================================================






// ----- __default__::Negator.Impl --------------------------------------------------

inline __default___Negator_Impl_internalUpdate__DefaultInitialMode()
{
	printf(".\n");
}

proctype __default___Negator_Impl(chan parent)
{
	printf("### __default___Negator_Impl(%d) ### started\n", _pid);



	// *** Variables for storing Inputs, Outputs, Subcomponents ***
	int eventInt;
	int eventSum;

	bool store_self_i;
	bool store_self_o; bool new_self_o;



	// *** Create Subcomponents ***



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	parent?activate, _, _, _;

	// Initialize Own Out Data Ports
	store_self_o = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Initialize Non-Data Subcomponents' In Data Ports (must be done since sent on updates)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	parent!activate, 0, 0, 0;
	goto _DefaultInitialMode;



	// *** Run as automaton & React to messages ***


_DefaultInitialMode:
	printf("### __default___Negator_Impl(%d) ### enters state '_DefaultInitialMode'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: parent?update, store_self_i, _, _ ->
		printf("### __default___Negator_Impl(%d) ### update with new input values: i=%d, #=%d\n", _pid, store_self_i, 1);

		// Update Subcomponents: First Iteration
		__default___Negator_Impl_internalUpdate__DefaultInitialMode();

		// Update Subcomponents: No Fixpoint Iteration needed!

		// Update own output values
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports
		store_self_o = !(store_self_i);

		// Respond with own output values
		printf("### __default___Negator_Impl(%d) ### update finally lead to new output values: o=%d, #=%d\n", _pid, store_self_o, 1);
		parent!update, 0, store_self_o, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: parent?deactivate, _, _, _ ->
		// deactivate active subcomponents
		parent!deactivate, 0, 0, 0;
		// reactivate
		parent?activate, _, _, _;
		parent!activate, 0, 0, 0;

	// Incomming Message: reset (from parent)
	:: parent?reset, _, _, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		parent!reset, 0, 0, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od; // --- _DefaultInitialMode --- 

}






// ================================================================================================






// ----- Environment ------------------------------------------------------------------------------

active proctype Environment()
{
	printf("### ENV(%d) ### Environment started.\n", _pid);

	// *** Variables for storing Root Component ***
	pid pid_root;
	chan chan_root = [0] of {mtype, bool, bool, int};

	bool root_i_store;
	bool root_o_store;

	// *** Start & Activate Root Component ***
	nT(true);
	pid_root = run __default___Negator_Impl(chan_root);
	chan_root!activate, 0, 0, 0;
	chan_root?activate, _, _, _;
	chan_root!update, root_i_store, 0, 0;
	chan_root?update, _, root_o_store, _;
	fT;

	// *** React to Messages from Root ***
	do
	// Invalidate: react with update
	:: chan_root?invalidate, _, _, _ ->
		chan_root!update, root_i_store, 0, 0;
		chan_root?update, _, root_o_store, _;
		fT;  // root responsible for fT after invalidate-update-cycle!
	// Trymultiway: respond 0 partners
	:: chan_root?trymultiway, _, _, _ ->
		chan_root!trymultiway, 0, 0, 0;
	od;
}


