// This file has been generated by slim2promela, based on SLIM-Input: examples\TransitionChangesDataPort.slim



// ----- Message Types ----------------------------------------------------------------------------

mtype = { update, invalidate, trymultiway, activate, deactivate, reset };



// ----- MACROs for ensuring atomicity of transitions ---------------------------------------------

bool gflagGoNextTransition = false;

#define nT(guard) d_step { \
	guard && !gflagGoNextTransition; \
	gflagGoNextTransition = true; \
	printf("### (%d) ### Process %d is allowed to take its next transition!\n", _pid, _pid) }

#define fT d_step { \
	gflagGoNextTransition = false; \
	printf("### (%d) ### Process %d returned right to take next transition!\n", _pid, _pid) }



// ----- DEFINE integer constants for enum data types ---------------------------------------------







// ================================================================================================






// ----- __default__::R.Impl --------------------------------------------------

inline __default___R_Impl_internalUpdate_r0()
{
	printf(".\n");
}

inline __default___R_Impl_internalUpdate_r1()
{
	printf(".\n");
}

proctype __default___R_Impl(chan parent)
{
	printf("### __default___R_Impl(%d) ### started\n", _pid);



	// *** Variables for storing Inputs, Outputs, Subcomponents ***
	int eventInt;
	int eventSum;

	int store_self_y;
	int store_self_a; int new_self_a;
	int store_self_b; int new_self_b;



	// *** Create Subcomponents ***



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	parent?activate, _, _, _, _;

	// Initialize Own Out Data Ports
	store_self_a = -2;
	store_self_b = -2;

	// Initialize Data Subcomponents (only those active in start mode)

	// Initialize Non-Data Subcomponents' In Data Ports (must be done since sent on updates)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	parent!activate, 0, 0, 0, 0;
	goto r0;



	// *** Run as automaton & React to messages ***


r0:
	printf("### __default___R_Impl(%d) ### enters state 'r0'\n", _pid);
	do

	// Proactive Transition (w/o event): r0 -[when EmptyExpression then (a) := (5); ]-> r1
	:: nT(true) ->
		new_self_a = 5;
		store_self_a = new_self_a;
		parent!invalidate, 0, 0, 0, 0;  // propagate changes; fT by root!
		goto r1;

	// Incomming Message: update (from parent)
	:: parent?update, store_self_y, _, _, _ ->
		printf("### __default___R_Impl(%d) ### update with new input values: y=%d, #=%d\n", _pid, store_self_y, 1);

		// Update Subcomponents: First Iteration
		__default___R_Impl_internalUpdate_r0();

		// Update Subcomponents: No Fixpoint Iteration needed!

		// Update own output values
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports
		store_self_b = (store_self_y) + (1);

		// Respond with own output values
		printf("### __default___R_Impl(%d) ### update finally lead to new output values: a=%d, b=%d, #=%d\n", _pid, store_self_a, store_self_b, 2);
		parent!update, 0, store_self_a, store_self_b, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: parent?deactivate, _, _, _, _ ->
		// deactivate active subcomponents
		parent!deactivate, 0, 0, 0, 0;
		// reactivate
		parent?activate, _, _, _, _;
		parent!activate, 0, 0, 0, 0;

	// Incomming Message: reset (from parent)
	:: parent?reset, _, _, _, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		parent!reset, 0, 0, 0, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od; // --- r0 --- 


r1:
	printf("### __default___R_Impl(%d) ### enters state 'r1'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: parent?update, store_self_y, _, _, _ ->
		printf("### __default___R_Impl(%d) ### update with new input values: y=%d, #=%d\n", _pid, store_self_y, 1);

		// Update Subcomponents: First Iteration
		__default___R_Impl_internalUpdate_r1();

		// Update Subcomponents: No Fixpoint Iteration needed!

		// Update own output values
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports
		store_self_b = (store_self_y) + (1);

		// Respond with own output values
		printf("### __default___R_Impl(%d) ### update finally lead to new output values: a=%d, b=%d, #=%d\n", _pid, store_self_a, store_self_b, 2);
		parent!update, 0, store_self_a, store_self_b, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: parent?deactivate, _, _, _, _ ->
		// deactivate active subcomponents
		parent!deactivate, 0, 0, 0, 0;
		// reactivate
		parent?activate, _, _, _, _;
		parent!activate, 0, 0, 0, 0;

	// Incomming Message: reset (from parent)
	:: parent?reset, _, _, _, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		parent!reset, 0, 0, 0, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od; // --- r1 --- 

}





// ----- __default__::Q.Impl --------------------------------------------------

inline __default___Q_Impl_internalUpdate__DefaultInitialMode()
{
	// Update subcomponent myR
	store_myR_y = store_myR_a;
	myR!update, store_myR_y, 0, 0, 0;
	myR?update, _, new_myR_a, new_myR_b, _;
	printf(".\n");
}

proctype __default___Q_Impl(chan parent)
{
	printf("### __default___Q_Impl(%d) ### started\n", _pid);



	// *** Variables for storing Inputs, Outputs, Subcomponents ***
	int eventInt;
	int eventSum;

	int store_self_z;
	int store_self_c; int new_self_c;
	int store_self_e; int new_self_e;
	int store_self_d; int new_self_d;

	pid pid_myR;
	int store_myR_y;
	int store_myR_a; int new_myR_a;
	int store_myR_b; int new_myR_b;



	// *** Create Subcomponents ***

	// myR : __default__::R.Impl
	chan myR = [0] of {mtype, int, int, int, int};
	pid_myR = run __default___R_Impl(myR);



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	parent?activate, _, _, _, _, _;

	// Initialize Own Out Data Ports
	store_self_c = -1;
	store_self_e = -1;
	store_self_d = -1;

	// Initialize Data Subcomponents (only those active in start mode)

	// Initialize Non-Data Subcomponents' In Data Ports (must be done since sent on updates)
	store_myR_y = -2;

	// Activate Non-Data Subcomponents (only those active in start mode)
	myR!activate, 0, 0, 0, 0;
	myR?activate, _, _, _, _;

	// Activation completed
	parent!activate, 0, 0, 0, 0, 0;
	goto _DefaultInitialMode;



	// *** Run as automaton & React to messages ***


_DefaultInitialMode:
	printf("### __default___Q_Impl(%d) ### enters state '_DefaultInitialMode'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: parent?update, store_self_z, _, _, _, _ ->
		printf("### __default___Q_Impl(%d) ### update with new input values: z=%d, #=%d\n", _pid, store_self_z, 1);

		// Update Subcomponents: First Iteration
		__default___Q_Impl_internalUpdate__DefaultInitialMode();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(store_myR_a == new_myR_a && store_myR_b == new_myR_b && true) ->
			store_myR_a = new_myR_a; store_myR_b = new_myR_b; 
			__default___Q_Impl_internalUpdate__DefaultInitialMode();
		:: else -> break;
		od;

		// Update own output values
		// a) Via Data Port Connections from subcomponents' out data ports
		store_self_c = store_myR_a;
		store_self_d = store_myR_b;
		// b) Via Flows from own in data ports
		store_self_e = (store_self_z) + (10);

		// Respond with own output values
		printf("### __default___Q_Impl(%d) ### update finally lead to new output values: c=%d, e=%d, d=%d, #=%d\n", _pid, store_self_c, store_self_e, store_self_d, 3);
		parent!update, 0, store_self_c, store_self_e, store_self_d, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: myR?invalidate, _, _, _, _ ->
		parent!invalidate, 0, 0, 0, 0, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: parent?deactivate, _, _, _, _, _ ->
		// deactivate active subcomponents
		myR!deactivate, 0, 0, 0, 0;
		myR?deactivate, _, _, _, _;
		parent!deactivate, 0, 0, 0, 0, 0;
		// reactivate
		parent?activate, _, _, _, _, _;
		myR!activate, 0, 0, 0, 0;
		myR?activate, _, _, _, _;
		parent!activate, 0, 0, 0, 0, 0;

	// Incomming Message: reset (from parent)
	:: parent?reset, _, _, _, _, _ ->
		// reset active subcomponents
		myR!reset, 0, 0, 0, 0;
		myR?reset, _, _, _, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		parent!reset, 0, 0, 0, 0, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od; // --- _DefaultInitialMode --- 

}





// ----- __default__::P.Impl --------------------------------------------------

inline __default___P_Impl_internalUpdate__DefaultInitialMode()
{
	// Update subcomponent myQ
	store_myQ_z = store_myQ_c;
	myQ!update, store_myQ_z, 0, 0, 0, 0;
	myQ?update, _, new_myQ_c, new_myQ_e, new_myQ_d, _;
	printf(".\n");
}

proctype __default___P_Impl(chan parent)
{
	printf("### __default___P_Impl(%d) ### started\n", _pid);



	// *** Variables for storing Inputs, Outputs, Subcomponents ***
	int eventInt;
	int eventSum;


	pid pid_myQ;
	int store_myQ_z;
	int store_myQ_c; int new_myQ_c;
	int store_myQ_e; int new_myQ_e;
	int store_myQ_d; int new_myQ_d;



	// *** Create Subcomponents ***

	// myQ : __default__::Q.Impl
	chan myQ = [0] of {mtype, int, int, int, int, int};
	pid_myQ = run __default___Q_Impl(myQ);



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	parent?activate, _;

	// Initialize Own Out Data Ports

	// Initialize Data Subcomponents (only those active in start mode)

	// Initialize Non-Data Subcomponents' In Data Ports (must be done since sent on updates)
	store_myQ_z = -1;

	// Activate Non-Data Subcomponents (only those active in start mode)
	myQ!activate, 0, 0, 0, 0, 0;
	myQ?activate, _, _, _, _, _;

	// Activation completed
	parent!activate, 0;
	goto _DefaultInitialMode;



	// *** Run as automaton & React to messages ***


_DefaultInitialMode:
	printf("### __default___P_Impl(%d) ### enters state '_DefaultInitialMode'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: parent?update, _ ->
		printf("### __default___P_Impl(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		__default___P_Impl_internalUpdate__DefaultInitialMode();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(store_myQ_c == new_myQ_c && store_myQ_e == new_myQ_e && store_myQ_d == new_myQ_d && true) ->
			store_myQ_c = new_myQ_c; store_myQ_e = new_myQ_e; store_myQ_d = new_myQ_d; 
			__default___P_Impl_internalUpdate__DefaultInitialMode();
		:: else -> break;
		od;

		// Update own output values
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Respond with own output values
		printf("### __default___P_Impl(%d) ### update finally lead to new output values: #=%d\n", _pid, 0);
		parent!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: myQ?invalidate, _, _, _, _, _ ->
		parent!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: parent?deactivate, _ ->
		// deactivate active subcomponents
		myQ!deactivate, 0, 0, 0, 0, 0;
		myQ?deactivate, _, _, _, _, _;
		parent!deactivate, 0;
		// reactivate
		parent?activate, _;
		myQ!activate, 0, 0, 0, 0, 0;
		myQ?activate, _, _, _, _, _;
		parent!activate, 0;

	// Incomming Message: reset (from parent)
	:: parent?reset, _ ->
		// reset active subcomponents
		myQ!reset, 0, 0, 0, 0, 0;
		myQ?reset, _, _, _, _, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		parent!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od; // --- _DefaultInitialMode --- 

}






// ================================================================================================






// ----- Environment ------------------------------------------------------------------------------

active proctype Environment()
{
	printf("### ENV(%d) ### Environment started.\n", _pid);

	// *** Variables for storing Root Component ***
	pid pid_root;
	chan chan_root = [0] of {mtype, int};


	// *** Start & Activate Root Component ***
	nT(true);
	pid_root = run __default___P_Impl(chan_root);
	chan_root!activate, 0;
	chan_root?activate, _;
	chan_root!update, 0;
	chan_root?update, _;
	fT;

	// *** React to Messages from Root ***
	do
	// Invalidate: react with update
	:: chan_root?invalidate, _ ->
		chan_root!update, 0;
		chan_root?update, _;
		fT;  // root responsible for fT after invalidate-update-cycle!
	// Trymultiway: respond 0 partners
	:: chan_root?trymultiway, _ ->
		chan_root!trymultiway, 0;
	od;
}

