// This file has been generated by slim2promela-trans2, based on SLIM-Input: examples\Adder_X.slim



// ----- Message Types ----------------------------------------------------------------------------

mtype = { update, invalidate, trymultiway, activate, deactivate, reset };



// ----- MACROs for ensuring atomicity of transitions ---------------------------------------------

bool gflagGoNextTransition = true;

#define nT(guard) d_step { \
	guard && !gflagGoNextTransition; \
	gflagGoNextTransition = true; \
	printf("### (%d) ### Process %d is allowed to take its next transition!\n", _pid, _pid) }

#define fT d_step { \
	gflagGoNextTransition = false; \
	printf("### (%d) ### Process %d returned right to take next transition!\n", _pid, _pid) }



// ----- DEFINE integer constants for enum data types ---------------------------------------------







// ================================================================================================






// ----- Global Variable Declarations for storing Components' Data --------------------------------

// *** root : __default__::Main.Impl ***
chan chan_root = [0] of { mtype, int };
bool odpStore_root_bit2Xalarm; bool odpNew_root_bit2Xalarm;
bool odpStore_root_output; bool odpNew_root_output;
bool odpStore_root_run; bool odpNew_root_run;
bool odpStore_root_adderXalarm; bool odpNew_root_adderXalarm;
bool odpStore_root_bit1Xalarm; bool odpNew_root_bit1Xalarm;

// *** root_rnd1 : __default__::Random.Impl ***
chan chan_root_rnd1 = [0] of { mtype, int };
bool odpStore_root_rnd1_output; bool odpNew_root_rnd1_output;

// *** root_rnd2 : __default__::Random.Impl ***
chan chan_root_rnd2 = [0] of { mtype, int };
bool odpStore_root_rnd2_output; bool odpNew_root_rnd2_output;

// *** root_abus : __default__::Bus.Impl ***
chan chan_root_abus = [0] of { mtype, int };

// *** root_bit2 : __default__::Bit.Impl ***
chan chan_root_bit2 = [0] of { mtype, int };
bool idpStore_root_bit2_input;
bool odpStore_root_bit2_output; bool odpNew_root_bit2_output;
bool odpStore_root_bit2_alarm; bool odpNew_root_bit2_alarm;

// *** root_bit1 : __default__::Bit.Impl ***
chan chan_root_bit1 = [0] of { mtype, int };
bool idpStore_root_bit1_input;
bool odpStore_root_bit1_output; bool odpNew_root_bit1_output;
bool odpStore_root_bit1_alarm; bool odpNew_root_bit1_alarm;

// *** root_adder : __default__::Adder.Impl ***
chan chan_root_adder = [0] of { mtype, int };
bool idpStore_root_adder_input2;
bool idpStore_root_adder_input1;
bool odpStore_root_adder_output; bool odpNew_root_adder_output;
bool odpStore_root_adder_alarm; bool odpNew_root_adder_alarm;






// ================================================================================================






// ----- Environment ------------------------------------------------------------------------------

active proctype Environment()
{
	printf("### ENV(%d) ### Environment started.\n", _pid);


	// *** Activate & Update root component ***
	// 'nT(true)' is omitted, since gflagGoNextTransition therefore initally set to true
	chan_root!activate, 0;
	chan_root?activate, _;
	// For tests: manipulate (root's input data port) variables here
	chan_root!update, 0;
	chan_root?update, _;
	fT;

	// *** React to Messages from root component ***
	do
	// Invalidate: react with update
	:: chan_root?invalidate, _ ->
		chan_root!update, 0;
		chan_root?update, _;
		fT;  // root responsible for fT after invalidate-update-cycle!
	// Trymultiway: respond 0 partners
	:: chan_root?trymultiway, _ ->
		chan_root!trymultiway, 0;
	od;
}






// ================================================================================================






// ----- root : __default__::Main.Impl --------------------------------------------------

inline inlineUpdateModegone_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXrnd12_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXadder_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXbit12_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModeinit_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXrnd2_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXrnd1_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXbit1_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}

inline inlineUpdateModegoneXbit2_root()
{
	// Update subcomponent rnd1
	chan_root_rnd1!update, 0;
	chan_root_rnd1?update, _;
	// Update subcomponent rnd2
	chan_root_rnd2!update, 0;
	chan_root_rnd2?update, _;
	// Update subcomponent abus
	chan_root_abus!update, 0;
	chan_root_abus?update, _;
	// Update subcomponent bit2
	idpStore_root_bit2_input = odpStore_root_rnd2_output;
	chan_root_bit2!update, 0;
	chan_root_bit2?update, _;
	// Update subcomponent bit1
	idpStore_root_bit1_input = odpStore_root_rnd1_output;
	chan_root_bit1!update, 0;
	chan_root_bit1?update, _;
	// Update subcomponent adder
	idpStore_root_adder_input1 = odpStore_root_bit1_output;
	idpStore_root_adder_input2 = odpStore_root_bit2_output;
	chan_root_adder!update, 0;
	chan_root_adder?update, _;
	printf(".\n");
}


active proctype process_root()
{
	printf("### root(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root?activate, _;

	// Initialize Own Data Ports
	odpNew_root_bit2Xalarm = false; odpStore_root_bit2Xalarm = false;
	odpNew_root_output = false; odpStore_root_output = false;
	odpNew_root_run = false; odpStore_root_run = false;
	odpNew_root_adderXalarm = false; odpStore_root_adderXalarm = false;
	odpNew_root_bit1Xalarm = false; odpStore_root_bit1Xalarm = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)
	chan_root_rnd1!activate, 0;
	chan_root_rnd1?activate, _;
	chan_root_rnd2!activate, 0;
	chan_root_rnd2?activate, _;
	chan_root_abus!activate, 0;
	chan_root_abus?activate, _;
	chan_root_bit2!activate, 0;
	chan_root_bit2?activate, _;
	chan_root_bit1!activate, 0;
	chan_root_bit1?activate, _;
	chan_root_adder!activate, 0;
	chan_root_adder?activate, _;

	// Activation completed
	chan_root!activate, 0;
	goto mode_init;



	// *** Run as automaton & React to messages ***


	// --- Mode: gone ---
mode_gone:
	printf("### root(%d) ### enters state 'gone'\n", _pid);
	do

	// Proactive Transition (w/o event): gone -[when EmptyExpression then (run) := (False); ]-> init
	:: nT(true) ->
		odpNew_root_run = false;
		chan_root!invalidate, 0;  // propagate changes; fT by root!
		goto mode_init;

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegone_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegone_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: gone ---


	// --- Mode: goneXrnd12 ---
mode_goneXrnd12:
	printf("### root(%d) ### enters state 'goneXrnd12'\n", _pid);
	do

	// No proactive/master transition: goneXrnd12 -[bit1.go when None then EmptyExpressionList]-> goneXbit1

	// No proactive/master transition: goneXrnd12 -[bit2.go when None then EmptyExpressionList]-> goneXbit2

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXrnd12 -[bit2.go when EmptyExpression then EmptyExpressionList]-> goneXbit2
			:: true ->
				// Answer to trymultiway
				chan_root_bit2!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_bit2?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXbit2;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_bit2!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXrnd12 -[bit1.go when EmptyExpression then EmptyExpressionList]-> goneXbit1
			:: true ->
				// Answer to trymultiway
				chan_root_bit1!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_bit1?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXbit1;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_bit1!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXrnd12_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXrnd12_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXrnd12 ---


	// --- Mode: goneXadder ---
mode_goneXadder:
	printf("### root(%d) ### enters state 'goneXadder'\n", _pid);
	do

	// Proactive Transition (w/o event): goneXadder -[when EmptyExpression then (run) := (True); ]-> gone
	:: nT(true) ->
		odpNew_root_run = true;
		chan_root!invalidate, 0;  // propagate changes; fT by root!
		goto mode_gone;

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXadder_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXadder_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXadder ---


	// --- Mode: goneXbit12 ---
mode_goneXbit12:
	printf("### root(%d) ### enters state 'goneXbit12'\n", _pid);
	do

	// No proactive/master transition: goneXbit12 -[adder.go when None then EmptyExpressionList]-> goneXadder

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXbit12 -[adder.go when EmptyExpression then EmptyExpressionList]-> goneXadder
			:: true ->
				// Answer to trymultiway
				chan_root_adder!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_adder?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXadder;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_adder!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXbit12_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXbit12_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXbit12 ---


	// --- Mode: init ---
mode_init:
	printf("### root(%d) ### enters state 'init'\n", _pid);
	do

	// No proactive/master transition: init -[rnd1.go when None then EmptyExpressionList]-> goneXrnd1

	// No proactive/master transition: init -[rnd2.go when None then EmptyExpressionList]-> goneXrnd2

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): init -[rnd1.go when EmptyExpression then EmptyExpressionList]-> goneXrnd1
			:: true ->
				// Answer to trymultiway
				chan_root_rnd1!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_rnd1?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXrnd1;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_rnd1!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): init -[rnd2.go when EmptyExpression then EmptyExpressionList]-> goneXrnd2
			:: true ->
				// Answer to trymultiway
				chan_root_rnd2!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_rnd2?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXrnd2;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_rnd2!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModeinit_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModeinit_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: init ---


	// --- Mode: goneXrnd2 ---
mode_goneXrnd2:
	printf("### root(%d) ### enters state 'goneXrnd2'\n", _pid);
	do

	// No proactive/master transition: goneXrnd2 -[rnd1.go when None then EmptyExpressionList]-> goneXrnd12

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXrnd2 -[rnd1.go when EmptyExpression then EmptyExpressionList]-> goneXrnd12
			:: true ->
				// Answer to trymultiway
				chan_root_rnd1!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_rnd1?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXrnd12;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_rnd1!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXrnd2_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXrnd2_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXrnd2 ---


	// --- Mode: goneXrnd1 ---
mode_goneXrnd1:
	printf("### root(%d) ### enters state 'goneXrnd1'\n", _pid);
	do

	// No proactive/master transition: goneXrnd1 -[rnd2.go when None then EmptyExpressionList]-> goneXrnd12

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXrnd1 -[rnd2.go when EmptyExpression then EmptyExpressionList]-> goneXrnd12
			:: true ->
				// Answer to trymultiway
				chan_root_rnd2!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_rnd2?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXrnd12;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_rnd2!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXrnd1_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXrnd1_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXrnd1 ---


	// --- Mode: goneXbit1 ---
mode_goneXbit1:
	printf("### root(%d) ### enters state 'goneXbit1'\n", _pid);
	do

	// No proactive/master transition: goneXbit1 -[bit2.go when None then EmptyExpressionList]-> goneXbit12

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXbit1 -[bit2.go when EmptyExpression then EmptyExpressionList]-> goneXbit12
			:: true ->
				// Answer to trymultiway
				chan_root_bit2!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_bit2?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXbit12;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_bit2!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXbit1_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXbit1_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXbit1 ---


	// --- Mode: goneXbit2 ---
mode_goneXbit2:
	printf("### root(%d) ### enters state 'goneXbit2'\n", _pid);
	do

	// No proactive/master transition: goneXbit2 -[bit1.go when None then EmptyExpressionList]-> goneXbit12

	// Incomming Message: trymultiway (from subcomponent rnd1: go (1) )
	:: chan_root_rnd1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent rnd2: go (1) )
	:: chan_root_rnd2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_rnd2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit2: go (1) )
	:: chan_root_bit2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_bit2!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent bit1: go (1) )
	:: chan_root_bit1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): goneXbit2 -[bit1.go when EmptyExpression then EmptyExpressionList]-> goneXbit12
			:: true ->
				// Answer to trymultiway
				chan_root_bit1!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_bit1?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_goneXbit12;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_bit1!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent adder: go (1) )
	:: chan_root_adder?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_adder!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModegoneXbit2_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_rnd1_output == odpNew_root_rnd1_output && odpStore_root_rnd2_output == odpNew_root_rnd2_output && odpStore_root_bit2_output == odpNew_root_bit2_output && odpStore_root_bit2_alarm == odpNew_root_bit2_alarm && odpStore_root_bit1_output == odpNew_root_bit1_output && odpStore_root_bit1_alarm == odpNew_root_bit1_alarm && odpStore_root_adder_output == odpNew_root_adder_output && odpStore_root_adder_alarm == odpNew_root_adder_alarm) ->
			odpStore_root_rnd1_output = odpNew_root_rnd1_output; odpStore_root_rnd2_output = odpNew_root_rnd2_output; odpStore_root_bit2_output = odpNew_root_bit2_output; odpStore_root_bit2_alarm = odpNew_root_bit2_alarm; odpStore_root_bit1_output = odpNew_root_bit1_output; odpStore_root_bit1_alarm = odpNew_root_bit1_alarm; odpStore_root_adder_output = odpNew_root_adder_output; odpStore_root_adder_alarm = odpNew_root_adder_alarm; 
			inlineUpdateModegoneXbit2_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_output = odpStore_root_adder_output;
		odpNew_root_bit1Xalarm = odpStore_root_bit1_alarm;
		odpNew_root_bit2Xalarm = odpStore_root_bit2_alarm;
		odpNew_root_adderXalarm = odpStore_root_adder_alarm;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: bit2Xalarm=%d, output=%d, run=%d, adderXalarm=%d, bit1Xalarm=%d, #=%d\n", _pid, odpNew_root_bit2Xalarm, odpNew_root_output, odpNew_root_run, odpNew_root_adderXalarm, odpNew_root_bit1Xalarm, 5);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_rnd1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_rnd2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_abus?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit2?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_bit1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_adder?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		chan_root_rnd1?deactivate, _;
		chan_root_rnd2!deactivate, 0;
		chan_root_rnd2?deactivate, _;
		chan_root_abus!deactivate, 0;
		chan_root_abus?deactivate, _;
		chan_root_bit2!deactivate, 0;
		chan_root_bit2?deactivate, _;
		chan_root_bit1!deactivate, 0;
		chan_root_bit1?deactivate, _;
		chan_root_adder!deactivate, 0;
		chan_root_adder?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_rnd1!activate, 0;
		chan_root_rnd1?activate, _;
		chan_root_rnd2!activate, 0;
		chan_root_rnd2?activate, _;
		chan_root_abus!activate, 0;
		chan_root_abus?activate, _;
		chan_root_bit2!activate, 0;
		chan_root_bit2?activate, _;
		chan_root_bit1!activate, 0;
		chan_root_bit1?activate, _;
		chan_root_adder!activate, 0;
		chan_root_adder?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_rnd1!reset, 0;
		chan_root_rnd1?reset, _;
		chan_root_rnd2!reset, 0;
		chan_root_rnd2?reset, _;
		chan_root_abus!reset, 0;
		chan_root_abus?reset, _;
		chan_root_bit2!reset, 0;
		chan_root_bit2?reset, _;
		chan_root_bit1!reset, 0;
		chan_root_bit1?reset, _;
		chan_root_adder!reset, 0;
		chan_root_adder?reset, _;
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: goneXbit2 ---

}



// ----- root_rnd1 : __default__::Random.Impl --------------------------------------------------

inline inlineUpdateModeinit_root_rnd1()
{
	printf(".\n");
}


active proctype process_root_rnd1()
{
	printf("### root_rnd1(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_rnd1?activate, _;

	// Initialize Own Data Ports
	odpNew_root_rnd1_output = false; odpStore_root_rnd1_output = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_rnd1!activate, 0;
	goto mode_init;



	// *** Run as automaton & React to messages ***


	// --- Mode: init ---
mode_init:
	printf("### root_rnd1(%d) ### enters state 'init'\n", _pid);
	do

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := (True); ]-> init
	:: nT(true) ->
		chan_root_rnd1!trymultiway, 1;
		chan_root_rnd1?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_rnd1_output = true;
			chan_root_rnd1!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := (False); ]-> init
	:: nT(true) ->
		chan_root_rnd1!trymultiway, 1;
		chan_root_rnd1?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_rnd1_output = false;
			chan_root_rnd1!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_rnd1?update, _ ->

		// Display text message: input parameters
		printf("### root_rnd1(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModeinit_root_rnd1();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_rnd1(%d) ### update finally lead to new output values: output=%d, #=%d\n", _pid, odpNew_root_rnd1_output, 1);

		// Send update acknowledge to parent
		chan_root_rnd1!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_rnd1?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd1!deactivate, 0;
		// reactivate
		chan_root_rnd1?activate, _;
		chan_root_rnd1!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_rnd1?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_rnd1!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: init ---

}



// ----- root_rnd2 : __default__::Random.Impl --------------------------------------------------

inline inlineUpdateModeinit_root_rnd2()
{
	printf(".\n");
}


active proctype process_root_rnd2()
{
	printf("### root_rnd2(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_rnd2?activate, _;

	// Initialize Own Data Ports
	odpNew_root_rnd2_output = false; odpStore_root_rnd2_output = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_rnd2!activate, 0;
	goto mode_init;



	// *** Run as automaton & React to messages ***


	// --- Mode: init ---
mode_init:
	printf("### root_rnd2(%d) ### enters state 'init'\n", _pid);
	do

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := (True); ]-> init
	:: nT(true) ->
		chan_root_rnd2!trymultiway, 1;
		chan_root_rnd2?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_rnd2_output = true;
			chan_root_rnd2!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := (False); ]-> init
	:: nT(true) ->
		chan_root_rnd2!trymultiway, 1;
		chan_root_rnd2?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_rnd2_output = false;
			chan_root_rnd2!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_rnd2?update, _ ->

		// Display text message: input parameters
		printf("### root_rnd2(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModeinit_root_rnd2();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_rnd2(%d) ### update finally lead to new output values: output=%d, #=%d\n", _pid, odpNew_root_rnd2_output, 1);

		// Send update acknowledge to parent
		chan_root_rnd2!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_rnd2?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_rnd2!deactivate, 0;
		// reactivate
		chan_root_rnd2?activate, _;
		chan_root_rnd2!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_rnd2?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_rnd2!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: init ---

}



// ----- root_abus : __default__::Bus.Impl --------------------------------------------------

inline inlineUpdateMode_DefaultInitialMode_root_abus()
{
	printf(".\n");
}


active proctype process_root_abus()
{
	printf("### root_abus(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_abus?activate, _;

	// Initialize Own Data Ports

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_abus!activate, 0;
	goto mode__DefaultInitialMode;



	// *** Run as automaton & React to messages ***


	// --- Mode: _DefaultInitialMode ---
mode__DefaultInitialMode:
	printf("### root_abus(%d) ### enters state '_DefaultInitialMode'\n", _pid);
	do

	// Incomming Message: update (from parent)
	:: chan_root_abus?update, _ ->

		// Display text message: input parameters
		printf("### root_abus(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateMode_DefaultInitialMode_root_abus();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_abus(%d) ### update finally lead to new output values: #=%d\n", _pid, 0);

		// Send update acknowledge to parent
		chan_root_abus!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_abus?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_abus!deactivate, 0;
		// reactivate
		chan_root_abus?activate, _;
		chan_root_abus!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_abus?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_abus!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: _DefaultInitialMode ---

}



// ----- root_bit2 : __default__::Bit.Impl --------------------------------------------------

inline inlineUpdateModeinit_root_bit2()
{
	printf(".\n");
}


active proctype process_root_bit2()
{
	printf("### root_bit2(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_bit2?activate, _;

	// Initialize Own Data Ports
	idpStore_root_bit2_input = false;
	odpNew_root_bit2_output = false; odpStore_root_bit2_output = false;
	odpNew_root_bit2_alarm = false; odpStore_root_bit2_alarm = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_bit2!activate, 0;
	goto mode_init;



	// *** Run as automaton & React to messages ***


	// --- Mode: init ---
mode_init:
	printf("### root_bit2(%d) ### enters state 'init'\n", _pid);
	do

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := (input); ]-> init
	:: nT(true) ->
		chan_root_bit2!trymultiway, 1;
		chan_root_bit2?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_bit2_output = idpStore_root_bit2_input;
			chan_root_bit2!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_bit2?update, _ ->

		// Display text message: input parameters
		printf("### root_bit2(%d) ### update with new input values: input=%d, #=%d\n", _pid, idpStore_root_bit2_input, 1);

		// Update Subcomponents: First Iteration
		inlineUpdateModeinit_root_bit2();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_bit2(%d) ### update finally lead to new output values: output=%d, alarm=%d, #=%d\n", _pid, odpNew_root_bit2_output, odpNew_root_bit2_alarm, 2);

		// Send update acknowledge to parent
		chan_root_bit2!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_bit2?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_bit2!deactivate, 0;
		// reactivate
		chan_root_bit2?activate, _;
		chan_root_bit2!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_bit2?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_bit2!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: init ---

}



// ----- root_bit1 : __default__::Bit.Impl --------------------------------------------------

inline inlineUpdateModeinit_root_bit1()
{
	printf(".\n");
}


active proctype process_root_bit1()
{
	printf("### root_bit1(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_bit1?activate, _;

	// Initialize Own Data Ports
	idpStore_root_bit1_input = false;
	odpNew_root_bit1_output = false; odpStore_root_bit1_output = false;
	odpNew_root_bit1_alarm = false; odpStore_root_bit1_alarm = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_bit1!activate, 0;
	goto mode_init;



	// *** Run as automaton & React to messages ***


	// --- Mode: init ---
mode_init:
	printf("### root_bit1(%d) ### enters state 'init'\n", _pid);
	do

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := (input); ]-> init
	:: nT(true) ->
		chan_root_bit1!trymultiway, 1;
		chan_root_bit1?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_bit1_output = idpStore_root_bit1_input;
			chan_root_bit1!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_bit1?update, _ ->

		// Display text message: input parameters
		printf("### root_bit1(%d) ### update with new input values: input=%d, #=%d\n", _pid, idpStore_root_bit1_input, 1);

		// Update Subcomponents: First Iteration
		inlineUpdateModeinit_root_bit1();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_bit1(%d) ### update finally lead to new output values: output=%d, alarm=%d, #=%d\n", _pid, odpNew_root_bit1_output, odpNew_root_bit1_alarm, 2);

		// Send update acknowledge to parent
		chan_root_bit1!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_bit1?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_bit1!deactivate, 0;
		// reactivate
		chan_root_bit1?activate, _;
		chan_root_bit1!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_bit1?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_bit1!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: init ---

}



// ----- root_adder : __default__::Adder.Impl --------------------------------------------------

inline inlineUpdateModeinit_root_adder()
{
	printf(".\n");
}


active proctype process_root_adder()
{
	printf("### root_adder(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_adder?activate, _;

	// Initialize Own Data Ports
	idpStore_root_adder_input2 = false;
	idpStore_root_adder_input1 = false;
	odpNew_root_adder_output = false; odpStore_root_adder_output = false;
	odpNew_root_adder_alarm = false; odpStore_root_adder_alarm = false;

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_adder!activate, 0;
	goto mode_init;



	// *** Run as automaton & React to messages ***


	// --- Mode: init ---
mode_init:
	printf("### root_adder(%d) ### enters state 'init'\n", _pid);
	do

	// Master Transition (own out event): init -[go when EmptyExpression then (output) := ((input1) xor (input2)); ]-> init
	:: nT(true) ->
		chan_root_adder!trymultiway, 1;
		chan_root_adder?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			odpNew_root_adder_output = ((idpStore_root_adder_input1) && !(idpStore_root_adder_input2)) || (!(idpStore_root_adder_input1) && (idpStore_root_adder_input2));
			chan_root_adder!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_init;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_adder?update, _ ->

		// Display text message: input parameters
		printf("### root_adder(%d) ### update with new input values: input2=%d, input1=%d, #=%d\n", _pid, idpStore_root_adder_input2, idpStore_root_adder_input1, 2);

		// Update Subcomponents: First Iteration
		inlineUpdateModeinit_root_adder();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_adder(%d) ### update finally lead to new output values: output=%d, alarm=%d, #=%d\n", _pid, odpNew_root_adder_output, odpNew_root_adder_alarm, 2);

		// Send update acknowledge to parent
		chan_root_adder!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_adder?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_adder!deactivate, 0;
		// reactivate
		chan_root_adder?activate, _;
		chan_root_adder!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_adder?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_adder!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: init ---

}
