// This file has been generated by slim2promela-trans2, based on SLIM-Input: examples\RedundantBatterySystem2.slim



// ----- Message Types ----------------------------------------------------------------------------

mtype = { update, invalidate, trymultiway, activate, deactivate, reset };



// ----- MACROs for ensuring atomicity of transitions ---------------------------------------------

bool gflagGoNextTransition = true;

#define nT(guard) d_step { \
	guard && !gflagGoNextTransition; \
	gflagGoNextTransition = true; \
	printf("### (%d) ### Process %d is allowed to take its next transition!\n", _pid, _pid) }

#define fT d_step { \
	gflagGoNextTransition = false; \
	printf("### (%d) ### Process %d returned right to take next transition!\n", _pid, _pid) }



// ----- DEFINE integer constants for enum data types ---------------------------------------------







// ================================================================================================






// ----- Global Variable Declarations for storing Components' Data --------------------------------

// *** root : __default__::Power.Imp ***
chan chan_root = [0] of { mtype, int };
int odpStore_root_voltage; int odpNew_root_voltage;

// *** root_batt1 : __default__::Battery.Imp ***
chan chan_root_batt1 = [0] of { mtype, int };
int odpStore_root_batt1_voltage; int odpNew_root_batt1_voltage;
int dscStore_root_batt1_energy; int dscNew_root_batt1_energy;

// *** root_batt2 : __default__::Battery.Imp ***
chan chan_root_batt2 = [0] of { mtype, int };
int odpStore_root_batt2_voltage; int odpNew_root_batt2_voltage;
int dscStore_root_batt2_energy; int dscNew_root_batt2_energy;






// ================================================================================================






// ----- Environment ------------------------------------------------------------------------------

active proctype Environment()
{
	printf("### ENV(%d) ### Environment started.\n", _pid);


	// *** Activate & Update root component ***
	// 'nT(true)' is omitted, since gflagGoNextTransition therefore initally set to true
	chan_root!activate, 0;
	chan_root?activate, _;
	// For tests: manipulate (root's input data port) variables here
	chan_root!update, 0;
	chan_root?update, _;
	fT;

	// *** React to Messages from root component ***
	do
	// Invalidate: react with update
	:: chan_root?invalidate, _ ->
		chan_root!update, 0;
		chan_root?update, _;
		fT;  // root responsible for fT after invalidate-update-cycle!
	// Trymultiway: respond 0 partners
	:: chan_root?trymultiway, _ ->
		chan_root!trymultiway, 0;
	od;
}






// ================================================================================================






// ----- root : __default__::Power.Imp --------------------------------------------------

inline inlineUpdateModebackup_root()
{
	// Update subcomponent batt2
	chan_root_batt2!update, 0;
	chan_root_batt2?update, _;
	printf(".\n");
}

inline inlineUpdateModeprimary_root()
{
	// Update subcomponent batt1
	chan_root_batt1!update, 0;
	chan_root_batt1?update, _;
	printf(".\n");
}


active proctype process_root()
{
	printf("### root(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root?activate, _;

	// Initialize Own Data Ports

	// Initialize Data Subcomponents (only those active in start mode)

	// Activate Non-Data Subcomponents (only those active in start mode)
	chan_root_batt1!activate, 0;
	chan_root_batt1?activate, _;

	// Activation completed
	chan_root!activate, 0;
	goto mode_primary;



	// *** Run as automaton & React to messages ***


	// --- Mode: backup ---
mode_backup:
	printf("### root(%d) ### enters state 'backup'\n", _pid);
	do

	// No proactive/master transition: backup -[batt2.empty when None then EmptyExpressionList]-> primary

	// Incomming Message: trymultiway (from subcomponent batt1: empty (1) )
	:: chan_root_batt1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_batt1!trymultiway, eventSum;

	// Incomming Message: trymultiway (from subcomponent batt2: empty (1) )
	:: chan_root_batt2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): backup -[batt2.empty when EmptyExpression then EmptyExpressionList]-> primary
			:: true ->
				// Answer to trymultiway
				chan_root_batt2!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_batt2?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				chan_root_batt2!deactivate, 0;
				chan_root_batt2?deactivate, _;
				chan_root_batt1!activate, 0;
				chan_root_batt1?activate, _;
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_primary;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_batt2!trymultiway, eventSum;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModebackup_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_batt1_voltage == odpNew_root_batt1_voltage && odpStore_root_batt2_voltage == odpNew_root_batt2_voltage) ->
			odpStore_root_batt1_voltage = odpNew_root_batt1_voltage; odpStore_root_batt2_voltage = odpNew_root_batt2_voltage; 
			inlineUpdateModebackup_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_voltage = odpStore_root_batt2_voltage;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: voltage=%d, #=%d\n", _pid, odpNew_root_voltage, 1);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_batt1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_batt2?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_batt2!deactivate, 0;
		chan_root_batt2?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_batt2!activate, 0;
		chan_root_batt2?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_batt2!reset, 0;
		chan_root_batt2?reset, _;
		// activate already deactivated subcomponents to reset them
		chan_root_batt1!activate, 0;
		chan_root_batt1?activate, _;
		chan_root_batt1!reset, 0;
		chan_root_batt1?reset, _;
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: backup ---


	// --- Mode: primary ---
mode_primary:
	printf("### root(%d) ### enters state 'primary'\n", _pid);
	do

	// No proactive/master transition: primary -[batt1.empty when None then EmptyExpressionList]-> backup

	// Incomming Message: trymultiway (from subcomponent batt1: empty (1) )
	:: chan_root_batt1?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (subcomponent's out event): primary -[batt1.empty when EmptyExpression then EmptyExpressionList]-> backup
			:: true ->
				// Answer to trymultiway
				chan_root_batt1!trymultiway, eventSum+1;
				// Receive invalidate from subcomponent containing the master transition (before possible deactivating it!)
				chan_root_batt1?invalidate, _;
				// Adjust Subcomponents' Activation (now it is even safe to deactivate the subcomponent containing the master)
				chan_root_batt1!deactivate, 0;
				chan_root_batt1?deactivate, _;
				chan_root_batt2!activate, 0;
				chan_root_batt2?activate, _;
				// Forward invalidate
				chan_root!invalidate, 0;
				goto mode_backup;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
				chan_root_batt1!trymultiway, eventSum;

		fi;

	// Incomming Message: trymultiway (from subcomponent batt2: empty (1) )
	:: chan_root_batt2?trymultiway, 1 ->
		eventSum = 0;

		// Ask parent via Event Port Connections

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		chan_root_batt2!trymultiway, eventSum;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModeprimary_root();

		// Update Subcomponents: Fixpoint Iteration
		do
		:: !(odpStore_root_batt1_voltage == odpNew_root_batt1_voltage && odpStore_root_batt2_voltage == odpNew_root_batt2_voltage) ->
			odpStore_root_batt1_voltage = odpNew_root_batt1_voltage; odpStore_root_batt2_voltage = odpNew_root_batt2_voltage; 
			inlineUpdateModeprimary_root();
		:: else -> break;
		od;

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		odpNew_root_voltage = odpStore_root_batt1_voltage;
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: voltage=%d, #=%d\n", _pid, odpNew_root_voltage, 1);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_batt1?invalidate, _ ->
		chan_root!invalidate, 0;
	:: chan_root_batt2?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_batt1!deactivate, 0;
		chan_root_batt1?deactivate, _;
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_batt1!activate, 0;
		chan_root_batt1?activate, _;
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_batt1!reset, 0;
		chan_root_batt1?reset, _;
		// activate already deactivated subcomponents to reset them
		chan_root_batt2!activate, 0;
		chan_root_batt2?activate, _;
		chan_root_batt2!reset, 0;
		chan_root_batt2?reset, _;
		// confirm reset
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: primary ---

}



// ----- root_batt1 : __default__::Battery.Imp --------------------------------------------------

inline inlineUpdateModedepleted_root_batt1()
{
	printf(".\n");
}

inline inlineUpdateModecharged_root_batt1()
{
	printf(".\n");
}


active proctype process_root_batt1()
{
	printf("### root_batt1(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_batt1?activate, _;

	// Initialize Own Data Ports

	// Initialize Data Subcomponents (only those active in start mode)
	c_code { *((float *)&(now.dscStore_root_batt1_energy)) = 100; };

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_batt1!activate, 0;
	goto mode_charged;



	// *** Run as automaton & React to messages ***


	// --- Mode: depleted ---
mode_depleted:
	printf("### root_batt1(%d) ### enters state 'depleted'\n", _pid);
	do

	// Proactive Transition (w/o event): depleted -[when EmptyExpression then (energy) := ((energy) * (0.985)); (voltage) := ((0.6) * (energy)); ]-> depleted
	:: nT(true) ->
		c_code { *((float *)&(now.dscNew_root_batt1_energy)) = (*((float *)&(now.dscStore_root_batt1_energy))) * (0.985); };
		c_code { *((float *)&(now.odpNew_root_batt1_voltage)) = (0.6) * (*((float *)&(now.dscStore_root_batt1_energy))); };
		dscStore_root_batt1_energy = dscNew_root_batt1_energy;
		chan_root_batt1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_depleted;

	// Proactive Transition (w/o event): depleted -[when EmptyExpression then (energy) := (100); ]-> charged
	:: nT(true) ->
		c_code { *((float *)&(now.dscNew_root_batt1_energy)) = 100; };
		dscStore_root_batt1_energy = dscNew_root_batt1_energy;
		chan_root_batt1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_charged;

	// Incomming Message: update (from parent)
	:: chan_root_batt1?update, _ ->

		// Display text message: input parameters
		printf("### root_batt1(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModedepleted_root_batt1();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_batt1(%d) ### update finally lead to new output values: voltage=%d, #=%d\n", _pid, odpNew_root_batt1_voltage, 1);

		// Send update acknowledge to parent
		chan_root_batt1!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_batt1?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_batt1!deactivate, 0;
		// reactivate
		chan_root_batt1?activate, _;
		chan_root_batt1!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_batt1?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_batt1!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: depleted ---


	// --- Mode: charged ---
mode_charged:
	printf("### root_batt1(%d) ### enters state 'charged'\n", _pid);
	do

	// Proactive Transition (w/o event): charged -[when (energy) >= (20) then (energy) := ((energy) * (0.99)); (voltage) := ((6) * (energy)); ]-> charged
	:: nT(c_expr { (*((float *)&(now.dscStore_root_batt1_energy))) >= (20) }) ->
		c_code { *((float *)&(now.dscNew_root_batt1_energy)) = (*((float *)&(now.dscStore_root_batt1_energy))) * (0.99); };
		c_code { *((float *)&(now.odpNew_root_batt1_voltage)) = (6) * (*((float *)&(now.dscStore_root_batt1_energy))); };
		dscStore_root_batt1_energy = dscNew_root_batt1_energy;
		chan_root_batt1!invalidate, 0;  // propagate changes; fT by root!
		goto mode_charged;

	// Master Transition (own out event): charged -[empty when (energy) < (20) then EmptyExpressionList]-> depleted
	:: nT(c_expr { (*((float *)&(now.dscStore_root_batt1_energy))) < (20) }) ->
		chan_root_batt1!trymultiway, 1;
		chan_root_batt1?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			chan_root_batt1!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_depleted;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_batt1?update, _ ->

		// Display text message: input parameters
		printf("### root_batt1(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModecharged_root_batt1();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_batt1(%d) ### update finally lead to new output values: voltage=%d, #=%d\n", _pid, odpNew_root_batt1_voltage, 1);

		// Send update acknowledge to parent
		chan_root_batt1!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_batt1?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_batt1!deactivate, 0;
		// reactivate
		chan_root_batt1?activate, _;
		chan_root_batt1!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_batt1?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_batt1!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: charged ---

}



// ----- root_batt2 : __default__::Battery.Imp --------------------------------------------------

inline inlineUpdateModedepleted_root_batt2()
{
	printf(".\n");
}

inline inlineUpdateModecharged_root_batt2()
{
	printf(".\n");
}


active proctype process_root_batt2()
{
	printf("### root_batt2(%d) ### started\n", _pid);
	int eventInt, eventSum;



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_batt2?activate, _;

	// Initialize Own Data Ports

	// Initialize Data Subcomponents (only those active in start mode)
	c_code { *((float *)&(now.dscStore_root_batt2_energy)) = 100; };

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	chan_root_batt2!activate, 0;
	goto mode_charged;



	// *** Run as automaton & React to messages ***


	// --- Mode: depleted ---
mode_depleted:
	printf("### root_batt2(%d) ### enters state 'depleted'\n", _pid);
	do

	// Proactive Transition (w/o event): depleted -[when EmptyExpression then (energy) := ((energy) * (0.985)); (voltage) := ((0.6) * (energy)); ]-> depleted
	:: nT(true) ->
		c_code { *((float *)&(now.dscNew_root_batt2_energy)) = (*((float *)&(now.dscStore_root_batt2_energy))) * (0.985); };
		c_code { *((float *)&(now.odpNew_root_batt2_voltage)) = (0.6) * (*((float *)&(now.dscStore_root_batt2_energy))); };
		dscStore_root_batt2_energy = dscNew_root_batt2_energy;
		chan_root_batt2!invalidate, 0;  // propagate changes; fT by root!
		goto mode_depleted;

	// Proactive Transition (w/o event): depleted -[when EmptyExpression then (energy) := (100); ]-> charged
	:: nT(true) ->
		c_code { *((float *)&(now.dscNew_root_batt2_energy)) = 100; };
		dscStore_root_batt2_energy = dscNew_root_batt2_energy;
		chan_root_batt2!invalidate, 0;  // propagate changes; fT by root!
		goto mode_charged;

	// Incomming Message: update (from parent)
	:: chan_root_batt2?update, _ ->

		// Display text message: input parameters
		printf("### root_batt2(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModedepleted_root_batt2();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_batt2(%d) ### update finally lead to new output values: voltage=%d, #=%d\n", _pid, odpNew_root_batt2_voltage, 1);

		// Send update acknowledge to parent
		chan_root_batt2!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_batt2?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_batt2!deactivate, 0;
		// reactivate
		chan_root_batt2?activate, _;
		chan_root_batt2!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_batt2?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_batt2!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: depleted ---


	// --- Mode: charged ---
mode_charged:
	printf("### root_batt2(%d) ### enters state 'charged'\n", _pid);
	do

	// Proactive Transition (w/o event): charged -[when (energy) >= (20) then (energy) := ((energy) * (0.99)); (voltage) := ((6) * (energy)); ]-> charged
	:: nT(c_expr { (*((float *)&(now.dscStore_root_batt2_energy))) >= (20) }) ->
		c_code { *((float *)&(now.dscNew_root_batt2_energy)) = (*((float *)&(now.dscStore_root_batt2_energy))) * (0.99); };
		c_code { *((float *)&(now.odpNew_root_batt2_voltage)) = (6) * (*((float *)&(now.dscStore_root_batt2_energy))); };
		dscStore_root_batt2_energy = dscNew_root_batt2_energy;
		chan_root_batt2!invalidate, 0;  // propagate changes; fT by root!
		goto mode_charged;

	// Master Transition (own out event): charged -[empty when (energy) < (20) then EmptyExpressionList]-> depleted
	:: nT(c_expr { (*((float *)&(now.dscStore_root_batt2_energy))) < (20) }) ->
		chan_root_batt2!trymultiway, 1;
		chan_root_batt2?trymultiway, eventInt;
		if
		:: eventInt > 0 ->
			chan_root_batt2!invalidate, 0; // Not necessary if no effects, but parent may expect to retrieve this message!; fT by root!
			goto mode_depleted;
		:: else -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Incomming Message: update (from parent)
	:: chan_root_batt2?update, _ ->

		// Display text message: input parameters
		printf("### root_batt2(%d) ### update with new input values: #=%d\n", _pid, 0);

		// Update Subcomponents: First Iteration
		inlineUpdateModecharged_root_batt2();

		// Update Subcomponents: No Fixpoint Iteration needed since no subcomponent with out data ports!

		// Update own out data ports
		// a) Via Data Port Connections from subcomponents' out data ports
		// b) Via Flows from own in data ports

		// Display text message: output parameters
		printf("### root_batt2(%d) ### update finally lead to new output values: voltage=%d, #=%d\n", _pid, odpNew_root_batt2_voltage, 1);

		// Send update acknowledge to parent
		chan_root_batt2!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_batt2?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_batt2!deactivate, 0;
		// reactivate
		chan_root_batt2?activate, _;
		chan_root_batt2!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_batt2?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them
		// confirm reset
		chan_root_batt2!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: charged ---

}
