// This file has been generated by Slim2Promela.



// ----- Message Types ----------------------------------------------------------------------------

mtype = { update, invalidate, trymultiway, activate, deactivate, reset };



// ----- MACROs for ensuring atomicity of transitions ---------------------------------------------

bool gflagGoNextTransition = true;  // initially true for Environment proctype

#define nT(guard) d_step { \
	guard && !gflagGoNextTransition; \
	gflagGoNextTransition = true; \
	printf("### (%d) ### Process %d is allowed to take its next transition!\n", _pid, _pid) }
#define fT d_step { \
	gflagGoNextTransition = false; \
	printf("### (%d) ### Process %d returned right to take next transition!\n", _pid, _pid); \
	printf("NEW GLOBAL STATE: root.mySubcomp.mode=%d, root.mode=%d\n", nominalMode_root_mySubcomp, nominalMode_root) }



// ----- Flag for Multiway Event Communication ----------------------------------------------------

bool gflagTrymultiway = false;



// ----- DEFINE integer type & constants for enum data types --------------------------------------

#define enumIntType byte



// ----- DEFINE integer type & constants for nominal modes ----------------------------------------

#define modeIntType byte
#define modeID_moe2 2
#define modeID_moe1 3
#define modeID_smiep 7
#define modeID_ini 5
#define modeID_smoep 6
#define modeID_mie1 1
#define modeID_mie2 4
#define modeID_sini 8



// ----- DEFINE placeholders with atomic propositions ---------------------------------------------
// Note: Defined names for enums/modes cannot be used in properties as CPP does not replace text in later #defines.







// ================================================================================================






// ----- Global Variable Declarations for storing Components' Data --------------------------------

// *** root : __default__::Root.Impl ***
chan chan_root = [0] of { mtype, int };
modeIntType nominalMode_root;

// *** root_mySubcomp : __default__::Subcomp.Impl ***
chan chan_root_mySubcomp = [0] of { mtype, int };
modeIntType nominalMode_root_mySubcomp;






// ================================================================================================






// ----- Environment ------------------------------------------------------------------------------

active proctype Environment()
{
	printf("### ENV(%d) ### Environment started.\n", _pid);


	// *** Activate & Update root component ***
	chan_root!activate, 0;
	chan_root?activate, _;

	// For tests: manipulate root's input data port variables here

	chan_root!update, 0;
	chan_root?update, _;

	fT;  // Allow components to take transitions (initially nT reserved for Environment)



	// *** React to Messages from root component ***
	do

	// Invalidate: react with update
	:: chan_root?invalidate, _ ->
		chan_root!update, 0;
		chan_root?update, _;
		fT;  // Environment responsible for fT after invalidate-update-cycle!

	// Upward Trymultiway:
	:: chan_root?trymultiway, _ ->
		gflagTrymultiway = true;
		chan_root!trymultiway, 0;

	// Downward Trymultiway:
	:: nT(true) ->
		chan_root!trymultiway, 1;
		chan_root?trymultiway, _;
		if
		:: d_step { gflagTrymultiway ->
			gflagTrymultiway = false; }
			chan_root!update, 0;
			chan_root?update, _;
		:: else -> fT
		fi;
	:: nT(true) ->
		chan_root!trymultiway, 2;
		chan_root?trymultiway, _;
		if
		:: d_step { gflagTrymultiway ->
			gflagTrymultiway = false; }
			chan_root!update, 0;
			chan_root?update, _;
		:: else -> fT
		fi;
	:: nT(true) ->
		chan_root!trymultiway, 3;
		chan_root?trymultiway, _;
		if
		:: d_step { gflagTrymultiway ->
			gflagTrymultiway = false; }
			chan_root!update, 0;
			chan_root?update, _;
		:: else -> fT
		fi;

	od;
}






// ================================================================================================






// ----- root : __default__::Root.Impl --------------------------------------------------

inline inlineUpdateModemie1_root()
{

	// Update active subcomponent mySubcomp
	// 1.) Forward new inputs to subcomponents in data ports
	// 2.) Send update message to subcomponent & receive acknowledgement
	chan_root_mySubcomp!update, 0;
	chan_root_mySubcomp?update, _;

}

inline inlineUpdateModemoe2_root()
{

	// Update active subcomponent mySubcomp
	// 1.) Forward new inputs to subcomponents in data ports
	// 2.) Send update message to subcomponent & receive acknowledgement
	chan_root_mySubcomp!update, 0;
	chan_root_mySubcomp?update, _;

}

inline inlineUpdateModemoe1_root()
{

	// Update active subcomponent mySubcomp
	// 1.) Forward new inputs to subcomponents in data ports
	// 2.) Send update message to subcomponent & receive acknowledgement
	chan_root_mySubcomp!update, 0;
	chan_root_mySubcomp?update, _;

}

inline inlineUpdateModemie2_root()
{

	// Update active subcomponent mySubcomp
	// 1.) Forward new inputs to subcomponents in data ports
	// 2.) Send update message to subcomponent & receive acknowledgement
	chan_root_mySubcomp!update, 0;
	chan_root_mySubcomp?update, _;

}

inline inlineUpdateModeini_root()
{

	// Update active subcomponent mySubcomp
	// 1.) Forward new inputs to subcomponents in data ports
	// 2.) Send update message to subcomponent & receive acknowledgement
	chan_root_mySubcomp!update, 0;
	chan_root_mySubcomp?update, _;

}


active proctype process1_root()
{
	printf("### root(%d) ### started\n", _pid);



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root?activate, _;
	d_step {

		// Initialize Own Data Ports

		// Initialize Data Subcomponents (only those active in start mode)

		// Initialize Mode Info
		nominalMode_root = modeID_ini;
	}

	// Activate Non-Data Subcomponents (only those active in start mode)
	chan_root_mySubcomp!activate, 0;
	chan_root_mySubcomp?activate, _;

	// Activation completed
	printf("### root(%d) ### activated\n", _pid);
	chan_root!activate, 0;
	goto mode_ini;



	// *** Run as automaton & React to messages ***


	// --- Mode: mie1 ---
mode_mie1:
	printf("### root(%d) ### enters state 'mie1'\n", _pid);
	do

	// Proactive Transition (w/o event): mie1 -[when EmptyExpression then EmptyExpressionList]-> mie1
	:: nT(true) -> d_step {
		nominalMode_root = modeID_mie1; }
		printf("### root(%d) ### takes proactive transition: mie1 -[when EmptyExpression then EmptyExpressionList]-> mie1\n", _pid);
		chan_root!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_mie1;

	// Incomming Message: trymultiway (from parent: fie (1) )
	:: chan_root?trymultiway, 1 ->
		printf("### root(%d) ### receives trymultiway request for fie (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

			// Event Port Connection: fie -> mySubcomp.siep (and current mode mie1 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root_mySubcomp!trymultiway, 1;
			chan_root_mySubcomp?trymultiway, _;

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie1 (2) )
	:: chan_root?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for ie1 (No. 2)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie2 (3) )
	:: chan_root?trymultiway, 3 ->
		printf("### root(%d) ### receives trymultiway request for ie2 (No. 3)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from active subcomponent mySubcomp: soep (2) )
	:: chan_root_mySubcomp?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for mySubcomp.soep (No. 2)\n", _pid);

		// Ask parent via Event Port Connections

			// Event Port Connection: mySubcomp.soep -> foe (and current mode mie1 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root!trymultiway, 4;
			chan_root?trymultiway, _;

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateModemie1_root();

		// Update active subcomponents: No Fixpoint Iteration needed since no active subcomponent has out data ports!

		// Update own out data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_mySubcomp?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_mySubcomp!deactivate, 0;
		chan_root_mySubcomp?deactivate, _;
		printf("### root(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_mySubcomp!activate, 0;
		chan_root_mySubcomp?activate, _;
		printf("### root(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_mySubcomp!reset, 0;
		chan_root_mySubcomp?reset, _;
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: mie1 ---


	// --- Mode: moe2 ---
mode_moe2:
	printf("### root(%d) ### enters state 'moe2'\n", _pid);
	do

	// Proactive Transition (w/o event): moe2 -[when EmptyExpression then EmptyExpressionList]-> moe2
	:: nT(true) -> d_step {
		nominalMode_root = modeID_moe2; }
		printf("### root(%d) ### takes proactive transition: moe2 -[when EmptyExpression then EmptyExpressionList]-> moe2\n", _pid);
		chan_root!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_moe2;

	// Incomming Message: trymultiway (from parent: fie (1) )
	:: chan_root?trymultiway, 1 ->
		printf("### root(%d) ### receives trymultiway request for fie (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

			// Event Port Connection: fie -> mySubcomp.siep (and current mode moe2 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root_mySubcomp!trymultiway, 1;
			chan_root_mySubcomp?trymultiway, _;

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie1 (2) )
	:: chan_root?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for ie1 (No. 2)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie2 (3) )
	:: chan_root?trymultiway, 3 ->
		printf("### root(%d) ### receives trymultiway request for ie2 (No. 3)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from active subcomponent mySubcomp: soep (2) )
	:: chan_root_mySubcomp?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for mySubcomp.soep (No. 2)\n", _pid);

		// Ask parent via Event Port Connections

			// Event Port Connection: mySubcomp.soep -> foe (and current mode moe2 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root!trymultiway, 4;
			chan_root?trymultiway, _;

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateModemoe2_root();

		// Update active subcomponents: No Fixpoint Iteration needed since no active subcomponent has out data ports!

		// Update own out data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_mySubcomp?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_mySubcomp!deactivate, 0;
		chan_root_mySubcomp?deactivate, _;
		printf("### root(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_mySubcomp!activate, 0;
		chan_root_mySubcomp?activate, _;
		printf("### root(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_mySubcomp!reset, 0;
		chan_root_mySubcomp?reset, _;
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: moe2 ---


	// --- Mode: moe1 ---
mode_moe1:
	printf("### root(%d) ### enters state 'moe1'\n", _pid);
	do

	// Proactive Transition (w/o event): moe1 -[when EmptyExpression then EmptyExpressionList]-> moe1
	:: nT(true) -> d_step {
		nominalMode_root = modeID_moe1; }
		printf("### root(%d) ### takes proactive transition: moe1 -[when EmptyExpression then EmptyExpressionList]-> moe1\n", _pid);
		chan_root!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_moe1;

	// Incomming Message: trymultiway (from parent: fie (1) )
	:: chan_root?trymultiway, 1 ->
		printf("### root(%d) ### receives trymultiway request for fie (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

			// Event Port Connection: fie -> mySubcomp.siep (and current mode moe1 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root_mySubcomp!trymultiway, 1;
			chan_root_mySubcomp?trymultiway, _;

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie1 (2) )
	:: chan_root?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for ie1 (No. 2)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie2 (3) )
	:: chan_root?trymultiway, 3 ->
		printf("### root(%d) ### receives trymultiway request for ie2 (No. 3)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from active subcomponent mySubcomp: soep (2) )
	:: chan_root_mySubcomp?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for mySubcomp.soep (No. 2)\n", _pid);

		// Ask parent via Event Port Connections

			// Event Port Connection: mySubcomp.soep -> foe (and current mode moe1 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root!trymultiway, 4;
			chan_root?trymultiway, _;

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateModemoe1_root();

		// Update active subcomponents: No Fixpoint Iteration needed since no active subcomponent has out data ports!

		// Update own out data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_mySubcomp?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_mySubcomp!deactivate, 0;
		chan_root_mySubcomp?deactivate, _;
		printf("### root(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_mySubcomp!activate, 0;
		chan_root_mySubcomp?activate, _;
		printf("### root(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_mySubcomp!reset, 0;
		chan_root_mySubcomp?reset, _;
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: moe1 ---


	// --- Mode: mie2 ---
mode_mie2:
	printf("### root(%d) ### enters state 'mie2'\n", _pid);
	do

	// Proactive Transition (w/o event): mie2 -[when EmptyExpression then EmptyExpressionList]-> mie2
	:: nT(true) -> d_step {
		nominalMode_root = modeID_mie2; }
		printf("### root(%d) ### takes proactive transition: mie2 -[when EmptyExpression then EmptyExpressionList]-> mie2\n", _pid);
		chan_root!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_mie2;

	// Incomming Message: trymultiway (from parent: fie (1) )
	:: chan_root?trymultiway, 1 ->
		printf("### root(%d) ### receives trymultiway request for fie (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

			// Event Port Connection: fie -> mySubcomp.siep (and current mode mie2 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root_mySubcomp!trymultiway, 1;
			chan_root_mySubcomp?trymultiway, _;

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie1 (2) )
	:: chan_root?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for ie1 (No. 2)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie2 (3) )
	:: chan_root?trymultiway, 3 ->
		printf("### root(%d) ### receives trymultiway request for ie2 (No. 3)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from active subcomponent mySubcomp: soep (2) )
	:: chan_root_mySubcomp?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for mySubcomp.soep (No. 2)\n", _pid);

		// Ask parent via Event Port Connections

			// Event Port Connection: mySubcomp.soep -> foe (and current mode mie2 is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root!trymultiway, 4;
			chan_root?trymultiway, _;

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateModemie2_root();

		// Update active subcomponents: No Fixpoint Iteration needed since no active subcomponent has out data ports!

		// Update own out data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_mySubcomp?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_mySubcomp!deactivate, 0;
		chan_root_mySubcomp?deactivate, _;
		printf("### root(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_mySubcomp!activate, 0;
		chan_root_mySubcomp?activate, _;
		printf("### root(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_mySubcomp!reset, 0;
		chan_root_mySubcomp?reset, _;
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: mie2 ---


	// --- Mode: ini ---
mode_ini:
	printf("### root(%d) ### enters state 'ini'\n", _pid);
	do

	// No proactive/master transition: ini -[ie1 when EmptyExpression then EmptyExpressionList]-> mie1

	// No proactive/master transition: ini -[ie2 when EmptyExpression then EmptyExpressionList]-> mie2

	// Master Transition (own out event): ini -[oe1 when EmptyExpression then EmptyExpressionList]-> moe1
	:: nT(true) ->
		// We know: gflagTrymultiway == false, since reset after every trymultiway!
		chan_root!trymultiway, 5;
		chan_root?trymultiway, _;
		if
		:: d_step { gflagTrymultiway ->
			gflagTrymultiway = false;   // Reset after usage => false for next trymultiway and outside trymultiway
			nominalMode_root = modeID_moe1; }
			printf("### root(%d) ### takes master transition: ini -[oe1 when EmptyExpression then EmptyExpressionList]-> moe1\n", _pid);
			chan_root!invalidate, 0; // Supercomponent expects to retrieve this message! fT by root!
			goto mode_moe1;
		:: !gflagTrymultiway -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Master Transition (own out event): ini -[oe2 when EmptyExpression then EmptyExpressionList]-> moe2
	:: nT(true) ->
		// We know: gflagTrymultiway == false, since reset after every trymultiway!
		chan_root!trymultiway, 6;
		chan_root?trymultiway, _;
		if
		:: d_step { gflagTrymultiway ->
			gflagTrymultiway = false;   // Reset after usage => false for next trymultiway and outside trymultiway
			nominalMode_root = modeID_moe2; }
			printf("### root(%d) ### takes master transition: ini -[oe2 when EmptyExpression then EmptyExpressionList]-> moe2\n", _pid);
			chan_root!invalidate, 0; // Supercomponent expects to retrieve this message! fT by root!
			goto mode_moe2;
		:: !gflagTrymultiway -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Proactive Transition (w/o event): ini -[when EmptyExpression then EmptyExpressionList]-> ini
	:: nT(true) -> d_step {
		nominalMode_root = modeID_ini; }
		printf("### root(%d) ### takes proactive transition: ini -[when EmptyExpression then EmptyExpressionList]-> ini\n", _pid);
		chan_root!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_ini;

	// Incomming Message: trymultiway (from parent: fie (1) )
	:: chan_root?trymultiway, 1 ->
		printf("### root(%d) ### receives trymultiway request for fie (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

			// Event Port Connection: fie -> mySubcomp.siep (and current mode ini is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root_mySubcomp!trymultiway, 1;
			chan_root_mySubcomp?trymultiway, _;

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root!trymultiway, 0;

	// Incomming Message: trymultiway (from parent: ie1 (2) )
	:: chan_root?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for ie1 (No. 2)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): ini -[ie1 when EmptyExpression then EmptyExpressionList]-> mie1
			:: d_step { true ->
				gflagTrymultiway = true;
				nominalMode_root = modeID_mie1; }
				printf("### root(%d) ### takes reactive transition: ini -[ie1 when EmptyExpression then EmptyExpressionList]-> mie1\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
				chan_root!trymultiway, 0;
				goto mode_mie1;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
				chan_root!trymultiway, 0;

		fi;

	// Incomming Message: trymultiway (from parent: ie2 (3) )
	:: chan_root?trymultiway, 3 ->
		printf("### root(%d) ### receives trymultiway request for ie2 (No. 3)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): ini -[ie2 when EmptyExpression then EmptyExpressionList]-> mie2
			:: d_step { true ->
				gflagTrymultiway = true;
				nominalMode_root = modeID_mie2; }
				printf("### root(%d) ### takes reactive transition: ini -[ie2 when EmptyExpression then EmptyExpressionList]-> mie2\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
				chan_root!trymultiway, 0;
				goto mode_mie2;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
				chan_root!trymultiway, 0;

		fi;

	// Incomming Message: trymultiway (from active subcomponent mySubcomp: soep (2) )
	:: chan_root_mySubcomp?trymultiway, 2 ->
		printf("### root(%d) ### receives trymultiway request for mySubcomp.soep (No. 2)\n", _pid);

		// Ask parent via Event Port Connections

			// Event Port Connection: mySubcomp.soep -> foe (and current mode ini is in modes [u'mie1', u'moe2', u'moe1', u'mie2', u'ini'])
			chan_root!trymultiway, 4;
			chan_root?trymultiway, _;

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root?update, _ ->

		// Display text message: input parameters
		printf("### root(%d) ### update with new input values: \n", _pid);

		// Update active subcomponents: First Iteration
		inlineUpdateModeini_root();

		// Update active subcomponents: No Fixpoint Iteration needed since no active subcomponent has out data ports!

		// Update own out data ports

		// Display text message: output parameters
		printf("### root(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root!update, 0;

	// Incomming Message: invalidate (from subcomponents only)
	:: chan_root_mySubcomp?invalidate, _ ->
		chan_root!invalidate, 0;

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root?deactivate, _ ->
		// deactivate active subcomponents
		chan_root_mySubcomp!deactivate, 0;
		chan_root_mySubcomp?deactivate, _;
		printf("### root(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root!deactivate, 0;
		// reactivate
		chan_root?activate, _;
		chan_root_mySubcomp!activate, 0;
		chan_root_mySubcomp?activate, _;
		printf("### root(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root?reset, _ ->
		// reset active subcomponents
		chan_root_mySubcomp!reset, 0;
		chan_root_mySubcomp?reset, _;
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: ini ---

}



// ----- root_mySubcomp : __default__::Subcomp.Impl --------------------------------------------------


active proctype process2_root_mySubcomp()
{
	printf("### root_mySubcomp(%d) ### started\n", _pid);



	// *** Wait for first activation ***
FirstActivationOrReactivationWithoutModeHistory:
	chan_root_mySubcomp?activate, _;
	d_step {

		// Initialize Own Data Ports

		// Initialize Data Subcomponents (only those active in start mode)

		// Initialize Mode Info
		nominalMode_root_mySubcomp = modeID_sini;
	}

	// Activate Non-Data Subcomponents (only those active in start mode)

	// Activation completed
	printf("### root_mySubcomp(%d) ### activated\n", _pid);
	chan_root_mySubcomp!activate, 0;
	goto mode_sini;



	// *** Run as automaton & React to messages ***


	// --- Mode: smoep ---
mode_smoep:
	printf("### root_mySubcomp(%d) ### enters state 'smoep'\n", _pid);
	do

	// Proactive Transition (w/o event): smoep -[when EmptyExpression then EmptyExpressionList]-> smoep
	:: nT(true) -> d_step {
		nominalMode_root_mySubcomp = modeID_smoep; }
		printf("### root_mySubcomp(%d) ### takes proactive transition: smoep -[when EmptyExpression then EmptyExpressionList]-> smoep\n", _pid);
		chan_root_mySubcomp!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_smoep;

	// Incomming Message: trymultiway (from parent: siep (1) )
	:: chan_root_mySubcomp?trymultiway, 1 ->
		printf("### root_mySubcomp(%d) ### receives trymultiway request for siep (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root_mySubcomp(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root_mySubcomp?update, _ ->

		// Display text message: input parameters
		printf("### root_mySubcomp(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_mySubcomp(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root_mySubcomp!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_mySubcomp?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_mySubcomp(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_mySubcomp!deactivate, 0;
		// reactivate
		chan_root_mySubcomp?activate, _;
		printf("### root_mySubcomp(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_mySubcomp!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_mySubcomp?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root_mySubcomp(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_mySubcomp!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: smoep ---


	// --- Mode: smiep ---
mode_smiep:
	printf("### root_mySubcomp(%d) ### enters state 'smiep'\n", _pid);
	do

	// Proactive Transition (w/o event): smiep -[when EmptyExpression then EmptyExpressionList]-> smiep
	:: nT(true) -> d_step {
		nominalMode_root_mySubcomp = modeID_smiep; }
		printf("### root_mySubcomp(%d) ### takes proactive transition: smiep -[when EmptyExpression then EmptyExpressionList]-> smiep\n", _pid);
		chan_root_mySubcomp!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_smiep;

	// Incomming Message: trymultiway (from parent: siep (1) )
	:: chan_root_mySubcomp?trymultiway, 1 ->
		printf("### root_mySubcomp(%d) ### receives trymultiway request for siep (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// No Reactive Transitions => just answer to trymultiway
		printf("### root_mySubcomp(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
		chan_root_mySubcomp!trymultiway, 0;

	// Incomming Message: update (from parent)
	:: chan_root_mySubcomp?update, _ ->

		// Display text message: input parameters
		printf("### root_mySubcomp(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_mySubcomp(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root_mySubcomp!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_mySubcomp?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_mySubcomp(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_mySubcomp!deactivate, 0;
		// reactivate
		chan_root_mySubcomp?activate, _;
		printf("### root_mySubcomp(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_mySubcomp!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_mySubcomp?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root_mySubcomp(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_mySubcomp!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: smiep ---


	// --- Mode: sini ---
mode_sini:
	printf("### root_mySubcomp(%d) ### enters state 'sini'\n", _pid);
	do

	// No proactive/master transition: sini -[siep when EmptyExpression then EmptyExpressionList]-> smiep

	// Master Transition (own out event): sini -[soep when EmptyExpression then EmptyExpressionList]-> smoep
	:: nT(true) ->
		// We know: gflagTrymultiway == false, since reset after every trymultiway!
		chan_root_mySubcomp!trymultiway, 2;
		chan_root_mySubcomp?trymultiway, _;
		if
		:: d_step { gflagTrymultiway ->
			gflagTrymultiway = false;   // Reset after usage => false for next trymultiway and outside trymultiway
			nominalMode_root_mySubcomp = modeID_smoep; }
			printf("### root_mySubcomp(%d) ### takes master transition: sini -[soep when EmptyExpression then EmptyExpressionList]-> smoep\n", _pid);
			chan_root_mySubcomp!invalidate, 0; // Supercomponent expects to retrieve this message! fT by root!
			goto mode_smoep;
		:: !gflagTrymultiway -> fT; // no communication partner => continue with loop (no jump/reentrance of state)
		fi;

	// Proactive Transition (w/o event): sini -[when EmptyExpression then EmptyExpressionList]-> sini
	:: nT(true) -> d_step {
		nominalMode_root_mySubcomp = modeID_sini; }
		printf("### root_mySubcomp(%d) ### takes proactive transition: sini -[when EmptyExpression then EmptyExpressionList]-> sini\n", _pid);
		chan_root_mySubcomp!invalidate, 0;  // Propagate changes of data ports & fT by root! (Could be avoided when no changes to data ports.)
		goto mode_sini;

	// Incomming Message: trymultiway (from parent: siep (1) )
	:: chan_root_mySubcomp?trymultiway, 1 ->
		printf("### root_mySubcomp(%d) ### receives trymultiway request for siep (No. 1)\n", _pid);

		// Ask subcomponents via Event Port Connections

		// Reactive Transitions
		if

			// Reactive Transition (own in event): sini -[siep when EmptyExpression then EmptyExpressionList]-> smiep
			:: d_step { true ->
				gflagTrymultiway = true;
				nominalMode_root_mySubcomp = modeID_smiep; }
				printf("### root_mySubcomp(%d) ### takes reactive transition: sini -[siep when EmptyExpression then EmptyExpressionList]-> smiep\n", _pid);
				// Answer to trymultiway, no invalidate necessary since sended by Master Transition
				printf("### root_mySubcomp(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
				chan_root_mySubcomp!trymultiway, 0;
				goto mode_smiep;

			// No Reactive Transition enabled => just answer to trymultiway
			:: else ->
			printf("### root_mySubcomp(%d) ### answers to trymultiway: %d\n", _pid, gflagTrymultiway);
				chan_root_mySubcomp!trymultiway, 0;

		fi;

	// Incomming Message: update (from parent)
	:: chan_root_mySubcomp?update, _ ->

		// Display text message: input parameters
		printf("### root_mySubcomp(%d) ### update with new input values: \n", _pid);

		// No active subcomponents to update

		// Update own out data ports

		// Display text message: output parameters
		printf("### root_mySubcomp(%d) ### update finally lead to new output values: \n", _pid);

		// Send update acknowledge to parent
		chan_root_mySubcomp!update, 0;

	// Incomming Message: invalidate (from subcomponents only)

	// Incomming Message: deactivate (from parent) - keep mode history
	:: chan_root_mySubcomp?deactivate, _ ->
		// deactivate active subcomponents
		printf("### root_mySubcomp(%d) ### was deactivated (with mode history)\n", _pid);
		chan_root_mySubcomp!deactivate, 0;
		// reactivate
		chan_root_mySubcomp?activate, _;
		printf("### root_mySubcomp(%d) ### was reactivated (with mode history)\n", _pid);
		chan_root_mySubcomp!activate, 0;

	// Incomming Message: reset (from parent)
	:: chan_root_mySubcomp?reset, _ ->
		// reset active subcomponents
		// activate already deactivated subcomponents to reset them (only those with mode history)
		// confirm reset
		printf("### root_mySubcomp(%d) ### is deactivated and forced to be reset\n", _pid);
		chan_root_mySubcomp!reset, 0;
		goto FirstActivationOrReactivationWithoutModeHistory;

	od;
	// --- /Mode: sini ---

}
