# =============================================================================
#  This file is part of the ``HASDEL'' Toolset.
#  Copyright (C) 2014 by Fondazione Bruno Kessler
#  Copyright (C) 2014 by RWTH Aachen University
#
#
#  The HASDEL Toolset can be copied, modified and/or redistributed
#  under the terms of the HASDEL General Public License, either
#  version 1 of the License, or (at your option) any later version.
#
#  You should have received a copy of the HASDEL General Public
#  License along with this software. If not, please contact the
#  copyright owners.
#
#  The HASDEL Toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  HASDEL General Public License for more details.
#
#  For more information on the HASDEL Project see the Project Web
#  site at <http://compassinternal.informatik.rwth-aachen.de/hasdel-site/> 
#  or email to <hasdel-support@lists.rwth-aachen.de>.  
#
#  Please report bugs to <hasdel-support@lists.rwth-aachen.de>.
# =============================================================================

# COMPASS-related imports
from slim_compiler.src.smv.converter import SmvConverter

######################### CLASS MainExtensionConverter #########################

class MainExtensionConverter (SmvConverter):
    """Class for converting SLIM models into SMV models integrated with
    additional SMV code for the main component."""

    def __init__(self):
        super(MainExtensionConverter, self).__init__(generate_timed_fsm=True)
        self.main_extension = None

    def set_main_extension(self, extension_smv_code):
        self.main_extension = extension_smv_code

    def _main_module(self, root_impl):
        if self.main_extension is not None:
            return self._root_declaration(root_impl) + self.main_extension
        else:
            return self._root_declaration(root_impl)

