# $ANTLR 3.1.1 Slim.g 2014-12-10 14:05:21

import sys
from antlr3 import *
from antlr3.compat import set, frozenset

from antlr3.tree import *

         
from slim_compiler.src.errorManagement.exceptions import *
from slim_compiler.src import globals



# for convenience in actions
HIDDEN = BaseRecognizer.HIDDEN

# token types
OE_PROP=120
FLOW=131
MINUS=97
WHEN=71
SEMICOLON=8
PROCESS=13
MODE_TRANS=117
ERROR=62
TRANSITIONS=35
FLOWS=104
IEPORT=110
ENUM=86
IN=21
DOT=27
LPAREN=58
CONNECTIONS=33
OUT=22
CASE=51
FQ_NAME_OR_IDENT=125
SEC=91
ATACTIVATION=42
MIN=92
ERR_CLOCK=122
PUBLIC=5
THEN=53
XOR=76
CLOCK=84
ERR_TRANS=123
FDIR=28
ERR_TYPE=108
ASSIGN=57
COMMENT=135
DIVIDE=98
GROUP=12
ARROW=39
EVENT_CONNECTION=127
MEMORY=15
OCCURRENCE=65
COMMA=60
ERR_IMPL=109
BUS=17
STATES=68
ERR_EVENT=121
IE_PROP=119
ODPORT=113
OBSERVABLE=29
LBRACKET=54
IDPORT=112
MODEL=10
PRIVATE=6
FEATURES=9
XNOR=77
PROB=102
MODES=34
UNARY_MINUS=130
ALPHANUM=134
LE=48
TO=73
NEQ=82
DAY=94
THREAD=11
PROPAGATION=64
NORMAL=128
SYSTEM=19
ACTIVATION=41
EVENTS=69
POISSON=67
ALARM=30
MODE=43
LT=47
RESET=56
CLOCKS=70
CONTINUOUS=85
EVENT=24
PASSIVE=105
PACKAGE=4
OEPORT=111
SUBCOMPONENTS=32
MODE_TRANS_PROB=118
ERRORPORT=114
NUMBER=133
SUBCOMPONENT=115
PORT=25
PROCESSOR=16
RUNNING=37
TRAJ_EXPR=129
ACCESSES=38
DEVICE=18
FIXED=66
TRUE=100
RPAREN=59
EQ=81
IMP=79
DATA_CONNECTION=126
NAME=124
DERIVATIVE=80
NOT=74
DATA=14
AND=46
OTHERWISE=52
REAL=88
END=7
PLUS=96
STORED=36
HOUR=93
INITIAL=40
IFF=78
STATE=61
WITHIN=72
INT=87
COMP_IMPL=107
NONBLOCKING=26
WS=136
EOF=-1
GE=50
ON=23
MSEC=90
COMP_TYPE=106
OR=75
MOD=99
TIMES=95
IMPLEMENTATION=31
NOMINAL=63
COLON=20
RBRACKET=55
GT=49
URGENT=44
IDENT=132
BOOL=83
WHILE=45
FALSE=101
PER=103
DEFAULT=89
THREAD_GROUP=116

# token names
tokenNames = [
    "<invalid>", "<EOR>", "<DOWN>", "<UP>", 
    "PACKAGE", "PUBLIC", "PRIVATE", "END", "SEMICOLON", "FEATURES", "MODEL", 
    "THREAD", "GROUP", "PROCESS", "DATA", "MEMORY", "PROCESSOR", "BUS", 
    "DEVICE", "SYSTEM", "COLON", "IN", "OUT", "ON", "EVENT", "PORT", "NONBLOCKING", 
    "DOT", "FDIR", "OBSERVABLE", "ALARM", "IMPLEMENTATION", "SUBCOMPONENTS", 
    "CONNECTIONS", "MODES", "TRANSITIONS", "STORED", "RUNNING", "ACCESSES", 
    "ARROW", "INITIAL", "ACTIVATION", "ATACTIVATION", "MODE", "URGENT", 
    "WHILE", "AND", "LT", "LE", "GT", "GE", "CASE", "OTHERWISE", "THEN", 
    "LBRACKET", "RBRACKET", "RESET", "ASSIGN", "LPAREN", "RPAREN", "COMMA", 
    "STATE", "ERROR", "NOMINAL", "PROPAGATION", "OCCURRENCE", "FIXED", "POISSON", 
    "STATES", "EVENTS", "CLOCKS", "WHEN", "WITHIN", "TO", "NOT", "OR", "XOR", 
    "XNOR", "IFF", "IMP", "DERIVATIVE", "EQ", "NEQ", "BOOL", "CLOCK", "CONTINUOUS", 
    "ENUM", "INT", "REAL", "DEFAULT", "MSEC", "SEC", "MIN", "HOUR", "DAY", 
    "TIMES", "PLUS", "MINUS", "DIVIDE", "MOD", "TRUE", "FALSE", "PROB", 
    "PER", "FLOWS", "PASSIVE", "COMP_TYPE", "COMP_IMPL", "ERR_TYPE", "ERR_IMPL", 
    "IEPORT", "OEPORT", "IDPORT", "ODPORT", "ERRORPORT", "SUBCOMPONENT", 
    "THREAD_GROUP", "MODE_TRANS", "MODE_TRANS_PROB", "IE_PROP", "OE_PROP", 
    "ERR_EVENT", "ERR_CLOCK", "ERR_TRANS", "NAME", "FQ_NAME_OR_IDENT", "DATA_CONNECTION", 
    "EVENT_CONNECTION", "NORMAL", "TRAJ_EXPR", "UNARY_MINUS", "FLOW", "IDENT", 
    "NUMBER", "ALPHANUM", "COMMENT", "WS"
]




class SlimParser(Parser):
    grammarFileName = "Slim.g"
    antlr_version = version_str_to_tuple("3.1.1")
    antlr_version_str = "3.1.1"
    tokenNames = tokenNames

    def __init__(self, input, state=None):
        if state is None:
            state = RecognizerSharedState()

        Parser.__init__(self, input, state)


        self.dfa1 = self.DFA1(
            self, 1,
            eot = self.DFA1_eot,
            eof = self.DFA1_eof,
            min = self.DFA1_min,
            max = self.DFA1_max,
            accept = self.DFA1_accept,
            special = self.DFA1_special,
            transition = self.DFA1_transition
            )

        self.dfa4 = self.DFA4(
            self, 4,
            eot = self.DFA4_eot,
            eof = self.DFA4_eof,
            min = self.DFA4_min,
            max = self.DFA4_max,
            accept = self.DFA4_accept,
            special = self.DFA4_special,
            transition = self.DFA4_transition
            )

        self.dfa3 = self.DFA3(
            self, 3,
            eot = self.DFA3_eot,
            eof = self.DFA3_eof,
            min = self.DFA3_min,
            max = self.DFA3_max,
            accept = self.DFA3_accept,
            special = self.DFA3_special,
            transition = self.DFA3_transition
            )

        self.dfa6 = self.DFA6(
            self, 6,
            eot = self.DFA6_eot,
            eof = self.DFA6_eof,
            min = self.DFA6_min,
            max = self.DFA6_max,
            accept = self.DFA6_accept,
            special = self.DFA6_special,
            transition = self.DFA6_transition
            )

        self.dfa5 = self.DFA5(
            self, 5,
            eot = self.DFA5_eot,
            eof = self.DFA5_eof,
            min = self.DFA5_min,
            max = self.DFA5_max,
            accept = self.DFA5_accept,
            special = self.DFA5_special,
            transition = self.DFA5_transition
            )

        self.dfa8 = self.DFA8(
            self, 8,
            eot = self.DFA8_eot,
            eof = self.DFA8_eof,
            min = self.DFA8_min,
            max = self.DFA8_max,
            accept = self.DFA8_accept,
            special = self.DFA8_special,
            transition = self.DFA8_transition
            )

        self.dfa44 = self.DFA44(
            self, 44,
            eot = self.DFA44_eot,
            eof = self.DFA44_eof,
            min = self.DFA44_min,
            max = self.DFA44_max,
            accept = self.DFA44_accept,
            special = self.DFA44_special,
            transition = self.DFA44_transition
            )

        self.dfa53 = self.DFA53(
            self, 53,
            eot = self.DFA53_eot,
            eof = self.DFA53_eof,
            min = self.DFA53_min,
            max = self.DFA53_max,
            accept = self.DFA53_accept,
            special = self.DFA53_special,
            transition = self.DFA53_transition
            )

        self.dfa80 = self.DFA80(
            self, 80,
            eot = self.DFA80_eot,
            eof = self.DFA80_eof,
            min = self.DFA80_min,
            max = self.DFA80_max,
            accept = self.DFA80_accept,
            special = self.DFA80_special,
            transition = self.DFA80_transition
            )

        self.dfa86 = self.DFA86(
            self, 86,
            eot = self.DFA86_eot,
            eof = self.DFA86_eof,
            min = self.DFA86_min,
            max = self.DFA86_max,
            accept = self.DFA86_accept,
            special = self.DFA86_special,
            transition = self.DFA86_transition
            )

        self.dfa88 = self.DFA88(
            self, 88,
            eot = self.DFA88_eot,
            eof = self.DFA88_eof,
            min = self.DFA88_min,
            max = self.DFA88_max,
            accept = self.DFA88_accept,
            special = self.DFA88_special,
            transition = self.DFA88_transition
            )

        self.dfa87 = self.DFA87(
            self, 87,
            eot = self.DFA87_eot,
            eof = self.DFA87_eof,
            min = self.DFA87_min,
            max = self.DFA87_max,
            accept = self.DFA87_accept,
            special = self.DFA87_special,
            transition = self.DFA87_transition
            )

        self.dfa92 = self.DFA92(
            self, 92,
            eot = self.DFA92_eot,
            eof = self.DFA92_eof,
            min = self.DFA92_min,
            max = self.DFA92_max,
            accept = self.DFA92_accept,
            special = self.DFA92_special,
            transition = self.DFA92_transition
            )

        self.dfa114 = self.DFA114(
            self, 114,
            eot = self.DFA114_eot,
            eof = self.DFA114_eof,
            min = self.DFA114_min,
            max = self.DFA114_max,
            accept = self.DFA114_accept,
            special = self.DFA114_special,
            transition = self.DFA114_transition
            )

        self.dfa115 = self.DFA115(
            self, 115,
            eot = self.DFA115_eot,
            eof = self.DFA115_eof,
            min = self.DFA115_min,
            max = self.DFA115_max,
            accept = self.DFA115_accept,
            special = self.DFA115_special,
            transition = self.DFA115_transition
            )






                
        self._adaptor = CommonTreeAdaptor()


        
    def getTreeAdaptor(self):
        return self._adaptor

    def setTreeAdaptor(self, adaptor):
        self._adaptor = adaptor

    adaptor = property(getTreeAdaptor, setTreeAdaptor)

             
    """Stack of current rules being parsed. Mainly used by the error handler."""
    rules = []

    def parseError(self, message):
    	"""
    	Insert exception in error list, but do not interrupt parser.
    	"""
    	self.reportError(SLIMParserException(message, self.input))


    class specification_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "specification"
    # Slim.g:198:1: specification : ( ( ( packageSpecification | declaration )+ ) | EOF );
    def specification(self, ):

        retval = self.specification_return()
        retval.start = self.input.LT(1)

        root_0 = None

        EOF3 = None
        packageSpecification1 = None

        declaration2 = None


        EOF3_tree = None

        self.rules.append("SLIM specification") 
        try:
            try:
                # Slim.g:201:2: ( ( ( packageSpecification | declaration )+ ) | EOF )
                alt2 = 2
                LA2_0 = self.input.LA(1)

                if (LA2_0 == PACKAGE or LA2_0 == THREAD or LA2_0 == PROCESS or (MEMORY <= LA2_0 <= SYSTEM) or LA2_0 == FDIR or LA2_0 == ERROR) :
                    alt2 = 1
                elif (LA2_0 == EOF) :
                    alt2 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 2, 0, self.input)

                    raise nvae

                if alt2 == 1:
                    # Slim.g:201:4: ( ( packageSpecification | declaration )+ )
                    pass 
                    root_0 = self._adaptor.nil()

                    # Slim.g:201:4: ( ( packageSpecification | declaration )+ )
                    # Slim.g:202:4: ( packageSpecification | declaration )+
                    pass 
                    # Slim.g:202:4: ( packageSpecification | declaration )+
                    cnt1 = 0
                    while True: #loop1
                        alt1 = 3
                        alt1 = self.dfa1.predict(self.input)
                        if alt1 == 1:
                            # Slim.g:202:5: packageSpecification
                            pass 
                            self._state.following.append(self.FOLLOW_packageSpecification_in_specification1031)
                            packageSpecification1 = self.packageSpecification()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                self._adaptor.addChild(root_0, packageSpecification1.tree)


                        elif alt1 == 2:
                            # Slim.g:202:28: declaration
                            pass 
                            self._state.following.append(self.FOLLOW_declaration_in_specification1035)
                            declaration2 = self.declaration()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                self._adaptor.addChild(root_0, declaration2.tree)


                        else:
                            if cnt1 >= 1:
                                break #loop1

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            eee = EarlyExitException(1, self.input)
                            raise eee

                        cnt1 += 1







                elif alt2 == 2:
                    # Slim.g:203:7: EOF
                    pass 
                    root_0 = self._adaptor.nil()

                    if self._state.backtracking == 0:
                        self.parseError("Must declare at least one package or declaration")

                    EOF3=self.match(self.input, EOF, self.FOLLOW_EOF_in_specification1050)
                    if self._state.backtracking == 0:

                        EOF3_tree = self._adaptor.createWithPayload(EOF3)
                        self._adaptor.addChild(root_0, EOF3_tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "specification"

    class packageSpecification_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "packageSpecification"
    # Slim.g:207:1: packageSpecification : PACKAGE IDENT PUBLIC ( ( declaration )+ | ) ( PRIVATE ( ( declaration )+ | ) )? END IDENT SEMICOLON ;
    def packageSpecification(self, ):

        retval = self.packageSpecification_return()
        retval.start = self.input.LT(1)

        root_0 = None

        PACKAGE4 = None
        IDENT5 = None
        PUBLIC6 = None
        PRIVATE8 = None
        END10 = None
        IDENT11 = None
        SEMICOLON12 = None
        declaration7 = None

        declaration9 = None


        PACKAGE4_tree = None
        IDENT5_tree = None
        PUBLIC6_tree = None
        PRIVATE8_tree = None
        END10_tree = None
        IDENT11_tree = None
        SEMICOLON12_tree = None

        self.rules.append("package specification") 
        try:
            try:
                # Slim.g:210:2: ( PACKAGE IDENT PUBLIC ( ( declaration )+ | ) ( PRIVATE ( ( declaration )+ | ) )? END IDENT SEMICOLON )
                # Slim.g:210:4: PACKAGE IDENT PUBLIC ( ( declaration )+ | ) ( PRIVATE ( ( declaration )+ | ) )? END IDENT SEMICOLON
                pass 
                root_0 = self._adaptor.nil()

                PACKAGE4=self.match(self.input, PACKAGE, self.FOLLOW_PACKAGE_in_packageSpecification1072)
                if self._state.backtracking == 0:

                    PACKAGE4_tree = self._adaptor.createWithPayload(PACKAGE4)
                    root_0 = self._adaptor.becomeRoot(PACKAGE4_tree, root_0)

                IDENT5=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_packageSpecification1075)
                if self._state.backtracking == 0:

                    IDENT5_tree = self._adaptor.createWithPayload(IDENT5)
                    self._adaptor.addChild(root_0, IDENT5_tree)

                PUBLIC6=self.match(self.input, PUBLIC, self.FOLLOW_PUBLIC_in_packageSpecification1081)
                if self._state.backtracking == 0:

                    PUBLIC6_tree = self._adaptor.createWithPayload(PUBLIC6)
                    self._adaptor.addChild(root_0, PUBLIC6_tree)

                # Slim.g:211:11: ( ( declaration )+ | )
                alt4 = 2
                alt4 = self.dfa4.predict(self.input)
                if alt4 == 1:
                    # Slim.g:211:12: ( declaration )+
                    pass 
                    # Slim.g:211:12: ( declaration )+
                    cnt3 = 0
                    while True: #loop3
                        alt3 = 2
                        alt3 = self.dfa3.predict(self.input)
                        if alt3 == 1:
                            # Slim.g:0:0: declaration
                            pass 
                            self._state.following.append(self.FOLLOW_declaration_in_packageSpecification1084)
                            declaration7 = self.declaration()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                self._adaptor.addChild(root_0, declaration7.tree)


                        else:
                            if cnt3 >= 1:
                                break #loop3

                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            eee = EarlyExitException(3, self.input)
                            raise eee

                        cnt3 += 1




                elif alt4 == 2:
                    # Slim.g:211:27: 
                    pass 
                    if self._state.backtracking == 0:
                        self.parseError("Expected at least one public declaration")




                # Slim.g:212:4: ( PRIVATE ( ( declaration )+ | ) )?
                alt7 = 2
                LA7_0 = self.input.LA(1)

                if (LA7_0 == PRIVATE) :
                    alt7 = 1
                if alt7 == 1:
                    # Slim.g:212:5: PRIVATE ( ( declaration )+ | )
                    pass 
                    PRIVATE8=self.match(self.input, PRIVATE, self.FOLLOW_PRIVATE_in_packageSpecification1096)
                    if self._state.backtracking == 0:

                        PRIVATE8_tree = self._adaptor.createWithPayload(PRIVATE8)
                        self._adaptor.addChild(root_0, PRIVATE8_tree)

                    # Slim.g:212:13: ( ( declaration )+ | )
                    alt6 = 2
                    alt6 = self.dfa6.predict(self.input)
                    if alt6 == 1:
                        # Slim.g:212:14: ( declaration )+
                        pass 
                        # Slim.g:212:14: ( declaration )+
                        cnt5 = 0
                        while True: #loop5
                            alt5 = 2
                            alt5 = self.dfa5.predict(self.input)
                            if alt5 == 1:
                                # Slim.g:0:0: declaration
                                pass 
                                self._state.following.append(self.FOLLOW_declaration_in_packageSpecification1099)
                                declaration9 = self.declaration()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    self._adaptor.addChild(root_0, declaration9.tree)


                            else:
                                if cnt5 >= 1:
                                    break #loop5

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(5, self.input)
                                raise eee

                            cnt5 += 1




                    elif alt6 == 2:
                        # Slim.g:212:29: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expected private declaration")







                END10=self.match(self.input, END, self.FOLLOW_END_in_packageSpecification1111)
                IDENT11=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_packageSpecification1114)
                if self._state.backtracking == 0:

                    IDENT11_tree = self._adaptor.createWithPayload(IDENT11)
                    self._adaptor.addChild(root_0, IDENT11_tree)

                SEMICOLON12=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_packageSpecification1116)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "packageSpecification"

    class declaration_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "declaration"
    # Slim.g:216:1: declaration : ({...}? => componentType | {...}? => componentImplementation | {...}? => errorType | {...}? => errorImplementation );
    def declaration(self, ):

        retval = self.declaration_return()
        retval.start = self.input.LT(1)

        root_0 = None

        componentType13 = None

        componentImplementation14 = None

        errorType15 = None

        errorImplementation16 = None



        try:
            try:
                # Slim.g:217:2: ({...}? => componentType | {...}? => componentImplementation | {...}? => errorType | {...}? => errorImplementation )
                alt8 = 4
                alt8 = self.dfa8.predict(self.input)
                if alt8 == 1:
                    # Slim.g:217:4: {...}? => componentType
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "declaration", "globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL")

                    self._state.following.append(self.FOLLOW_componentType_in_declaration1132)
                    componentType13 = self.componentType()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, componentType13.tree)


                elif alt8 == 2:
                    # Slim.g:218:4: {...}? => componentImplementation
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "declaration", "globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL")

                    self._state.following.append(self.FOLLOW_componentImplementation_in_declaration1140)
                    componentImplementation14 = self.componentImplementation()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, componentImplementation14.tree)


                elif alt8 == 3:
                    # Slim.g:219:4: {...}? => errorType
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((globals.PARSER_ACCEPT_ERROR)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "declaration", "globals.PARSER_ACCEPT_ERROR")

                    self._state.following.append(self.FOLLOW_errorType_in_declaration1148)
                    errorType15 = self.errorType()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, errorType15.tree)


                elif alt8 == 4:
                    # Slim.g:220:4: {...}? => errorImplementation
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((globals.PARSER_ACCEPT_ERROR)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "declaration", "globals.PARSER_ACCEPT_ERROR")

                    self._state.following.append(self.FOLLOW_errorImplementation_in_declaration1156)
                    errorImplementation16 = self.errorImplementation()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, errorImplementation16.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "declaration"

    class componentType_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "componentType"
    # Slim.g:223:1: componentType : ({...}? => ( FDIR )? ) componentCategory IDENT ( FEATURES ( ( portSpec )+ | ) )? END IDENT SEMICOLON -> ^( COMP_TYPE ( FDIR )? componentCategory IDENT ( portSpec )* IDENT ) ;
    def componentType(self, ):

        retval = self.componentType_return()
        retval.start = self.input.LT(1)

        root_0 = None

        FDIR17 = None
        IDENT19 = None
        FEATURES20 = None
        END22 = None
        IDENT23 = None
        SEMICOLON24 = None
        componentCategory18 = None

        portSpec21 = None


        FDIR17_tree = None
        IDENT19_tree = None
        FEATURES20_tree = None
        END22_tree = None
        IDENT23_tree = None
        SEMICOLON24_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_FDIR = RewriteRuleTokenStream(self._adaptor, "token FDIR")
        stream_END = RewriteRuleTokenStream(self._adaptor, "token END")
        stream_FEATURES = RewriteRuleTokenStream(self._adaptor, "token FEATURES")
        stream_portSpec = RewriteRuleSubtreeStream(self._adaptor, "rule portSpec")
        stream_componentCategory = RewriteRuleSubtreeStream(self._adaptor, "rule componentCategory")
        self.rules.append("component specification") 
        try:
            try:
                # Slim.g:226:2: ( ({...}? => ( FDIR )? ) componentCategory IDENT ( FEATURES ( ( portSpec )+ | ) )? END IDENT SEMICOLON -> ^( COMP_TYPE ( FDIR )? componentCategory IDENT ( portSpec )* IDENT ) )
                # Slim.g:226:4: ({...}? => ( FDIR )? ) componentCategory IDENT ( FEATURES ( ( portSpec )+ | ) )? END IDENT SEMICOLON
                pass 
                # Slim.g:226:4: ({...}? => ( FDIR )? )
                # Slim.g:226:5: {...}? => ( FDIR )?
                pass 
                if not ((globals.PARSER_ACCEPT_NOMINAL)):
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    raise FailedPredicateException(self.input, "componentType", "globals.PARSER_ACCEPT_NOMINAL")

                # Slim.g:226:40: ( FDIR )?
                alt9 = 2
                LA9_0 = self.input.LA(1)

                if (LA9_0 == FDIR) :
                    alt9 = 1
                if alt9 == 1:
                    # Slim.g:226:41: FDIR
                    pass 
                    FDIR17=self.match(self.input, FDIR, self.FOLLOW_FDIR_in_componentType1183) 
                    if self._state.backtracking == 0:
                        stream_FDIR.add(FDIR17)






                self._state.following.append(self.FOLLOW_componentCategory_in_componentType1188)
                componentCategory18 = self.componentCategory()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_componentCategory.add(componentCategory18.tree)
                IDENT19=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_componentType1190) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT19)
                # Slim.g:227:4: ( FEATURES ( ( portSpec )+ | ) )?
                alt12 = 2
                LA12_0 = self.input.LA(1)

                if (LA12_0 == FEATURES) :
                    alt12 = 1
                if alt12 == 1:
                    # Slim.g:227:5: FEATURES ( ( portSpec )+ | )
                    pass 
                    FEATURES20=self.match(self.input, FEATURES, self.FOLLOW_FEATURES_in_componentType1196) 
                    if self._state.backtracking == 0:
                        stream_FEATURES.add(FEATURES20)
                    # Slim.g:227:14: ( ( portSpec )+ | )
                    alt11 = 2
                    LA11_0 = self.input.LA(1)

                    if (LA11_0 == IDENT) :
                        alt11 = 1
                    elif (LA11_0 == END) :
                        alt11 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 11, 0, self.input)

                        raise nvae

                    if alt11 == 1:
                        # Slim.g:227:15: ( portSpec )+
                        pass 
                        # Slim.g:227:15: ( portSpec )+
                        cnt10 = 0
                        while True: #loop10
                            alt10 = 2
                            LA10_0 = self.input.LA(1)

                            if (LA10_0 == IDENT) :
                                alt10 = 1


                            if alt10 == 1:
                                # Slim.g:0:0: portSpec
                                pass 
                                self._state.following.append(self.FOLLOW_portSpec_in_componentType1199)
                                portSpec21 = self.portSpec()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_portSpec.add(portSpec21.tree)


                            else:
                                if cnt10 >= 1:
                                    break #loop10

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(10, self.input)
                                raise eee

                            cnt10 += 1




                    elif alt11 == 2:
                        # Slim.g:227:27: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting feature declaration")







                END22=self.match(self.input, END, self.FOLLOW_END_in_componentType1211) 
                if self._state.backtracking == 0:
                    stream_END.add(END22)
                IDENT23=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_componentType1213) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT23)
                SEMICOLON24=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_componentType1215) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON24)

                # AST Rewrite
                # elements: IDENT, componentCategory, IDENT, portSpec, FDIR
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 229:3: -> ^( COMP_TYPE ( FDIR )? componentCategory IDENT ( portSpec )* IDENT )
                    # Slim.g:229:6: ^( COMP_TYPE ( FDIR )? componentCategory IDENT ( portSpec )* IDENT )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(COMP_TYPE, "COMP_TYPE"), root_1)

                    # Slim.g:229:18: ( FDIR )?
                    if stream_FDIR.hasNext():
                        self._adaptor.addChild(root_1, stream_FDIR.nextNode())


                    stream_FDIR.reset();
                    self._adaptor.addChild(root_1, stream_componentCategory.nextTree())
                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    # Slim.g:229:50: ( portSpec )*
                    while stream_portSpec.hasNext():
                        self._adaptor.addChild(root_1, stream_portSpec.nextTree())


                    stream_portSpec.reset();
                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "componentType"

    class componentImplementation_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "componentImplementation"
    # Slim.g:232:1: componentImplementation : ({...}? => ( FDIR )? ) componentCategory IMPLEMENTATION name ( SUBCOMPONENTS ( ( subcomponent )+ | ) )? ( CONNECTIONS ( ( portConnection )+ | ) )? ( FLOWS ( ( flow )+ | ) )? ( MODES ( ( mode )+ | ) ( TRANSITIONS ( ( modeTransition )+ | ) )? )? END name SEMICOLON -> ^( COMP_IMPL ( FDIR )? componentCategory name ( subcomponent )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* name ) ;
    def componentImplementation(self, ):

        retval = self.componentImplementation_return()
        retval.start = self.input.LT(1)

        root_0 = None

        FDIR25 = None
        IMPLEMENTATION27 = None
        SUBCOMPONENTS29 = None
        CONNECTIONS31 = None
        FLOWS33 = None
        MODES35 = None
        TRANSITIONS37 = None
        END39 = None
        SEMICOLON41 = None
        componentCategory26 = None

        name28 = None

        subcomponent30 = None

        portConnection32 = None

        flow34 = None

        mode36 = None

        modeTransition38 = None

        name40 = None


        FDIR25_tree = None
        IMPLEMENTATION27_tree = None
        SUBCOMPONENTS29_tree = None
        CONNECTIONS31_tree = None
        FLOWS33_tree = None
        MODES35_tree = None
        TRANSITIONS37_tree = None
        END39_tree = None
        SEMICOLON41_tree = None
        stream_MODES = RewriteRuleTokenStream(self._adaptor, "token MODES")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_FDIR = RewriteRuleTokenStream(self._adaptor, "token FDIR")
        stream_IMPLEMENTATION = RewriteRuleTokenStream(self._adaptor, "token IMPLEMENTATION")
        stream_END = RewriteRuleTokenStream(self._adaptor, "token END")
        stream_CONNECTIONS = RewriteRuleTokenStream(self._adaptor, "token CONNECTIONS")
        stream_FLOWS = RewriteRuleTokenStream(self._adaptor, "token FLOWS")
        stream_TRANSITIONS = RewriteRuleTokenStream(self._adaptor, "token TRANSITIONS")
        stream_SUBCOMPONENTS = RewriteRuleTokenStream(self._adaptor, "token SUBCOMPONENTS")
        stream_mode = RewriteRuleSubtreeStream(self._adaptor, "rule mode")
        stream_subcomponent = RewriteRuleSubtreeStream(self._adaptor, "rule subcomponent")
        stream_modeTransition = RewriteRuleSubtreeStream(self._adaptor, "rule modeTransition")
        stream_portConnection = RewriteRuleSubtreeStream(self._adaptor, "rule portConnection")
        stream_name = RewriteRuleSubtreeStream(self._adaptor, "rule name")
        stream_componentCategory = RewriteRuleSubtreeStream(self._adaptor, "rule componentCategory")
        stream_flow = RewriteRuleSubtreeStream(self._adaptor, "rule flow")
        self.rules.append("component implementation") 
        try:
            try:
                # Slim.g:235:2: ( ({...}? => ( FDIR )? ) componentCategory IMPLEMENTATION name ( SUBCOMPONENTS ( ( subcomponent )+ | ) )? ( CONNECTIONS ( ( portConnection )+ | ) )? ( FLOWS ( ( flow )+ | ) )? ( MODES ( ( mode )+ | ) ( TRANSITIONS ( ( modeTransition )+ | ) )? )? END name SEMICOLON -> ^( COMP_IMPL ( FDIR )? componentCategory name ( subcomponent )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* name ) )
                # Slim.g:235:7: ({...}? => ( FDIR )? ) componentCategory IMPLEMENTATION name ( SUBCOMPONENTS ( ( subcomponent )+ | ) )? ( CONNECTIONS ( ( portConnection )+ | ) )? ( FLOWS ( ( flow )+ | ) )? ( MODES ( ( mode )+ | ) ( TRANSITIONS ( ( modeTransition )+ | ) )? )? END name SEMICOLON
                pass 
                # Slim.g:235:7: ({...}? => ( FDIR )? )
                # Slim.g:235:8: {...}? => ( FDIR )?
                pass 
                if not ((globals.PARSER_ACCEPT_FDIR)):
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    raise FailedPredicateException(self.input, "componentImplementation", "globals.PARSER_ACCEPT_FDIR")

                # Slim.g:235:40: ( FDIR )?
                alt13 = 2
                LA13_0 = self.input.LA(1)

                if (LA13_0 == FDIR) :
                    alt13 = 1
                if alt13 == 1:
                    # Slim.g:235:41: FDIR
                    pass 
                    FDIR25=self.match(self.input, FDIR, self.FOLLOW_FDIR_in_componentImplementation1266) 
                    if self._state.backtracking == 0:
                        stream_FDIR.add(FDIR25)






                self._state.following.append(self.FOLLOW_componentCategory_in_componentImplementation1271)
                componentCategory26 = self.componentCategory()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_componentCategory.add(componentCategory26.tree)
                IMPLEMENTATION27=self.match(self.input, IMPLEMENTATION, self.FOLLOW_IMPLEMENTATION_in_componentImplementation1273) 
                if self._state.backtracking == 0:
                    stream_IMPLEMENTATION.add(IMPLEMENTATION27)
                self._state.following.append(self.FOLLOW_name_in_componentImplementation1275)
                name28 = self.name()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_name.add(name28.tree)
                # Slim.g:236:4: ( SUBCOMPONENTS ( ( subcomponent )+ | ) )?
                alt16 = 2
                LA16_0 = self.input.LA(1)

                if (LA16_0 == SUBCOMPONENTS) :
                    alt16 = 1
                if alt16 == 1:
                    # Slim.g:236:5: SUBCOMPONENTS ( ( subcomponent )+ | )
                    pass 
                    SUBCOMPONENTS29=self.match(self.input, SUBCOMPONENTS, self.FOLLOW_SUBCOMPONENTS_in_componentImplementation1281) 
                    if self._state.backtracking == 0:
                        stream_SUBCOMPONENTS.add(SUBCOMPONENTS29)
                    # Slim.g:236:19: ( ( subcomponent )+ | )
                    alt15 = 2
                    LA15_0 = self.input.LA(1)

                    if (LA15_0 == IDENT) :
                        alt15 = 1
                    elif (LA15_0 == END or (CONNECTIONS <= LA15_0 <= MODES) or LA15_0 == FLOWS) :
                        alt15 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 15, 0, self.input)

                        raise nvae

                    if alt15 == 1:
                        # Slim.g:236:20: ( subcomponent )+
                        pass 
                        # Slim.g:236:20: ( subcomponent )+
                        cnt14 = 0
                        while True: #loop14
                            alt14 = 2
                            LA14_0 = self.input.LA(1)

                            if (LA14_0 == IDENT) :
                                alt14 = 1


                            if alt14 == 1:
                                # Slim.g:0:0: subcomponent
                                pass 
                                self._state.following.append(self.FOLLOW_subcomponent_in_componentImplementation1284)
                                subcomponent30 = self.subcomponent()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_subcomponent.add(subcomponent30.tree)


                            else:
                                if cnt14 >= 1:
                                    break #loop14

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(14, self.input)
                                raise eee

                            cnt14 += 1




                    elif alt15 == 2:
                        # Slim.g:236:36: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting subcomponent specification")







                # Slim.g:237:4: ( CONNECTIONS ( ( portConnection )+ | ) )?
                alt19 = 2
                LA19_0 = self.input.LA(1)

                if (LA19_0 == CONNECTIONS) :
                    alt19 = 1
                if alt19 == 1:
                    # Slim.g:237:5: CONNECTIONS ( ( portConnection )+ | )
                    pass 
                    CONNECTIONS31=self.match(self.input, CONNECTIONS, self.FOLLOW_CONNECTIONS_in_componentImplementation1298) 
                    if self._state.backtracking == 0:
                        stream_CONNECTIONS.add(CONNECTIONS31)
                    # Slim.g:237:17: ( ( portConnection )+ | )
                    alt18 = 2
                    LA18_0 = self.input.LA(1)

                    if (LA18_0 == DATA or LA18_0 == EVENT) :
                        alt18 = 1
                    elif (LA18_0 == END or LA18_0 == MODES or LA18_0 == FLOWS) :
                        alt18 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 18, 0, self.input)

                        raise nvae

                    if alt18 == 1:
                        # Slim.g:237:18: ( portConnection )+
                        pass 
                        # Slim.g:237:18: ( portConnection )+
                        cnt17 = 0
                        while True: #loop17
                            alt17 = 2
                            LA17_0 = self.input.LA(1)

                            if (LA17_0 == DATA or LA17_0 == EVENT) :
                                alt17 = 1


                            if alt17 == 1:
                                # Slim.g:0:0: portConnection
                                pass 
                                self._state.following.append(self.FOLLOW_portConnection_in_componentImplementation1301)
                                portConnection32 = self.portConnection()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_portConnection.add(portConnection32.tree)


                            else:
                                if cnt17 >= 1:
                                    break #loop17

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(17, self.input)
                                raise eee

                            cnt17 += 1




                    elif alt18 == 2:
                        # Slim.g:237:36: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting port connection")







                # Slim.g:238:4: ( FLOWS ( ( flow )+ | ) )?
                alt22 = 2
                LA22_0 = self.input.LA(1)

                if (LA22_0 == FLOWS) :
                    alt22 = 1
                if alt22 == 1:
                    # Slim.g:238:5: FLOWS ( ( flow )+ | )
                    pass 
                    FLOWS33=self.match(self.input, FLOWS, self.FOLLOW_FLOWS_in_componentImplementation1315) 
                    if self._state.backtracking == 0:
                        stream_FLOWS.add(FLOWS33)
                    # Slim.g:238:11: ( ( flow )+ | )
                    alt21 = 2
                    LA21_0 = self.input.LA(1)

                    if (LA21_0 == IDENT) :
                        alt21 = 1
                    elif (LA21_0 == END or LA21_0 == MODES) :
                        alt21 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 21, 0, self.input)

                        raise nvae

                    if alt21 == 1:
                        # Slim.g:238:12: ( flow )+
                        pass 
                        # Slim.g:238:12: ( flow )+
                        cnt20 = 0
                        while True: #loop20
                            alt20 = 2
                            LA20_0 = self.input.LA(1)

                            if (LA20_0 == IDENT) :
                                alt20 = 1


                            if alt20 == 1:
                                # Slim.g:0:0: flow
                                pass 
                                self._state.following.append(self.FOLLOW_flow_in_componentImplementation1318)
                                flow34 = self.flow()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_flow.add(flow34.tree)


                            else:
                                if cnt20 >= 1:
                                    break #loop20

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(20, self.input)
                                raise eee

                            cnt20 += 1




                    elif alt21 == 2:
                        # Slim.g:238:20: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting flow specification")







                # Slim.g:239:4: ( MODES ( ( mode )+ | ) ( TRANSITIONS ( ( modeTransition )+ | ) )? )?
                alt28 = 2
                LA28_0 = self.input.LA(1)

                if (LA28_0 == MODES) :
                    alt28 = 1
                if alt28 == 1:
                    # Slim.g:239:5: MODES ( ( mode )+ | ) ( TRANSITIONS ( ( modeTransition )+ | ) )?
                    pass 
                    MODES35=self.match(self.input, MODES, self.FOLLOW_MODES_in_componentImplementation1332) 
                    if self._state.backtracking == 0:
                        stream_MODES.add(MODES35)
                    # Slim.g:239:11: ( ( mode )+ | )
                    alt24 = 2
                    LA24_0 = self.input.LA(1)

                    if (LA24_0 == IDENT) :
                        alt24 = 1
                    elif (LA24_0 == END or LA24_0 == TRANSITIONS) :
                        alt24 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 24, 0, self.input)

                        raise nvae

                    if alt24 == 1:
                        # Slim.g:239:12: ( mode )+
                        pass 
                        # Slim.g:239:12: ( mode )+
                        cnt23 = 0
                        while True: #loop23
                            alt23 = 2
                            LA23_0 = self.input.LA(1)

                            if (LA23_0 == IDENT) :
                                alt23 = 1


                            if alt23 == 1:
                                # Slim.g:0:0: mode
                                pass 
                                self._state.following.append(self.FOLLOW_mode_in_componentImplementation1335)
                                mode36 = self.mode()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_mode.add(mode36.tree)


                            else:
                                if cnt23 >= 1:
                                    break #loop23

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(23, self.input)
                                raise eee

                            cnt23 += 1




                    elif alt24 == 2:
                        # Slim.g:239:20: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting mode specification")




                    # Slim.g:239:71: ( TRANSITIONS ( ( modeTransition )+ | ) )?
                    alt27 = 2
                    LA27_0 = self.input.LA(1)

                    if (LA27_0 == TRANSITIONS) :
                        alt27 = 1
                    if alt27 == 1:
                        # Slim.g:239:72: TRANSITIONS ( ( modeTransition )+ | )
                        pass 
                        TRANSITIONS37=self.match(self.input, TRANSITIONS, self.FOLLOW_TRANSITIONS_in_componentImplementation1344) 
                        if self._state.backtracking == 0:
                            stream_TRANSITIONS.add(TRANSITIONS37)
                        # Slim.g:239:84: ( ( modeTransition )+ | )
                        alt26 = 2
                        LA26_0 = self.input.LA(1)

                        if (LA26_0 == TIMES or LA26_0 == IDENT) :
                            alt26 = 1
                        elif (LA26_0 == END) :
                            alt26 = 2
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 26, 0, self.input)

                            raise nvae

                        if alt26 == 1:
                            # Slim.g:239:85: ( modeTransition )+
                            pass 
                            # Slim.g:239:85: ( modeTransition )+
                            cnt25 = 0
                            while True: #loop25
                                alt25 = 2
                                LA25_0 = self.input.LA(1)

                                if (LA25_0 == TIMES or LA25_0 == IDENT) :
                                    alt25 = 1


                                if alt25 == 1:
                                    # Slim.g:0:0: modeTransition
                                    pass 
                                    self._state.following.append(self.FOLLOW_modeTransition_in_componentImplementation1347)
                                    modeTransition38 = self.modeTransition()

                                    self._state.following.pop()
                                    if self._state.backtracking == 0:
                                        stream_modeTransition.add(modeTransition38.tree)


                                else:
                                    if cnt25 >= 1:
                                        break #loop25

                                    if self._state.backtracking > 0:
                                        raise BacktrackingFailed

                                    eee = EarlyExitException(25, self.input)
                                    raise eee

                                cnt25 += 1




                        elif alt26 == 2:
                            # Slim.g:239:102: 
                            pass 
                            if self._state.backtracking == 0:
                                self.parseError("Expecting mode transition")










                END39=self.match(self.input, END, self.FOLLOW_END_in_componentImplementation1360) 
                if self._state.backtracking == 0:
                    stream_END.add(END39)
                self._state.following.append(self.FOLLOW_name_in_componentImplementation1362)
                name40 = self.name()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_name.add(name40.tree)
                SEMICOLON41=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_componentImplementation1364) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON41)

                # AST Rewrite
                # elements: name, name, flow, mode, portConnection, modeTransition, componentCategory, FDIR, subcomponent
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 241:3: -> ^( COMP_IMPL ( FDIR )? componentCategory name ( subcomponent )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* name )
                    # Slim.g:241:6: ^( COMP_IMPL ( FDIR )? componentCategory name ( subcomponent )* ( portConnection )* ( flow )* ( mode )* ( modeTransition )* name )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(COMP_IMPL, "COMP_IMPL"), root_1)

                    # Slim.g:241:18: ( FDIR )?
                    if stream_FDIR.hasNext():
                        self._adaptor.addChild(root_1, stream_FDIR.nextNode())


                    stream_FDIR.reset();
                    self._adaptor.addChild(root_1, stream_componentCategory.nextTree())
                    self._adaptor.addChild(root_1, stream_name.nextTree())
                    # Slim.g:241:49: ( subcomponent )*
                    while stream_subcomponent.hasNext():
                        self._adaptor.addChild(root_1, stream_subcomponent.nextTree())


                    stream_subcomponent.reset();
                    # Slim.g:241:63: ( portConnection )*
                    while stream_portConnection.hasNext():
                        self._adaptor.addChild(root_1, stream_portConnection.nextTree())


                    stream_portConnection.reset();
                    # Slim.g:241:79: ( flow )*
                    while stream_flow.hasNext():
                        self._adaptor.addChild(root_1, stream_flow.nextTree())


                    stream_flow.reset();
                    # Slim.g:241:85: ( mode )*
                    while stream_mode.hasNext():
                        self._adaptor.addChild(root_1, stream_mode.nextTree())


                    stream_mode.reset();
                    # Slim.g:241:91: ( modeTransition )*
                    while stream_modeTransition.hasNext():
                        self._adaptor.addChild(root_1, stream_modeTransition.nextTree())


                    stream_modeTransition.reset();
                    self._adaptor.addChild(root_1, stream_name.nextTree())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "componentImplementation"

    class errorType_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorType"
    # Slim.g:244:1: errorType : ERROR MODEL IDENT ( FEATURES ( ( errorFeature )+ | ) )? END IDENT SEMICOLON -> ^( ERR_TYPE IDENT ( errorFeature )* IDENT ) ;
    def errorType(self, ):

        retval = self.errorType_return()
        retval.start = self.input.LT(1)

        root_0 = None

        ERROR42 = None
        MODEL43 = None
        IDENT44 = None
        FEATURES45 = None
        END47 = None
        IDENT48 = None
        SEMICOLON49 = None
        errorFeature46 = None


        ERROR42_tree = None
        MODEL43_tree = None
        IDENT44_tree = None
        FEATURES45_tree = None
        END47_tree = None
        IDENT48_tree = None
        SEMICOLON49_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")
        stream_END = RewriteRuleTokenStream(self._adaptor, "token END")
        stream_MODEL = RewriteRuleTokenStream(self._adaptor, "token MODEL")
        stream_FEATURES = RewriteRuleTokenStream(self._adaptor, "token FEATURES")
        stream_errorFeature = RewriteRuleSubtreeStream(self._adaptor, "rule errorFeature")
        self.rules.append("error specification") 
        try:
            try:
                # Slim.g:247:2: ( ERROR MODEL IDENT ( FEATURES ( ( errorFeature )+ | ) )? END IDENT SEMICOLON -> ^( ERR_TYPE IDENT ( errorFeature )* IDENT ) )
                # Slim.g:247:4: ERROR MODEL IDENT ( FEATURES ( ( errorFeature )+ | ) )? END IDENT SEMICOLON
                pass 
                ERROR42=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_errorType1420) 
                if self._state.backtracking == 0:
                    stream_ERROR.add(ERROR42)
                MODEL43=self.match(self.input, MODEL, self.FOLLOW_MODEL_in_errorType1422) 
                if self._state.backtracking == 0:
                    stream_MODEL.add(MODEL43)
                IDENT44=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorType1424) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT44)
                # Slim.g:248:4: ( FEATURES ( ( errorFeature )+ | ) )?
                alt31 = 2
                LA31_0 = self.input.LA(1)

                if (LA31_0 == FEATURES) :
                    alt31 = 1
                if alt31 == 1:
                    # Slim.g:248:5: FEATURES ( ( errorFeature )+ | )
                    pass 
                    FEATURES45=self.match(self.input, FEATURES, self.FOLLOW_FEATURES_in_errorType1431) 
                    if self._state.backtracking == 0:
                        stream_FEATURES.add(FEATURES45)
                    # Slim.g:248:14: ( ( errorFeature )+ | )
                    alt30 = 2
                    LA30_0 = self.input.LA(1)

                    if (LA30_0 == IDENT) :
                        alt30 = 1
                    elif (LA30_0 == END) :
                        alt30 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 30, 0, self.input)

                        raise nvae

                    if alt30 == 1:
                        # Slim.g:248:15: ( errorFeature )+
                        pass 
                        # Slim.g:248:15: ( errorFeature )+
                        cnt29 = 0
                        while True: #loop29
                            alt29 = 2
                            LA29_0 = self.input.LA(1)

                            if (LA29_0 == IDENT) :
                                alt29 = 1


                            if alt29 == 1:
                                # Slim.g:0:0: errorFeature
                                pass 
                                self._state.following.append(self.FOLLOW_errorFeature_in_errorType1434)
                                errorFeature46 = self.errorFeature()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_errorFeature.add(errorFeature46.tree)


                            else:
                                if cnt29 >= 1:
                                    break #loop29

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(29, self.input)
                                raise eee

                            cnt29 += 1




                    elif alt30 == 2:
                        # Slim.g:248:31: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting error feature")







                END47=self.match(self.input, END, self.FOLLOW_END_in_errorType1446) 
                if self._state.backtracking == 0:
                    stream_END.add(END47)
                IDENT48=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorType1448) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT48)
                SEMICOLON49=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorType1450) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON49)

                # AST Rewrite
                # elements: errorFeature, IDENT, IDENT
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 250:3: -> ^( ERR_TYPE IDENT ( errorFeature )* IDENT )
                    # Slim.g:250:6: ^( ERR_TYPE IDENT ( errorFeature )* IDENT )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ERR_TYPE, "ERR_TYPE"), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    # Slim.g:250:23: ( errorFeature )*
                    while stream_errorFeature.hasNext():
                        self._adaptor.addChild(root_1, stream_errorFeature.nextTree())


                    stream_errorFeature.reset();
                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorType"

    class errorImplementation_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorImplementation"
    # Slim.g:253:1: errorImplementation : ERROR MODEL IMPLEMENTATION name ( EVENTS ( ( errorEvent )+ | ) )? ( CLOCKS ( ( errorClock )+ | ) )? ( STATES ( ( errorState )+ | ) )? ( TRANSITIONS ( ( errorTransition )+ | ) )? END name SEMICOLON -> ^( ERR_IMPL name ( errorClock )* ( errorState )* ( errorEvent )* ( errorTransition )* name ) ;
    def errorImplementation(self, ):

        retval = self.errorImplementation_return()
        retval.start = self.input.LT(1)

        root_0 = None

        ERROR50 = None
        MODEL51 = None
        IMPLEMENTATION52 = None
        EVENTS54 = None
        CLOCKS56 = None
        STATES58 = None
        TRANSITIONS60 = None
        END62 = None
        SEMICOLON64 = None
        name53 = None

        errorEvent55 = None

        errorClock57 = None

        errorState59 = None

        errorTransition61 = None

        name63 = None


        ERROR50_tree = None
        MODEL51_tree = None
        IMPLEMENTATION52_tree = None
        EVENTS54_tree = None
        CLOCKS56_tree = None
        STATES58_tree = None
        TRANSITIONS60_tree = None
        END62_tree = None
        SEMICOLON64_tree = None
        stream_STATES = RewriteRuleTokenStream(self._adaptor, "token STATES")
        stream_EVENTS = RewriteRuleTokenStream(self._adaptor, "token EVENTS")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_IMPLEMENTATION = RewriteRuleTokenStream(self._adaptor, "token IMPLEMENTATION")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")
        stream_END = RewriteRuleTokenStream(self._adaptor, "token END")
        stream_MODEL = RewriteRuleTokenStream(self._adaptor, "token MODEL")
        stream_TRANSITIONS = RewriteRuleTokenStream(self._adaptor, "token TRANSITIONS")
        stream_CLOCKS = RewriteRuleTokenStream(self._adaptor, "token CLOCKS")
        stream_errorState = RewriteRuleSubtreeStream(self._adaptor, "rule errorState")
        stream_errorTransition = RewriteRuleSubtreeStream(self._adaptor, "rule errorTransition")
        stream_name = RewriteRuleSubtreeStream(self._adaptor, "rule name")
        stream_errorEvent = RewriteRuleSubtreeStream(self._adaptor, "rule errorEvent")
        stream_errorClock = RewriteRuleSubtreeStream(self._adaptor, "rule errorClock")
        self.rules.append("error implementation") 
        try:
            try:
                # Slim.g:256:2: ( ERROR MODEL IMPLEMENTATION name ( EVENTS ( ( errorEvent )+ | ) )? ( CLOCKS ( ( errorClock )+ | ) )? ( STATES ( ( errorState )+ | ) )? ( TRANSITIONS ( ( errorTransition )+ | ) )? END name SEMICOLON -> ^( ERR_IMPL name ( errorClock )* ( errorState )* ( errorEvent )* ( errorTransition )* name ) )
                # Slim.g:256:4: ERROR MODEL IMPLEMENTATION name ( EVENTS ( ( errorEvent )+ | ) )? ( CLOCKS ( ( errorClock )+ | ) )? ( STATES ( ( errorState )+ | ) )? ( TRANSITIONS ( ( errorTransition )+ | ) )? END name SEMICOLON
                pass 
                ERROR50=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_errorImplementation1486) 
                if self._state.backtracking == 0:
                    stream_ERROR.add(ERROR50)
                MODEL51=self.match(self.input, MODEL, self.FOLLOW_MODEL_in_errorImplementation1488) 
                if self._state.backtracking == 0:
                    stream_MODEL.add(MODEL51)
                IMPLEMENTATION52=self.match(self.input, IMPLEMENTATION, self.FOLLOW_IMPLEMENTATION_in_errorImplementation1490) 
                if self._state.backtracking == 0:
                    stream_IMPLEMENTATION.add(IMPLEMENTATION52)
                self._state.following.append(self.FOLLOW_name_in_errorImplementation1492)
                name53 = self.name()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_name.add(name53.tree)
                # Slim.g:257:4: ( EVENTS ( ( errorEvent )+ | ) )?
                alt34 = 2
                LA34_0 = self.input.LA(1)

                if (LA34_0 == EVENTS) :
                    alt34 = 1
                if alt34 == 1:
                    # Slim.g:257:5: EVENTS ( ( errorEvent )+ | )
                    pass 
                    EVENTS54=self.match(self.input, EVENTS, self.FOLLOW_EVENTS_in_errorImplementation1498) 
                    if self._state.backtracking == 0:
                        stream_EVENTS.add(EVENTS54)
                    # Slim.g:257:12: ( ( errorEvent )+ | )
                    alt33 = 2
                    LA33_0 = self.input.LA(1)

                    if (LA33_0 == IDENT) :
                        alt33 = 1
                    elif (LA33_0 == END or LA33_0 == TRANSITIONS or LA33_0 == STATES or LA33_0 == CLOCKS) :
                        alt33 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 33, 0, self.input)

                        raise nvae

                    if alt33 == 1:
                        # Slim.g:257:13: ( errorEvent )+
                        pass 
                        # Slim.g:257:13: ( errorEvent )+
                        cnt32 = 0
                        while True: #loop32
                            alt32 = 2
                            LA32_0 = self.input.LA(1)

                            if (LA32_0 == IDENT) :
                                alt32 = 1


                            if alt32 == 1:
                                # Slim.g:0:0: errorEvent
                                pass 
                                self._state.following.append(self.FOLLOW_errorEvent_in_errorImplementation1501)
                                errorEvent55 = self.errorEvent()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_errorEvent.add(errorEvent55.tree)


                            else:
                                if cnt32 >= 1:
                                    break #loop32

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(32, self.input)
                                raise eee

                            cnt32 += 1




                    elif alt33 == 2:
                        # Slim.g:257:27: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting error event")







                # Slim.g:258:4: ( CLOCKS ( ( errorClock )+ | ) )?
                alt37 = 2
                LA37_0 = self.input.LA(1)

                if (LA37_0 == CLOCKS) :
                    alt37 = 1
                if alt37 == 1:
                    # Slim.g:258:5: CLOCKS ( ( errorClock )+ | )
                    pass 
                    CLOCKS56=self.match(self.input, CLOCKS, self.FOLLOW_CLOCKS_in_errorImplementation1515) 
                    if self._state.backtracking == 0:
                        stream_CLOCKS.add(CLOCKS56)
                    # Slim.g:258:12: ( ( errorClock )+ | )
                    alt36 = 2
                    LA36_0 = self.input.LA(1)

                    if (LA36_0 == IDENT) :
                        alt36 = 1
                    elif (LA36_0 == END or LA36_0 == TRANSITIONS or LA36_0 == STATES) :
                        alt36 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 36, 0, self.input)

                        raise nvae

                    if alt36 == 1:
                        # Slim.g:258:13: ( errorClock )+
                        pass 
                        # Slim.g:258:13: ( errorClock )+
                        cnt35 = 0
                        while True: #loop35
                            alt35 = 2
                            LA35_0 = self.input.LA(1)

                            if (LA35_0 == IDENT) :
                                alt35 = 1


                            if alt35 == 1:
                                # Slim.g:0:0: errorClock
                                pass 
                                self._state.following.append(self.FOLLOW_errorClock_in_errorImplementation1518)
                                errorClock57 = self.errorClock()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_errorClock.add(errorClock57.tree)


                            else:
                                if cnt35 >= 1:
                                    break #loop35

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(35, self.input)
                                raise eee

                            cnt35 += 1




                    elif alt36 == 2:
                        # Slim.g:258:27: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting error clock")







                # Slim.g:259:4: ( STATES ( ( errorState )+ | ) )?
                alt40 = 2
                LA40_0 = self.input.LA(1)

                if (LA40_0 == STATES) :
                    alt40 = 1
                if alt40 == 1:
                    # Slim.g:259:5: STATES ( ( errorState )+ | )
                    pass 
                    STATES58=self.match(self.input, STATES, self.FOLLOW_STATES_in_errorImplementation1532) 
                    if self._state.backtracking == 0:
                        stream_STATES.add(STATES58)
                    # Slim.g:259:12: ( ( errorState )+ | )
                    alt39 = 2
                    LA39_0 = self.input.LA(1)

                    if (LA39_0 == IDENT) :
                        alt39 = 1
                    elif (LA39_0 == END or LA39_0 == TRANSITIONS) :
                        alt39 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 39, 0, self.input)

                        raise nvae

                    if alt39 == 1:
                        # Slim.g:259:13: ( errorState )+
                        pass 
                        # Slim.g:259:13: ( errorState )+
                        cnt38 = 0
                        while True: #loop38
                            alt38 = 2
                            LA38_0 = self.input.LA(1)

                            if (LA38_0 == IDENT) :
                                alt38 = 1


                            if alt38 == 1:
                                # Slim.g:0:0: errorState
                                pass 
                                self._state.following.append(self.FOLLOW_errorState_in_errorImplementation1535)
                                errorState59 = self.errorState()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_errorState.add(errorState59.tree)


                            else:
                                if cnt38 >= 1:
                                    break #loop38

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(38, self.input)
                                raise eee

                            cnt38 += 1




                    elif alt39 == 2:
                        # Slim.g:259:27: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting error state")







                # Slim.g:260:4: ( TRANSITIONS ( ( errorTransition )+ | ) )?
                alt43 = 2
                LA43_0 = self.input.LA(1)

                if (LA43_0 == TRANSITIONS) :
                    alt43 = 1
                if alt43 == 1:
                    # Slim.g:260:5: TRANSITIONS ( ( errorTransition )+ | )
                    pass 
                    TRANSITIONS60=self.match(self.input, TRANSITIONS, self.FOLLOW_TRANSITIONS_in_errorImplementation1549) 
                    if self._state.backtracking == 0:
                        stream_TRANSITIONS.add(TRANSITIONS60)
                    # Slim.g:260:17: ( ( errorTransition )+ | )
                    alt42 = 2
                    LA42_0 = self.input.LA(1)

                    if (LA42_0 == TIMES or LA42_0 == IDENT) :
                        alt42 = 1
                    elif (LA42_0 == END) :
                        alt42 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 42, 0, self.input)

                        raise nvae

                    if alt42 == 1:
                        # Slim.g:260:18: ( errorTransition )+
                        pass 
                        # Slim.g:260:18: ( errorTransition )+
                        cnt41 = 0
                        while True: #loop41
                            alt41 = 2
                            LA41_0 = self.input.LA(1)

                            if (LA41_0 == TIMES or LA41_0 == IDENT) :
                                alt41 = 1


                            if alt41 == 1:
                                # Slim.g:0:0: errorTransition
                                pass 
                                self._state.following.append(self.FOLLOW_errorTransition_in_errorImplementation1552)
                                errorTransition61 = self.errorTransition()

                                self._state.following.pop()
                                if self._state.backtracking == 0:
                                    stream_errorTransition.add(errorTransition61.tree)


                            else:
                                if cnt41 >= 1:
                                    break #loop41

                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                eee = EarlyExitException(41, self.input)
                                raise eee

                            cnt41 += 1




                    elif alt42 == 2:
                        # Slim.g:260:37: 
                        pass 
                        if self._state.backtracking == 0:
                            self.parseError("Expecting error transition")







                END62=self.match(self.input, END, self.FOLLOW_END_in_errorImplementation1564) 
                if self._state.backtracking == 0:
                    stream_END.add(END62)
                self._state.following.append(self.FOLLOW_name_in_errorImplementation1566)
                name63 = self.name()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_name.add(name63.tree)
                SEMICOLON64=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorImplementation1568) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON64)

                # AST Rewrite
                # elements: errorTransition, name, errorClock, name, errorState, errorEvent
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 262:3: -> ^( ERR_IMPL name ( errorClock )* ( errorState )* ( errorEvent )* ( errorTransition )* name )
                    # Slim.g:262:6: ^( ERR_IMPL name ( errorClock )* ( errorState )* ( errorEvent )* ( errorTransition )* name )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ERR_IMPL, "ERR_IMPL"), root_1)

                    self._adaptor.addChild(root_1, stream_name.nextTree())
                    # Slim.g:262:22: ( errorClock )*
                    while stream_errorClock.hasNext():
                        self._adaptor.addChild(root_1, stream_errorClock.nextTree())


                    stream_errorClock.reset();
                    # Slim.g:262:34: ( errorState )*
                    while stream_errorState.hasNext():
                        self._adaptor.addChild(root_1, stream_errorState.nextTree())


                    stream_errorState.reset();
                    # Slim.g:262:46: ( errorEvent )*
                    while stream_errorEvent.hasNext():
                        self._adaptor.addChild(root_1, stream_errorEvent.nextTree())


                    stream_errorEvent.reset();
                    # Slim.g:262:58: ( errorTransition )*
                    while stream_errorTransition.hasNext():
                        self._adaptor.addChild(root_1, stream_errorTransition.nextTree())


                    stream_errorTransition.reset();
                    self._adaptor.addChild(root_1, stream_name.nextTree())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorImplementation"

    class componentCategory_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "componentCategory"
    # Slim.g:265:1: componentCategory : ( PROCESS | THREAD GROUP -> THREAD_GROUP | THREAD | PROCESSOR | MEMORY | DEVICE | BUS | SYSTEM );
    def componentCategory(self, ):

        retval = self.componentCategory_return()
        retval.start = self.input.LT(1)

        root_0 = None

        PROCESS65 = None
        THREAD66 = None
        GROUP67 = None
        THREAD68 = None
        PROCESSOR69 = None
        MEMORY70 = None
        DEVICE71 = None
        BUS72 = None
        SYSTEM73 = None

        PROCESS65_tree = None
        THREAD66_tree = None
        GROUP67_tree = None
        THREAD68_tree = None
        PROCESSOR69_tree = None
        MEMORY70_tree = None
        DEVICE71_tree = None
        BUS72_tree = None
        SYSTEM73_tree = None
        stream_GROUP = RewriteRuleTokenStream(self._adaptor, "token GROUP")
        stream_THREAD = RewriteRuleTokenStream(self._adaptor, "token THREAD")

        try:
            try:
                # Slim.g:268:2: ( PROCESS | THREAD GROUP -> THREAD_GROUP | THREAD | PROCESSOR | MEMORY | DEVICE | BUS | SYSTEM )
                alt44 = 8
                alt44 = self.dfa44.predict(self.input)
                if alt44 == 1:
                    # Slim.g:268:4: PROCESS
                    pass 
                    root_0 = self._adaptor.nil()

                    PROCESS65=self.match(self.input, PROCESS, self.FOLLOW_PROCESS_in_componentCategory1609)
                    if self._state.backtracking == 0:

                        PROCESS65_tree = self._adaptor.createWithPayload(PROCESS65)
                        self._adaptor.addChild(root_0, PROCESS65_tree)



                elif alt44 == 2:
                    # Slim.g:269:4: THREAD GROUP
                    pass 
                    THREAD66=self.match(self.input, THREAD, self.FOLLOW_THREAD_in_componentCategory1614) 
                    if self._state.backtracking == 0:
                        stream_THREAD.add(THREAD66)
                    GROUP67=self.match(self.input, GROUP, self.FOLLOW_GROUP_in_componentCategory1616) 
                    if self._state.backtracking == 0:
                        stream_GROUP.add(GROUP67)

                    # AST Rewrite
                    # elements: 
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 269:17: -> THREAD_GROUP
                        self._adaptor.addChild(root_0, self._adaptor.createFromType(THREAD_GROUP, "THREAD_GROUP"))



                        retval.tree = root_0


                elif alt44 == 3:
                    # Slim.g:270:4: THREAD
                    pass 
                    root_0 = self._adaptor.nil()

                    THREAD68=self.match(self.input, THREAD, self.FOLLOW_THREAD_in_componentCategory1625)
                    if self._state.backtracking == 0:

                        THREAD68_tree = self._adaptor.createWithPayload(THREAD68)
                        self._adaptor.addChild(root_0, THREAD68_tree)



                elif alt44 == 4:
                    # Slim.g:271:4: PROCESSOR
                    pass 
                    root_0 = self._adaptor.nil()

                    PROCESSOR69=self.match(self.input, PROCESSOR, self.FOLLOW_PROCESSOR_in_componentCategory1630)
                    if self._state.backtracking == 0:

                        PROCESSOR69_tree = self._adaptor.createWithPayload(PROCESSOR69)
                        self._adaptor.addChild(root_0, PROCESSOR69_tree)



                elif alt44 == 5:
                    # Slim.g:272:4: MEMORY
                    pass 
                    root_0 = self._adaptor.nil()

                    MEMORY70=self.match(self.input, MEMORY, self.FOLLOW_MEMORY_in_componentCategory1635)
                    if self._state.backtracking == 0:

                        MEMORY70_tree = self._adaptor.createWithPayload(MEMORY70)
                        self._adaptor.addChild(root_0, MEMORY70_tree)



                elif alt44 == 6:
                    # Slim.g:273:4: DEVICE
                    pass 
                    root_0 = self._adaptor.nil()

                    DEVICE71=self.match(self.input, DEVICE, self.FOLLOW_DEVICE_in_componentCategory1640)
                    if self._state.backtracking == 0:

                        DEVICE71_tree = self._adaptor.createWithPayload(DEVICE71)
                        self._adaptor.addChild(root_0, DEVICE71_tree)



                elif alt44 == 7:
                    # Slim.g:274:4: BUS
                    pass 
                    root_0 = self._adaptor.nil()

                    BUS72=self.match(self.input, BUS, self.FOLLOW_BUS_in_componentCategory1645)
                    if self._state.backtracking == 0:

                        BUS72_tree = self._adaptor.createWithPayload(BUS72)
                        self._adaptor.addChild(root_0, BUS72_tree)



                elif alt44 == 8:
                    # Slim.g:275:4: SYSTEM
                    pass 
                    root_0 = self._adaptor.nil()

                    SYSTEM73=self.match(self.input, SYSTEM, self.FOLLOW_SYSTEM_in_componentCategory1650)
                    if self._state.backtracking == 0:

                        SYSTEM73_tree = self._adaptor.createWithPayload(SYSTEM73)
                        self._adaptor.addChild(root_0, SYSTEM73_tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "componentCategory"

    class dataType_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "dataType"
    # Slim.g:278:1: dataType : ( BOOL | CLOCK ( timeScale )? | CONTINUOUS | ENUM LPAREN identifierList RPAREN | INT | REAL | intRange );
    def dataType(self, ):

        retval = self.dataType_return()
        retval.start = self.input.LT(1)

        root_0 = None

        BOOL74 = None
        CLOCK75 = None
        CONTINUOUS77 = None
        ENUM78 = None
        LPAREN79 = None
        RPAREN81 = None
        INT82 = None
        REAL83 = None
        timeScale76 = None

        identifierList80 = None

        intRange84 = None


        BOOL74_tree = None
        CLOCK75_tree = None
        CONTINUOUS77_tree = None
        ENUM78_tree = None
        LPAREN79_tree = None
        RPAREN81_tree = None
        INT82_tree = None
        REAL83_tree = None

        self.rules.append("data type") 
        try:
            try:
                # Slim.g:281:2: ( BOOL | CLOCK ( timeScale )? | CONTINUOUS | ENUM LPAREN identifierList RPAREN | INT | REAL | intRange )
                alt46 = 7
                LA46 = self.input.LA(1)
                if LA46 == BOOL:
                    alt46 = 1
                elif LA46 == CLOCK:
                    alt46 = 2
                elif LA46 == CONTINUOUS:
                    alt46 = 3
                elif LA46 == ENUM:
                    alt46 = 4
                elif LA46 == INT:
                    alt46 = 5
                elif LA46 == REAL:
                    alt46 = 6
                elif LA46 == LBRACKET:
                    alt46 = 7
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 46, 0, self.input)

                    raise nvae

                if alt46 == 1:
                    # Slim.g:281:4: BOOL
                    pass 
                    root_0 = self._adaptor.nil()

                    BOOL74=self.match(self.input, BOOL, self.FOLLOW_BOOL_in_dataType1673)
                    if self._state.backtracking == 0:

                        BOOL74_tree = self._adaptor.createWithPayload(BOOL74)
                        self._adaptor.addChild(root_0, BOOL74_tree)



                elif alt46 == 2:
                    # Slim.g:282:4: CLOCK ( timeScale )?
                    pass 
                    root_0 = self._adaptor.nil()

                    CLOCK75=self.match(self.input, CLOCK, self.FOLLOW_CLOCK_in_dataType1678)
                    if self._state.backtracking == 0:

                        CLOCK75_tree = self._adaptor.createWithPayload(CLOCK75)
                        self._adaptor.addChild(root_0, CLOCK75_tree)

                    # Slim.g:282:10: ( timeScale )?
                    alt45 = 2
                    LA45_0 = self.input.LA(1)

                    if ((MSEC <= LA45_0 <= DAY)) :
                        alt45 = 1
                    if alt45 == 1:
                        # Slim.g:0:0: timeScale
                        pass 
                        self._state.following.append(self.FOLLOW_timeScale_in_dataType1680)
                        timeScale76 = self.timeScale()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, timeScale76.tree)





                elif alt46 == 3:
                    # Slim.g:283:4: CONTINUOUS
                    pass 
                    root_0 = self._adaptor.nil()

                    CONTINUOUS77=self.match(self.input, CONTINUOUS, self.FOLLOW_CONTINUOUS_in_dataType1686)
                    if self._state.backtracking == 0:

                        CONTINUOUS77_tree = self._adaptor.createWithPayload(CONTINUOUS77)
                        self._adaptor.addChild(root_0, CONTINUOUS77_tree)



                elif alt46 == 4:
                    # Slim.g:284:4: ENUM LPAREN identifierList RPAREN
                    pass 
                    root_0 = self._adaptor.nil()

                    ENUM78=self.match(self.input, ENUM, self.FOLLOW_ENUM_in_dataType1691)
                    if self._state.backtracking == 0:

                        ENUM78_tree = self._adaptor.createWithPayload(ENUM78)
                        root_0 = self._adaptor.becomeRoot(ENUM78_tree, root_0)

                    LPAREN79=self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_dataType1694)
                    self._state.following.append(self.FOLLOW_identifierList_in_dataType1697)
                    identifierList80 = self.identifierList()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, identifierList80.tree)
                    RPAREN81=self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_dataType1699)


                elif alt46 == 5:
                    # Slim.g:285:4: INT
                    pass 
                    root_0 = self._adaptor.nil()

                    INT82=self.match(self.input, INT, self.FOLLOW_INT_in_dataType1705)
                    if self._state.backtracking == 0:

                        INT82_tree = self._adaptor.createWithPayload(INT82)
                        self._adaptor.addChild(root_0, INT82_tree)



                elif alt46 == 6:
                    # Slim.g:286:6: REAL
                    pass 
                    root_0 = self._adaptor.nil()

                    REAL83=self.match(self.input, REAL, self.FOLLOW_REAL_in_dataType1712)
                    if self._state.backtracking == 0:

                        REAL83_tree = self._adaptor.createWithPayload(REAL83)
                        self._adaptor.addChild(root_0, REAL83_tree)



                elif alt46 == 7:
                    # Slim.g:287:6: intRange
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_intRange_in_dataType1719)
                    intRange84 = self.intRange()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, intRange84.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "dataType"

    class timeScale_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "timeScale"
    # Slim.g:290:1: timeScale : ( MSEC | SEC | MIN | HOUR | DAY );
    def timeScale(self, ):

        retval = self.timeScale_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set85 = None

        set85_tree = None

        self.rules.append("time scale") 
        try:
            try:
                # Slim.g:293:2: ( MSEC | SEC | MIN | HOUR | DAY )
                # Slim.g:
                pass 
                root_0 = self._adaptor.nil()

                set85 = self.input.LT(1)
                if (MSEC <= self.input.LA(1) <= DAY):
                    self.input.consume()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, self._adaptor.createWithPayload(set85))
                    self._state.errorRecovery = False

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    mse = MismatchedSetException(None, self.input)
                    raise mse





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "timeScale"

    class intRange_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "intRange"
    # Slim.g:300:1: intRange : LBRACKET l= number DOT DOT u= number RBRACKET ;
    def intRange(self, ):

        retval = self.intRange_return()
        retval.start = self.input.LT(1)

        root_0 = None

        LBRACKET86 = None
        DOT87 = None
        DOT88 = None
        RBRACKET89 = None
        l = None

        u = None


        LBRACKET86_tree = None
        DOT87_tree = None
        DOT88_tree = None
        RBRACKET89_tree = None

        self.rules.append("integer range") 
        try:
            try:
                # Slim.g:303:5: ( LBRACKET l= number DOT DOT u= number RBRACKET )
                # Slim.g:303:9: LBRACKET l= number DOT DOT u= number RBRACKET
                pass 
                root_0 = self._adaptor.nil()

                LBRACKET86=self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_intRange1788)
                self._state.following.append(self.FOLLOW_number_in_intRange1793)
                l = self.number()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, l.tree)
                DOT87=self.match(self.input, DOT, self.FOLLOW_DOT_in_intRange1795)
                DOT88=self.match(self.input, DOT, self.FOLLOW_DOT_in_intRange1798)
                self._state.following.append(self.FOLLOW_number_in_intRange1803)
                u = self.number()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, u.tree)
                RBRACKET89=self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_intRange1805)
                if self._state.backtracking == 0:
                         
                    if ((l is not None) and [self.input.toString(l.start,l.stop)] or [None])[0].find('.') != -1 or ((u is not None) and [self.input.toString(u.start,u.stop)] or [None])[0].find('.') != -1:
                        self.parseError("Range cannot specify real numbers")
                        




                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "intRange"

    class identifierList_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "identifierList"
    # Slim.g:310:1: identifierList : IDENT ( COMMA IDENT )* ;
    def identifierList(self, ):

        retval = self.identifierList_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT90 = None
        COMMA91 = None
        IDENT92 = None

        IDENT90_tree = None
        COMMA91_tree = None
        IDENT92_tree = None

        self.rules.append("identifier list") 
        try:
            try:
                # Slim.g:313:2: ( IDENT ( COMMA IDENT )* )
                # Slim.g:313:4: IDENT ( COMMA IDENT )*
                pass 
                root_0 = self._adaptor.nil()

                IDENT90=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_identifierList1837)
                if self._state.backtracking == 0:

                    IDENT90_tree = self._adaptor.createWithPayload(IDENT90)
                    self._adaptor.addChild(root_0, IDENT90_tree)

                # Slim.g:313:10: ( COMMA IDENT )*
                while True: #loop47
                    alt47 = 2
                    LA47_0 = self.input.LA(1)

                    if (LA47_0 == COMMA) :
                        alt47 = 1


                    if alt47 == 1:
                        # Slim.g:313:11: COMMA IDENT
                        pass 
                        COMMA91=self.match(self.input, COMMA, self.FOLLOW_COMMA_in_identifierList1840)
                        IDENT92=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_identifierList1843)
                        if self._state.backtracking == 0:

                            IDENT92_tree = self._adaptor.createWithPayload(IDENT92)
                            self._adaptor.addChild(root_0, IDENT92_tree)



                    else:
                        break #loop47





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "identifierList"

    class portSpec_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "portSpec"
    # Slim.g:317:1: portSpec : ( IDENT COLON IN EVENT PORT SEMICOLON -> ^( IEPORT IDENT ) | IDENT COLON OUT EVENT PORT ( NONBLOCKING )? SEMICOLON -> ^( OEPORT IDENT ( NONBLOCKING )? ) | IDENT COLON IN DATA PORT dataType ( initialization )? SEMICOLON -> ^( IDPORT IDENT dataType ( initialization )? ) | IDENT COLON OUT DATA PORT dataType ( initialization )? ( OBSERVABLE | ALARM )? SEMICOLON -> ^( ODPORT IDENT dataType ( initialization )? ( OBSERVABLE )? ( ALARM )? ) | {...}? => IDENT COLON ERROR EVENT PORT ( POISSON NUMBER )? SEMICOLON -> ^( ERRORPORT IDENT ( POISSON NUMBER )? ) );
    def portSpec(self, ):

        retval = self.portSpec_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT93 = None
        COLON94 = None
        IN95 = None
        EVENT96 = None
        PORT97 = None
        SEMICOLON98 = None
        IDENT99 = None
        COLON100 = None
        OUT101 = None
        EVENT102 = None
        PORT103 = None
        NONBLOCKING104 = None
        SEMICOLON105 = None
        IDENT106 = None
        COLON107 = None
        IN108 = None
        DATA109 = None
        PORT110 = None
        SEMICOLON113 = None
        IDENT114 = None
        COLON115 = None
        OUT116 = None
        DATA117 = None
        PORT118 = None
        OBSERVABLE121 = None
        ALARM122 = None
        SEMICOLON123 = None
        IDENT124 = None
        COLON125 = None
        ERROR126 = None
        EVENT127 = None
        PORT128 = None
        POISSON129 = None
        NUMBER130 = None
        SEMICOLON131 = None
        dataType111 = None

        initialization112 = None

        dataType119 = None

        initialization120 = None


        IDENT93_tree = None
        COLON94_tree = None
        IN95_tree = None
        EVENT96_tree = None
        PORT97_tree = None
        SEMICOLON98_tree = None
        IDENT99_tree = None
        COLON100_tree = None
        OUT101_tree = None
        EVENT102_tree = None
        PORT103_tree = None
        NONBLOCKING104_tree = None
        SEMICOLON105_tree = None
        IDENT106_tree = None
        COLON107_tree = None
        IN108_tree = None
        DATA109_tree = None
        PORT110_tree = None
        SEMICOLON113_tree = None
        IDENT114_tree = None
        COLON115_tree = None
        OUT116_tree = None
        DATA117_tree = None
        PORT118_tree = None
        OBSERVABLE121_tree = None
        ALARM122_tree = None
        SEMICOLON123_tree = None
        IDENT124_tree = None
        COLON125_tree = None
        ERROR126_tree = None
        EVENT127_tree = None
        PORT128_tree = None
        POISSON129_tree = None
        NUMBER130_tree = None
        SEMICOLON131_tree = None
        stream_NUMBER = RewriteRuleTokenStream(self._adaptor, "token NUMBER")
        stream_PORT = RewriteRuleTokenStream(self._adaptor, "token PORT")
        stream_POISSON = RewriteRuleTokenStream(self._adaptor, "token POISSON")
        stream_IN = RewriteRuleTokenStream(self._adaptor, "token IN")
        stream_OBSERVABLE = RewriteRuleTokenStream(self._adaptor, "token OBSERVABLE")
        stream_ALARM = RewriteRuleTokenStream(self._adaptor, "token ALARM")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_EVENT = RewriteRuleTokenStream(self._adaptor, "token EVENT")
        stream_OUT = RewriteRuleTokenStream(self._adaptor, "token OUT")
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_DATA = RewriteRuleTokenStream(self._adaptor, "token DATA")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_NONBLOCKING = RewriteRuleTokenStream(self._adaptor, "token NONBLOCKING")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")
        stream_dataType = RewriteRuleSubtreeStream(self._adaptor, "rule dataType")
        stream_initialization = RewriteRuleSubtreeStream(self._adaptor, "rule initialization")
        self.rules.append("port specification") 
        try:
            try:
                # Slim.g:320:2: ( IDENT COLON IN EVENT PORT SEMICOLON -> ^( IEPORT IDENT ) | IDENT COLON OUT EVENT PORT ( NONBLOCKING )? SEMICOLON -> ^( OEPORT IDENT ( NONBLOCKING )? ) | IDENT COLON IN DATA PORT dataType ( initialization )? SEMICOLON -> ^( IDPORT IDENT dataType ( initialization )? ) | IDENT COLON OUT DATA PORT dataType ( initialization )? ( OBSERVABLE | ALARM )? SEMICOLON -> ^( ODPORT IDENT dataType ( initialization )? ( OBSERVABLE )? ( ALARM )? ) | {...}? => IDENT COLON ERROR EVENT PORT ( POISSON NUMBER )? SEMICOLON -> ^( ERRORPORT IDENT ( POISSON NUMBER )? ) )
                alt53 = 5
                alt53 = self.dfa53.predict(self.input)
                if alt53 == 1:
                    # Slim.g:320:4: IDENT COLON IN EVENT PORT SEMICOLON
                    pass 
                    IDENT93=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_portSpec1871) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT93)
                    COLON94=self.match(self.input, COLON, self.FOLLOW_COLON_in_portSpec1873) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON94)
                    IN95=self.match(self.input, IN, self.FOLLOW_IN_in_portSpec1875) 
                    if self._state.backtracking == 0:
                        stream_IN.add(IN95)
                    EVENT96=self.match(self.input, EVENT, self.FOLLOW_EVENT_in_portSpec1877) 
                    if self._state.backtracking == 0:
                        stream_EVENT.add(EVENT96)
                    PORT97=self.match(self.input, PORT, self.FOLLOW_PORT_in_portSpec1879) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT97)
                    SEMICOLON98=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portSpec1881) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON98)

                    # AST Rewrite
                    # elements: IDENT
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 321:3: -> ^( IEPORT IDENT )
                        # Slim.g:321:6: ^( IEPORT IDENT )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(IEPORT, "IEPORT"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt53 == 2:
                    # Slim.g:322:4: IDENT COLON OUT EVENT PORT ( NONBLOCKING )? SEMICOLON
                    pass 
                    IDENT99=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_portSpec1896) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT99)
                    COLON100=self.match(self.input, COLON, self.FOLLOW_COLON_in_portSpec1898) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON100)
                    OUT101=self.match(self.input, OUT, self.FOLLOW_OUT_in_portSpec1900) 
                    if self._state.backtracking == 0:
                        stream_OUT.add(OUT101)
                    EVENT102=self.match(self.input, EVENT, self.FOLLOW_EVENT_in_portSpec1902) 
                    if self._state.backtracking == 0:
                        stream_EVENT.add(EVENT102)
                    PORT103=self.match(self.input, PORT, self.FOLLOW_PORT_in_portSpec1904) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT103)
                    # Slim.g:322:31: ( NONBLOCKING )?
                    alt48 = 2
                    LA48_0 = self.input.LA(1)

                    if (LA48_0 == NONBLOCKING) :
                        alt48 = 1
                    if alt48 == 1:
                        # Slim.g:322:32: NONBLOCKING
                        pass 
                        NONBLOCKING104=self.match(self.input, NONBLOCKING, self.FOLLOW_NONBLOCKING_in_portSpec1907) 
                        if self._state.backtracking == 0:
                            stream_NONBLOCKING.add(NONBLOCKING104)



                    SEMICOLON105=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portSpec1911) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON105)

                    # AST Rewrite
                    # elements: IDENT, NONBLOCKING
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 323:3: -> ^( OEPORT IDENT ( NONBLOCKING )? )
                        # Slim.g:323:6: ^( OEPORT IDENT ( NONBLOCKING )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(OEPORT, "OEPORT"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        # Slim.g:323:21: ( NONBLOCKING )?
                        if stream_NONBLOCKING.hasNext():
                            self._adaptor.addChild(root_1, stream_NONBLOCKING.nextNode())


                        stream_NONBLOCKING.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt53 == 3:
                    # Slim.g:324:4: IDENT COLON IN DATA PORT dataType ( initialization )? SEMICOLON
                    pass 
                    IDENT106=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_portSpec1931) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT106)
                    COLON107=self.match(self.input, COLON, self.FOLLOW_COLON_in_portSpec1933) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON107)
                    IN108=self.match(self.input, IN, self.FOLLOW_IN_in_portSpec1935) 
                    if self._state.backtracking == 0:
                        stream_IN.add(IN108)
                    DATA109=self.match(self.input, DATA, self.FOLLOW_DATA_in_portSpec1937) 
                    if self._state.backtracking == 0:
                        stream_DATA.add(DATA109)
                    PORT110=self.match(self.input, PORT, self.FOLLOW_PORT_in_portSpec1939) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT110)
                    self._state.following.append(self.FOLLOW_dataType_in_portSpec1941)
                    dataType111 = self.dataType()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_dataType.add(dataType111.tree)
                    # Slim.g:324:38: ( initialization )?
                    alt49 = 2
                    LA49_0 = self.input.LA(1)

                    if (LA49_0 == DEFAULT) :
                        alt49 = 1
                    if alt49 == 1:
                        # Slim.g:324:39: initialization
                        pass 
                        self._state.following.append(self.FOLLOW_initialization_in_portSpec1944)
                        initialization112 = self.initialization()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_initialization.add(initialization112.tree)



                    SEMICOLON113=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portSpec1948) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON113)

                    # AST Rewrite
                    # elements: IDENT, initialization, dataType
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 325:3: -> ^( IDPORT IDENT dataType ( initialization )? )
                        # Slim.g:325:6: ^( IDPORT IDENT dataType ( initialization )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(IDPORT, "IDPORT"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        self._adaptor.addChild(root_1, stream_dataType.nextTree())
                        # Slim.g:325:30: ( initialization )?
                        if stream_initialization.hasNext():
                            self._adaptor.addChild(root_1, stream_initialization.nextTree())


                        stream_initialization.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt53 == 4:
                    # Slim.g:326:4: IDENT COLON OUT DATA PORT dataType ( initialization )? ( OBSERVABLE | ALARM )? SEMICOLON
                    pass 
                    IDENT114=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_portSpec1970) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT114)
                    COLON115=self.match(self.input, COLON, self.FOLLOW_COLON_in_portSpec1972) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON115)
                    OUT116=self.match(self.input, OUT, self.FOLLOW_OUT_in_portSpec1974) 
                    if self._state.backtracking == 0:
                        stream_OUT.add(OUT116)
                    DATA117=self.match(self.input, DATA, self.FOLLOW_DATA_in_portSpec1976) 
                    if self._state.backtracking == 0:
                        stream_DATA.add(DATA117)
                    PORT118=self.match(self.input, PORT, self.FOLLOW_PORT_in_portSpec1978) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT118)
                    self._state.following.append(self.FOLLOW_dataType_in_portSpec1980)
                    dataType119 = self.dataType()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_dataType.add(dataType119.tree)
                    # Slim.g:326:39: ( initialization )?
                    alt50 = 2
                    LA50_0 = self.input.LA(1)

                    if (LA50_0 == DEFAULT) :
                        alt50 = 1
                    if alt50 == 1:
                        # Slim.g:326:40: initialization
                        pass 
                        self._state.following.append(self.FOLLOW_initialization_in_portSpec1983)
                        initialization120 = self.initialization()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_initialization.add(initialization120.tree)



                    # Slim.g:326:57: ( OBSERVABLE | ALARM )?
                    alt51 = 3
                    LA51_0 = self.input.LA(1)

                    if (LA51_0 == OBSERVABLE) :
                        alt51 = 1
                    elif (LA51_0 == ALARM) :
                        alt51 = 2
                    if alt51 == 1:
                        # Slim.g:326:58: OBSERVABLE
                        pass 
                        OBSERVABLE121=self.match(self.input, OBSERVABLE, self.FOLLOW_OBSERVABLE_in_portSpec1988) 
                        if self._state.backtracking == 0:
                            stream_OBSERVABLE.add(OBSERVABLE121)


                    elif alt51 == 2:
                        # Slim.g:326:71: ALARM
                        pass 
                        ALARM122=self.match(self.input, ALARM, self.FOLLOW_ALARM_in_portSpec1992) 
                        if self._state.backtracking == 0:
                            stream_ALARM.add(ALARM122)



                    SEMICOLON123=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portSpec1996) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON123)

                    # AST Rewrite
                    # elements: ALARM, dataType, initialization, OBSERVABLE, IDENT
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 327:3: -> ^( ODPORT IDENT dataType ( initialization )? ( OBSERVABLE )? ( ALARM )? )
                        # Slim.g:327:6: ^( ODPORT IDENT dataType ( initialization )? ( OBSERVABLE )? ( ALARM )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ODPORT, "ODPORT"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        self._adaptor.addChild(root_1, stream_dataType.nextTree())
                        # Slim.g:327:30: ( initialization )?
                        if stream_initialization.hasNext():
                            self._adaptor.addChild(root_1, stream_initialization.nextTree())


                        stream_initialization.reset();
                        # Slim.g:327:46: ( OBSERVABLE )?
                        if stream_OBSERVABLE.hasNext():
                            self._adaptor.addChild(root_1, stream_OBSERVABLE.nextNode())


                        stream_OBSERVABLE.reset();
                        # Slim.g:327:58: ( ALARM )?
                        if stream_ALARM.hasNext():
                            self._adaptor.addChild(root_1, stream_ALARM.nextNode())


                        stream_ALARM.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt53 == 5:
                    # Slim.g:328:4: {...}? => IDENT COLON ERROR EVENT PORT ( POISSON NUMBER )? SEMICOLON
                    pass 
                    if not ((globals.PARSER_ACCEPT_EXTENDED_MODEL)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "portSpec", "globals.PARSER_ACCEPT_EXTENDED_MODEL")

                    IDENT124=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_portSpec2026) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT124)
                    COLON125=self.match(self.input, COLON, self.FOLLOW_COLON_in_portSpec2028) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON125)
                    ERROR126=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_portSpec2030) 
                    if self._state.backtracking == 0:
                        stream_ERROR.add(ERROR126)
                    EVENT127=self.match(self.input, EVENT, self.FOLLOW_EVENT_in_portSpec2032) 
                    if self._state.backtracking == 0:
                        stream_EVENT.add(EVENT127)
                    PORT128=self.match(self.input, PORT, self.FOLLOW_PORT_in_portSpec2034) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT128)
                    # Slim.g:328:74: ( POISSON NUMBER )?
                    alt52 = 2
                    LA52_0 = self.input.LA(1)

                    if (LA52_0 == POISSON) :
                        alt52 = 1
                    if alt52 == 1:
                        # Slim.g:328:75: POISSON NUMBER
                        pass 
                        POISSON129=self.match(self.input, POISSON, self.FOLLOW_POISSON_in_portSpec2037) 
                        if self._state.backtracking == 0:
                            stream_POISSON.add(POISSON129)
                        NUMBER130=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_portSpec2039) 
                        if self._state.backtracking == 0:
                            stream_NUMBER.add(NUMBER130)



                    SEMICOLON131=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portSpec2043) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON131)

                    # AST Rewrite
                    # elements: POISSON, IDENT, NUMBER
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 329:3: -> ^( ERRORPORT IDENT ( POISSON NUMBER )? )
                        # Slim.g:329:6: ^( ERRORPORT IDENT ( POISSON NUMBER )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ERRORPORT, "ERRORPORT"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        # Slim.g:329:24: ( POISSON NUMBER )?
                        if stream_POISSON.hasNext() or stream_NUMBER.hasNext():
                            self._adaptor.addChild(root_1, stream_POISSON.nextNode())
                            self._adaptor.addChild(root_1, stream_NUMBER.nextNode())


                        stream_POISSON.reset();
                        stream_NUMBER.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "portSpec"

    class initialization_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "initialization"
    # Slim.g:332:1: initialization : DEFAULT value ;
    def initialization(self, ):

        retval = self.initialization_return()
        retval.start = self.input.LT(1)

        root_0 = None

        DEFAULT132 = None
        value133 = None


        DEFAULT132_tree = None

        try:
            try:
                # Slim.g:333:2: ( DEFAULT value )
                # Slim.g:333:4: DEFAULT value
                pass 
                root_0 = self._adaptor.nil()

                DEFAULT132=self.match(self.input, DEFAULT, self.FOLLOW_DEFAULT_in_initialization2072)
                self._state.following.append(self.FOLLOW_value_in_initialization2075)
                value133 = self.value()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, value133.tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "initialization"

    class value_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "value"
    # Slim.g:336:1: value : ( TRUE | FALSE | number | IDENT );
    def value(self, ):

        retval = self.value_return()
        retval.start = self.input.LT(1)

        root_0 = None

        TRUE134 = None
        FALSE135 = None
        IDENT137 = None
        number136 = None


        TRUE134_tree = None
        FALSE135_tree = None
        IDENT137_tree = None

        self.rules.append("value") 
        try:
            try:
                # Slim.g:339:2: ( TRUE | FALSE | number | IDENT )
                alt54 = 4
                LA54 = self.input.LA(1)
                if LA54 == TRUE:
                    alt54 = 1
                elif LA54 == FALSE:
                    alt54 = 2
                elif LA54 == MINUS or LA54 == NUMBER:
                    alt54 = 3
                elif LA54 == IDENT:
                    alt54 = 4
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 54, 0, self.input)

                    raise nvae

                if alt54 == 1:
                    # Slim.g:339:4: TRUE
                    pass 
                    root_0 = self._adaptor.nil()

                    TRUE134=self.match(self.input, TRUE, self.FOLLOW_TRUE_in_value2096)
                    if self._state.backtracking == 0:

                        TRUE134_tree = self._adaptor.createWithPayload(TRUE134)
                        self._adaptor.addChild(root_0, TRUE134_tree)



                elif alt54 == 2:
                    # Slim.g:340:4: FALSE
                    pass 
                    root_0 = self._adaptor.nil()

                    FALSE135=self.match(self.input, FALSE, self.FOLLOW_FALSE_in_value2101)
                    if self._state.backtracking == 0:

                        FALSE135_tree = self._adaptor.createWithPayload(FALSE135)
                        self._adaptor.addChild(root_0, FALSE135_tree)



                elif alt54 == 3:
                    # Slim.g:341:4: number
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_number_in_value2106)
                    number136 = self.number()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, number136.tree)


                elif alt54 == 4:
                    # Slim.g:342:4: IDENT
                    pass 
                    root_0 = self._adaptor.nil()

                    IDENT137=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_value2111)
                    if self._state.backtracking == 0:

                        IDENT137_tree = self._adaptor.createWithPayload(IDENT137)
                        self._adaptor.addChild(root_0, IDENT137_tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "value"

    class timeScaledNumber_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "timeScaledNumber"
    # Slim.g:345:1: timeScaledNumber : ( number timeScale | number );
    def timeScaledNumber(self, ):

        retval = self.timeScaledNumber_return()
        retval.start = self.input.LT(1)

        root_0 = None

        number138 = None

        timeScale139 = None

        number140 = None



        try:
            try:
                # Slim.g:346:2: ( number timeScale | number )
                alt55 = 2
                LA55_0 = self.input.LA(1)

                if (LA55_0 == MINUS) :
                    LA55_1 = self.input.LA(2)

                    if (LA55_1 == NUMBER) :
                        LA55_3 = self.input.LA(3)

                        if (LA55_3 == EOF or LA55_3 == SEMICOLON or LA55_3 == WHILE or LA55_3 == THEN or LA55_3 == RBRACKET or LA55_3 == TO) :
                            alt55 = 2
                        elif ((MSEC <= LA55_3 <= DAY)) :
                            alt55 = 1
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 55, 3, self.input)

                            raise nvae

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 55, 1, self.input)

                        raise nvae

                elif (LA55_0 == NUMBER) :
                    LA55_2 = self.input.LA(2)

                    if ((MSEC <= LA55_2 <= DAY)) :
                        alt55 = 1
                    elif (LA55_2 == EOF or LA55_2 == SEMICOLON or LA55_2 == WHILE or LA55_2 == THEN or LA55_2 == RBRACKET or LA55_2 == TO) :
                        alt55 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 55, 2, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 55, 0, self.input)

                    raise nvae

                if alt55 == 1:
                    # Slim.g:346:4: number timeScale
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_number_in_timeScaledNumber2122)
                    number138 = self.number()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, number138.tree)
                    self._state.following.append(self.FOLLOW_timeScale_in_timeScaledNumber2124)
                    timeScale139 = self.timeScale()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        root_0 = self._adaptor.becomeRoot(timeScale139.tree, root_0)


                elif alt55 == 2:
                    # Slim.g:347:4: number
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_number_in_timeScaledNumber2130)
                    number140 = self.number()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, number140.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "timeScaledNumber"

    class number_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "number"
    # Slim.g:350:1: number : ( MINUS NUMBER | NUMBER );
    def number(self, ):

        retval = self.number_return()
        retval.start = self.input.LT(1)

        root_0 = None

        MINUS141 = None
        NUMBER142 = None
        NUMBER143 = None

        MINUS141_tree = None
        NUMBER142_tree = None
        NUMBER143_tree = None

        self.rules.append("number") 
        try:
            try:
                # Slim.g:353:5: ( MINUS NUMBER | NUMBER )
                alt56 = 2
                LA56_0 = self.input.LA(1)

                if (LA56_0 == MINUS) :
                    alt56 = 1
                elif (LA56_0 == NUMBER) :
                    alt56 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 56, 0, self.input)

                    raise nvae

                if alt56 == 1:
                    # Slim.g:353:9: MINUS NUMBER
                    pass 
                    root_0 = self._adaptor.nil()

                    MINUS141=self.match(self.input, MINUS, self.FOLLOW_MINUS_in_number2156)
                    NUMBER142=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_number2159)
                    if self._state.backtracking == 0:

                        NUMBER142_tree = self._adaptor.createWithPayload(NUMBER142)
                        self._adaptor.addChild(root_0, NUMBER142_tree)

                    if self._state.backtracking == 0:
                        NUMBER142.setText("-" + NUMBER142.getText()) 



                elif alt56 == 2:
                    # Slim.g:355:4: NUMBER
                    pass 
                    root_0 = self._adaptor.nil()

                    NUMBER143=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_number2168)
                    if self._state.backtracking == 0:

                        NUMBER143_tree = self._adaptor.createWithPayload(NUMBER143)
                        self._adaptor.addChild(root_0, NUMBER143_tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "number"

    class name_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "name"
    # Slim.g:360:1: name : IDENT DOT IDENT -> ^( NAME IDENT IDENT ) ;
    def name(self, ):

        retval = self.name_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT144 = None
        DOT145 = None
        IDENT146 = None

        IDENT144_tree = None
        DOT145_tree = None
        IDENT146_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_DOT = RewriteRuleTokenStream(self._adaptor, "token DOT")

        self.rules.append("name") 
        try:
            try:
                # Slim.g:363:2: ( IDENT DOT IDENT -> ^( NAME IDENT IDENT ) )
                # Slim.g:363:4: IDENT DOT IDENT
                pass 
                IDENT144=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_name2197) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT144)
                DOT145=self.match(self.input, DOT, self.FOLLOW_DOT_in_name2199) 
                if self._state.backtracking == 0:
                    stream_DOT.add(DOT145)
                IDENT146=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_name2201) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT146)

                # AST Rewrite
                # elements: IDENT, IDENT
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 364:3: -> ^( NAME IDENT IDENT )
                    # Slim.g:364:6: ^( NAME IDENT IDENT )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(NAME, "NAME"), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "name"

    class uniqueNameOrIdentifier_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "uniqueNameOrIdentifier"
    # Slim.g:367:1: uniqueNameOrIdentifier : ( IDENT COLON COLON nameOrIdentifier -> ^( FQ_NAME_OR_IDENT IDENT nameOrIdentifier ) | nameOrIdentifier );
    def uniqueNameOrIdentifier(self, ):

        retval = self.uniqueNameOrIdentifier_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT147 = None
        COLON148 = None
        COLON149 = None
        nameOrIdentifier150 = None

        nameOrIdentifier151 = None


        IDENT147_tree = None
        COLON148_tree = None
        COLON149_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_nameOrIdentifier = RewriteRuleSubtreeStream(self._adaptor, "rule nameOrIdentifier")
        try:
            try:
                # Slim.g:368:2: ( IDENT COLON COLON nameOrIdentifier -> ^( FQ_NAME_OR_IDENT IDENT nameOrIdentifier ) | nameOrIdentifier )
                alt57 = 2
                LA57_0 = self.input.LA(1)

                if (LA57_0 == IDENT) :
                    LA57_1 = self.input.LA(2)

                    if (LA57_1 == COLON) :
                        alt57 = 1
                    elif (LA57_1 == SEMICOLON or LA57_1 == IN or LA57_1 == DOT or (STORED <= LA57_1 <= ACCESSES)) :
                        alt57 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 57, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 57, 0, self.input)

                    raise nvae

                if alt57 == 1:
                    # Slim.g:368:4: IDENT COLON COLON nameOrIdentifier
                    pass 
                    IDENT147=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_uniqueNameOrIdentifier2226) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT147)
                    COLON148=self.match(self.input, COLON, self.FOLLOW_COLON_in_uniqueNameOrIdentifier2228) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON148)
                    COLON149=self.match(self.input, COLON, self.FOLLOW_COLON_in_uniqueNameOrIdentifier2230) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON149)
                    self._state.following.append(self.FOLLOW_nameOrIdentifier_in_uniqueNameOrIdentifier2233)
                    nameOrIdentifier150 = self.nameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_nameOrIdentifier.add(nameOrIdentifier150.tree)

                    # AST Rewrite
                    # elements: nameOrIdentifier, IDENT
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 369:3: -> ^( FQ_NAME_OR_IDENT IDENT nameOrIdentifier )
                        # Slim.g:369:6: ^( FQ_NAME_OR_IDENT IDENT nameOrIdentifier )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(FQ_NAME_OR_IDENT, "FQ_NAME_OR_IDENT"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        self._adaptor.addChild(root_1, stream_nameOrIdentifier.nextTree())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt57 == 2:
                    # Slim.g:370:4: nameOrIdentifier
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_nameOrIdentifier_in_uniqueNameOrIdentifier2250)
                    nameOrIdentifier151 = self.nameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, nameOrIdentifier151.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "uniqueNameOrIdentifier"

    class nameOrIdentifier_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "nameOrIdentifier"
    # Slim.g:373:1: nameOrIdentifier : ( name | IDENT );
    def nameOrIdentifier(self, ):

        retval = self.nameOrIdentifier_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT153 = None
        name152 = None


        IDENT153_tree = None

        try:
            try:
                # Slim.g:374:2: ( name | IDENT )
                alt58 = 2
                LA58_0 = self.input.LA(1)

                if (LA58_0 == IDENT) :
                    LA58_1 = self.input.LA(2)

                    if (LA58_1 == DOT) :
                        alt58 = 1
                    elif (LA58_1 == EOF or LA58_1 == SEMICOLON or LA58_1 == IN or (STORED <= LA58_1 <= ARROW) or LA58_1 == THEN or LA58_1 == RBRACKET or LA58_1 == ASSIGN or (WHEN <= LA58_1 <= WITHIN) or LA58_1 == OR or LA58_1 == PASSIVE) :
                        alt58 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 58, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 58, 0, self.input)

                    raise nvae

                if alt58 == 1:
                    # Slim.g:374:4: name
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_name_in_nameOrIdentifier2262)
                    name152 = self.name()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, name152.tree)


                elif alt58 == 2:
                    # Slim.g:375:4: IDENT
                    pass 
                    root_0 = self._adaptor.nil()

                    IDENT153=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_nameOrIdentifier2267)
                    if self._state.backtracking == 0:

                        IDENT153_tree = self._adaptor.createWithPayload(IDENT153)
                        self._adaptor.addChild(root_0, IDENT153_tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "nameOrIdentifier"

    class subcomponent_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "subcomponent"
    # Slim.g:379:1: subcomponent : ( IDENT COLON componentCategory uniqueNameOrIdentifier ( binding )* ( inModes )? SEMICOLON -> ^( componentCategory IDENT uniqueNameOrIdentifier ( inModes )? ( binding )* ) | IDENT COLON DATA dataType ( initialization )? ( inModes )? ( OBSERVABLE )? SEMICOLON -> ^( DATA IDENT ( inModes )? dataType ( initialization )? ( OBSERVABLE )? ) );
    def subcomponent(self, ):

        retval = self.subcomponent_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT154 = None
        COLON155 = None
        SEMICOLON160 = None
        IDENT161 = None
        COLON162 = None
        DATA163 = None
        OBSERVABLE167 = None
        SEMICOLON168 = None
        componentCategory156 = None

        uniqueNameOrIdentifier157 = None

        binding158 = None

        inModes159 = None

        dataType164 = None

        initialization165 = None

        inModes166 = None


        IDENT154_tree = None
        COLON155_tree = None
        SEMICOLON160_tree = None
        IDENT161_tree = None
        COLON162_tree = None
        DATA163_tree = None
        OBSERVABLE167_tree = None
        SEMICOLON168_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_DATA = RewriteRuleTokenStream(self._adaptor, "token DATA")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_OBSERVABLE = RewriteRuleTokenStream(self._adaptor, "token OBSERVABLE")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_uniqueNameOrIdentifier = RewriteRuleSubtreeStream(self._adaptor, "rule uniqueNameOrIdentifier")
        stream_dataType = RewriteRuleSubtreeStream(self._adaptor, "rule dataType")
        stream_binding = RewriteRuleSubtreeStream(self._adaptor, "rule binding")
        stream_initialization = RewriteRuleSubtreeStream(self._adaptor, "rule initialization")
        stream_componentCategory = RewriteRuleSubtreeStream(self._adaptor, "rule componentCategory")
        stream_inModes = RewriteRuleSubtreeStream(self._adaptor, "rule inModes")
        self.rules.append("subcomponent") 
        try:
            try:
                # Slim.g:382:2: ( IDENT COLON componentCategory uniqueNameOrIdentifier ( binding )* ( inModes )? SEMICOLON -> ^( componentCategory IDENT uniqueNameOrIdentifier ( inModes )? ( binding )* ) | IDENT COLON DATA dataType ( initialization )? ( inModes )? ( OBSERVABLE )? SEMICOLON -> ^( DATA IDENT ( inModes )? dataType ( initialization )? ( OBSERVABLE )? ) )
                alt64 = 2
                LA64_0 = self.input.LA(1)

                if (LA64_0 == IDENT) :
                    LA64_1 = self.input.LA(2)

                    if (LA64_1 == COLON) :
                        LA64_2 = self.input.LA(3)

                        if (LA64_2 == DATA) :
                            alt64 = 2
                        elif (LA64_2 == THREAD or LA64_2 == PROCESS or (MEMORY <= LA64_2 <= SYSTEM)) :
                            alt64 = 1
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 64, 2, self.input)

                            raise nvae

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 64, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 64, 0, self.input)

                    raise nvae

                if alt64 == 1:
                    # Slim.g:382:4: IDENT COLON componentCategory uniqueNameOrIdentifier ( binding )* ( inModes )? SEMICOLON
                    pass 
                    IDENT154=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_subcomponent2292) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT154)
                    COLON155=self.match(self.input, COLON, self.FOLLOW_COLON_in_subcomponent2294) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON155)
                    self._state.following.append(self.FOLLOW_componentCategory_in_subcomponent2296)
                    componentCategory156 = self.componentCategory()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_componentCategory.add(componentCategory156.tree)
                    self._state.following.append(self.FOLLOW_uniqueNameOrIdentifier_in_subcomponent2298)
                    uniqueNameOrIdentifier157 = self.uniqueNameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_uniqueNameOrIdentifier.add(uniqueNameOrIdentifier157.tree)
                    # Slim.g:382:57: ( binding )*
                    while True: #loop59
                        alt59 = 2
                        LA59_0 = self.input.LA(1)

                        if ((STORED <= LA59_0 <= ACCESSES)) :
                            alt59 = 1


                        if alt59 == 1:
                            # Slim.g:0:0: binding
                            pass 
                            self._state.following.append(self.FOLLOW_binding_in_subcomponent2300)
                            binding158 = self.binding()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                stream_binding.add(binding158.tree)


                        else:
                            break #loop59


                    # Slim.g:382:66: ( inModes )?
                    alt60 = 2
                    LA60_0 = self.input.LA(1)

                    if (LA60_0 == IN) :
                        alt60 = 1
                    if alt60 == 1:
                        # Slim.g:0:0: inModes
                        pass 
                        self._state.following.append(self.FOLLOW_inModes_in_subcomponent2303)
                        inModes159 = self.inModes()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_inModes.add(inModes159.tree)



                    SEMICOLON160=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_subcomponent2306) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON160)

                    # AST Rewrite
                    # elements: IDENT, componentCategory, binding, inModes, uniqueNameOrIdentifier
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 383:3: -> ^( componentCategory IDENT uniqueNameOrIdentifier ( inModes )? ( binding )* )
                        # Slim.g:383:6: ^( componentCategory IDENT uniqueNameOrIdentifier ( inModes )? ( binding )* )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(stream_componentCategory.nextNode(), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        self._adaptor.addChild(root_1, stream_uniqueNameOrIdentifier.nextTree())
                        # Slim.g:383:55: ( inModes )?
                        if stream_inModes.hasNext():
                            self._adaptor.addChild(root_1, stream_inModes.nextTree())


                        stream_inModes.reset();
                        # Slim.g:383:64: ( binding )*
                        while stream_binding.hasNext():
                            self._adaptor.addChild(root_1, stream_binding.nextTree())


                        stream_binding.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt64 == 2:
                    # Slim.g:384:4: IDENT COLON DATA dataType ( initialization )? ( inModes )? ( OBSERVABLE )? SEMICOLON
                    pass 
                    IDENT161=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_subcomponent2329) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT161)
                    COLON162=self.match(self.input, COLON, self.FOLLOW_COLON_in_subcomponent2331) 
                    if self._state.backtracking == 0:
                        stream_COLON.add(COLON162)
                    DATA163=self.match(self.input, DATA, self.FOLLOW_DATA_in_subcomponent2333) 
                    if self._state.backtracking == 0:
                        stream_DATA.add(DATA163)
                    self._state.following.append(self.FOLLOW_dataType_in_subcomponent2335)
                    dataType164 = self.dataType()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_dataType.add(dataType164.tree)
                    # Slim.g:384:30: ( initialization )?
                    alt61 = 2
                    LA61_0 = self.input.LA(1)

                    if (LA61_0 == DEFAULT) :
                        alt61 = 1
                    if alt61 == 1:
                        # Slim.g:0:0: initialization
                        pass 
                        self._state.following.append(self.FOLLOW_initialization_in_subcomponent2337)
                        initialization165 = self.initialization()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_initialization.add(initialization165.tree)



                    # Slim.g:384:46: ( inModes )?
                    alt62 = 2
                    LA62_0 = self.input.LA(1)

                    if (LA62_0 == IN) :
                        alt62 = 1
                    if alt62 == 1:
                        # Slim.g:0:0: inModes
                        pass 
                        self._state.following.append(self.FOLLOW_inModes_in_subcomponent2340)
                        inModes166 = self.inModes()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_inModes.add(inModes166.tree)



                    # Slim.g:384:55: ( OBSERVABLE )?
                    alt63 = 2
                    LA63_0 = self.input.LA(1)

                    if (LA63_0 == OBSERVABLE) :
                        alt63 = 1
                    if alt63 == 1:
                        # Slim.g:0:0: OBSERVABLE
                        pass 
                        OBSERVABLE167=self.match(self.input, OBSERVABLE, self.FOLLOW_OBSERVABLE_in_subcomponent2343) 
                        if self._state.backtracking == 0:
                            stream_OBSERVABLE.add(OBSERVABLE167)



                    SEMICOLON168=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_subcomponent2346) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON168)

                    # AST Rewrite
                    # elements: DATA, OBSERVABLE, dataType, initialization, inModes, IDENT
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 385:3: -> ^( DATA IDENT ( inModes )? dataType ( initialization )? ( OBSERVABLE )? )
                        # Slim.g:385:6: ^( DATA IDENT ( inModes )? dataType ( initialization )? ( OBSERVABLE )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(stream_DATA.nextNode(), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        # Slim.g:385:19: ( inModes )?
                        if stream_inModes.hasNext():
                            self._adaptor.addChild(root_1, stream_inModes.nextTree())


                        stream_inModes.reset();
                        self._adaptor.addChild(root_1, stream_dataType.nextTree())
                        # Slim.g:385:37: ( initialization )?
                        if stream_initialization.hasNext():
                            self._adaptor.addChild(root_1, stream_initialization.nextTree())


                        stream_initialization.reset();
                        # Slim.g:385:53: ( OBSERVABLE )?
                        if stream_OBSERVABLE.hasNext():
                            self._adaptor.addChild(root_1, stream_OBSERVABLE.nextNode())


                        stream_OBSERVABLE.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "subcomponent"

    class binding_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "binding"
    # Slim.g:388:1: binding : ( STORED IN | RUNNING ON | ACCESSES ) IDENT ;
    def binding(self, ):

        retval = self.binding_return()
        retval.start = self.input.LT(1)

        root_0 = None

        STORED169 = None
        IN170 = None
        RUNNING171 = None
        ON172 = None
        ACCESSES173 = None
        IDENT174 = None

        STORED169_tree = None
        IN170_tree = None
        RUNNING171_tree = None
        ON172_tree = None
        ACCESSES173_tree = None
        IDENT174_tree = None

        try:
            try:
                # Slim.g:389:2: ( ( STORED IN | RUNNING ON | ACCESSES ) IDENT )
                # Slim.g:389:4: ( STORED IN | RUNNING ON | ACCESSES ) IDENT
                pass 
                root_0 = self._adaptor.nil()

                # Slim.g:389:4: ( STORED IN | RUNNING ON | ACCESSES )
                alt65 = 3
                LA65 = self.input.LA(1)
                if LA65 == STORED:
                    alt65 = 1
                elif LA65 == RUNNING:
                    alt65 = 2
                elif LA65 == ACCESSES:
                    alt65 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 65, 0, self.input)

                    raise nvae

                if alt65 == 1:
                    # Slim.g:389:5: STORED IN
                    pass 
                    STORED169=self.match(self.input, STORED, self.FOLLOW_STORED_in_binding2379)
                    if self._state.backtracking == 0:

                        STORED169_tree = self._adaptor.createWithPayload(STORED169)
                        root_0 = self._adaptor.becomeRoot(STORED169_tree, root_0)

                    IN170=self.match(self.input, IN, self.FOLLOW_IN_in_binding2382)


                elif alt65 == 2:
                    # Slim.g:389:19: RUNNING ON
                    pass 
                    RUNNING171=self.match(self.input, RUNNING, self.FOLLOW_RUNNING_in_binding2387)
                    if self._state.backtracking == 0:

                        RUNNING171_tree = self._adaptor.createWithPayload(RUNNING171)
                        root_0 = self._adaptor.becomeRoot(RUNNING171_tree, root_0)

                    ON172=self.match(self.input, ON, self.FOLLOW_ON_in_binding2390)


                elif alt65 == 3:
                    # Slim.g:389:34: ACCESSES
                    pass 
                    ACCESSES173=self.match(self.input, ACCESSES, self.FOLLOW_ACCESSES_in_binding2395)
                    if self._state.backtracking == 0:

                        ACCESSES173_tree = self._adaptor.createWithPayload(ACCESSES173)
                        root_0 = self._adaptor.becomeRoot(ACCESSES173_tree, root_0)




                IDENT174=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_binding2399)
                if self._state.backtracking == 0:

                    IDENT174_tree = self._adaptor.createWithPayload(IDENT174)
                    self._adaptor.addChild(root_0, IDENT174_tree)




                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "binding"

    class portConnection_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "portConnection"
    # Slim.g:393:1: portConnection : ( EVENT PORT nameOrIdentifier ARROW nameOrIdentifier ( inModes )? ( PASSIVE )? SEMICOLON -> ^( EVENT_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? ( PASSIVE )? ) | DATA PORT nameOrIdentifier ARROW nameOrIdentifier ( inModes )? SEMICOLON -> ^( DATA_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? ) );
    def portConnection(self, ):

        retval = self.portConnection_return()
        retval.start = self.input.LT(1)

        root_0 = None

        EVENT175 = None
        PORT176 = None
        ARROW178 = None
        PASSIVE181 = None
        SEMICOLON182 = None
        DATA183 = None
        PORT184 = None
        ARROW186 = None
        SEMICOLON189 = None
        nameOrIdentifier177 = None

        nameOrIdentifier179 = None

        inModes180 = None

        nameOrIdentifier185 = None

        nameOrIdentifier187 = None

        inModes188 = None


        EVENT175_tree = None
        PORT176_tree = None
        ARROW178_tree = None
        PASSIVE181_tree = None
        SEMICOLON182_tree = None
        DATA183_tree = None
        PORT184_tree = None
        ARROW186_tree = None
        SEMICOLON189_tree = None
        stream_PASSIVE = RewriteRuleTokenStream(self._adaptor, "token PASSIVE")
        stream_ARROW = RewriteRuleTokenStream(self._adaptor, "token ARROW")
        stream_PORT = RewriteRuleTokenStream(self._adaptor, "token PORT")
        stream_DATA = RewriteRuleTokenStream(self._adaptor, "token DATA")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_EVENT = RewriteRuleTokenStream(self._adaptor, "token EVENT")
        stream_nameOrIdentifier = RewriteRuleSubtreeStream(self._adaptor, "rule nameOrIdentifier")
        stream_inModes = RewriteRuleSubtreeStream(self._adaptor, "rule inModes")
        self.rules.append("port connection") 
        try:
            try:
                # Slim.g:396:2: ( EVENT PORT nameOrIdentifier ARROW nameOrIdentifier ( inModes )? ( PASSIVE )? SEMICOLON -> ^( EVENT_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? ( PASSIVE )? ) | DATA PORT nameOrIdentifier ARROW nameOrIdentifier ( inModes )? SEMICOLON -> ^( DATA_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? ) )
                alt69 = 2
                LA69_0 = self.input.LA(1)

                if (LA69_0 == EVENT) :
                    alt69 = 1
                elif (LA69_0 == DATA) :
                    alt69 = 2
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 69, 0, self.input)

                    raise nvae

                if alt69 == 1:
                    # Slim.g:396:4: EVENT PORT nameOrIdentifier ARROW nameOrIdentifier ( inModes )? ( PASSIVE )? SEMICOLON
                    pass 
                    EVENT175=self.match(self.input, EVENT, self.FOLLOW_EVENT_in_portConnection2424) 
                    if self._state.backtracking == 0:
                        stream_EVENT.add(EVENT175)
                    PORT176=self.match(self.input, PORT, self.FOLLOW_PORT_in_portConnection2426) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT176)
                    self._state.following.append(self.FOLLOW_nameOrIdentifier_in_portConnection2428)
                    nameOrIdentifier177 = self.nameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_nameOrIdentifier.add(nameOrIdentifier177.tree)
                    ARROW178=self.match(self.input, ARROW, self.FOLLOW_ARROW_in_portConnection2430) 
                    if self._state.backtracking == 0:
                        stream_ARROW.add(ARROW178)
                    self._state.following.append(self.FOLLOW_nameOrIdentifier_in_portConnection2432)
                    nameOrIdentifier179 = self.nameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_nameOrIdentifier.add(nameOrIdentifier179.tree)
                    # Slim.g:396:55: ( inModes )?
                    alt66 = 2
                    LA66_0 = self.input.LA(1)

                    if (LA66_0 == IN) :
                        alt66 = 1
                    if alt66 == 1:
                        # Slim.g:0:0: inModes
                        pass 
                        self._state.following.append(self.FOLLOW_inModes_in_portConnection2434)
                        inModes180 = self.inModes()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_inModes.add(inModes180.tree)



                    # Slim.g:396:64: ( PASSIVE )?
                    alt67 = 2
                    LA67_0 = self.input.LA(1)

                    if (LA67_0 == PASSIVE) :
                        alt67 = 1
                    if alt67 == 1:
                        # Slim.g:0:0: PASSIVE
                        pass 
                        PASSIVE181=self.match(self.input, PASSIVE, self.FOLLOW_PASSIVE_in_portConnection2437) 
                        if self._state.backtracking == 0:
                            stream_PASSIVE.add(PASSIVE181)



                    SEMICOLON182=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portConnection2440) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON182)

                    # AST Rewrite
                    # elements: PASSIVE, nameOrIdentifier, nameOrIdentifier, inModes
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 397:3: -> ^( EVENT_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? ( PASSIVE )? )
                        # Slim.g:397:6: ^( EVENT_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? ( PASSIVE )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(EVENT_CONNECTION, "EVENT_CONNECTION"), root_1)

                        self._adaptor.addChild(root_1, stream_nameOrIdentifier.nextTree())
                        self._adaptor.addChild(root_1, stream_nameOrIdentifier.nextTree())
                        # Slim.g:397:59: ( inModes )?
                        if stream_inModes.hasNext():
                            self._adaptor.addChild(root_1, stream_inModes.nextTree())


                        stream_inModes.reset();
                        # Slim.g:397:68: ( PASSIVE )?
                        if stream_PASSIVE.hasNext():
                            self._adaptor.addChild(root_1, stream_PASSIVE.nextNode())


                        stream_PASSIVE.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt69 == 2:
                    # Slim.g:398:4: DATA PORT nameOrIdentifier ARROW nameOrIdentifier ( inModes )? SEMICOLON
                    pass 
                    DATA183=self.match(self.input, DATA, self.FOLLOW_DATA_in_portConnection2463) 
                    if self._state.backtracking == 0:
                        stream_DATA.add(DATA183)
                    PORT184=self.match(self.input, PORT, self.FOLLOW_PORT_in_portConnection2465) 
                    if self._state.backtracking == 0:
                        stream_PORT.add(PORT184)
                    self._state.following.append(self.FOLLOW_nameOrIdentifier_in_portConnection2467)
                    nameOrIdentifier185 = self.nameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_nameOrIdentifier.add(nameOrIdentifier185.tree)
                    ARROW186=self.match(self.input, ARROW, self.FOLLOW_ARROW_in_portConnection2469) 
                    if self._state.backtracking == 0:
                        stream_ARROW.add(ARROW186)
                    self._state.following.append(self.FOLLOW_nameOrIdentifier_in_portConnection2471)
                    nameOrIdentifier187 = self.nameOrIdentifier()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_nameOrIdentifier.add(nameOrIdentifier187.tree)
                    # Slim.g:398:54: ( inModes )?
                    alt68 = 2
                    LA68_0 = self.input.LA(1)

                    if (LA68_0 == IN) :
                        alt68 = 1
                    if alt68 == 1:
                        # Slim.g:0:0: inModes
                        pass 
                        self._state.following.append(self.FOLLOW_inModes_in_portConnection2473)
                        inModes188 = self.inModes()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_inModes.add(inModes188.tree)



                    SEMICOLON189=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_portConnection2476) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON189)

                    # AST Rewrite
                    # elements: inModes, nameOrIdentifier, nameOrIdentifier
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 399:3: -> ^( DATA_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? )
                        # Slim.g:399:6: ^( DATA_CONNECTION nameOrIdentifier nameOrIdentifier ( inModes )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(DATA_CONNECTION, "DATA_CONNECTION"), root_1)

                        self._adaptor.addChild(root_1, stream_nameOrIdentifier.nextTree())
                        self._adaptor.addChild(root_1, stream_nameOrIdentifier.nextTree())
                        # Slim.g:399:58: ( inModes )?
                        if stream_inModes.hasNext():
                            self._adaptor.addChild(root_1, stream_inModes.nextTree())


                        stream_inModes.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "portConnection"

    class flow_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "flow"
    # Slim.g:403:1: flow : nameOrIdentifier ASSIGN expression ( inModes )? SEMICOLON -> ^( FLOW nameOrIdentifier expression ( inModes )? ) ;
    def flow(self, ):

        retval = self.flow_return()
        retval.start = self.input.LT(1)

        root_0 = None

        ASSIGN191 = None
        SEMICOLON194 = None
        nameOrIdentifier190 = None

        expression192 = None

        inModes193 = None


        ASSIGN191_tree = None
        SEMICOLON194_tree = None
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_ASSIGN = RewriteRuleTokenStream(self._adaptor, "token ASSIGN")
        stream_nameOrIdentifier = RewriteRuleSubtreeStream(self._adaptor, "rule nameOrIdentifier")
        stream_expression = RewriteRuleSubtreeStream(self._adaptor, "rule expression")
        stream_inModes = RewriteRuleSubtreeStream(self._adaptor, "rule inModes")
        self.rules.append("flow") 
        try:
            try:
                # Slim.g:406:5: ( nameOrIdentifier ASSIGN expression ( inModes )? SEMICOLON -> ^( FLOW nameOrIdentifier expression ( inModes )? ) )
                # Slim.g:406:9: nameOrIdentifier ASSIGN expression ( inModes )? SEMICOLON
                pass 
                if self._state.backtracking == 0:
                    self.allow_names = True

                self._state.following.append(self.FOLLOW_nameOrIdentifier_in_flow2522)
                nameOrIdentifier190 = self.nameOrIdentifier()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_nameOrIdentifier.add(nameOrIdentifier190.tree)
                ASSIGN191=self.match(self.input, ASSIGN, self.FOLLOW_ASSIGN_in_flow2524) 
                if self._state.backtracking == 0:
                    stream_ASSIGN.add(ASSIGN191)
                self._state.following.append(self.FOLLOW_expression_in_flow2526)
                expression192 = self.expression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_expression.add(expression192.tree)
                if self._state.backtracking == 0:
                    self.allow_names = False

                # Slim.g:406:97: ( inModes )?
                alt70 = 2
                LA70_0 = self.input.LA(1)

                if (LA70_0 == IN) :
                    alt70 = 1
                if alt70 == 1:
                    # Slim.g:406:98: inModes
                    pass 
                    self._state.following.append(self.FOLLOW_inModes_in_flow2531)
                    inModes193 = self.inModes()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_inModes.add(inModes193.tree)



                SEMICOLON194=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_flow2535) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON194)

                # AST Rewrite
                # elements: expression, inModes, nameOrIdentifier
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 407:9: -> ^( FLOW nameOrIdentifier expression ( inModes )? )
                    # Slim.g:407:12: ^( FLOW nameOrIdentifier expression ( inModes )? )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(FLOW, "FLOW"), root_1)

                    self._adaptor.addChild(root_1, stream_nameOrIdentifier.nextTree())
                    self._adaptor.addChild(root_1, stream_expression.nextTree())
                    # Slim.g:407:47: ( inModes )?
                    if stream_inModes.hasNext():
                        self._adaptor.addChild(root_1, stream_inModes.nextTree())


                    stream_inModes.reset();

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "flow"

    class mode_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "mode"
    # Slim.g:412:1: mode : IDENT COLON modeType MODE ( urgent )? ( WHILE invariant )? SEMICOLON -> ^( modeType IDENT ( urgent )? ( invariant )? ) ;
    def mode(self, ):

        retval = self.mode_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT195 = None
        COLON196 = None
        MODE198 = None
        WHILE200 = None
        SEMICOLON202 = None
        modeType197 = None

        urgent199 = None

        invariant201 = None


        IDENT195_tree = None
        COLON196_tree = None
        MODE198_tree = None
        WHILE200_tree = None
        SEMICOLON202_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_MODE = RewriteRuleTokenStream(self._adaptor, "token MODE")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_WHILE = RewriteRuleTokenStream(self._adaptor, "token WHILE")
        stream_modeType = RewriteRuleSubtreeStream(self._adaptor, "rule modeType")
        stream_urgent = RewriteRuleSubtreeStream(self._adaptor, "rule urgent")
        stream_invariant = RewriteRuleSubtreeStream(self._adaptor, "rule invariant")
        self.rules.append("mode specification") 
        try:
            try:
                # Slim.g:415:2: ( IDENT COLON modeType MODE ( urgent )? ( WHILE invariant )? SEMICOLON -> ^( modeType IDENT ( urgent )? ( invariant )? ) )
                # Slim.g:415:4: IDENT COLON modeType MODE ( urgent )? ( WHILE invariant )? SEMICOLON
                pass 
                IDENT195=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_mode2591) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT195)
                COLON196=self.match(self.input, COLON, self.FOLLOW_COLON_in_mode2593) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON196)
                self._state.following.append(self.FOLLOW_modeType_in_mode2595)
                modeType197 = self.modeType()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_modeType.add(modeType197.tree)
                MODE198=self.match(self.input, MODE, self.FOLLOW_MODE_in_mode2597) 
                if self._state.backtracking == 0:
                    stream_MODE.add(MODE198)
                # Slim.g:416:9: ( urgent )?
                alt71 = 2
                LA71_0 = self.input.LA(1)

                if (LA71_0 == URGENT) :
                    alt71 = 1
                if alt71 == 1:
                    # Slim.g:0:0: urgent
                    pass 
                    self._state.following.append(self.FOLLOW_urgent_in_mode2608)
                    urgent199 = self.urgent()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_urgent.add(urgent199.tree)



                # Slim.g:417:9: ( WHILE invariant )?
                alt72 = 2
                LA72_0 = self.input.LA(1)

                if (LA72_0 == WHILE) :
                    alt72 = 1
                if alt72 == 1:
                    # Slim.g:417:10: WHILE invariant
                    pass 
                    WHILE200=self.match(self.input, WHILE, self.FOLLOW_WHILE_in_mode2620) 
                    if self._state.backtracking == 0:
                        stream_WHILE.add(WHILE200)
                    self._state.following.append(self.FOLLOW_invariant_in_mode2622)
                    invariant201 = self.invariant()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_invariant.add(invariant201.tree)



                SEMICOLON202=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_mode2635) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON202)

                # AST Rewrite
                # elements: invariant, urgent, IDENT, modeType
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 419:3: -> ^( modeType IDENT ( urgent )? ( invariant )? )
                    # Slim.g:419:6: ^( modeType IDENT ( urgent )? ( invariant )? )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(stream_modeType.nextNode(), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    # Slim.g:419:23: ( urgent )?
                    if stream_urgent.hasNext():
                        self._adaptor.addChild(root_1, stream_urgent.nextTree())


                    stream_urgent.reset();
                    # Slim.g:419:31: ( invariant )?
                    if stream_invariant.hasNext():
                        self._adaptor.addChild(root_1, stream_invariant.nextTree())


                    stream_invariant.reset();

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "mode"

    class urgent_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "urgent"
    # Slim.g:422:1: urgent : ( URGENT IN timeScaledNumber -> ^( URGENT timeScaledNumber ) | URGENT IN NUMBER -> ^( URGENT NUMBER ) );
    def urgent(self, ):

        retval = self.urgent_return()
        retval.start = self.input.LT(1)

        root_0 = None

        URGENT203 = None
        IN204 = None
        URGENT206 = None
        IN207 = None
        NUMBER208 = None
        timeScaledNumber205 = None


        URGENT203_tree = None
        IN204_tree = None
        URGENT206_tree = None
        IN207_tree = None
        NUMBER208_tree = None
        stream_URGENT = RewriteRuleTokenStream(self._adaptor, "token URGENT")
        stream_NUMBER = RewriteRuleTokenStream(self._adaptor, "token NUMBER")
        stream_IN = RewriteRuleTokenStream(self._adaptor, "token IN")
        stream_timeScaledNumber = RewriteRuleSubtreeStream(self._adaptor, "rule timeScaledNumber")
        self.rules.append("urgent") 
        try:
            try:
                # Slim.g:425:2: ( URGENT IN timeScaledNumber -> ^( URGENT timeScaledNumber ) | URGENT IN NUMBER -> ^( URGENT NUMBER ) )
                alt73 = 2
                LA73_0 = self.input.LA(1)

                if (LA73_0 == URGENT) :
                    LA73_1 = self.input.LA(2)

                    if (LA73_1 == IN) :
                        LA73_2 = self.input.LA(3)

                        if (LA73_2 == NUMBER) :
                            LA73_3 = self.input.LA(4)

                            if (self.synpred98_Slim()) :
                                alt73 = 1
                            elif (True) :
                                alt73 = 2
                            else:
                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                nvae = NoViableAltException("", 73, 3, self.input)

                                raise nvae

                        elif (LA73_2 == MINUS) :
                            alt73 = 1
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 73, 2, self.input)

                            raise nvae

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 73, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 73, 0, self.input)

                    raise nvae

                if alt73 == 1:
                    # Slim.g:425:4: URGENT IN timeScaledNumber
                    pass 
                    URGENT203=self.match(self.input, URGENT, self.FOLLOW_URGENT_in_urgent2672) 
                    if self._state.backtracking == 0:
                        stream_URGENT.add(URGENT203)
                    IN204=self.match(self.input, IN, self.FOLLOW_IN_in_urgent2674) 
                    if self._state.backtracking == 0:
                        stream_IN.add(IN204)
                    self._state.following.append(self.FOLLOW_timeScaledNumber_in_urgent2676)
                    timeScaledNumber205 = self.timeScaledNumber()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_timeScaledNumber.add(timeScaledNumber205.tree)

                    # AST Rewrite
                    # elements: URGENT, timeScaledNumber
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 425:31: -> ^( URGENT timeScaledNumber )
                        # Slim.g:425:34: ^( URGENT timeScaledNumber )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(stream_URGENT.nextNode(), root_1)

                        self._adaptor.addChild(root_1, stream_timeScaledNumber.nextTree())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt73 == 2:
                    # Slim.g:426:4: URGENT IN NUMBER
                    pass 
                    URGENT206=self.match(self.input, URGENT, self.FOLLOW_URGENT_in_urgent2689) 
                    if self._state.backtracking == 0:
                        stream_URGENT.add(URGENT206)
                    IN207=self.match(self.input, IN, self.FOLLOW_IN_in_urgent2691) 
                    if self._state.backtracking == 0:
                        stream_IN.add(IN207)
                    NUMBER208=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_urgent2693) 
                    if self._state.backtracking == 0:
                        stream_NUMBER.add(NUMBER208)

                    # AST Rewrite
                    # elements: NUMBER, URGENT
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 426:21: -> ^( URGENT NUMBER )
                        # Slim.g:426:24: ^( URGENT NUMBER )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(stream_URGENT.nextNode(), root_1)

                        self._adaptor.addChild(root_1, stream_NUMBER.nextNode())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "urgent"

    class modeType_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "modeType"
    # Slim.g:429:1: modeType : ( INITIAL | ACTIVATION | {...}? => ERROR | -> NORMAL );
    def modeType(self, ):

        retval = self.modeType_return()
        retval.start = self.input.LT(1)

        root_0 = None

        INITIAL209 = None
        ACTIVATION210 = None
        ERROR211 = None

        INITIAL209_tree = None
        ACTIVATION210_tree = None
        ERROR211_tree = None

        try:
            try:
                # Slim.g:430:2: ( INITIAL | ACTIVATION | {...}? => ERROR | -> NORMAL )
                alt74 = 4
                LA74_0 = self.input.LA(1)

                if (LA74_0 == INITIAL) :
                    alt74 = 1
                elif (LA74_0 == ACTIVATION) :
                    alt74 = 2
                elif (LA74_0 == ERROR) and ((globals.PARSER_ACCEPT_NOMINAL and globals.PARSER_ACCEPT_ERROR)):
                    alt74 = 3
                elif (LA74_0 == MODE) :
                    alt74 = 4
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 74, 0, self.input)

                    raise nvae

                if alt74 == 1:
                    # Slim.g:430:4: INITIAL
                    pass 
                    root_0 = self._adaptor.nil()

                    INITIAL209=self.match(self.input, INITIAL, self.FOLLOW_INITIAL_in_modeType2713)
                    if self._state.backtracking == 0:

                        INITIAL209_tree = self._adaptor.createWithPayload(INITIAL209)
                        self._adaptor.addChild(root_0, INITIAL209_tree)



                elif alt74 == 2:
                    # Slim.g:431:4: ACTIVATION
                    pass 
                    root_0 = self._adaptor.nil()

                    ACTIVATION210=self.match(self.input, ACTIVATION, self.FOLLOW_ACTIVATION_in_modeType2718)
                    if self._state.backtracking == 0:

                        ACTIVATION210_tree = self._adaptor.createWithPayload(ACTIVATION210)
                        self._adaptor.addChild(root_0, ACTIVATION210_tree)



                elif alt74 == 3:
                    # Slim.g:432:4: {...}? => ERROR
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((globals.PARSER_ACCEPT_NOMINAL and globals.PARSER_ACCEPT_ERROR)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "modeType", "globals.PARSER_ACCEPT_NOMINAL and globals.PARSER_ACCEPT_ERROR")

                    ERROR211=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_modeType2726)
                    if self._state.backtracking == 0:

                        ERROR211_tree = self._adaptor.createWithPayload(ERROR211)
                        self._adaptor.addChild(root_0, ERROR211_tree)



                elif alt74 == 4:
                    # Slim.g:434:3: 
                    pass 
                    # AST Rewrite
                    # elements: 
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 434:3: -> NORMAL
                        self._adaptor.addChild(root_0, self._adaptor.createFromType(NORMAL, "NORMAL"))



                        retval.tree = root_0


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "modeType"

    class invariant_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "invariant"
    # Slim.g:437:1: invariant : atomicInvariant ( AND atomicInvariant )* ;
    def invariant(self, ):

        retval = self.invariant_return()
        retval.start = self.input.LT(1)

        root_0 = None

        AND213 = None
        atomicInvariant212 = None

        atomicInvariant214 = None


        AND213_tree = None

        self.rules.append("invariant") 
        try:
            try:
                # Slim.g:440:2: ( atomicInvariant ( AND atomicInvariant )* )
                # Slim.g:440:4: atomicInvariant ( AND atomicInvariant )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_atomicInvariant_in_invariant2759)
                atomicInvariant212 = self.atomicInvariant()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, atomicInvariant212.tree)
                # Slim.g:440:20: ( AND atomicInvariant )*
                while True: #loop75
                    alt75 = 2
                    LA75_0 = self.input.LA(1)

                    if (LA75_0 == AND) :
                        alt75 = 1


                    if alt75 == 1:
                        # Slim.g:440:21: AND atomicInvariant
                        pass 
                        AND213=self.match(self.input, AND, self.FOLLOW_AND_in_invariant2762)
                        if self._state.backtracking == 0:

                            AND213_tree = self._adaptor.createWithPayload(AND213)
                            root_0 = self._adaptor.becomeRoot(AND213_tree, root_0)

                        self._state.following.append(self.FOLLOW_atomicInvariant_in_invariant2765)
                        atomicInvariant214 = self.atomicInvariant()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, atomicInvariant214.tree)


                    else:
                        break #loop75





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "invariant"

    class atomicInvariant_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "atomicInvariant"
    # Slim.g:443:1: atomicInvariant : ( expression | trajectoryEquation );
    def atomicInvariant(self, ):

        retval = self.atomicInvariant_return()
        retval.start = self.input.LT(1)

        root_0 = None

        expression215 = None

        trajectoryEquation216 = None



        try:
            try:
                # Slim.g:444:2: ( expression | trajectoryEquation )
                alt76 = 2
                LA76_0 = self.input.LA(1)

                if (LA76_0 == MODE or LA76_0 == CASE or LA76_0 == LPAREN or LA76_0 == ERROR or LA76_0 == NOT or LA76_0 == ENUM or LA76_0 == MINUS or (TRUE <= LA76_0 <= FALSE) or LA76_0 == NUMBER) :
                    alt76 = 1
                elif (LA76_0 == IDENT) :
                    LA76_2 = self.input.LA(2)

                    if (LA76_2 == EOF or LA76_2 == SEMICOLON or LA76_2 == DOT or (AND <= LA76_2 <= GE) or (OR <= LA76_2 <= IMP) or (EQ <= LA76_2 <= NEQ) or (MSEC <= LA76_2 <= MOD)) :
                        alt76 = 1
                    elif (LA76_2 == DERIVATIVE) :
                        alt76 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 76, 2, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 76, 0, self.input)

                    raise nvae

                if alt76 == 1:
                    # Slim.g:444:4: expression
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_expression_in_atomicInvariant2779)
                    expression215 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression215.tree)


                elif alt76 == 2:
                    # Slim.g:445:4: trajectoryEquation
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_trajectoryEquation_in_atomicInvariant2784)
                    trajectoryEquation216 = self.trajectoryEquation()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, trajectoryEquation216.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "atomicInvariant"

    class expression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "expression"
    # Slim.g:450:1: expression : impExpression ;
    def expression(self, ):

        retval = self.expression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        impExpression217 = None



        self.rules.append("expression") 
        try:
            try:
                # Slim.g:453:2: ( impExpression )
                # Slim.g:453:5: impExpression
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_impExpression_in_expression2811)
                impExpression217 = self.impExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, impExpression217.tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "expression"

    class expressionsOnly_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "expressionsOnly"
    # Slim.g:456:1: expressionsOnly : {...}? => expression EOF ;
    def expressionsOnly(self, ):

        retval = self.expressionsOnly_return()
        retval.start = self.input.LT(1)

        root_0 = None

        EOF219 = None
        expression218 = None


        EOF219_tree = None

        try:
            try:
                # Slim.g:457:2: ({...}? => expression EOF )
                # Slim.g:457:4: {...}? => expression EOF
                pass 
                root_0 = self._adaptor.nil()

                if not ((globals.PARSER_EXPRESSIONS_ONLY)):
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    raise FailedPredicateException(self.input, "expressionsOnly", "globals.PARSER_EXPRESSIONS_ONLY")

                self._state.following.append(self.FOLLOW_expression_in_expressionsOnly2825)
                expression218 = self.expression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, expression218.tree)
                EOF219=self.match(self.input, EOF, self.FOLLOW_EOF_in_expressionsOnly2827)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "expressionsOnly"

    class impExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "impExpression"
    # Slim.g:460:1: impExpression : iffExpression ( IMP iffExpression )* ;
    def impExpression(self, ):

        retval = self.impExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IMP221 = None
        iffExpression220 = None

        iffExpression222 = None


        IMP221_tree = None

        try:
            try:
                # Slim.g:461:2: ( iffExpression ( IMP iffExpression )* )
                # Slim.g:461:4: iffExpression ( IMP iffExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_iffExpression_in_impExpression2839)
                iffExpression220 = self.iffExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, iffExpression220.tree)
                # Slim.g:461:18: ( IMP iffExpression )*
                while True: #loop77
                    alt77 = 2
                    LA77_0 = self.input.LA(1)

                    if (LA77_0 == IMP) :
                        alt77 = 1


                    if alt77 == 1:
                        # Slim.g:461:19: IMP iffExpression
                        pass 
                        IMP221=self.match(self.input, IMP, self.FOLLOW_IMP_in_impExpression2842)
                        if self._state.backtracking == 0:

                            IMP221_tree = self._adaptor.createWithPayload(IMP221)
                            root_0 = self._adaptor.becomeRoot(IMP221_tree, root_0)

                        self._state.following.append(self.FOLLOW_iffExpression_in_impExpression2845)
                        iffExpression222 = self.iffExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, iffExpression222.tree)


                    else:
                        break #loop77





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "impExpression"

    class iffExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "iffExpression"
    # Slim.g:464:1: iffExpression : orExpression ( IFF orExpression )* ;
    def iffExpression(self, ):

        retval = self.iffExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IFF224 = None
        orExpression223 = None

        orExpression225 = None


        IFF224_tree = None

        try:
            try:
                # Slim.g:465:2: ( orExpression ( IFF orExpression )* )
                # Slim.g:465:4: orExpression ( IFF orExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_orExpression_in_iffExpression2858)
                orExpression223 = self.orExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, orExpression223.tree)
                # Slim.g:465:17: ( IFF orExpression )*
                while True: #loop78
                    alt78 = 2
                    LA78_0 = self.input.LA(1)

                    if (LA78_0 == IFF) :
                        alt78 = 1


                    if alt78 == 1:
                        # Slim.g:465:18: IFF orExpression
                        pass 
                        IFF224=self.match(self.input, IFF, self.FOLLOW_IFF_in_iffExpression2861)
                        if self._state.backtracking == 0:

                            IFF224_tree = self._adaptor.createWithPayload(IFF224)
                            root_0 = self._adaptor.becomeRoot(IFF224_tree, root_0)

                        self._state.following.append(self.FOLLOW_orExpression_in_iffExpression2864)
                        orExpression225 = self.orExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, orExpression225.tree)


                    else:
                        break #loop78





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "iffExpression"

    class orExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "orExpression"
    # Slim.g:468:1: orExpression : andExpression ( ( OR | XOR | XNOR ) andExpression )* ;
    def orExpression(self, ):

        retval = self.orExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set227 = None
        andExpression226 = None

        andExpression228 = None


        set227_tree = None

        try:
            try:
                # Slim.g:469:2: ( andExpression ( ( OR | XOR | XNOR ) andExpression )* )
                # Slim.g:469:4: andExpression ( ( OR | XOR | XNOR ) andExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_andExpression_in_orExpression2877)
                andExpression226 = self.andExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, andExpression226.tree)
                # Slim.g:469:18: ( ( OR | XOR | XNOR ) andExpression )*
                while True: #loop79
                    alt79 = 2
                    LA79_0 = self.input.LA(1)

                    if ((OR <= LA79_0 <= XNOR)) :
                        alt79 = 1


                    if alt79 == 1:
                        # Slim.g:469:19: ( OR | XOR | XNOR ) andExpression
                        pass 
                        set227 = self.input.LT(1)
                        set227 = self.input.LT(1)
                        if (OR <= self.input.LA(1) <= XNOR):
                            self.input.consume()
                            if self._state.backtracking == 0:
                                root_0 = self._adaptor.becomeRoot(self._adaptor.createWithPayload(set227), root_0)
                            self._state.errorRecovery = False

                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            mse = MismatchedSetException(None, self.input)
                            raise mse


                        self._state.following.append(self.FOLLOW_andExpression_in_orExpression2889)
                        andExpression228 = self.andExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, andExpression228.tree)


                    else:
                        break #loop79





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "orExpression"

    class andExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "andExpression"
    # Slim.g:472:1: andExpression : compareExpression ( AND compareExpression )* ;
    def andExpression(self, ):

        retval = self.andExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        AND230 = None
        compareExpression229 = None

        compareExpression231 = None


        AND230_tree = None

        try:
            try:
                # Slim.g:473:2: ( compareExpression ( AND compareExpression )* )
                # Slim.g:473:4: compareExpression ( AND compareExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_compareExpression_in_andExpression2903)
                compareExpression229 = self.compareExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, compareExpression229.tree)
                # Slim.g:473:22: ( AND compareExpression )*
                while True: #loop80
                    alt80 = 2
                    alt80 = self.dfa80.predict(self.input)
                    if alt80 == 1:
                        # Slim.g:473:23: AND compareExpression
                        pass 
                        AND230=self.match(self.input, AND, self.FOLLOW_AND_in_andExpression2906)
                        if self._state.backtracking == 0:

                            AND230_tree = self._adaptor.createWithPayload(AND230)
                            root_0 = self._adaptor.becomeRoot(AND230_tree, root_0)

                        self._state.following.append(self.FOLLOW_compareExpression_in_andExpression2909)
                        compareExpression231 = self.compareExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, compareExpression231.tree)


                    else:
                        break #loop80





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "andExpression"

    class compareExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "compareExpression"
    # Slim.g:476:1: compareExpression : relativeExpression ({...}? => ( EQ | NEQ ) relativeExpression )* ;
    def compareExpression(self, ):

        retval = self.compareExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set233 = None
        relativeExpression232 = None

        relativeExpression234 = None


        set233_tree = None

        try:
            try:
                # Slim.g:477:2: ( relativeExpression ({...}? => ( EQ | NEQ ) relativeExpression )* )
                # Slim.g:477:4: relativeExpression ({...}? => ( EQ | NEQ ) relativeExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_relativeExpression_in_compareExpression2924)
                relativeExpression232 = self.relativeExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, relativeExpression232.tree)
                # Slim.g:477:23: ({...}? => ( EQ | NEQ ) relativeExpression )*
                while True: #loop81
                    alt81 = 2
                    LA81_0 = self.input.LA(1)

                    if ((EQ <= LA81_0 <= NEQ)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        alt81 = 1


                    if alt81 == 1:
                        # Slim.g:477:24: {...}? => ( EQ | NEQ ) relativeExpression
                        pass 
                        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            raise FailedPredicateException(self.input, "compareExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                        set233 = self.input.LT(1)
                        set233 = self.input.LT(1)
                        if (EQ <= self.input.LA(1) <= NEQ):
                            self.input.consume()
                            if self._state.backtracking == 0:
                                root_0 = self._adaptor.becomeRoot(self._adaptor.createWithPayload(set233), root_0)
                            self._state.errorRecovery = False

                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            mse = MismatchedSetException(None, self.input)
                            raise mse


                        self._state.following.append(self.FOLLOW_relativeExpression_in_compareExpression2937)
                        relativeExpression234 = self.relativeExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, relativeExpression234.tree)


                    else:
                        break #loop81





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "compareExpression"

    class relativeExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "relativeExpression"
    # Slim.g:480:1: relativeExpression : addExpression ({...}? => ( LT | LE | GT | GE ) addExpression )* ;
    def relativeExpression(self, ):

        retval = self.relativeExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set236 = None
        addExpression235 = None

        addExpression237 = None


        set236_tree = None

        try:
            try:
                # Slim.g:481:2: ( addExpression ({...}? => ( LT | LE | GT | GE ) addExpression )* )
                # Slim.g:481:4: addExpression ({...}? => ( LT | LE | GT | GE ) addExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_addExpression_in_relativeExpression2951)
                addExpression235 = self.addExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, addExpression235.tree)
                # Slim.g:481:18: ({...}? => ( LT | LE | GT | GE ) addExpression )*
                while True: #loop82
                    alt82 = 2
                    LA82_0 = self.input.LA(1)

                    if ((LT <= LA82_0 <= GE)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        alt82 = 1


                    if alt82 == 1:
                        # Slim.g:481:19: {...}? => ( LT | LE | GT | GE ) addExpression
                        pass 
                        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            raise FailedPredicateException(self.input, "relativeExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                        set236 = self.input.LT(1)
                        set236 = self.input.LT(1)
                        if (LT <= self.input.LA(1) <= GE):
                            self.input.consume()
                            if self._state.backtracking == 0:
                                root_0 = self._adaptor.becomeRoot(self._adaptor.createWithPayload(set236), root_0)
                            self._state.errorRecovery = False

                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            mse = MismatchedSetException(None, self.input)
                            raise mse


                        self._state.following.append(self.FOLLOW_addExpression_in_relativeExpression2968)
                        addExpression237 = self.addExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, addExpression237.tree)


                    else:
                        break #loop82





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "relativeExpression"

    class addExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "addExpression"
    # Slim.g:484:1: addExpression : mulExpression ({...}? => ( PLUS | MINUS ) mulExpression )* ;
    def addExpression(self, ):

        retval = self.addExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set239 = None
        mulExpression238 = None

        mulExpression240 = None


        set239_tree = None

        try:
            try:
                # Slim.g:485:2: ( mulExpression ({...}? => ( PLUS | MINUS ) mulExpression )* )
                # Slim.g:485:4: mulExpression ({...}? => ( PLUS | MINUS ) mulExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_mulExpression_in_addExpression2981)
                mulExpression238 = self.mulExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, mulExpression238.tree)
                # Slim.g:485:18: ({...}? => ( PLUS | MINUS ) mulExpression )*
                while True: #loop83
                    alt83 = 2
                    LA83_0 = self.input.LA(1)

                    if ((PLUS <= LA83_0 <= MINUS)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        alt83 = 1


                    if alt83 == 1:
                        # Slim.g:485:19: {...}? => ( PLUS | MINUS ) mulExpression
                        pass 
                        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            raise FailedPredicateException(self.input, "addExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                        set239 = self.input.LT(1)
                        set239 = self.input.LT(1)
                        if (PLUS <= self.input.LA(1) <= MINUS):
                            self.input.consume()
                            if self._state.backtracking == 0:
                                root_0 = self._adaptor.becomeRoot(self._adaptor.createWithPayload(set239), root_0)
                            self._state.errorRecovery = False

                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            mse = MismatchedSetException(None, self.input)
                            raise mse


                        self._state.following.append(self.FOLLOW_mulExpression_in_addExpression2994)
                        mulExpression240 = self.mulExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, mulExpression240.tree)


                    else:
                        break #loop83





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "addExpression"

    class mulExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "mulExpression"
    # Slim.g:488:1: mulExpression : timeExpression ({...}? => ( TIMES | DIVIDE | MOD ) timeExpression )* ;
    def mulExpression(self, ):

        retval = self.mulExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set242 = None
        timeExpression241 = None

        timeExpression243 = None


        set242_tree = None

        try:
            try:
                # Slim.g:489:2: ( timeExpression ({...}? => ( TIMES | DIVIDE | MOD ) timeExpression )* )
                # Slim.g:489:4: timeExpression ({...}? => ( TIMES | DIVIDE | MOD ) timeExpression )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_timeExpression_in_mulExpression3007)
                timeExpression241 = self.timeExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, timeExpression241.tree)
                # Slim.g:489:19: ({...}? => ( TIMES | DIVIDE | MOD ) timeExpression )*
                while True: #loop84
                    alt84 = 2
                    LA84_0 = self.input.LA(1)

                    if (LA84_0 == TIMES or (DIVIDE <= LA84_0 <= MOD)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        alt84 = 1


                    if alt84 == 1:
                        # Slim.g:489:20: {...}? => ( TIMES | DIVIDE | MOD ) timeExpression
                        pass 
                        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            raise FailedPredicateException(self.input, "mulExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                        set242 = self.input.LT(1)
                        set242 = self.input.LT(1)
                        if self.input.LA(1) == TIMES or (DIVIDE <= self.input.LA(1) <= MOD):
                            self.input.consume()
                            if self._state.backtracking == 0:
                                root_0 = self._adaptor.becomeRoot(self._adaptor.createWithPayload(set242), root_0)
                            self._state.errorRecovery = False

                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            mse = MismatchedSetException(None, self.input)
                            raise mse


                        self._state.following.append(self.FOLLOW_timeExpression_in_mulExpression3022)
                        timeExpression243 = self.timeExpression()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, timeExpression243.tree)


                    else:
                        break #loop84





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "mulExpression"

    class timeExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "timeExpression"
    # Slim.g:492:1: timeExpression : unaryExpression ( timeScale )* ;
    def timeExpression(self, ):

        retval = self.timeExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        unaryExpression244 = None

        timeScale245 = None



        try:
            try:
                # Slim.g:493:2: ( unaryExpression ( timeScale )* )
                # Slim.g:493:4: unaryExpression ( timeScale )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_unaryExpression_in_timeExpression3035)
                unaryExpression244 = self.unaryExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, unaryExpression244.tree)
                # Slim.g:493:20: ( timeScale )*
                while True: #loop85
                    alt85 = 2
                    LA85_0 = self.input.LA(1)

                    if ((MSEC <= LA85_0 <= DAY)) :
                        alt85 = 1


                    if alt85 == 1:
                        # Slim.g:493:21: timeScale
                        pass 
                        self._state.following.append(self.FOLLOW_timeScale_in_timeExpression3038)
                        timeScale245 = self.timeScale()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            root_0 = self._adaptor.becomeRoot(timeScale245.tree, root_0)


                    else:
                        break #loop85





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "timeExpression"

    class unaryExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "unaryExpression"
    # Slim.g:496:1: unaryExpression : ( ( NOT unaryExpression ) -> ^( NOT unaryExpression ) | ( MINUS unaryExpression ) -> ^( UNARY_MINUS unaryExpression ) | atomicExpression );
    def unaryExpression(self, ):

        retval = self.unaryExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        NOT246 = None
        MINUS248 = None
        unaryExpression247 = None

        unaryExpression249 = None

        atomicExpression250 = None


        NOT246_tree = None
        MINUS248_tree = None
        stream_NOT = RewriteRuleTokenStream(self._adaptor, "token NOT")
        stream_MINUS = RewriteRuleTokenStream(self._adaptor, "token MINUS")
        stream_unaryExpression = RewriteRuleSubtreeStream(self._adaptor, "rule unaryExpression")
        try:
            try:
                # Slim.g:497:2: ( ( NOT unaryExpression ) -> ^( NOT unaryExpression ) | ( MINUS unaryExpression ) -> ^( UNARY_MINUS unaryExpression ) | atomicExpression )
                alt86 = 3
                alt86 = self.dfa86.predict(self.input)
                if alt86 == 1:
                    # Slim.g:497:4: ( NOT unaryExpression )
                    pass 
                    # Slim.g:497:4: ( NOT unaryExpression )
                    # Slim.g:497:5: NOT unaryExpression
                    pass 
                    NOT246=self.match(self.input, NOT, self.FOLLOW_NOT_in_unaryExpression3053) 
                    if self._state.backtracking == 0:
                        stream_NOT.add(NOT246)
                    self._state.following.append(self.FOLLOW_unaryExpression_in_unaryExpression3055)
                    unaryExpression247 = self.unaryExpression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_unaryExpression.add(unaryExpression247.tree)




                    # AST Rewrite
                    # elements: unaryExpression, NOT
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 497:26: -> ^( NOT unaryExpression )
                        # Slim.g:497:29: ^( NOT unaryExpression )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(stream_NOT.nextNode(), root_1)

                        self._adaptor.addChild(root_1, stream_unaryExpression.nextTree())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt86 == 2:
                    # Slim.g:498:4: ( MINUS unaryExpression )
                    pass 
                    # Slim.g:498:4: ( MINUS unaryExpression )
                    # Slim.g:498:5: MINUS unaryExpression
                    pass 
                    MINUS248=self.match(self.input, MINUS, self.FOLLOW_MINUS_in_unaryExpression3070) 
                    if self._state.backtracking == 0:
                        stream_MINUS.add(MINUS248)
                    self._state.following.append(self.FOLLOW_unaryExpression_in_unaryExpression3072)
                    unaryExpression249 = self.unaryExpression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_unaryExpression.add(unaryExpression249.tree)




                    # AST Rewrite
                    # elements: unaryExpression
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 498:28: -> ^( UNARY_MINUS unaryExpression )
                        # Slim.g:498:31: ^( UNARY_MINUS unaryExpression )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(UNARY_MINUS, "UNARY_MINUS"), root_1)

                        self._adaptor.addChild(root_1, stream_unaryExpression.nextTree())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt86 == 3:
                    # Slim.g:499:4: atomicExpression
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_atomicExpression_in_unaryExpression3086)
                    atomicExpression250 = self.atomicExpression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, atomicExpression250.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "unaryExpression"

    class atomicExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "atomicExpression"
    # Slim.g:502:1: atomicExpression : ({...}? => number | {...}? => atomicExpressionForParserExpressionsOnly | {...}? => name | IDENT | {...}? => ( TRUE | FALSE ) | LPAREN expression RPAREN | {...}? => CASE ( expression COLON expression SEMICOLON )* ( expression COLON expression ) OTHERWISE expression END );
    def atomicExpression(self, ):

        retval = self.atomicExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT254 = None
        set255 = None
        LPAREN256 = None
        RPAREN258 = None
        CASE259 = None
        COLON261 = None
        SEMICOLON263 = None
        COLON265 = None
        OTHERWISE267 = None
        END269 = None
        number251 = None

        atomicExpressionForParserExpressionsOnly252 = None

        name253 = None

        expression257 = None

        expression260 = None

        expression262 = None

        expression264 = None

        expression266 = None

        expression268 = None


        IDENT254_tree = None
        set255_tree = None
        LPAREN256_tree = None
        RPAREN258_tree = None
        CASE259_tree = None
        COLON261_tree = None
        SEMICOLON263_tree = None
        COLON265_tree = None
        OTHERWISE267_tree = None
        END269_tree = None

        try:
            try:
                # Slim.g:503:2: ({...}? => number | {...}? => atomicExpressionForParserExpressionsOnly | {...}? => name | IDENT | {...}? => ( TRUE | FALSE ) | LPAREN expression RPAREN | {...}? => CASE ( expression COLON expression SEMICOLON )* ( expression COLON expression ) OTHERWISE expression END )
                alt88 = 7
                alt88 = self.dfa88.predict(self.input)
                if alt88 == 1:
                    # Slim.g:503:4: {...}? => number
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "atomicExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                    self._state.following.append(self.FOLLOW_number_in_atomicExpression3100)
                    number251 = self.number()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, number251.tree)


                elif alt88 == 2:
                    # Slim.g:504:4: {...}? => atomicExpressionForParserExpressionsOnly
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "atomicExpression", "globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                    self._state.following.append(self.FOLLOW_atomicExpressionForParserExpressionsOnly_in_atomicExpression3108)
                    atomicExpressionForParserExpressionsOnly252 = self.atomicExpressionForParserExpressionsOnly()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, atomicExpressionForParserExpressionsOnly252.tree)


                elif alt88 == 3:
                    # Slim.g:505:4: {...}? => name
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((self.allow_names)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "atomicExpression", "self.allow_names")

                    self._state.following.append(self.FOLLOW_name_in_atomicExpression3116)
                    name253 = self.name()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, name253.tree)


                elif alt88 == 4:
                    # Slim.g:506:4: IDENT
                    pass 
                    root_0 = self._adaptor.nil()

                    IDENT254=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_atomicExpression3121)
                    if self._state.backtracking == 0:

                        IDENT254_tree = self._adaptor.createWithPayload(IDENT254)
                        self._adaptor.addChild(root_0, IDENT254_tree)



                elif alt88 == 5:
                    # Slim.g:507:4: {...}? => ( TRUE | FALSE )
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "atomicExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                    set255 = self.input.LT(1)
                    if (TRUE <= self.input.LA(1) <= FALSE):
                        self.input.consume()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, self._adaptor.createWithPayload(set255))
                        self._state.errorRecovery = False

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        mse = MismatchedSetException(None, self.input)
                        raise mse




                elif alt88 == 6:
                    # Slim.g:508:4: LPAREN expression RPAREN
                    pass 
                    root_0 = self._adaptor.nil()

                    LPAREN256=self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_atomicExpression3140)
                    self._state.following.append(self.FOLLOW_expression_in_atomicExpression3143)
                    expression257 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression257.tree)
                    RPAREN258=self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_atomicExpression3145)


                elif alt88 == 7:
                    # Slim.g:509:4: {...}? => CASE ( expression COLON expression SEMICOLON )* ( expression COLON expression ) OTHERWISE expression END
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "atomicExpression", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

                    CASE259=self.match(self.input, CASE, self.FOLLOW_CASE_in_atomicExpression3154)
                    if self._state.backtracking == 0:

                        CASE259_tree = self._adaptor.createWithPayload(CASE259)
                        root_0 = self._adaptor.becomeRoot(CASE259_tree, root_0)

                    # Slim.g:509:59: ( expression COLON expression SEMICOLON )*
                    while True: #loop87
                        alt87 = 2
                        alt87 = self.dfa87.predict(self.input)
                        if alt87 == 1:
                            # Slim.g:509:60: expression COLON expression SEMICOLON
                            pass 
                            self._state.following.append(self.FOLLOW_expression_in_atomicExpression3158)
                            expression260 = self.expression()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                self._adaptor.addChild(root_0, expression260.tree)
                            COLON261=self.match(self.input, COLON, self.FOLLOW_COLON_in_atomicExpression3160)
                            self._state.following.append(self.FOLLOW_expression_in_atomicExpression3163)
                            expression262 = self.expression()

                            self._state.following.pop()
                            if self._state.backtracking == 0:
                                self._adaptor.addChild(root_0, expression262.tree)
                            SEMICOLON263=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_atomicExpression3165)


                        else:
                            break #loop87


                    # Slim.g:509:102: ( expression COLON expression )
                    # Slim.g:509:103: expression COLON expression
                    pass 
                    self._state.following.append(self.FOLLOW_expression_in_atomicExpression3171)
                    expression264 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression264.tree)
                    COLON265=self.match(self.input, COLON, self.FOLLOW_COLON_in_atomicExpression3173)
                    self._state.following.append(self.FOLLOW_expression_in_atomicExpression3176)
                    expression266 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression266.tree)



                    OTHERWISE267=self.match(self.input, OTHERWISE, self.FOLLOW_OTHERWISE_in_atomicExpression3179)
                    if self._state.backtracking == 0:

                        OTHERWISE267_tree = self._adaptor.createWithPayload(OTHERWISE267)
                        self._adaptor.addChild(root_0, OTHERWISE267_tree)

                    self._state.following.append(self.FOLLOW_expression_in_atomicExpression3181)
                    expression268 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression268.tree)
                    END269=self.match(self.input, END, self.FOLLOW_END_in_atomicExpression3183)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "atomicExpression"

    class atomicExpressionForParserExpressionsOnly_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "atomicExpressionForParserExpressionsOnly"
    # Slim.g:512:1: atomicExpressionForParserExpressionsOnly : ( ENUM COLON i1= IDENT | MODE COLON i1= IDENT | ERROR COLON i1= IDENT | MODE -> | ERROR -> | i1= IDENT ( DOT i2= IDENT )* ( DOT (s= MODE | s= ERROR ) )? );
    def atomicExpressionForParserExpressionsOnly(self, ):

        retval = self.atomicExpressionForParserExpressionsOnly_return()
        retval.start = self.input.LT(1)

        root_0 = None

        i1 = None
        i2 = None
        s = None
        ENUM270 = None
        COLON271 = None
        MODE272 = None
        COLON273 = None
        ERROR274 = None
        COLON275 = None
        MODE276 = None
        ERROR277 = None
        DOT278 = None
        DOT279 = None

        i1_tree = None
        i2_tree = None
        s_tree = None
        ENUM270_tree = None
        COLON271_tree = None
        MODE272_tree = None
        COLON273_tree = None
        ERROR274_tree = None
        COLON275_tree = None
        MODE276_tree = None
        ERROR277_tree = None
        DOT278_tree = None
        DOT279_tree = None
        stream_MODE = RewriteRuleTokenStream(self._adaptor, "token MODE")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")

        try:
            try:
                # Slim.g:513:5: ( ENUM COLON i1= IDENT | MODE COLON i1= IDENT | ERROR COLON i1= IDENT | MODE -> | ERROR -> | i1= IDENT ( DOT i2= IDENT )* ( DOT (s= MODE | s= ERROR ) )? )
                alt92 = 6
                alt92 = self.dfa92.predict(self.input)
                if alt92 == 1:
                    # Slim.g:513:9: ENUM COLON i1= IDENT
                    pass 
                    root_0 = self._adaptor.nil()

                    ENUM270=self.match(self.input, ENUM, self.FOLLOW_ENUM_in_atomicExpressionForParserExpressionsOnly3201)
                    COLON271=self.match(self.input, COLON, self.FOLLOW_COLON_in_atomicExpressionForParserExpressionsOnly3204)
                    i1=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3209)
                    if self._state.backtracking == 0:

                        i1_tree = self._adaptor.createWithPayload(i1)
                        self._adaptor.addChild(root_0, i1_tree)

                    if self._state.backtracking == 0:
                           
                        i1.setText("enum:" + i1.text)
                        		



                elif alt92 == 2:
                    # Slim.g:517:4: MODE COLON i1= IDENT
                    pass 
                    root_0 = self._adaptor.nil()

                    MODE272=self.match(self.input, MODE, self.FOLLOW_MODE_in_atomicExpressionForParserExpressionsOnly3218)
                    COLON273=self.match(self.input, COLON, self.FOLLOW_COLON_in_atomicExpressionForParserExpressionsOnly3221)
                    i1=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3226)
                    if self._state.backtracking == 0:

                        i1_tree = self._adaptor.createWithPayload(i1)
                        self._adaptor.addChild(root_0, i1_tree)

                    if self._state.backtracking == 0:
                           
                        i1.setText("mode:" + i1.text)		
                        		



                elif alt92 == 3:
                    # Slim.g:521:4: ERROR COLON i1= IDENT
                    pass 
                    root_0 = self._adaptor.nil()

                    ERROR274=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_atomicExpressionForParserExpressionsOnly3235)
                    COLON275=self.match(self.input, COLON, self.FOLLOW_COLON_in_atomicExpressionForParserExpressionsOnly3238)
                    i1=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3243)
                    if self._state.backtracking == 0:

                        i1_tree = self._adaptor.createWithPayload(i1)
                        self._adaptor.addChild(root_0, i1_tree)

                    if self._state.backtracking == 0:
                           
                        i1.setText("error:" + i1.text)		
                        		



                elif alt92 == 4:
                    # Slim.g:525:8: MODE
                    pass 
                    MODE276=self.match(self.input, MODE, self.FOLLOW_MODE_in_atomicExpressionForParserExpressionsOnly3256) 
                    if self._state.backtracking == 0:
                        stream_MODE.add(MODE276)

                    # AST Rewrite
                    # elements: 
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 526:10: ->
                        self._adaptor.addChild(root_0, CommonTree(CommonToken(type=IDENT,text=MODE276.text)) )



                        retval.tree = root_0


                elif alt92 == 5:
                    # Slim.g:527:7: ERROR
                    pass 
                    ERROR277=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_atomicExpressionForParserExpressionsOnly3278) 
                    if self._state.backtracking == 0:
                        stream_ERROR.add(ERROR277)

                    # AST Rewrite
                    # elements: 
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 528:10: ->
                        self._adaptor.addChild(root_0, CommonTree(CommonToken(type=IDENT,text=ERROR277.text)) )



                        retval.tree = root_0


                elif alt92 == 6:
                    # Slim.g:529:12: i1= IDENT ( DOT i2= IDENT )* ( DOT (s= MODE | s= ERROR ) )?
                    pass 
                    root_0 = self._adaptor.nil()

                    i1=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3307)
                    if self._state.backtracking == 0:

                        i1_tree = self._adaptor.createWithPayload(i1)
                        self._adaptor.addChild(root_0, i1_tree)

                    # Slim.g:529:21: ( DOT i2= IDENT )*
                    while True: #loop89
                        alt89 = 2
                        LA89_0 = self.input.LA(1)

                        if (LA89_0 == DOT) :
                            LA89_1 = self.input.LA(2)

                            if (LA89_1 == IDENT) :
                                alt89 = 1




                        if alt89 == 1:
                            # Slim.g:529:22: DOT i2= IDENT
                            pass 
                            DOT278=self.match(self.input, DOT, self.FOLLOW_DOT_in_atomicExpressionForParserExpressionsOnly3310)
                            i2=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3315)
                            if self._state.backtracking == 0:
                                i1.setText(i1.text + "." + i2.text) 



                        else:
                            break #loop89


                    # Slim.g:530:11: ( DOT (s= MODE | s= ERROR ) )?
                    alt91 = 2
                    LA91_0 = self.input.LA(1)

                    if (LA91_0 == DOT) :
                        alt91 = 1
                    if alt91 == 1:
                        # Slim.g:530:12: DOT (s= MODE | s= ERROR )
                        pass 
                        DOT279=self.match(self.input, DOT, self.FOLLOW_DOT_in_atomicExpressionForParserExpressionsOnly3335)
                        # Slim.g:530:17: (s= MODE | s= ERROR )
                        alt90 = 2
                        LA90_0 = self.input.LA(1)

                        if (LA90_0 == MODE) :
                            alt90 = 1
                        elif (LA90_0 == ERROR) :
                            alt90 = 2
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 90, 0, self.input)

                            raise nvae

                        if alt90 == 1:
                            # Slim.g:530:18: s= MODE
                            pass 
                            s=self.match(self.input, MODE, self.FOLLOW_MODE_in_atomicExpressionForParserExpressionsOnly3341)


                        elif alt90 == 2:
                            # Slim.g:530:26: s= ERROR
                            pass 
                            s=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_atomicExpressionForParserExpressionsOnly3346)



                        if self._state.backtracking == 0:
                            i1.setText(i1.text + "." + s.text) 






                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "atomicExpressionForParserExpressionsOnly"

    class trajectoryEquation_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "trajectoryEquation"
    # Slim.g:533:1: trajectoryEquation : IDENT DERIVATIVE EQ trajectoryExpression ;
    def trajectoryEquation(self, ):

        retval = self.trajectoryEquation_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT280 = None
        DERIVATIVE281 = None
        EQ282 = None
        trajectoryExpression283 = None


        IDENT280_tree = None
        DERIVATIVE281_tree = None
        EQ282_tree = None

        try:
            try:
                # Slim.g:534:2: ( IDENT DERIVATIVE EQ trajectoryExpression )
                # Slim.g:534:4: IDENT DERIVATIVE EQ trajectoryExpression
                pass 
                root_0 = self._adaptor.nil()

                IDENT280=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_trajectoryEquation3367)
                if self._state.backtracking == 0:

                    IDENT280_tree = self._adaptor.createWithPayload(IDENT280)
                    self._adaptor.addChild(root_0, IDENT280_tree)

                DERIVATIVE281=self.match(self.input, DERIVATIVE, self.FOLLOW_DERIVATIVE_in_trajectoryEquation3369)
                if self._state.backtracking == 0:

                    DERIVATIVE281_tree = self._adaptor.createWithPayload(DERIVATIVE281)
                    root_0 = self._adaptor.becomeRoot(DERIVATIVE281_tree, root_0)

                EQ282=self.match(self.input, EQ, self.FOLLOW_EQ_in_trajectoryEquation3372)
                self._state.following.append(self.FOLLOW_trajectoryExpression_in_trajectoryEquation3375)
                trajectoryExpression283 = self.trajectoryExpression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, trajectoryExpression283.tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "trajectoryEquation"

    class trajectoryExpression_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "trajectoryExpression"
    # Slim.g:537:1: trajectoryExpression : number ( PER timeScale )? ;
    def trajectoryExpression(self, ):

        retval = self.trajectoryExpression_return()
        retval.start = self.input.LT(1)

        root_0 = None

        PER285 = None
        number284 = None

        timeScale286 = None


        PER285_tree = None

        try:
            try:
                # Slim.g:538:2: ( number ( PER timeScale )? )
                # Slim.g:538:4: number ( PER timeScale )?
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_number_in_trajectoryExpression3387)
                number284 = self.number()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, number284.tree)
                # Slim.g:538:11: ( PER timeScale )?
                alt93 = 2
                LA93_0 = self.input.LA(1)

                if (LA93_0 == PER) :
                    alt93 = 1
                if alt93 == 1:
                    # Slim.g:538:12: PER timeScale
                    pass 
                    PER285=self.match(self.input, PER, self.FOLLOW_PER_in_trajectoryExpression3390)
                    if self._state.backtracking == 0:

                        PER285_tree = self._adaptor.createWithPayload(PER285)
                        self._adaptor.addChild(root_0, PER285_tree)

                    self._state.following.append(self.FOLLOW_timeScale_in_trajectoryExpression3392)
                    timeScale286 = self.timeScale()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, timeScale286.tree)






                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "trajectoryExpression"

    class modeTransition_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "modeTransition"
    # Slim.g:543:1: modeTransition : ( sourceMode MINUS LBRACKET ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? RBRACKET ARROW IDENT SEMICOLON -> ^( MODE_TRANS sourceMode IDENT ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? ) | IDENT MINUS LBRACKET PROB NUMBER RBRACKET ARROW IDENT SEMICOLON -> ^( MODE_TRANS_PROB IDENT IDENT NUMBER ) );
    def modeTransition(self, ):

        retval = self.modeTransition_return()
        retval.start = self.input.LT(1)

        root_0 = None

        MINUS288 = None
        LBRACKET289 = None
        WHEN291 = None
        WITHIN293 = None
        THEN295 = None
        RBRACKET297 = None
        ARROW298 = None
        IDENT299 = None
        SEMICOLON300 = None
        IDENT301 = None
        MINUS302 = None
        LBRACKET303 = None
        PROB304 = None
        NUMBER305 = None
        RBRACKET306 = None
        ARROW307 = None
        IDENT308 = None
        SEMICOLON309 = None
        sourceMode287 = None

        modeTrigger290 = None

        modeGuard292 = None

        timeDelay294 = None

        modeEffect296 = None


        MINUS288_tree = None
        LBRACKET289_tree = None
        WHEN291_tree = None
        WITHIN293_tree = None
        THEN295_tree = None
        RBRACKET297_tree = None
        ARROW298_tree = None
        IDENT299_tree = None
        SEMICOLON300_tree = None
        IDENT301_tree = None
        MINUS302_tree = None
        LBRACKET303_tree = None
        PROB304_tree = None
        NUMBER305_tree = None
        RBRACKET306_tree = None
        ARROW307_tree = None
        IDENT308_tree = None
        SEMICOLON309_tree = None
        stream_PROB = RewriteRuleTokenStream(self._adaptor, "token PROB")
        stream_WHEN = RewriteRuleTokenStream(self._adaptor, "token WHEN")
        stream_NUMBER = RewriteRuleTokenStream(self._adaptor, "token NUMBER")
        stream_ARROW = RewriteRuleTokenStream(self._adaptor, "token ARROW")
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_LBRACKET = RewriteRuleTokenStream(self._adaptor, "token LBRACKET")
        stream_WITHIN = RewriteRuleTokenStream(self._adaptor, "token WITHIN")
        stream_THEN = RewriteRuleTokenStream(self._adaptor, "token THEN")
        stream_RBRACKET = RewriteRuleTokenStream(self._adaptor, "token RBRACKET")
        stream_MINUS = RewriteRuleTokenStream(self._adaptor, "token MINUS")
        stream_sourceMode = RewriteRuleSubtreeStream(self._adaptor, "rule sourceMode")
        stream_modeTrigger = RewriteRuleSubtreeStream(self._adaptor, "rule modeTrigger")
        stream_modeEffect = RewriteRuleSubtreeStream(self._adaptor, "rule modeEffect")
        stream_timeDelay = RewriteRuleSubtreeStream(self._adaptor, "rule timeDelay")
        stream_modeGuard = RewriteRuleSubtreeStream(self._adaptor, "rule modeGuard")
        self.rules.append("mode transition") 
        try:
            try:
                # Slim.g:546:2: ( sourceMode MINUS LBRACKET ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? RBRACKET ARROW IDENT SEMICOLON -> ^( MODE_TRANS sourceMode IDENT ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? ) | IDENT MINUS LBRACKET PROB NUMBER RBRACKET ARROW IDENT SEMICOLON -> ^( MODE_TRANS_PROB IDENT IDENT NUMBER ) )
                alt98 = 2
                LA98_0 = self.input.LA(1)

                if (LA98_0 == IDENT) :
                    LA98_1 = self.input.LA(2)

                    if (LA98_1 == MINUS) :
                        LA98_3 = self.input.LA(3)

                        if (LA98_3 == LBRACKET) :
                            LA98_4 = self.input.LA(4)

                            if (LA98_4 == PROB) :
                                alt98 = 2
                            elif (LA98_4 == ATACTIVATION or LA98_4 == THEN or (RBRACKET <= LA98_4 <= RESET) or (WHEN <= LA98_4 <= WITHIN) or LA98_4 == IDENT) :
                                alt98 = 1
                            else:
                                if self._state.backtracking > 0:
                                    raise BacktrackingFailed

                                nvae = NoViableAltException("", 98, 4, self.input)

                                raise nvae

                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 98, 3, self.input)

                            raise nvae

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 98, 1, self.input)

                        raise nvae

                elif (LA98_0 == TIMES) :
                    alt98 = 1
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 98, 0, self.input)

                    raise nvae

                if alt98 == 1:
                    # Slim.g:546:4: sourceMode MINUS LBRACKET ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? RBRACKET ARROW IDENT SEMICOLON
                    pass 
                    self._state.following.append(self.FOLLOW_sourceMode_in_modeTransition3420)
                    sourceMode287 = self.sourceMode()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_sourceMode.add(sourceMode287.tree)
                    MINUS288=self.match(self.input, MINUS, self.FOLLOW_MINUS_in_modeTransition3422) 
                    if self._state.backtracking == 0:
                        stream_MINUS.add(MINUS288)
                    LBRACKET289=self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_modeTransition3424) 
                    if self._state.backtracking == 0:
                        stream_LBRACKET.add(LBRACKET289)
                    # Slim.g:546:30: ( modeTrigger )?
                    alt94 = 2
                    LA94_0 = self.input.LA(1)

                    if (LA94_0 == ATACTIVATION or LA94_0 == RESET or LA94_0 == IDENT) :
                        alt94 = 1
                    if alt94 == 1:
                        # Slim.g:0:0: modeTrigger
                        pass 
                        self._state.following.append(self.FOLLOW_modeTrigger_in_modeTransition3426)
                        modeTrigger290 = self.modeTrigger()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_modeTrigger.add(modeTrigger290.tree)



                    # Slim.g:546:43: ( WHEN modeGuard )?
                    alt95 = 2
                    LA95_0 = self.input.LA(1)

                    if (LA95_0 == WHEN) :
                        alt95 = 1
                    if alt95 == 1:
                        # Slim.g:546:44: WHEN modeGuard
                        pass 
                        WHEN291=self.match(self.input, WHEN, self.FOLLOW_WHEN_in_modeTransition3430) 
                        if self._state.backtracking == 0:
                            stream_WHEN.add(WHEN291)
                        self._state.following.append(self.FOLLOW_modeGuard_in_modeTransition3432)
                        modeGuard292 = self.modeGuard()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_modeGuard.add(modeGuard292.tree)



                    # Slim.g:546:61: ( WITHIN timeDelay )?
                    alt96 = 2
                    LA96_0 = self.input.LA(1)

                    if (LA96_0 == WITHIN) :
                        alt96 = 1
                    if alt96 == 1:
                        # Slim.g:546:62: WITHIN timeDelay
                        pass 
                        WITHIN293=self.match(self.input, WITHIN, self.FOLLOW_WITHIN_in_modeTransition3437) 
                        if self._state.backtracking == 0:
                            stream_WITHIN.add(WITHIN293)
                        self._state.following.append(self.FOLLOW_timeDelay_in_modeTransition3439)
                        timeDelay294 = self.timeDelay()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_timeDelay.add(timeDelay294.tree)



                    # Slim.g:546:81: ( THEN modeEffect )?
                    alt97 = 2
                    LA97_0 = self.input.LA(1)

                    if (LA97_0 == THEN) :
                        alt97 = 1
                    if alt97 == 1:
                        # Slim.g:546:82: THEN modeEffect
                        pass 
                        THEN295=self.match(self.input, THEN, self.FOLLOW_THEN_in_modeTransition3444) 
                        if self._state.backtracking == 0:
                            stream_THEN.add(THEN295)
                        self._state.following.append(self.FOLLOW_modeEffect_in_modeTransition3446)
                        modeEffect296 = self.modeEffect()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            stream_modeEffect.add(modeEffect296.tree)



                    RBRACKET297=self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_modeTransition3450) 
                    if self._state.backtracking == 0:
                        stream_RBRACKET.add(RBRACKET297)
                    ARROW298=self.match(self.input, ARROW, self.FOLLOW_ARROW_in_modeTransition3452) 
                    if self._state.backtracking == 0:
                        stream_ARROW.add(ARROW298)
                    IDENT299=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_modeTransition3454) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT299)
                    SEMICOLON300=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_modeTransition3456) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON300)

                    # AST Rewrite
                    # elements: sourceMode, modeTrigger, timeDelay, THEN, IDENT, WITHIN, WHEN, modeGuard, modeEffect
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 547:3: -> ^( MODE_TRANS sourceMode IDENT ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? )
                        # Slim.g:547:6: ^( MODE_TRANS sourceMode IDENT ( modeTrigger )? ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(MODE_TRANS, "MODE_TRANS"), root_1)

                        self._adaptor.addChild(root_1, stream_sourceMode.nextTree())
                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        # Slim.g:547:36: ( modeTrigger )?
                        if stream_modeTrigger.hasNext():
                            self._adaptor.addChild(root_1, stream_modeTrigger.nextTree())


                        stream_modeTrigger.reset();
                        # Slim.g:547:49: ( WHEN modeGuard )?
                        if stream_WHEN.hasNext() or stream_modeGuard.hasNext():
                            self._adaptor.addChild(root_1, stream_WHEN.nextNode())
                            self._adaptor.addChild(root_1, stream_modeGuard.nextTree())


                        stream_WHEN.reset();
                        stream_modeGuard.reset();
                        # Slim.g:547:67: ( WITHIN timeDelay )?
                        if stream_timeDelay.hasNext() or stream_WITHIN.hasNext():
                            self._adaptor.addChild(root_1, stream_WITHIN.nextNode())
                            self._adaptor.addChild(root_1, stream_timeDelay.nextTree())


                        stream_timeDelay.reset();
                        stream_WITHIN.reset();
                        # Slim.g:547:87: ( THEN modeEffect )?
                        if stream_THEN.hasNext() or stream_modeEffect.hasNext():
                            self._adaptor.addChild(root_1, stream_THEN.nextNode())
                            self._adaptor.addChild(root_1, stream_modeEffect.nextTree())


                        stream_THEN.reset();
                        stream_modeEffect.reset();

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                elif alt98 == 2:
                    # Slim.g:548:4: IDENT MINUS LBRACKET PROB NUMBER RBRACKET ARROW IDENT SEMICOLON
                    pass 
                    IDENT301=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_modeTransition3497) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT301)
                    MINUS302=self.match(self.input, MINUS, self.FOLLOW_MINUS_in_modeTransition3499) 
                    if self._state.backtracking == 0:
                        stream_MINUS.add(MINUS302)
                    LBRACKET303=self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_modeTransition3501) 
                    if self._state.backtracking == 0:
                        stream_LBRACKET.add(LBRACKET303)
                    PROB304=self.match(self.input, PROB, self.FOLLOW_PROB_in_modeTransition3503) 
                    if self._state.backtracking == 0:
                        stream_PROB.add(PROB304)
                    NUMBER305=self.match(self.input, NUMBER, self.FOLLOW_NUMBER_in_modeTransition3505) 
                    if self._state.backtracking == 0:
                        stream_NUMBER.add(NUMBER305)
                    RBRACKET306=self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_modeTransition3507) 
                    if self._state.backtracking == 0:
                        stream_RBRACKET.add(RBRACKET306)
                    ARROW307=self.match(self.input, ARROW, self.FOLLOW_ARROW_in_modeTransition3509) 
                    if self._state.backtracking == 0:
                        stream_ARROW.add(ARROW307)
                    IDENT308=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_modeTransition3511) 
                    if self._state.backtracking == 0:
                        stream_IDENT.add(IDENT308)
                    SEMICOLON309=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_modeTransition3513) 
                    if self._state.backtracking == 0:
                        stream_SEMICOLON.add(SEMICOLON309)

                    # AST Rewrite
                    # elements: IDENT, IDENT, NUMBER
                    # token labels: 
                    # rule labels: retval
                    # token list labels: 
                    # rule list labels: 
                    if self._state.backtracking == 0:

                        retval.tree = root_0

                        if retval is not None:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                        else:
                            stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                        root_0 = self._adaptor.nil()
                        # 549:3: -> ^( MODE_TRANS_PROB IDENT IDENT NUMBER )
                        # Slim.g:549:6: ^( MODE_TRANS_PROB IDENT IDENT NUMBER )
                        root_1 = self._adaptor.nil()
                        root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(MODE_TRANS_PROB, "MODE_TRANS_PROB"), root_1)

                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                        self._adaptor.addChild(root_1, stream_NUMBER.nextNode())

                        self._adaptor.addChild(root_0, root_1)



                        retval.tree = root_0


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "modeTransition"

    class timeDelay_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "timeDelay"
    # Slim.g:552:1: timeDelay : timeScaledNumber TO timeScaledNumber ;
    def timeDelay(self, ):

        retval = self.timeDelay_return()
        retval.start = self.input.LT(1)

        root_0 = None

        TO311 = None
        timeScaledNumber310 = None

        timeScaledNumber312 = None


        TO311_tree = None

        self.rules.append("time delay")
        try:
            try:
                # Slim.g:555:2: ( timeScaledNumber TO timeScaledNumber )
                # Slim.g:555:4: timeScaledNumber TO timeScaledNumber
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_timeScaledNumber_in_timeDelay3548)
                timeScaledNumber310 = self.timeScaledNumber()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, timeScaledNumber310.tree)
                TO311=self.match(self.input, TO, self.FOLLOW_TO_in_timeDelay3550)
                self._state.following.append(self.FOLLOW_timeScaledNumber_in_timeDelay3553)
                timeScaledNumber312 = self.timeScaledNumber()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, timeScaledNumber312.tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop();


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "timeDelay"

    class sourceMode_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "sourceMode"
    # Slim.g:558:1: sourceMode : ( IDENT | TIMES );
    def sourceMode(self, ):

        retval = self.sourceMode_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set313 = None

        set313_tree = None

        try:
            try:
                # Slim.g:559:5: ( IDENT | TIMES )
                # Slim.g:
                pass 
                root_0 = self._adaptor.nil()

                set313 = self.input.LT(1)
                if self.input.LA(1) == TIMES or self.input.LA(1) == IDENT:
                    self.input.consume()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, self._adaptor.createWithPayload(set313))
                    self._state.errorRecovery = False

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    mse = MismatchedSetException(None, self.input)
                    raise mse





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "sourceMode"

    class modeTrigger_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "modeTrigger"
    # Slim.g:563:1: modeTrigger : ( nameOrIdentifierDisjunction | RESET | ATACTIVATION );
    def modeTrigger(self, ):

        retval = self.modeTrigger_return()
        retval.start = self.input.LT(1)

        root_0 = None

        RESET315 = None
        ATACTIVATION316 = None
        nameOrIdentifierDisjunction314 = None


        RESET315_tree = None
        ATACTIVATION316_tree = None

        try:
            try:
                # Slim.g:564:2: ( nameOrIdentifierDisjunction | RESET | ATACTIVATION )
                alt99 = 3
                LA99 = self.input.LA(1)
                if LA99 == IDENT:
                    alt99 = 1
                elif LA99 == RESET:
                    alt99 = 2
                elif LA99 == ATACTIVATION:
                    alt99 = 3
                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 99, 0, self.input)

                    raise nvae

                if alt99 == 1:
                    # Slim.g:564:4: nameOrIdentifierDisjunction
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_nameOrIdentifierDisjunction_in_modeTrigger3594)
                    nameOrIdentifierDisjunction314 = self.nameOrIdentifierDisjunction()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, nameOrIdentifierDisjunction314.tree)


                elif alt99 == 2:
                    # Slim.g:565:4: RESET
                    pass 
                    root_0 = self._adaptor.nil()

                    RESET315=self.match(self.input, RESET, self.FOLLOW_RESET_in_modeTrigger3599)
                    if self._state.backtracking == 0:

                        RESET315_tree = self._adaptor.createWithPayload(RESET315)
                        self._adaptor.addChild(root_0, RESET315_tree)



                elif alt99 == 3:
                    # Slim.g:566:4: ATACTIVATION
                    pass 
                    root_0 = self._adaptor.nil()

                    ATACTIVATION316=self.match(self.input, ATACTIVATION, self.FOLLOW_ATACTIVATION_in_modeTrigger3604)
                    if self._state.backtracking == 0:

                        ATACTIVATION316_tree = self._adaptor.createWithPayload(ATACTIVATION316)
                        self._adaptor.addChild(root_0, ATACTIVATION316_tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "modeTrigger"

    class nameOrIdentifierDisjunction_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "nameOrIdentifierDisjunction"
    # Slim.g:569:1: nameOrIdentifierDisjunction : nameOrIdentifier ( OR nameOrIdentifier )* ;
    def nameOrIdentifierDisjunction(self, ):

        retval = self.nameOrIdentifierDisjunction_return()
        retval.start = self.input.LT(1)

        root_0 = None

        OR318 = None
        nameOrIdentifier317 = None

        nameOrIdentifier319 = None


        OR318_tree = None

        try:
            try:
                # Slim.g:570:5: ( nameOrIdentifier ( OR nameOrIdentifier )* )
                # Slim.g:570:9: nameOrIdentifier ( OR nameOrIdentifier )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_nameOrIdentifier_in_nameOrIdentifierDisjunction3621)
                nameOrIdentifier317 = self.nameOrIdentifier()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, nameOrIdentifier317.tree)
                # Slim.g:570:26: ( OR nameOrIdentifier )*
                while True: #loop100
                    alt100 = 2
                    LA100_0 = self.input.LA(1)

                    if (LA100_0 == OR) :
                        alt100 = 1


                    if alt100 == 1:
                        # Slim.g:570:27: OR nameOrIdentifier
                        pass 
                        OR318=self.match(self.input, OR, self.FOLLOW_OR_in_nameOrIdentifierDisjunction3624)
                        if self._state.backtracking == 0:

                            OR318_tree = self._adaptor.createWithPayload(OR318)
                            root_0 = self._adaptor.becomeRoot(OR318_tree, root_0)

                        self._state.following.append(self.FOLLOW_nameOrIdentifier_in_nameOrIdentifierDisjunction3627)
                        nameOrIdentifier319 = self.nameOrIdentifier()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, nameOrIdentifier319.tree)


                    else:
                        break #loop100





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "nameOrIdentifierDisjunction"

    class modeGuard_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "modeGuard"
    # Slim.g:573:1: modeGuard : expression ;
    def modeGuard(self, ):

        retval = self.modeGuard_return()
        retval.start = self.input.LT(1)

        root_0 = None

        expression320 = None



        try:
            try:
                # Slim.g:574:2: ( expression )
                # Slim.g:574:4: expression
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_expression_in_modeGuard3644)
                expression320 = self.expression()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, expression320.tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "modeGuard"

    class modeEffect_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "modeEffect"
    # Slim.g:577:1: modeEffect : assignment ( SEMICOLON assignment )* ;
    def modeEffect(self, ):

        retval = self.modeEffect_return()
        retval.start = self.input.LT(1)

        root_0 = None

        SEMICOLON322 = None
        assignment321 = None

        assignment323 = None


        SEMICOLON322_tree = None

        try:
            try:
                # Slim.g:578:2: ( assignment ( SEMICOLON assignment )* )
                # Slim.g:578:4: assignment ( SEMICOLON assignment )*
                pass 
                root_0 = self._adaptor.nil()

                self._state.following.append(self.FOLLOW_assignment_in_modeEffect3656)
                assignment321 = self.assignment()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, assignment321.tree)
                # Slim.g:578:15: ( SEMICOLON assignment )*
                while True: #loop101
                    alt101 = 2
                    LA101_0 = self.input.LA(1)

                    if (LA101_0 == SEMICOLON) :
                        alt101 = 1


                    if alt101 == 1:
                        # Slim.g:578:16: SEMICOLON assignment
                        pass 
                        SEMICOLON322=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_modeEffect3659)
                        self._state.following.append(self.FOLLOW_assignment_in_modeEffect3662)
                        assignment323 = self.assignment()

                        self._state.following.pop()
                        if self._state.backtracking == 0:
                            self._adaptor.addChild(root_0, assignment323.tree)


                    else:
                        break #loop101





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "modeEffect"

    class effectsOnly_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "effectsOnly"
    # Slim.g:581:1: effectsOnly : {...}? => modeEffect EOF ;
    def effectsOnly(self, ):

        retval = self.effectsOnly_return()
        retval.start = self.input.LT(1)

        root_0 = None

        EOF325 = None
        modeEffect324 = None


        EOF325_tree = None

        try:
            try:
                # Slim.g:582:2: ({...}? => modeEffect EOF )
                # Slim.g:582:4: {...}? => modeEffect EOF
                pass 
                root_0 = self._adaptor.nil()

                if not ((globals.PARSER_EFFECTS_ONLY)):
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    raise FailedPredicateException(self.input, "effectsOnly", "globals.PARSER_EFFECTS_ONLY")

                self._state.following.append(self.FOLLOW_modeEffect_in_effectsOnly3678)
                modeEffect324 = self.modeEffect()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, modeEffect324.tree)
                EOF325=self.match(self.input, EOF, self.FOLLOW_EOF_in_effectsOnly3680)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "effectsOnly"

    class assignmentsOnly_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "assignmentsOnly"
    # Slim.g:585:1: assignmentsOnly : {...}? => assignment EOF ;
    def assignmentsOnly(self, ):

        retval = self.assignmentsOnly_return()
        retval.start = self.input.LT(1)

        root_0 = None

        EOF327 = None
        assignment326 = None


        EOF327_tree = None

        try:
            try:
                # Slim.g:586:2: ({...}? => assignment EOF )
                # Slim.g:586:4: {...}? => assignment EOF
                pass 
                root_0 = self._adaptor.nil()

                if not ((globals.PARSER_ASSIGNMENTS_ONLY)):
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    raise FailedPredicateException(self.input, "assignmentsOnly", "globals.PARSER_ASSIGNMENTS_ONLY")

                self._state.following.append(self.FOLLOW_assignment_in_assignmentsOnly3696)
                assignment326 = self.assignment()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, assignment326.tree)
                EOF327=self.match(self.input, EOF, self.FOLLOW_EOF_in_assignmentsOnly3698)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "assignmentsOnly"

    class assignment_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "assignment"
    # Slim.g:589:1: assignment : ( IDENT ASSIGN expression | {...}? => name ASSIGN expression );
    def assignment(self, ):

        retval = self.assignment_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT328 = None
        ASSIGN329 = None
        ASSIGN332 = None
        expression330 = None

        name331 = None

        expression333 = None


        IDENT328_tree = None
        ASSIGN329_tree = None
        ASSIGN332_tree = None

        try:
            try:
                # Slim.g:590:2: ( IDENT ASSIGN expression | {...}? => name ASSIGN expression )
                alt102 = 2
                LA102_0 = self.input.LA(1)

                if (LA102_0 == IDENT) :
                    LA102_1 = self.input.LA(2)

                    if (LA102_1 == ASSIGN) :
                        alt102 = 1
                    elif (LA102_1 == DOT) and ((self.allow_names)):
                        alt102 = 2
                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 102, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 102, 0, self.input)

                    raise nvae

                if alt102 == 1:
                    # Slim.g:590:4: IDENT ASSIGN expression
                    pass 
                    root_0 = self._adaptor.nil()

                    IDENT328=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_assignment3712)
                    if self._state.backtracking == 0:

                        IDENT328_tree = self._adaptor.createWithPayload(IDENT328)
                        self._adaptor.addChild(root_0, IDENT328_tree)

                    ASSIGN329=self.match(self.input, ASSIGN, self.FOLLOW_ASSIGN_in_assignment3714)
                    if self._state.backtracking == 0:

                        ASSIGN329_tree = self._adaptor.createWithPayload(ASSIGN329)
                        root_0 = self._adaptor.becomeRoot(ASSIGN329_tree, root_0)

                    self._state.following.append(self.FOLLOW_expression_in_assignment3717)
                    expression330 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression330.tree)


                elif alt102 == 2:
                    # Slim.g:591:4: {...}? => name ASSIGN expression
                    pass 
                    root_0 = self._adaptor.nil()

                    if not ((self.allow_names)):
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        raise FailedPredicateException(self.input, "assignment", "self.allow_names")

                    self._state.following.append(self.FOLLOW_name_in_assignment3725)
                    name331 = self.name()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, name331.tree)
                    ASSIGN332=self.match(self.input, ASSIGN, self.FOLLOW_ASSIGN_in_assignment3727)
                    if self._state.backtracking == 0:

                        ASSIGN332_tree = self._adaptor.createWithPayload(ASSIGN332)
                        root_0 = self._adaptor.becomeRoot(ASSIGN332_tree, root_0)

                    self._state.following.append(self.FOLLOW_expression_in_assignment3730)
                    expression333 = self.expression()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, expression333.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "assignment"

    class inModes_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "inModes"
    # Slim.g:594:1: inModes : IN MODES LPAREN identifierList RPAREN ;
    def inModes(self, ):

        retval = self.inModes_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IN334 = None
        MODES335 = None
        LPAREN336 = None
        RPAREN338 = None
        identifierList337 = None


        IN334_tree = None
        MODES335_tree = None
        LPAREN336_tree = None
        RPAREN338_tree = None

        try:
            try:
                # Slim.g:595:2: ( IN MODES LPAREN identifierList RPAREN )
                # Slim.g:595:4: IN MODES LPAREN identifierList RPAREN
                pass 
                root_0 = self._adaptor.nil()

                IN334=self.match(self.input, IN, self.FOLLOW_IN_in_inModes3742)
                MODES335=self.match(self.input, MODES, self.FOLLOW_MODES_in_inModes3745)
                LPAREN336=self.match(self.input, LPAREN, self.FOLLOW_LPAREN_in_inModes3748)
                self._state.following.append(self.FOLLOW_identifierList_in_inModes3751)
                identifierList337 = self.identifierList()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, identifierList337.tree)
                RPAREN338=self.match(self.input, RPAREN, self.FOLLOW_RPAREN_in_inModes3753)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "inModes"

    class errorFeature_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorFeature"
    # Slim.g:599:1: errorFeature : ( errorTypeState | errorPropagation );
    def errorFeature(self, ):

        retval = self.errorFeature_return()
        retval.start = self.input.LT(1)

        root_0 = None

        errorTypeState339 = None

        errorPropagation340 = None



        try:
            try:
                # Slim.g:600:2: ( errorTypeState | errorPropagation )
                alt103 = 2
                LA103_0 = self.input.LA(1)

                if (LA103_0 == IDENT) :
                    LA103_1 = self.input.LA(2)

                    if (LA103_1 == COLON) :
                        LA103_2 = self.input.LA(3)

                        if ((IN <= LA103_2 <= OUT)) :
                            alt103 = 2
                        elif ((INITIAL <= LA103_2 <= ACTIVATION) or LA103_2 == ERROR) :
                            alt103 = 1
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 103, 2, self.input)

                            raise nvae

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 103, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 103, 0, self.input)

                    raise nvae

                if alt103 == 1:
                    # Slim.g:600:4: errorTypeState
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_errorTypeState_in_errorFeature3769)
                    errorTypeState339 = self.errorTypeState()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, errorTypeState339.tree)


                elif alt103 == 2:
                    # Slim.g:601:4: errorPropagation
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_errorPropagation_in_errorFeature3774)
                    errorPropagation340 = self.errorPropagation()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, errorPropagation340.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorFeature"

    class errorTypeState_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorTypeState"
    # Slim.g:604:1: errorTypeState : IDENT COLON stateType STATE SEMICOLON -> ^( stateType IDENT ) ;
    def errorTypeState(self, ):

        retval = self.errorTypeState_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT341 = None
        COLON342 = None
        STATE344 = None
        SEMICOLON345 = None
        stateType343 = None


        IDENT341_tree = None
        COLON342_tree = None
        STATE344_tree = None
        SEMICOLON345_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_STATE = RewriteRuleTokenStream(self._adaptor, "token STATE")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_stateType = RewriteRuleSubtreeStream(self._adaptor, "rule stateType")
        self.rules.append("error state") 
        try:
            try:
                # Slim.g:607:2: ( IDENT COLON stateType STATE SEMICOLON -> ^( stateType IDENT ) )
                # Slim.g:607:4: IDENT COLON stateType STATE SEMICOLON
                pass 
                IDENT341=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorTypeState3796) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT341)
                COLON342=self.match(self.input, COLON, self.FOLLOW_COLON_in_errorTypeState3798) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON342)
                self._state.following.append(self.FOLLOW_stateType_in_errorTypeState3800)
                stateType343 = self.stateType()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_stateType.add(stateType343.tree)
                STATE344=self.match(self.input, STATE, self.FOLLOW_STATE_in_errorTypeState3802) 
                if self._state.backtracking == 0:
                    stream_STATE.add(STATE344)
                SEMICOLON345=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorTypeState3804) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON345)

                # AST Rewrite
                # elements: IDENT, stateType
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 608:3: -> ^( stateType IDENT )
                    # Slim.g:608:6: ^( stateType IDENT )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(stream_stateType.nextNode(), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorTypeState"

    class stateType_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "stateType"
    # Slim.g:611:1: stateType : ( INITIAL | ACTIVATION | ERROR );
    def stateType(self, ):

        retval = self.stateType_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set346 = None

        set346_tree = None

        try:
            try:
                # Slim.g:612:2: ( INITIAL | ACTIVATION | ERROR )
                # Slim.g:
                pass 
                root_0 = self._adaptor.nil()

                set346 = self.input.LT(1)
                if (INITIAL <= self.input.LA(1) <= ACTIVATION) or self.input.LA(1) == ERROR:
                    self.input.consume()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, self._adaptor.createWithPayload(set346))
                    self._state.errorRecovery = False

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    mse = MismatchedSetException(None, self.input)
                    raise mse





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "stateType"

    class errorPropagation_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorPropagation"
    # Slim.g:617:1: errorPropagation : ( inPropagation | outPropagation );
    def errorPropagation(self, ):

        retval = self.errorPropagation_return()
        retval.start = self.input.LT(1)

        root_0 = None

        inPropagation347 = None

        outPropagation348 = None



        self.rules.append("error propagation") 
        try:
            try:
                # Slim.g:620:2: ( inPropagation | outPropagation )
                alt104 = 2
                LA104_0 = self.input.LA(1)

                if (LA104_0 == IDENT) :
                    LA104_1 = self.input.LA(2)

                    if (LA104_1 == COLON) :
                        LA104_2 = self.input.LA(3)

                        if (LA104_2 == IN) :
                            alt104 = 1
                        elif (LA104_2 == OUT) :
                            alt104 = 2
                        else:
                            if self._state.backtracking > 0:
                                raise BacktrackingFailed

                            nvae = NoViableAltException("", 104, 2, self.input)

                            raise nvae

                    else:
                        if self._state.backtracking > 0:
                            raise BacktrackingFailed

                        nvae = NoViableAltException("", 104, 1, self.input)

                        raise nvae

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    nvae = NoViableAltException("", 104, 0, self.input)

                    raise nvae

                if alt104 == 1:
                    # Slim.g:620:4: inPropagation
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_inPropagation_in_errorPropagation3858)
                    inPropagation347 = self.inPropagation()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, inPropagation347.tree)


                elif alt104 == 2:
                    # Slim.g:621:4: outPropagation
                    pass 
                    root_0 = self._adaptor.nil()

                    self._state.following.append(self.FOLLOW_outPropagation_in_errorPropagation3863)
                    outPropagation348 = self.outPropagation()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, outPropagation348.tree)


                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorPropagation"

    class inPropagation_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "inPropagation"
    # Slim.g:624:1: inPropagation : IDENT COLON IN ERROR PROPAGATION SEMICOLON -> ^( IE_PROP IDENT ) ;
    def inPropagation(self, ):

        retval = self.inPropagation_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT349 = None
        COLON350 = None
        IN351 = None
        ERROR352 = None
        PROPAGATION353 = None
        SEMICOLON354 = None

        IDENT349_tree = None
        COLON350_tree = None
        IN351_tree = None
        ERROR352_tree = None
        PROPAGATION353_tree = None
        SEMICOLON354_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_IN = RewriteRuleTokenStream(self._adaptor, "token IN")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")
        stream_PROPAGATION = RewriteRuleTokenStream(self._adaptor, "token PROPAGATION")

        try:
            try:
                # Slim.g:625:2: ( IDENT COLON IN ERROR PROPAGATION SEMICOLON -> ^( IE_PROP IDENT ) )
                # Slim.g:625:4: IDENT COLON IN ERROR PROPAGATION SEMICOLON
                pass 
                IDENT349=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_inPropagation3875) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT349)
                COLON350=self.match(self.input, COLON, self.FOLLOW_COLON_in_inPropagation3877) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON350)
                IN351=self.match(self.input, IN, self.FOLLOW_IN_in_inPropagation3879) 
                if self._state.backtracking == 0:
                    stream_IN.add(IN351)
                ERROR352=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_inPropagation3881) 
                if self._state.backtracking == 0:
                    stream_ERROR.add(ERROR352)
                PROPAGATION353=self.match(self.input, PROPAGATION, self.FOLLOW_PROPAGATION_in_inPropagation3883) 
                if self._state.backtracking == 0:
                    stream_PROPAGATION.add(PROPAGATION353)
                SEMICOLON354=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_inPropagation3885) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON354)

                # AST Rewrite
                # elements: IDENT
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 626:3: -> ^( IE_PROP IDENT )
                    # Slim.g:626:6: ^( IE_PROP IDENT )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(IE_PROP, "IE_PROP"), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "inPropagation"

    class outPropagation_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "outPropagation"
    # Slim.g:629:1: outPropagation : IDENT COLON OUT ERROR PROPAGATION SEMICOLON -> ^( OE_PROP IDENT ) ;
    def outPropagation(self, ):

        retval = self.outPropagation_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT355 = None
        COLON356 = None
        OUT357 = None
        ERROR358 = None
        PROPAGATION359 = None
        SEMICOLON360 = None

        IDENT355_tree = None
        COLON356_tree = None
        OUT357_tree = None
        ERROR358_tree = None
        PROPAGATION359_tree = None
        SEMICOLON360_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")
        stream_PROPAGATION = RewriteRuleTokenStream(self._adaptor, "token PROPAGATION")
        stream_OUT = RewriteRuleTokenStream(self._adaptor, "token OUT")

        try:
            try:
                # Slim.g:630:2: ( IDENT COLON OUT ERROR PROPAGATION SEMICOLON -> ^( OE_PROP IDENT ) )
                # Slim.g:630:4: IDENT COLON OUT ERROR PROPAGATION SEMICOLON
                pass 
                IDENT355=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_outPropagation3907) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT355)
                COLON356=self.match(self.input, COLON, self.FOLLOW_COLON_in_outPropagation3909) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON356)
                OUT357=self.match(self.input, OUT, self.FOLLOW_OUT_in_outPropagation3911) 
                if self._state.backtracking == 0:
                    stream_OUT.add(OUT357)
                ERROR358=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_outPropagation3913) 
                if self._state.backtracking == 0:
                    stream_ERROR.add(ERROR358)
                PROPAGATION359=self.match(self.input, PROPAGATION, self.FOLLOW_PROPAGATION_in_outPropagation3915) 
                if self._state.backtracking == 0:
                    stream_PROPAGATION.add(PROPAGATION359)
                SEMICOLON360=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_outPropagation3917) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON360)

                # AST Rewrite
                # elements: IDENT
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 631:3: -> ^( OE_PROP IDENT )
                    # Slim.g:631:6: ^( OE_PROP IDENT )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(OE_PROP, "OE_PROP"), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "outPropagation"

    class occurrence_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "occurrence"
    # Slim.g:634:1: occurrence : OCCURRENCE distribution number ;
    def occurrence(self, ):

        retval = self.occurrence_return()
        retval.start = self.input.LT(1)

        root_0 = None

        OCCURRENCE361 = None
        distribution362 = None

        number363 = None


        OCCURRENCE361_tree = None

        try:
            try:
                # Slim.g:635:2: ( OCCURRENCE distribution number )
                # Slim.g:635:4: OCCURRENCE distribution number
                pass 
                root_0 = self._adaptor.nil()

                OCCURRENCE361=self.match(self.input, OCCURRENCE, self.FOLLOW_OCCURRENCE_in_occurrence3939)
                self._state.following.append(self.FOLLOW_distribution_in_occurrence3942)
                distribution362 = self.distribution()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, distribution362.tree)
                self._state.following.append(self.FOLLOW_number_in_occurrence3944)
                number363 = self.number()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    self._adaptor.addChild(root_0, number363.tree)



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "occurrence"

    class distribution_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "distribution"
    # Slim.g:638:1: distribution : POISSON ;
    def distribution(self, ):

        retval = self.distribution_return()
        retval.start = self.input.LT(1)

        root_0 = None

        POISSON364 = None

        POISSON364_tree = None

        try:
            try:
                # Slim.g:639:2: ( POISSON )
                # Slim.g:639:4: POISSON
                pass 
                root_0 = self._adaptor.nil()

                POISSON364=self.match(self.input, POISSON, self.FOLLOW_POISSON_in_distribution3956)
                if self._state.backtracking == 0:

                    POISSON364_tree = self._adaptor.createWithPayload(POISSON364)
                    self._adaptor.addChild(root_0, POISSON364_tree)




                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "distribution"

    class errorEvent_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorEvent"
    # Slim.g:643:1: errorEvent : IDENT COLON ERROR EVENT ( occurrence )? ( PER timeScale )? SEMICOLON -> ^( ERR_EVENT IDENT ( occurrence )? ( timeScale )? ) ;
    def errorEvent(self, ):

        retval = self.errorEvent_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT365 = None
        COLON366 = None
        ERROR367 = None
        EVENT368 = None
        PER370 = None
        SEMICOLON372 = None
        occurrence369 = None

        timeScale371 = None


        IDENT365_tree = None
        COLON366_tree = None
        ERROR367_tree = None
        EVENT368_tree = None
        PER370_tree = None
        SEMICOLON372_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_ERROR = RewriteRuleTokenStream(self._adaptor, "token ERROR")
        stream_PER = RewriteRuleTokenStream(self._adaptor, "token PER")
        stream_EVENT = RewriteRuleTokenStream(self._adaptor, "token EVENT")
        stream_timeScale = RewriteRuleSubtreeStream(self._adaptor, "rule timeScale")
        stream_occurrence = RewriteRuleSubtreeStream(self._adaptor, "rule occurrence")
        self.rules.append("error event") 
        try:
            try:
                # Slim.g:646:2: ( IDENT COLON ERROR EVENT ( occurrence )? ( PER timeScale )? SEMICOLON -> ^( ERR_EVENT IDENT ( occurrence )? ( timeScale )? ) )
                # Slim.g:646:4: IDENT COLON ERROR EVENT ( occurrence )? ( PER timeScale )? SEMICOLON
                pass 
                IDENT365=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorEvent3980) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT365)
                COLON366=self.match(self.input, COLON, self.FOLLOW_COLON_in_errorEvent3982) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON366)
                ERROR367=self.match(self.input, ERROR, self.FOLLOW_ERROR_in_errorEvent3984) 
                if self._state.backtracking == 0:
                    stream_ERROR.add(ERROR367)
                EVENT368=self.match(self.input, EVENT, self.FOLLOW_EVENT_in_errorEvent3986) 
                if self._state.backtracking == 0:
                    stream_EVENT.add(EVENT368)
                # Slim.g:646:28: ( occurrence )?
                alt105 = 2
                LA105_0 = self.input.LA(1)

                if (LA105_0 == OCCURRENCE) :
                    alt105 = 1
                if alt105 == 1:
                    # Slim.g:0:0: occurrence
                    pass 
                    self._state.following.append(self.FOLLOW_occurrence_in_errorEvent3988)
                    occurrence369 = self.occurrence()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_occurrence.add(occurrence369.tree)



                # Slim.g:646:40: ( PER timeScale )?
                alt106 = 2
                LA106_0 = self.input.LA(1)

                if (LA106_0 == PER) :
                    alt106 = 1
                if alt106 == 1:
                    # Slim.g:646:41: PER timeScale
                    pass 
                    PER370=self.match(self.input, PER, self.FOLLOW_PER_in_errorEvent3992) 
                    if self._state.backtracking == 0:
                        stream_PER.add(PER370)
                    self._state.following.append(self.FOLLOW_timeScale_in_errorEvent3994)
                    timeScale371 = self.timeScale()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_timeScale.add(timeScale371.tree)



                SEMICOLON372=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorEvent3998) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON372)

                # AST Rewrite
                # elements: occurrence, IDENT, timeScale
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 647:3: -> ^( ERR_EVENT IDENT ( occurrence )? ( timeScale )? )
                    # Slim.g:647:6: ^( ERR_EVENT IDENT ( occurrence )? ( timeScale )? )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ERR_EVENT, "ERR_EVENT"), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    # Slim.g:647:24: ( occurrence )?
                    if stream_occurrence.hasNext():
                        self._adaptor.addChild(root_1, stream_occurrence.nextTree())


                    stream_occurrence.reset();
                    # Slim.g:647:36: ( timeScale )?
                    if stream_timeScale.hasNext():
                        self._adaptor.addChild(root_1, stream_timeScale.nextTree())


                    stream_timeScale.reset();

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorEvent"

    class errorClock_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorClock"
    # Slim.g:650:1: errorClock : IDENT COLON DATA CLOCK ( timeScale )? SEMICOLON -> ^( ERR_CLOCK IDENT CLOCK ( timeScale )? ) ;
    def errorClock(self, ):

        retval = self.errorClock_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT373 = None
        COLON374 = None
        DATA375 = None
        CLOCK376 = None
        SEMICOLON378 = None
        timeScale377 = None


        IDENT373_tree = None
        COLON374_tree = None
        DATA375_tree = None
        CLOCK376_tree = None
        SEMICOLON378_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_DATA = RewriteRuleTokenStream(self._adaptor, "token DATA")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_CLOCK = RewriteRuleTokenStream(self._adaptor, "token CLOCK")
        stream_timeScale = RewriteRuleSubtreeStream(self._adaptor, "rule timeScale")
        self.rules.append("error clock") 
        try:
            try:
                # Slim.g:653:2: ( IDENT COLON DATA CLOCK ( timeScale )? SEMICOLON -> ^( ERR_CLOCK IDENT CLOCK ( timeScale )? ) )
                # Slim.g:653:4: IDENT COLON DATA CLOCK ( timeScale )? SEMICOLON
                pass 
                IDENT373=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorClock4035) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT373)
                COLON374=self.match(self.input, COLON, self.FOLLOW_COLON_in_errorClock4037) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON374)
                DATA375=self.match(self.input, DATA, self.FOLLOW_DATA_in_errorClock4039) 
                if self._state.backtracking == 0:
                    stream_DATA.add(DATA375)
                CLOCK376=self.match(self.input, CLOCK, self.FOLLOW_CLOCK_in_errorClock4041) 
                if self._state.backtracking == 0:
                    stream_CLOCK.add(CLOCK376)
                # Slim.g:653:27: ( timeScale )?
                alt107 = 2
                LA107_0 = self.input.LA(1)

                if ((MSEC <= LA107_0 <= DAY)) :
                    alt107 = 1
                if alt107 == 1:
                    # Slim.g:0:0: timeScale
                    pass 
                    self._state.following.append(self.FOLLOW_timeScale_in_errorClock4043)
                    timeScale377 = self.timeScale()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_timeScale.add(timeScale377.tree)



                SEMICOLON378=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorClock4046) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON378)

                # AST Rewrite
                # elements: timeScale, IDENT, CLOCK
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 654:3: -> ^( ERR_CLOCK IDENT CLOCK ( timeScale )? )
                    # Slim.g:654:6: ^( ERR_CLOCK IDENT CLOCK ( timeScale )? )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ERR_CLOCK, "ERR_CLOCK"), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    self._adaptor.addChild(root_1, stream_CLOCK.nextNode())
                    # Slim.g:654:30: ( timeScale )?
                    if stream_timeScale.hasNext():
                        self._adaptor.addChild(root_1, stream_timeScale.nextTree())


                    stream_timeScale.reset();

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorClock"

    class errorState_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorState"
    # Slim.g:657:1: errorState : IDENT COLON stateType STATE ( urgent )? ( WHILE invariant )? SEMICOLON -> ^( stateType IDENT ( urgent )? ( invariant )? ) ;
    def errorState(self, ):

        retval = self.errorState_return()
        retval.start = self.input.LT(1)

        root_0 = None

        IDENT379 = None
        COLON380 = None
        STATE382 = None
        WHILE384 = None
        SEMICOLON386 = None
        stateType381 = None

        urgent383 = None

        invariant385 = None


        IDENT379_tree = None
        COLON380_tree = None
        STATE382_tree = None
        WHILE384_tree = None
        SEMICOLON386_tree = None
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_STATE = RewriteRuleTokenStream(self._adaptor, "token STATE")
        stream_COLON = RewriteRuleTokenStream(self._adaptor, "token COLON")
        stream_WHILE = RewriteRuleTokenStream(self._adaptor, "token WHILE")
        stream_stateType = RewriteRuleSubtreeStream(self._adaptor, "rule stateType")
        stream_urgent = RewriteRuleSubtreeStream(self._adaptor, "rule urgent")
        stream_invariant = RewriteRuleSubtreeStream(self._adaptor, "rule invariant")
        self.rules.append("error state") 
        try:
            try:
                # Slim.g:660:2: ( IDENT COLON stateType STATE ( urgent )? ( WHILE invariant )? SEMICOLON -> ^( stateType IDENT ( urgent )? ( invariant )? ) )
                # Slim.g:660:4: IDENT COLON stateType STATE ( urgent )? ( WHILE invariant )? SEMICOLON
                pass 
                IDENT379=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorState4082) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT379)
                COLON380=self.match(self.input, COLON, self.FOLLOW_COLON_in_errorState4084) 
                if self._state.backtracking == 0:
                    stream_COLON.add(COLON380)
                self._state.following.append(self.FOLLOW_stateType_in_errorState4086)
                stateType381 = self.stateType()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_stateType.add(stateType381.tree)
                STATE382=self.match(self.input, STATE, self.FOLLOW_STATE_in_errorState4088) 
                if self._state.backtracking == 0:
                    stream_STATE.add(STATE382)
                # Slim.g:660:32: ( urgent )?
                alt108 = 2
                LA108_0 = self.input.LA(1)

                if (LA108_0 == URGENT) :
                    alt108 = 1
                if alt108 == 1:
                    # Slim.g:0:0: urgent
                    pass 
                    self._state.following.append(self.FOLLOW_urgent_in_errorState4090)
                    urgent383 = self.urgent()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_urgent.add(urgent383.tree)



                # Slim.g:660:40: ( WHILE invariant )?
                alt109 = 2
                LA109_0 = self.input.LA(1)

                if (LA109_0 == WHILE) :
                    alt109 = 1
                if alt109 == 1:
                    # Slim.g:660:41: WHILE invariant
                    pass 
                    WHILE384=self.match(self.input, WHILE, self.FOLLOW_WHILE_in_errorState4094) 
                    if self._state.backtracking == 0:
                        stream_WHILE.add(WHILE384)
                    self._state.following.append(self.FOLLOW_invariant_in_errorState4096)
                    invariant385 = self.invariant()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_invariant.add(invariant385.tree)



                SEMICOLON386=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorState4100) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON386)

                # AST Rewrite
                # elements: IDENT, invariant, stateType, urgent
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 661:3: -> ^( stateType IDENT ( urgent )? ( invariant )? )
                    # Slim.g:661:6: ^( stateType IDENT ( urgent )? ( invariant )? )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(stream_stateType.nextNode(), root_1)

                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    # Slim.g:661:24: ( urgent )?
                    if stream_urgent.hasNext():
                        self._adaptor.addChild(root_1, stream_urgent.nextTree())


                    stream_urgent.reset();
                    # Slim.g:661:32: ( invariant )?
                    if stream_invariant.hasNext():
                        self._adaptor.addChild(root_1, stream_invariant.nextTree())


                    stream_invariant.reset();

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorState"

    class errorTransition_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorTransition"
    # Slim.g:664:1: errorTransition : sourceState MINUS LBRACKET errorTrigger ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? RBRACKET ARROW IDENT SEMICOLON -> ^( ERR_TRANS sourceState errorTrigger IDENT ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? ) ;
    def errorTransition(self, ):

        retval = self.errorTransition_return()
        retval.start = self.input.LT(1)

        root_0 = None

        MINUS388 = None
        LBRACKET389 = None
        WHEN391 = None
        WITHIN393 = None
        THEN395 = None
        RBRACKET397 = None
        ARROW398 = None
        IDENT399 = None
        SEMICOLON400 = None
        sourceState387 = None

        errorTrigger390 = None

        modeGuard392 = None

        timeDelay394 = None

        modeEffect396 = None


        MINUS388_tree = None
        LBRACKET389_tree = None
        WHEN391_tree = None
        WITHIN393_tree = None
        THEN395_tree = None
        RBRACKET397_tree = None
        ARROW398_tree = None
        IDENT399_tree = None
        SEMICOLON400_tree = None
        stream_WHEN = RewriteRuleTokenStream(self._adaptor, "token WHEN")
        stream_ARROW = RewriteRuleTokenStream(self._adaptor, "token ARROW")
        stream_IDENT = RewriteRuleTokenStream(self._adaptor, "token IDENT")
        stream_SEMICOLON = RewriteRuleTokenStream(self._adaptor, "token SEMICOLON")
        stream_LBRACKET = RewriteRuleTokenStream(self._adaptor, "token LBRACKET")
        stream_WITHIN = RewriteRuleTokenStream(self._adaptor, "token WITHIN")
        stream_THEN = RewriteRuleTokenStream(self._adaptor, "token THEN")
        stream_RBRACKET = RewriteRuleTokenStream(self._adaptor, "token RBRACKET")
        stream_MINUS = RewriteRuleTokenStream(self._adaptor, "token MINUS")
        stream_errorTrigger = RewriteRuleSubtreeStream(self._adaptor, "rule errorTrigger")
        stream_modeEffect = RewriteRuleSubtreeStream(self._adaptor, "rule modeEffect")
        stream_timeDelay = RewriteRuleSubtreeStream(self._adaptor, "rule timeDelay")
        stream_sourceState = RewriteRuleSubtreeStream(self._adaptor, "rule sourceState")
        stream_modeGuard = RewriteRuleSubtreeStream(self._adaptor, "rule modeGuard")
        self.rules.append("error transition") 
        try:
            try:
                # Slim.g:667:2: ( sourceState MINUS LBRACKET errorTrigger ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? RBRACKET ARROW IDENT SEMICOLON -> ^( ERR_TRANS sourceState errorTrigger IDENT ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? ) )
                # Slim.g:667:4: sourceState MINUS LBRACKET errorTrigger ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? RBRACKET ARROW IDENT SEMICOLON
                pass 
                self._state.following.append(self.FOLLOW_sourceState_in_errorTransition4137)
                sourceState387 = self.sourceState()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_sourceState.add(sourceState387.tree)
                MINUS388=self.match(self.input, MINUS, self.FOLLOW_MINUS_in_errorTransition4139) 
                if self._state.backtracking == 0:
                    stream_MINUS.add(MINUS388)
                LBRACKET389=self.match(self.input, LBRACKET, self.FOLLOW_LBRACKET_in_errorTransition4141) 
                if self._state.backtracking == 0:
                    stream_LBRACKET.add(LBRACKET389)
                self._state.following.append(self.FOLLOW_errorTrigger_in_errorTransition4143)
                errorTrigger390 = self.errorTrigger()

                self._state.following.pop()
                if self._state.backtracking == 0:
                    stream_errorTrigger.add(errorTrigger390.tree)
                # Slim.g:667:44: ( WHEN modeGuard )?
                alt110 = 2
                LA110_0 = self.input.LA(1)

                if (LA110_0 == WHEN) :
                    alt110 = 1
                if alt110 == 1:
                    # Slim.g:667:45: WHEN modeGuard
                    pass 
                    WHEN391=self.match(self.input, WHEN, self.FOLLOW_WHEN_in_errorTransition4146) 
                    if self._state.backtracking == 0:
                        stream_WHEN.add(WHEN391)
                    self._state.following.append(self.FOLLOW_modeGuard_in_errorTransition4148)
                    modeGuard392 = self.modeGuard()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_modeGuard.add(modeGuard392.tree)



                # Slim.g:667:62: ( WITHIN timeDelay )?
                alt111 = 2
                LA111_0 = self.input.LA(1)

                if (LA111_0 == WITHIN) :
                    alt111 = 1
                if alt111 == 1:
                    # Slim.g:667:63: WITHIN timeDelay
                    pass 
                    WITHIN393=self.match(self.input, WITHIN, self.FOLLOW_WITHIN_in_errorTransition4153) 
                    if self._state.backtracking == 0:
                        stream_WITHIN.add(WITHIN393)
                    self._state.following.append(self.FOLLOW_timeDelay_in_errorTransition4155)
                    timeDelay394 = self.timeDelay()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_timeDelay.add(timeDelay394.tree)



                # Slim.g:667:82: ( THEN modeEffect )?
                alt112 = 2
                LA112_0 = self.input.LA(1)

                if (LA112_0 == THEN) :
                    alt112 = 1
                if alt112 == 1:
                    # Slim.g:667:83: THEN modeEffect
                    pass 
                    THEN395=self.match(self.input, THEN, self.FOLLOW_THEN_in_errorTransition4160) 
                    if self._state.backtracking == 0:
                        stream_THEN.add(THEN395)
                    self._state.following.append(self.FOLLOW_modeEffect_in_errorTransition4162)
                    modeEffect396 = self.modeEffect()

                    self._state.following.pop()
                    if self._state.backtracking == 0:
                        stream_modeEffect.add(modeEffect396.tree)



                RBRACKET397=self.match(self.input, RBRACKET, self.FOLLOW_RBRACKET_in_errorTransition4166) 
                if self._state.backtracking == 0:
                    stream_RBRACKET.add(RBRACKET397)
                ARROW398=self.match(self.input, ARROW, self.FOLLOW_ARROW_in_errorTransition4168) 
                if self._state.backtracking == 0:
                    stream_ARROW.add(ARROW398)
                IDENT399=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_errorTransition4170) 
                if self._state.backtracking == 0:
                    stream_IDENT.add(IDENT399)
                SEMICOLON400=self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_errorTransition4172) 
                if self._state.backtracking == 0:
                    stream_SEMICOLON.add(SEMICOLON400)

                # AST Rewrite
                # elements: sourceState, modeGuard, timeDelay, THEN, IDENT, modeEffect, WITHIN, errorTrigger, WHEN
                # token labels: 
                # rule labels: retval
                # token list labels: 
                # rule list labels: 
                if self._state.backtracking == 0:

                    retval.tree = root_0

                    if retval is not None:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", retval.tree)
                    else:
                        stream_retval = RewriteRuleSubtreeStream(self._adaptor, "token retval", None)


                    root_0 = self._adaptor.nil()
                    # 668:3: -> ^( ERR_TRANS sourceState errorTrigger IDENT ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? )
                    # Slim.g:668:6: ^( ERR_TRANS sourceState errorTrigger IDENT ( WHEN modeGuard )? ( WITHIN timeDelay )? ( THEN modeEffect )? )
                    root_1 = self._adaptor.nil()
                    root_1 = self._adaptor.becomeRoot(self._adaptor.createFromType(ERR_TRANS, "ERR_TRANS"), root_1)

                    self._adaptor.addChild(root_1, stream_sourceState.nextTree())
                    self._adaptor.addChild(root_1, stream_errorTrigger.nextTree())
                    self._adaptor.addChild(root_1, stream_IDENT.nextNode())
                    # Slim.g:668:49: ( WHEN modeGuard )?
                    if stream_modeGuard.hasNext() or stream_WHEN.hasNext():
                        self._adaptor.addChild(root_1, stream_WHEN.nextNode())
                        self._adaptor.addChild(root_1, stream_modeGuard.nextTree())


                    stream_modeGuard.reset();
                    stream_WHEN.reset();
                    # Slim.g:668:67: ( WITHIN timeDelay )?
                    if stream_timeDelay.hasNext() or stream_WITHIN.hasNext():
                        self._adaptor.addChild(root_1, stream_WITHIN.nextNode())
                        self._adaptor.addChild(root_1, stream_timeDelay.nextTree())


                    stream_timeDelay.reset();
                    stream_WITHIN.reset();
                    # Slim.g:668:87: ( THEN modeEffect )?
                    if stream_THEN.hasNext() or stream_modeEffect.hasNext():
                        self._adaptor.addChild(root_1, stream_THEN.nextNode())
                        self._adaptor.addChild(root_1, stream_modeEffect.nextTree())


                    stream_THEN.reset();
                    stream_modeEffect.reset();

                    self._adaptor.addChild(root_0, root_1)



                    retval.tree = root_0



                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)

                if self._state.backtracking == 0:
                    self.rules.pop() 


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorTransition"

    class sourceState_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "sourceState"
    # Slim.g:671:1: sourceState : ( IDENT | TIMES );
    def sourceState(self, ):

        retval = self.sourceState_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set401 = None

        set401_tree = None

        try:
            try:
                # Slim.g:672:5: ( IDENT | TIMES )
                # Slim.g:
                pass 
                root_0 = self._adaptor.nil()

                set401 = self.input.LT(1)
                if self.input.LA(1) == TIMES or self.input.LA(1) == IDENT:
                    self.input.consume()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, self._adaptor.createWithPayload(set401))
                    self._state.errorRecovery = False

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    mse = MismatchedSetException(None, self.input)
                    raise mse





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "sourceState"

    class errorTrigger_return(ParserRuleReturnScope):
        def __init__(self):
            ParserRuleReturnScope.__init__(self)

            self.tree = None




    # $ANTLR start "errorTrigger"
    # Slim.g:676:1: errorTrigger : ( IDENT | RESET | ATACTIVATION );
    def errorTrigger(self, ):

        retval = self.errorTrigger_return()
        retval.start = self.input.LT(1)

        root_0 = None

        set402 = None

        set402_tree = None

        try:
            try:
                # Slim.g:677:2: ( IDENT | RESET | ATACTIVATION )
                # Slim.g:
                pass 
                root_0 = self._adaptor.nil()

                set402 = self.input.LT(1)
                if self.input.LA(1) == ATACTIVATION or self.input.LA(1) == RESET or self.input.LA(1) == IDENT:
                    self.input.consume()
                    if self._state.backtracking == 0:
                        self._adaptor.addChild(root_0, self._adaptor.createWithPayload(set402))
                    self._state.errorRecovery = False

                else:
                    if self._state.backtracking > 0:
                        raise BacktrackingFailed

                    mse = MismatchedSetException(None, self.input)
                    raise mse





                retval.stop = self.input.LT(-1)

                if self._state.backtracking == 0:

                    retval.tree = self._adaptor.rulePostProcessing(root_0)
                    self._adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop)


            except RecognitionException, re:
                self.reportError(re)
                self.recover(self.input, re)
                retval.tree = self._adaptor.errorNode(self.input, retval.start, self.input.LT(-1), re)
        finally:

            pass

        return retval

    # $ANTLR end "errorTrigger"

    # $ANTLR start "synpred2_Slim"
    def synpred2_Slim_fragment(self, ):
        # Slim.g:202:28: ( declaration )
        # Slim.g:202:28: declaration
        pass 
        self._state.following.append(self.FOLLOW_declaration_in_synpred2_Slim1035)
        self.declaration()

        self._state.following.pop()


    # $ANTLR end "synpred2_Slim"



    # $ANTLR start "synpred4_Slim"
    def synpred4_Slim_fragment(self, ):
        # Slim.g:211:12: ( declaration )
        # Slim.g:211:12: declaration
        pass 
        self._state.following.append(self.FOLLOW_declaration_in_synpred4_Slim1084)
        self.declaration()

        self._state.following.pop()


    # $ANTLR end "synpred4_Slim"



    # $ANTLR start "synpred5_Slim"
    def synpred5_Slim_fragment(self, ):
        # Slim.g:211:12: ( ( declaration )+ )
        # Slim.g:211:12: ( declaration )+
        pass 
        # Slim.g:211:12: ( declaration )+
        cnt114 = 0
        while True: #loop114
            alt114 = 2
            alt114 = self.dfa114.predict(self.input)
            if alt114 == 1:
                # Slim.g:0:0: declaration
                pass 
                self._state.following.append(self.FOLLOW_declaration_in_synpred5_Slim1084)
                self.declaration()

                self._state.following.pop()


            else:
                if cnt114 >= 1:
                    break #loop114

                if self._state.backtracking > 0:
                    raise BacktrackingFailed

                eee = EarlyExitException(114, self.input)
                raise eee

            cnt114 += 1




    # $ANTLR end "synpred5_Slim"



    # $ANTLR start "synpred6_Slim"
    def synpred6_Slim_fragment(self, ):
        # Slim.g:212:14: ( declaration )
        # Slim.g:212:14: declaration
        pass 
        self._state.following.append(self.FOLLOW_declaration_in_synpred6_Slim1099)
        self.declaration()

        self._state.following.pop()


    # $ANTLR end "synpred6_Slim"



    # $ANTLR start "synpred7_Slim"
    def synpred7_Slim_fragment(self, ):
        # Slim.g:212:14: ( ( declaration )+ )
        # Slim.g:212:14: ( declaration )+
        pass 
        # Slim.g:212:14: ( declaration )+
        cnt115 = 0
        while True: #loop115
            alt115 = 2
            alt115 = self.dfa115.predict(self.input)
            if alt115 == 1:
                # Slim.g:0:0: declaration
                pass 
                self._state.following.append(self.FOLLOW_declaration_in_synpred7_Slim1099)
                self.declaration()

                self._state.following.pop()


            else:
                if cnt115 >= 1:
                    break #loop115

                if self._state.backtracking > 0:
                    raise BacktrackingFailed

                eee = EarlyExitException(115, self.input)
                raise eee

            cnt115 += 1




    # $ANTLR end "synpred7_Slim"



    # $ANTLR start "synpred9_Slim"
    def synpred9_Slim_fragment(self, ):
        # Slim.g:217:4: ({...}? => componentType )
        # Slim.g:217:4: {...}? => componentType
        pass 
        if not ((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred9_Slim", "globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL")

        self._state.following.append(self.FOLLOW_componentType_in_synpred9_Slim1132)
        self.componentType()

        self._state.following.pop()


    # $ANTLR end "synpred9_Slim"



    # $ANTLR start "synpred10_Slim"
    def synpred10_Slim_fragment(self, ):
        # Slim.g:218:4: ({...}? => componentImplementation )
        # Slim.g:218:4: {...}? => componentImplementation
        pass 
        if not ((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred10_Slim", "globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL")

        self._state.following.append(self.FOLLOW_componentImplementation_in_synpred10_Slim1140)
        self.componentImplementation()

        self._state.following.pop()


    # $ANTLR end "synpred10_Slim"



    # $ANTLR start "synpred11_Slim"
    def synpred11_Slim_fragment(self, ):
        # Slim.g:219:4: ({...}? => errorType )
        # Slim.g:219:4: {...}? => errorType
        pass 
        if not ((globals.PARSER_ACCEPT_ERROR)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred11_Slim", "globals.PARSER_ACCEPT_ERROR")

        self._state.following.append(self.FOLLOW_errorType_in_synpred11_Slim1148)
        self.errorType()

        self._state.following.pop()


    # $ANTLR end "synpred11_Slim"



    # $ANTLR start "synpred13_Slim"
    def synpred13_Slim_fragment(self, ):
        # Slim.g:227:15: ( portSpec )
        # Slim.g:227:15: portSpec
        pass 
        self._state.following.append(self.FOLLOW_portSpec_in_synpred13_Slim1199)
        self.portSpec()

        self._state.following.pop()


    # $ANTLR end "synpred13_Slim"



    # $ANTLR start "synpred14_Slim"
    def synpred14_Slim_fragment(self, ):
        # Slim.g:227:15: ( ( portSpec )+ )
        # Slim.g:227:15: ( portSpec )+
        pass 
        # Slim.g:227:15: ( portSpec )+
        cnt118 = 0
        while True: #loop118
            alt118 = 2
            LA118_0 = self.input.LA(1)

            if (LA118_0 == IDENT) :
                alt118 = 1


            if alt118 == 1:
                # Slim.g:0:0: portSpec
                pass 
                self._state.following.append(self.FOLLOW_portSpec_in_synpred14_Slim1199)
                self.portSpec()

                self._state.following.pop()


            else:
                if cnt118 >= 1:
                    break #loop118

                if self._state.backtracking > 0:
                    raise BacktrackingFailed

                eee = EarlyExitException(118, self.input)
                raise eee

            cnt118 += 1




    # $ANTLR end "synpred14_Slim"



    # $ANTLR start "synpred98_Slim"
    def synpred98_Slim_fragment(self, ):
        # Slim.g:425:4: ( URGENT IN timeScaledNumber )
        # Slim.g:425:4: URGENT IN timeScaledNumber
        pass 
        self.match(self.input, URGENT, self.FOLLOW_URGENT_in_synpred98_Slim2672)
        self.match(self.input, IN, self.FOLLOW_IN_in_synpred98_Slim2674)
        self._state.following.append(self.FOLLOW_timeScaledNumber_in_synpred98_Slim2676)
        self.timeScaledNumber()

        self._state.following.pop()


    # $ANTLR end "synpred98_Slim"



    # $ANTLR start "synpred101_Slim"
    def synpred101_Slim_fragment(self, ):
        # Slim.g:432:4: ({...}? => ERROR )
        # Slim.g:432:4: {...}? => ERROR
        pass 
        if not ((globals.PARSER_ACCEPT_NOMINAL and globals.PARSER_ACCEPT_ERROR)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred101_Slim", "globals.PARSER_ACCEPT_NOMINAL and globals.PARSER_ACCEPT_ERROR")

        self.match(self.input, ERROR, self.FOLLOW_ERROR_in_synpred101_Slim2726)


    # $ANTLR end "synpred101_Slim"



    # $ANTLR start "synpred109_Slim"
    def synpred109_Slim_fragment(self, ):
        # Slim.g:473:23: ( AND compareExpression )
        # Slim.g:473:23: AND compareExpression
        pass 
        self.match(self.input, AND, self.FOLLOW_AND_in_synpred109_Slim2906)
        self._state.following.append(self.FOLLOW_compareExpression_in_synpred109_Slim2909)
        self.compareExpression()

        self._state.following.pop()


    # $ANTLR end "synpred109_Slim"



    # $ANTLR start "synpred111_Slim"
    def synpred111_Slim_fragment(self, ):
        # Slim.g:477:24: ({...}? => ( EQ | NEQ ) relativeExpression )
        # Slim.g:477:24: {...}? => ( EQ | NEQ ) relativeExpression
        pass 
        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred111_Slim", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        if (EQ <= self.input.LA(1) <= NEQ):
            self.input.consume()
            self._state.errorRecovery = False

        else:
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            mse = MismatchedSetException(None, self.input)
            raise mse


        self._state.following.append(self.FOLLOW_relativeExpression_in_synpred111_Slim2937)
        self.relativeExpression()

        self._state.following.pop()


    # $ANTLR end "synpred111_Slim"



    # $ANTLR start "synpred115_Slim"
    def synpred115_Slim_fragment(self, ):
        # Slim.g:481:19: ({...}? => ( LT | LE | GT | GE ) addExpression )
        # Slim.g:481:19: {...}? => ( LT | LE | GT | GE ) addExpression
        pass 
        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred115_Slim", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        if (LT <= self.input.LA(1) <= GE):
            self.input.consume()
            self._state.errorRecovery = False

        else:
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            mse = MismatchedSetException(None, self.input)
            raise mse


        self._state.following.append(self.FOLLOW_addExpression_in_synpred115_Slim2968)
        self.addExpression()

        self._state.following.pop()


    # $ANTLR end "synpred115_Slim"



    # $ANTLR start "synpred117_Slim"
    def synpred117_Slim_fragment(self, ):
        # Slim.g:485:19: ({...}? => ( PLUS | MINUS ) mulExpression )
        # Slim.g:485:19: {...}? => ( PLUS | MINUS ) mulExpression
        pass 
        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred117_Slim", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        if (PLUS <= self.input.LA(1) <= MINUS):
            self.input.consume()
            self._state.errorRecovery = False

        else:
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            mse = MismatchedSetException(None, self.input)
            raise mse


        self._state.following.append(self.FOLLOW_mulExpression_in_synpred117_Slim2994)
        self.mulExpression()

        self._state.following.pop()


    # $ANTLR end "synpred117_Slim"



    # $ANTLR start "synpred120_Slim"
    def synpred120_Slim_fragment(self, ):
        # Slim.g:489:20: ({...}? => ( TIMES | DIVIDE | MOD ) timeExpression )
        # Slim.g:489:20: {...}? => ( TIMES | DIVIDE | MOD ) timeExpression
        pass 
        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred120_Slim", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        if self.input.LA(1) == TIMES or (DIVIDE <= self.input.LA(1) <= MOD):
            self.input.consume()
            self._state.errorRecovery = False

        else:
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            mse = MismatchedSetException(None, self.input)
            raise mse


        self._state.following.append(self.FOLLOW_timeExpression_in_synpred120_Slim3022)
        self.timeExpression()

        self._state.following.pop()


    # $ANTLR end "synpred120_Slim"



    # $ANTLR start "synpred123_Slim"
    def synpred123_Slim_fragment(self, ):
        # Slim.g:498:4: ( ( MINUS unaryExpression ) )
        # Slim.g:498:4: ( MINUS unaryExpression )
        pass 
        # Slim.g:498:4: ( MINUS unaryExpression )
        # Slim.g:498:5: MINUS unaryExpression
        pass 
        self.match(self.input, MINUS, self.FOLLOW_MINUS_in_synpred123_Slim3070)
        self._state.following.append(self.FOLLOW_unaryExpression_in_synpred123_Slim3072)
        self.unaryExpression()

        self._state.following.pop()





    # $ANTLR end "synpred123_Slim"



    # $ANTLR start "synpred124_Slim"
    def synpred124_Slim_fragment(self, ):
        # Slim.g:503:4: ({...}? => number )
        # Slim.g:503:4: {...}? => number
        pass 
        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred124_Slim", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        self._state.following.append(self.FOLLOW_number_in_synpred124_Slim3100)
        self.number()

        self._state.following.pop()


    # $ANTLR end "synpred124_Slim"



    # $ANTLR start "synpred125_Slim"
    def synpred125_Slim_fragment(self, ):
        # Slim.g:504:4: ({...}? => atomicExpressionForParserExpressionsOnly )
        # Slim.g:504:4: {...}? => atomicExpressionForParserExpressionsOnly
        pass 
        if not ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred125_Slim", "globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        self._state.following.append(self.FOLLOW_atomicExpressionForParserExpressionsOnly_in_synpred125_Slim3108)
        self.atomicExpressionForParserExpressionsOnly()

        self._state.following.pop()


    # $ANTLR end "synpred125_Slim"



    # $ANTLR start "synpred126_Slim"
    def synpred126_Slim_fragment(self, ):
        # Slim.g:505:4: ({...}? => name )
        # Slim.g:505:4: {...}? => name
        pass 
        if not ((self.allow_names)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred126_Slim", "self.allow_names")

        self._state.following.append(self.FOLLOW_name_in_synpred126_Slim3116)
        self.name()

        self._state.following.pop()


    # $ANTLR end "synpred126_Slim"



    # $ANTLR start "synpred127_Slim"
    def synpred127_Slim_fragment(self, ):
        # Slim.g:506:4: ( IDENT )
        # Slim.g:506:4: IDENT
        pass 
        self.match(self.input, IDENT, self.FOLLOW_IDENT_in_synpred127_Slim3121)


    # $ANTLR end "synpred127_Slim"



    # $ANTLR start "synpred129_Slim"
    def synpred129_Slim_fragment(self, ):
        # Slim.g:507:4: ({...}? => ( TRUE | FALSE ) )
        # Slim.g:507:4: {...}? => ( TRUE | FALSE )
        pass 
        if not ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            raise FailedPredicateException(self.input, "synpred129_Slim", "not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY")

        if (TRUE <= self.input.LA(1) <= FALSE):
            self.input.consume()
            self._state.errorRecovery = False

        else:
            if self._state.backtracking > 0:
                raise BacktrackingFailed

            mse = MismatchedSetException(None, self.input)
            raise mse




    # $ANTLR end "synpred129_Slim"



    # $ANTLR start "synpred131_Slim"
    def synpred131_Slim_fragment(self, ):
        # Slim.g:509:60: ( expression COLON expression SEMICOLON )
        # Slim.g:509:60: expression COLON expression SEMICOLON
        pass 
        self._state.following.append(self.FOLLOW_expression_in_synpred131_Slim3158)
        self.expression()

        self._state.following.pop()
        self.match(self.input, COLON, self.FOLLOW_COLON_in_synpred131_Slim3160)
        self._state.following.append(self.FOLLOW_expression_in_synpred131_Slim3163)
        self.expression()

        self._state.following.pop()
        self.match(self.input, SEMICOLON, self.FOLLOW_SEMICOLON_in_synpred131_Slim3165)


    # $ANTLR end "synpred131_Slim"



    # $ANTLR start "synpred133_Slim"
    def synpred133_Slim_fragment(self, ):
        # Slim.g:517:4: ( MODE COLON i1= IDENT )
        # Slim.g:517:4: MODE COLON i1= IDENT
        pass 
        self.match(self.input, MODE, self.FOLLOW_MODE_in_synpred133_Slim3218)
        self.match(self.input, COLON, self.FOLLOW_COLON_in_synpred133_Slim3221)
        i1=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_synpred133_Slim3226)


    # $ANTLR end "synpred133_Slim"



    # $ANTLR start "synpred134_Slim"
    def synpred134_Slim_fragment(self, ):
        # Slim.g:521:4: ( ERROR COLON i1= IDENT )
        # Slim.g:521:4: ERROR COLON i1= IDENT
        pass 
        self.match(self.input, ERROR, self.FOLLOW_ERROR_in_synpred134_Slim3235)
        self.match(self.input, COLON, self.FOLLOW_COLON_in_synpred134_Slim3238)
        i1=self.match(self.input, IDENT, self.FOLLOW_IDENT_in_synpred134_Slim3243)


    # $ANTLR end "synpred134_Slim"



    # $ANTLR start "synpred135_Slim"
    def synpred135_Slim_fragment(self, ):
        # Slim.g:525:8: ( MODE )
        # Slim.g:525:8: MODE
        pass 
        self.match(self.input, MODE, self.FOLLOW_MODE_in_synpred135_Slim3256)


    # $ANTLR end "synpred135_Slim"



    # $ANTLR start "synpred136_Slim"
    def synpred136_Slim_fragment(self, ):
        # Slim.g:527:7: ( ERROR )
        # Slim.g:527:7: ERROR
        pass 
        self.match(self.input, ERROR, self.FOLLOW_ERROR_in_synpred136_Slim3278)


    # $ANTLR end "synpred136_Slim"




    # Delegated rules

    def synpred123_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred123_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred129_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred129_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred115_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred115_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred120_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred120_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred13_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred13_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred101_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred101_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred109_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred109_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred10_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred10_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred9_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred9_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred111_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred111_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred5_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred5_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred131_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred131_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred2_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred2_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred126_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred126_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred134_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred134_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred133_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred133_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred136_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred136_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred98_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred98_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred4_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred4_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred125_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred125_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred127_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred127_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred6_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred6_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred117_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred117_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred135_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred135_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred124_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred124_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred7_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred7_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred14_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred14_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success

    def synpred11_Slim(self):
        self._state.backtracking += 1
        start = self.input.mark()
        try:
            self.synpred11_Slim_fragment()
        except BacktrackingFailed:
            success = False
        else:
            success = True
        self.input.rewind(start)
        self._state.backtracking -= 1
        return success



    # lookup tables for DFA #1

    DFA1_eot = DFA.unpack(
        u"\14\uffff"
        )

    DFA1_eof = DFA.unpack(
        u"\1\1\13\uffff"
        )

    DFA1_min = DFA.unpack(
        u"\1\4\13\uffff"
        )

    DFA1_max = DFA.unpack(
        u"\1\76\13\uffff"
        )

    DFA1_accept = DFA.unpack(
        u"\1\uffff\1\3\1\1\11\2"
        )

    DFA1_special = DFA.unpack(
        u"\1\0\13\uffff"
        )

            
    DFA1_transition = [
        DFA.unpack(u"\1\2\6\uffff\1\5\1\uffff\1\4\1\uffff\1\7\1\6\1\11\1"
        u"\10\1\12\10\uffff\1\3\41\uffff\1\13"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #1

    class DFA1(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA1_0 = input.LA(1)

                 
                index1_0 = input.index()
                input.rewind()
                s = -1
                if (LA1_0 == EOF):
                    s = 1

                elif (LA1_0 == PACKAGE):
                    s = 2

                elif (LA1_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 3

                elif (LA1_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 4

                elif (LA1_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 5

                elif (LA1_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 6

                elif (LA1_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 7

                elif (LA1_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 8

                elif (LA1_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 9

                elif (LA1_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 10

                elif (LA1_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 11

                 
                input.seek(index1_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 1, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #4

    DFA4_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA4_eof = DFA.unpack(
        u"\13\uffff"
        )

    DFA4_min = DFA.unpack(
        u"\1\6\12\uffff"
        )

    DFA4_max = DFA.unpack(
        u"\1\76\12\uffff"
        )

    DFA4_accept = DFA.unpack(
        u"\1\uffff\11\1\1\2"
        )

    DFA4_special = DFA.unpack(
        u"\1\0\12\uffff"
        )

            
    DFA4_transition = [
        DFA.unpack(u"\2\12\3\uffff\1\3\1\uffff\1\2\1\uffff\1\5\1\4\1\7\1"
        u"\6\1\10\10\uffff\1\1\41\uffff\1\11"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #4

    class DFA4(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA4_0 = input.LA(1)

                 
                index4_0 = input.index()
                input.rewind()
                s = -1
                if (LA4_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 1

                elif (LA4_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 2

                elif (LA4_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 3

                elif (LA4_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 4

                elif (LA4_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 5

                elif (LA4_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 6

                elif (LA4_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 7

                elif (LA4_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 8

                elif (LA4_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 9

                elif ((PRIVATE <= LA4_0 <= END)):
                    s = 10

                 
                input.seek(index4_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 4, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #3

    DFA3_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA3_eof = DFA.unpack(
        u"\13\uffff"
        )

    DFA3_min = DFA.unpack(
        u"\1\6\12\uffff"
        )

    DFA3_max = DFA.unpack(
        u"\1\76\12\uffff"
        )

    DFA3_accept = DFA.unpack(
        u"\1\uffff\1\2\11\1"
        )

    DFA3_special = DFA.unpack(
        u"\1\0\12\uffff"
        )

            
    DFA3_transition = [
        DFA.unpack(u"\2\1\3\uffff\1\4\1\uffff\1\3\1\uffff\1\6\1\5\1\10\1"
        u"\7\1\11\10\uffff\1\2\41\uffff\1\12"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #3

    class DFA3(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA3_0 = input.LA(1)

                 
                index3_0 = input.index()
                input.rewind()
                s = -1
                if ((PRIVATE <= LA3_0 <= END)):
                    s = 1

                elif (LA3_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 2

                elif (LA3_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 3

                elif (LA3_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 4

                elif (LA3_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 5

                elif (LA3_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 6

                elif (LA3_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 7

                elif (LA3_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 8

                elif (LA3_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 9

                elif (LA3_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 10

                 
                input.seek(index3_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 3, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #6

    DFA6_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA6_eof = DFA.unpack(
        u"\13\uffff"
        )

    DFA6_min = DFA.unpack(
        u"\1\7\12\uffff"
        )

    DFA6_max = DFA.unpack(
        u"\1\76\12\uffff"
        )

    DFA6_accept = DFA.unpack(
        u"\1\uffff\11\1\1\2"
        )

    DFA6_special = DFA.unpack(
        u"\1\0\12\uffff"
        )

            
    DFA6_transition = [
        DFA.unpack(u"\1\12\3\uffff\1\3\1\uffff\1\2\1\uffff\1\5\1\4\1\7\1"
        u"\6\1\10\10\uffff\1\1\41\uffff\1\11"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #6

    class DFA6(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA6_0 = input.LA(1)

                 
                index6_0 = input.index()
                input.rewind()
                s = -1
                if (LA6_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 1

                elif (LA6_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 2

                elif (LA6_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 3

                elif (LA6_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 4

                elif (LA6_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 5

                elif (LA6_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 6

                elif (LA6_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 7

                elif (LA6_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 8

                elif (LA6_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 9

                elif (LA6_0 == END):
                    s = 10

                 
                input.seek(index6_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 6, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #5

    DFA5_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA5_eof = DFA.unpack(
        u"\13\uffff"
        )

    DFA5_min = DFA.unpack(
        u"\1\7\12\uffff"
        )

    DFA5_max = DFA.unpack(
        u"\1\76\12\uffff"
        )

    DFA5_accept = DFA.unpack(
        u"\1\uffff\1\2\11\1"
        )

    DFA5_special = DFA.unpack(
        u"\1\0\12\uffff"
        )

            
    DFA5_transition = [
        DFA.unpack(u"\1\1\3\uffff\1\4\1\uffff\1\3\1\uffff\1\6\1\5\1\10\1"
        u"\7\1\11\10\uffff\1\2\41\uffff\1\12"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #5

    class DFA5(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA5_0 = input.LA(1)

                 
                index5_0 = input.index()
                input.rewind()
                s = -1
                if (LA5_0 == END):
                    s = 1

                elif (LA5_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 2

                elif (LA5_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 3

                elif (LA5_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 4

                elif (LA5_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 5

                elif (LA5_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 6

                elif (LA5_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 7

                elif (LA5_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 8

                elif (LA5_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 9

                elif (LA5_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 10

                 
                input.seek(index5_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 5, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #8

    DFA8_eot = DFA.unpack(
        u"\20\uffff"
        )

    DFA8_eof = DFA.unpack(
        u"\20\uffff"
        )

    DFA8_min = DFA.unpack(
        u"\2\13\1\37\1\14\5\37\1\12\2\uffff\2\37\2\uffff"
        )

    DFA8_max = DFA.unpack(
        u"\1\76\1\23\7\u0084\1\12\2\uffff\2\u0084\2\uffff"
        )

    DFA8_accept = DFA.unpack(
        u"\12\uffff\1\1\1\2\2\uffff\1\3\1\4"
        )

    DFA8_special = DFA.unpack(
        u"\1\4\1\uffff\1\1\1\2\1\0\1\3\1\5\1\7\1\11\1\10\2\uffff\1\6\1\12"
        u"\2\uffff"
        )

            
    DFA8_transition = [
        DFA.unpack(u"\1\3\1\uffff\1\2\1\uffff\1\5\1\4\1\7\1\6\1\10\10\uffff"
        u"\1\1\41\uffff\1\11"),
        DFA.unpack(u"\1\3\1\uffff\1\2\1\uffff\1\5\1\4\1\7\1\6\1\10"),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\14\22\uffff\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\15"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\13\144\uffff\1\12"),
        DFA.unpack(u"\1\17\144\uffff\1\16"),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #8

    class DFA8(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA8_4 = input.LA(1)

                 
                index8_4 = input.index()
                input.rewind()
                s = -1
                if (LA8_4 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_4 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_4)
                if s >= 0:
                    return s
            elif s == 1: 
                LA8_2 = input.LA(1)

                 
                index8_2 = input.index()
                input.rewind()
                s = -1
                if (LA8_2 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_2 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_2)
                if s >= 0:
                    return s
            elif s == 2: 
                LA8_3 = input.LA(1)

                 
                index8_3 = input.index()
                input.rewind()
                s = -1
                if (LA8_3 == GROUP):
                    s = 12

                elif (LA8_3 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_3 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_3)
                if s >= 0:
                    return s
            elif s == 3: 
                LA8_5 = input.LA(1)

                 
                index8_5 = input.index()
                input.rewind()
                s = -1
                if (LA8_5 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_5 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_5)
                if s >= 0:
                    return s
            elif s == 4: 
                LA8_0 = input.LA(1)

                 
                index8_0 = input.index()
                input.rewind()
                s = -1
                if (LA8_0 == FDIR):
                    s = 1

                elif (LA8_0 == PROCESS):
                    s = 2

                elif (LA8_0 == THREAD):
                    s = 3

                elif (LA8_0 == PROCESSOR):
                    s = 4

                elif (LA8_0 == MEMORY):
                    s = 5

                elif (LA8_0 == DEVICE):
                    s = 6

                elif (LA8_0 == BUS):
                    s = 7

                elif (LA8_0 == SYSTEM):
                    s = 8

                elif (LA8_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 9

                 
                input.seek(index8_0)
                if s >= 0:
                    return s
            elif s == 5: 
                LA8_6 = input.LA(1)

                 
                index8_6 = input.index()
                input.rewind()
                s = -1
                if (LA8_6 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_6 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_6)
                if s >= 0:
                    return s
            elif s == 6: 
                LA8_12 = input.LA(1)

                 
                index8_12 = input.index()
                input.rewind()
                s = -1
                if (LA8_12 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_12 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_12)
                if s >= 0:
                    return s
            elif s == 7: 
                LA8_7 = input.LA(1)

                 
                index8_7 = input.index()
                input.rewind()
                s = -1
                if (LA8_7 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_7 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_7)
                if s >= 0:
                    return s
            elif s == 8: 
                LA8_9 = input.LA(1)

                 
                index8_9 = input.index()
                input.rewind()
                s = -1
                if (LA8_9 == MODEL) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 13

                 
                input.seek(index8_9)
                if s >= 0:
                    return s
            elif s == 9: 
                LA8_8 = input.LA(1)

                 
                index8_8 = input.index()
                input.rewind()
                s = -1
                if (LA8_8 == IDENT) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL)))):
                    s = 10

                elif (LA8_8 == IMPLEMENTATION) and ((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR)))):
                    s = 11

                 
                input.seek(index8_8)
                if s >= 0:
                    return s
            elif s == 10: 
                LA8_13 = input.LA(1)

                 
                index8_13 = input.index()
                input.rewind()
                s = -1
                if (LA8_13 == IDENT) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 14

                elif (LA8_13 == IMPLEMENTATION) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 15

                 
                input.seek(index8_13)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 8, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #44

    DFA44_eot = DFA.unpack(
        u"\12\uffff"
        )

    DFA44_eof = DFA.unpack(
        u"\12\uffff"
        )

    DFA44_min = DFA.unpack(
        u"\1\13\1\uffff\1\14\7\uffff"
        )

    DFA44_max = DFA.unpack(
        u"\1\23\1\uffff\1\u0084\7\uffff"
        )

    DFA44_accept = DFA.unpack(
        u"\1\uffff\1\1\1\uffff\1\4\1\5\1\6\1\7\1\10\1\2\1\3"
        )

    DFA44_special = DFA.unpack(
        u"\12\uffff"
        )

            
    DFA44_transition = [
        DFA.unpack(u"\1\2\1\uffff\1\1\1\uffff\1\4\1\3\1\6\1\5\1\7"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\10\22\uffff\1\11\144\uffff\1\11"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #44

    DFA44 = DFA
    # lookup tables for DFA #53

    DFA53_eot = DFA.unpack(
        u"\12\uffff"
        )

    DFA53_eof = DFA.unpack(
        u"\12\uffff"
        )

    DFA53_min = DFA.unpack(
        u"\1\u0084\1\24\1\25\2\16\5\uffff"
        )

    DFA53_max = DFA.unpack(
        u"\1\u0084\1\24\1\76\2\30\5\uffff"
        )

    DFA53_accept = DFA.unpack(
        u"\5\uffff\1\5\1\1\1\3\1\2\1\4"
        )

    DFA53_special = DFA.unpack(
        u"\2\uffff\1\0\7\uffff"
        )

            
    DFA53_transition = [
        DFA.unpack(u"\1\1"),
        DFA.unpack(u"\1\2"),
        DFA.unpack(u"\1\3\1\4\47\uffff\1\5"),
        DFA.unpack(u"\1\7\11\uffff\1\6"),
        DFA.unpack(u"\1\11\11\uffff\1\10"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #53

    class DFA53(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA53_2 = input.LA(1)

                 
                index53_2 = input.index()
                input.rewind()
                s = -1
                if (LA53_2 == IN):
                    s = 3

                elif (LA53_2 == OUT):
                    s = 4

                elif (LA53_2 == ERROR) and ((globals.PARSER_ACCEPT_EXTENDED_MODEL)):
                    s = 5

                 
                input.seek(index53_2)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 53, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #80

    DFA80_eot = DFA.unpack(
        u"\20\uffff"
        )

    DFA80_eof = DFA.unpack(
        u"\1\1\17\uffff"
        )

    DFA80_min = DFA.unpack(
        u"\1\7\5\uffff\1\0\11\uffff"
        )

    DFA80_max = DFA.unpack(
        u"\1\117\5\uffff\1\0\11\uffff"
        )

    DFA80_accept = DFA.unpack(
        u"\1\uffff\1\2\15\uffff\1\1"
        )

    DFA80_special = DFA.unpack(
        u"\6\uffff\1\0\11\uffff"
        )

            
    DFA80_transition = [
        DFA.unpack(u"\2\1\13\uffff\2\1\30\uffff\1\6\5\uffff\2\1\1\uffff\1"
        u"\1\3\uffff\1\1\14\uffff\1\1\2\uffff\5\1"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #80

    class DFA80(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA80_6 = input.LA(1)

                 
                index80_6 = input.index()
                input.rewind()
                s = -1
                if (self.synpred109_Slim()):
                    s = 15

                elif (True):
                    s = 1

                 
                input.seek(index80_6)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 80, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #86

    DFA86_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA86_eof = DFA.unpack(
        u"\13\uffff"
        )

    DFA86_min = DFA.unpack(
        u"\1\53\1\uffff\1\53\6\uffff\1\0\1\uffff"
        )

    DFA86_max = DFA.unpack(
        u"\1\u0085\1\uffff\1\u0085\6\uffff\1\0\1\uffff"
        )

    DFA86_accept = DFA.unpack(
        u"\1\uffff\1\1\1\uffff\6\3\1\uffff\1\2"
        )

    DFA86_special = DFA.unpack(
        u"\1\0\10\uffff\1\1\1\uffff"
        )

            
    DFA86_transition = [
        DFA.unpack(u"\1\4\7\uffff\1\10\6\uffff\1\7\3\uffff\1\4\13\uffff\1"
        u"\1\13\uffff\1\4\12\uffff\1\2\2\uffff\2\6\36\uffff\1\5\1\3"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\12\7\uffff\1\12\6\uffff\1\12\3\uffff\1\12\13\uffff"
        u"\1\12\13\uffff\1\12\12\uffff\1\12\2\uffff\2\12\36\uffff\1\12\1"
        u"\11"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"")
    ]

    # class definition for DFA #86

    class DFA86(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA86_0 = input.LA(1)

                 
                index86_0 = input.index()
                input.rewind()
                s = -1
                if (LA86_0 == NOT):
                    s = 1

                elif (LA86_0 == MINUS):
                    s = 2

                elif (LA86_0 == NUMBER) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 3

                elif (LA86_0 == MODE or LA86_0 == ERROR or LA86_0 == ENUM) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 4

                elif (LA86_0 == IDENT):
                    s = 5

                elif ((TRUE <= LA86_0 <= FALSE)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 6

                elif (LA86_0 == LPAREN):
                    s = 7

                elif (LA86_0 == CASE) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 8

                 
                input.seek(index86_0)
                if s >= 0:
                    return s
            elif s == 1: 
                LA86_9 = input.LA(1)

                 
                index86_9 = input.index()
                input.rewind()
                s = -1
                if (self.synpred123_Slim()):
                    s = 10

                elif ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 8

                 
                input.seek(index86_9)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 86, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #88

    DFA88_eot = DFA.unpack(
        u"\14\uffff"
        )

    DFA88_eof = DFA.unpack(
        u"\14\uffff"
        )

    DFA88_min = DFA.unpack(
        u"\1\53\5\uffff\1\33\5\uffff"
        )

    DFA88_max = DFA.unpack(
        u"\1\u0085\5\uffff\1\33\5\uffff"
        )

    DFA88_accept = DFA.unpack(
        u"\1\uffff\2\1\3\2\1\uffff\1\5\1\6\1\7\1\3\1\4"
        )

    DFA88_special = DFA.unpack(
        u"\1\1\5\uffff\1\0\5\uffff"
        )

            
    DFA88_transition = [
        DFA.unpack(u"\1\4\7\uffff\1\11\6\uffff\1\10\3\uffff\1\5\27\uffff"
        u"\1\3\12\uffff\1\1\2\uffff\2\7\36\uffff\1\6\1\2"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\12"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #88

    class DFA88(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA88_6 = input.LA(1)

                 
                index88_6 = input.index()
                input.rewind()
                s = -1
                if (LA88_6 == DOT) and ((self.allow_names)):
                    s = 10

                elif (((self.synpred125_Slim()) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 5

                elif (self.synpred127_Slim()):
                    s = 11

                 
                input.seek(index88_6)
                if s >= 0:
                    return s
            elif s == 1: 
                LA88_0 = input.LA(1)

                 
                index88_0 = input.index()
                input.rewind()
                s = -1
                if (LA88_0 == MINUS) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 1

                elif (LA88_0 == NUMBER) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 2

                elif (LA88_0 == ENUM) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 3

                elif (LA88_0 == MODE) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 4

                elif (LA88_0 == ERROR) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 5

                elif (LA88_0 == IDENT):
                    s = 6

                elif ((TRUE <= LA88_0 <= FALSE)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 7

                elif (LA88_0 == LPAREN):
                    s = 8

                elif (LA88_0 == CASE) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 9

                 
                input.seek(index88_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 88, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #87

    DFA87_eot = DFA.unpack(
        u"\15\uffff"
        )

    DFA87_eof = DFA.unpack(
        u"\15\uffff"
        )

    DFA87_min = DFA.unpack(
        u"\1\53\12\0\2\uffff"
        )

    DFA87_max = DFA.unpack(
        u"\1\u0085\12\0\2\uffff"
        )

    DFA87_accept = DFA.unpack(
        u"\13\uffff\1\1\1\2"
        )

    DFA87_special = DFA.unpack(
        u"\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\2\uffff"
        )

            
    DFA87_transition = [
        DFA.unpack(u"\1\5\7\uffff\1\12\6\uffff\1\11\3\uffff\1\6\13\uffff"
        u"\1\1\13\uffff\1\4\12\uffff\1\2\2\uffff\2\10\36\uffff\1\7\1\3"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #87

    class DFA87(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA87_0 = input.LA(1)

                 
                index87_0 = input.index()
                input.rewind()
                s = -1
                if (LA87_0 == NOT):
                    s = 1

                elif (LA87_0 == MINUS):
                    s = 2

                elif (LA87_0 == NUMBER) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 3

                elif (LA87_0 == ENUM) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 4

                elif (LA87_0 == MODE) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 5

                elif (LA87_0 == ERROR) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 6

                elif (LA87_0 == IDENT):
                    s = 7

                elif ((TRUE <= LA87_0 <= FALSE)) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 8

                elif (LA87_0 == LPAREN):
                    s = 9

                elif (LA87_0 == CASE) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 10

                 
                input.seek(index87_0)
                if s >= 0:
                    return s
            elif s == 1: 
                LA87_1 = input.LA(1)

                 
                index87_1 = input.index()
                input.rewind()
                s = -1
                if (self.synpred131_Slim()):
                    s = 11

                elif (True):
                    s = 12

                 
                input.seek(index87_1)
                if s >= 0:
                    return s
            elif s == 2: 
                LA87_2 = input.LA(1)

                 
                index87_2 = input.index()
                input.rewind()
                s = -1
                if ((((self.synpred131_Slim()) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY))) or self.synpred131_Slim())):
                    s = 11

                elif (True):
                    s = 12

                 
                input.seek(index87_2)
                if s >= 0:
                    return s
            elif s == 3: 
                LA87_3 = input.LA(1)

                 
                index87_3 = input.index()
                input.rewind()
                s = -1
                if (((self.synpred131_Slim()) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 11

                elif ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 12

                 
                input.seek(index87_3)
                if s >= 0:
                    return s
            elif s == 4: 
                LA87_4 = input.LA(1)

                 
                index87_4 = input.index()
                input.rewind()
                s = -1
                if (((self.synpred131_Slim()) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 11

                elif ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 12

                 
                input.seek(index87_4)
                if s >= 0:
                    return s
            elif s == 5: 
                LA87_5 = input.LA(1)

                 
                index87_5 = input.index()
                input.rewind()
                s = -1
                if (((self.synpred131_Slim()) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 11

                elif ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 12

                 
                input.seek(index87_5)
                if s >= 0:
                    return s
            elif s == 6: 
                LA87_6 = input.LA(1)

                 
                index87_6 = input.index()
                input.rewind()
                s = -1
                if (((self.synpred131_Slim()) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 11

                elif ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 12

                 
                input.seek(index87_6)
                if s >= 0:
                    return s
            elif s == 7: 
                LA87_7 = input.LA(1)

                 
                index87_7 = input.index()
                input.rewind()
                s = -1
                if ((((self.synpred131_Slim()) and ((globals.PARSER_EXPRESSIONS_ONLY and not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY))) or self.synpred131_Slim() or ((self.synpred131_Slim()) and ((self.allow_names))))):
                    s = 11

                elif (True):
                    s = 12

                 
                input.seek(index87_7)
                if s >= 0:
                    return s
            elif s == 8: 
                LA87_8 = input.LA(1)

                 
                index87_8 = input.index()
                input.rewind()
                s = -1
                if (((self.synpred131_Slim()) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 11

                elif ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 12

                 
                input.seek(index87_8)
                if s >= 0:
                    return s
            elif s == 9: 
                LA87_9 = input.LA(1)

                 
                index87_9 = input.index()
                input.rewind()
                s = -1
                if (self.synpred131_Slim()):
                    s = 11

                elif (True):
                    s = 12

                 
                input.seek(index87_9)
                if s >= 0:
                    return s
            elif s == 10: 
                LA87_10 = input.LA(1)

                 
                index87_10 = input.index()
                input.rewind()
                s = -1
                if (((self.synpred131_Slim()) and ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)))):
                    s = 11

                elif ((not globals.PARSER_FT_BOOL_EXPRESSIONS_ONLY)):
                    s = 12

                 
                input.seek(index87_10)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 87, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #92

    DFA92_eot = DFA.unpack(
        u"\15\uffff"
        )

    DFA92_eof = DFA.unpack(
        u"\2\uffff\1\6\1\10\11\uffff"
        )

    DFA92_min = DFA.unpack(
        u"\1\53\1\uffff\2\7\1\uffff\1\53\1\uffff\1\53\1\uffff\2\0\2\uffff"
        )

    DFA92_max = DFA.unpack(
        u"\1\u0084\1\uffff\2\143\1\uffff\1\u0085\1\uffff\1\u0085\1\uffff"
        u"\2\0\2\uffff"
        )

    DFA92_accept = DFA.unpack(
        u"\1\uffff\1\1\2\uffff\1\6\1\uffff\1\4\1\uffff\1\5\2\uffff\1\2\1"
        u"\3"
        )

    DFA92_special = DFA.unpack(
        u"\11\uffff\1\1\1\0\2\uffff"
        )

            
    DFA92_transition = [
        DFA.unpack(u"\1\2\22\uffff\1\3\27\uffff\1\1\55\uffff\1\4"),
        DFA.unpack(u""),
        DFA.unpack(u"\2\6\13\uffff\1\5\1\6\30\uffff\5\6\1\uffff\2\6\1\uffff"
        u"\1\6\3\uffff\1\6\14\uffff\1\6\2\uffff\5\6\1\uffff\2\6\7\uffff\12"
        u"\6"),
        DFA.unpack(u"\2\10\13\uffff\1\7\1\10\30\uffff\5\10\1\uffff\2\10"
        u"\1\uffff\1\10\3\uffff\1\10\14\uffff\1\10\2\uffff\5\10\1\uffff\2"
        u"\10\7\uffff\12\10"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\6\7\uffff\1\6\6\uffff\1\6\3\uffff\1\6\13\uffff\1"
        u"\6\13\uffff\1\6\12\uffff\1\6\2\uffff\2\6\36\uffff\1\11\1\6"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\10\7\uffff\1\10\6\uffff\1\10\3\uffff\1\10\13\uffff"
        u"\1\10\13\uffff\1\10\12\uffff\1\10\2\uffff\2\10\36\uffff\1\12\1"
        u"\10"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u"\1\uffff"),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #92

    class DFA92(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA92_10 = input.LA(1)

                 
                index92_10 = input.index()
                input.rewind()
                s = -1
                if (self.synpred134_Slim()):
                    s = 12

                elif (self.synpred136_Slim()):
                    s = 8

                 
                input.seek(index92_10)
                if s >= 0:
                    return s
            elif s == 1: 
                LA92_9 = input.LA(1)

                 
                index92_9 = input.index()
                input.rewind()
                s = -1
                if (self.synpred133_Slim()):
                    s = 11

                elif (self.synpred135_Slim()):
                    s = 6

                 
                input.seek(index92_9)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 92, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #114

    DFA114_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA114_eof = DFA.unpack(
        u"\1\1\12\uffff"
        )

    DFA114_min = DFA.unpack(
        u"\1\13\12\uffff"
        )

    DFA114_max = DFA.unpack(
        u"\1\76\12\uffff"
        )

    DFA114_accept = DFA.unpack(
        u"\1\uffff\1\2\11\1"
        )

    DFA114_special = DFA.unpack(
        u"\1\0\12\uffff"
        )

            
    DFA114_transition = [
        DFA.unpack(u"\1\4\1\uffff\1\3\1\uffff\1\6\1\5\1\10\1\7\1\11\10\uffff"
        u"\1\2\41\uffff\1\12"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #114

    class DFA114(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA114_0 = input.LA(1)

                 
                index114_0 = input.index()
                input.rewind()
                s = -1
                if (LA114_0 == EOF):
                    s = 1

                elif (LA114_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 2

                elif (LA114_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 3

                elif (LA114_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 4

                elif (LA114_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 5

                elif (LA114_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 6

                elif (LA114_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 7

                elif (LA114_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 8

                elif (LA114_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 9

                elif (LA114_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 10

                 
                input.seek(index114_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 114, _s, input)
            self_.error(nvae)
            raise nvae
    # lookup tables for DFA #115

    DFA115_eot = DFA.unpack(
        u"\13\uffff"
        )

    DFA115_eof = DFA.unpack(
        u"\1\1\12\uffff"
        )

    DFA115_min = DFA.unpack(
        u"\1\13\12\uffff"
        )

    DFA115_max = DFA.unpack(
        u"\1\76\12\uffff"
        )

    DFA115_accept = DFA.unpack(
        u"\1\uffff\1\2\11\1"
        )

    DFA115_special = DFA.unpack(
        u"\1\0\12\uffff"
        )

            
    DFA115_transition = [
        DFA.unpack(u"\1\4\1\uffff\1\3\1\uffff\1\6\1\5\1\10\1\7\1\11\10\uffff"
        u"\1\2\41\uffff\1\12"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #115

    class DFA115(DFA):
        def specialStateTransition(self_, s, input):
            # convince pylint that my self_ magic is ok ;)
            # pylint: disable-msg=E0213

            # pretend we are a member of the recognizer
            # thus semantic predicates can be evaluated
            self = self_.recognizer

            _s = s

            if s == 0: 
                LA115_0 = input.LA(1)

                 
                index115_0 = input.index()
                input.rewind()
                s = -1
                if (LA115_0 == EOF):
                    s = 1

                elif (LA115_0 == FDIR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 2

                elif (LA115_0 == PROCESS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 3

                elif (LA115_0 == THREAD) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 4

                elif (LA115_0 == PROCESSOR) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 5

                elif (LA115_0 == MEMORY) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))))):
                    s = 6

                elif (LA115_0 == DEVICE) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 7

                elif (LA115_0 == BUS) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 8

                elif (LA115_0 == SYSTEM) and (((((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_NOMINAL))) or (((globals.PARSER_ACCEPT_FDIR or globals.PARSER_ACCEPT_NOMINAL)) and ((globals.PARSER_ACCEPT_FDIR))))):
                    s = 9

                elif (LA115_0 == ERROR) and ((globals.PARSER_ACCEPT_ERROR)):
                    s = 10

                 
                input.seek(index115_0)
                if s >= 0:
                    return s

            if self._state.backtracking >0:
                raise BacktrackingFailed
            nvae = NoViableAltException(self_.getDescription(), 115, _s, input)
            self_.error(nvae)
            raise nvae
 

    FOLLOW_packageSpecification_in_specification1031 = frozenset([1, 4, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_declaration_in_specification1035 = frozenset([1, 4, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_EOF_in_specification1050 = frozenset([1])
    FOLLOW_PACKAGE_in_packageSpecification1072 = frozenset([132])
    FOLLOW_IDENT_in_packageSpecification1075 = frozenset([5])
    FOLLOW_PUBLIC_in_packageSpecification1081 = frozenset([4, 6, 7, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_declaration_in_packageSpecification1084 = frozenset([4, 6, 7, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_PRIVATE_in_packageSpecification1096 = frozenset([4, 7, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_declaration_in_packageSpecification1099 = frozenset([4, 7, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_END_in_packageSpecification1111 = frozenset([132])
    FOLLOW_IDENT_in_packageSpecification1114 = frozenset([8])
    FOLLOW_SEMICOLON_in_packageSpecification1116 = frozenset([1])
    FOLLOW_componentType_in_declaration1132 = frozenset([1])
    FOLLOW_componentImplementation_in_declaration1140 = frozenset([1])
    FOLLOW_errorType_in_declaration1148 = frozenset([1])
    FOLLOW_errorImplementation_in_declaration1156 = frozenset([1])
    FOLLOW_FDIR_in_componentType1183 = frozenset([11, 13, 15, 16, 17, 18, 19, 28])
    FOLLOW_componentCategory_in_componentType1188 = frozenset([132])
    FOLLOW_IDENT_in_componentType1190 = frozenset([7, 9])
    FOLLOW_FEATURES_in_componentType1196 = frozenset([7, 132])
    FOLLOW_portSpec_in_componentType1199 = frozenset([7, 132])
    FOLLOW_END_in_componentType1211 = frozenset([132])
    FOLLOW_IDENT_in_componentType1213 = frozenset([8])
    FOLLOW_SEMICOLON_in_componentType1215 = frozenset([1])
    FOLLOW_FDIR_in_componentImplementation1266 = frozenset([11, 13, 15, 16, 17, 18, 19, 28])
    FOLLOW_componentCategory_in_componentImplementation1271 = frozenset([31])
    FOLLOW_IMPLEMENTATION_in_componentImplementation1273 = frozenset([132])
    FOLLOW_name_in_componentImplementation1275 = frozenset([7, 32, 33, 34, 104])
    FOLLOW_SUBCOMPONENTS_in_componentImplementation1281 = frozenset([7, 33, 34, 104, 132])
    FOLLOW_subcomponent_in_componentImplementation1284 = frozenset([7, 33, 34, 104, 132])
    FOLLOW_CONNECTIONS_in_componentImplementation1298 = frozenset([7, 14, 24, 34, 104])
    FOLLOW_portConnection_in_componentImplementation1301 = frozenset([7, 14, 24, 34, 104])
    FOLLOW_FLOWS_in_componentImplementation1315 = frozenset([7, 34, 132])
    FOLLOW_flow_in_componentImplementation1318 = frozenset([7, 34, 132])
    FOLLOW_MODES_in_componentImplementation1332 = frozenset([7, 35, 132])
    FOLLOW_mode_in_componentImplementation1335 = frozenset([7, 35, 132])
    FOLLOW_TRANSITIONS_in_componentImplementation1344 = frozenset([7, 95, 132])
    FOLLOW_modeTransition_in_componentImplementation1347 = frozenset([7, 95, 132])
    FOLLOW_END_in_componentImplementation1360 = frozenset([132])
    FOLLOW_name_in_componentImplementation1362 = frozenset([8])
    FOLLOW_SEMICOLON_in_componentImplementation1364 = frozenset([1])
    FOLLOW_ERROR_in_errorType1420 = frozenset([10])
    FOLLOW_MODEL_in_errorType1422 = frozenset([132])
    FOLLOW_IDENT_in_errorType1424 = frozenset([7, 9])
    FOLLOW_FEATURES_in_errorType1431 = frozenset([7, 132])
    FOLLOW_errorFeature_in_errorType1434 = frozenset([7, 132])
    FOLLOW_END_in_errorType1446 = frozenset([132])
    FOLLOW_IDENT_in_errorType1448 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorType1450 = frozenset([1])
    FOLLOW_ERROR_in_errorImplementation1486 = frozenset([10])
    FOLLOW_MODEL_in_errorImplementation1488 = frozenset([31])
    FOLLOW_IMPLEMENTATION_in_errorImplementation1490 = frozenset([132])
    FOLLOW_name_in_errorImplementation1492 = frozenset([7, 35, 68, 69, 70])
    FOLLOW_EVENTS_in_errorImplementation1498 = frozenset([7, 35, 68, 70, 132])
    FOLLOW_errorEvent_in_errorImplementation1501 = frozenset([7, 35, 68, 70, 132])
    FOLLOW_CLOCKS_in_errorImplementation1515 = frozenset([7, 35, 68, 132])
    FOLLOW_errorClock_in_errorImplementation1518 = frozenset([7, 35, 68, 132])
    FOLLOW_STATES_in_errorImplementation1532 = frozenset([7, 35, 132])
    FOLLOW_errorState_in_errorImplementation1535 = frozenset([7, 35, 132])
    FOLLOW_TRANSITIONS_in_errorImplementation1549 = frozenset([7, 95, 132])
    FOLLOW_errorTransition_in_errorImplementation1552 = frozenset([7, 95, 132])
    FOLLOW_END_in_errorImplementation1564 = frozenset([132])
    FOLLOW_name_in_errorImplementation1566 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorImplementation1568 = frozenset([1])
    FOLLOW_PROCESS_in_componentCategory1609 = frozenset([1])
    FOLLOW_THREAD_in_componentCategory1614 = frozenset([12])
    FOLLOW_GROUP_in_componentCategory1616 = frozenset([1])
    FOLLOW_THREAD_in_componentCategory1625 = frozenset([1])
    FOLLOW_PROCESSOR_in_componentCategory1630 = frozenset([1])
    FOLLOW_MEMORY_in_componentCategory1635 = frozenset([1])
    FOLLOW_DEVICE_in_componentCategory1640 = frozenset([1])
    FOLLOW_BUS_in_componentCategory1645 = frozenset([1])
    FOLLOW_SYSTEM_in_componentCategory1650 = frozenset([1])
    FOLLOW_BOOL_in_dataType1673 = frozenset([1])
    FOLLOW_CLOCK_in_dataType1678 = frozenset([1, 90, 91, 92, 93, 94])
    FOLLOW_timeScale_in_dataType1680 = frozenset([1])
    FOLLOW_CONTINUOUS_in_dataType1686 = frozenset([1])
    FOLLOW_ENUM_in_dataType1691 = frozenset([58])
    FOLLOW_LPAREN_in_dataType1694 = frozenset([132])
    FOLLOW_identifierList_in_dataType1697 = frozenset([59])
    FOLLOW_RPAREN_in_dataType1699 = frozenset([1])
    FOLLOW_INT_in_dataType1705 = frozenset([1])
    FOLLOW_REAL_in_dataType1712 = frozenset([1])
    FOLLOW_intRange_in_dataType1719 = frozenset([1])
    FOLLOW_set_in_timeScale0 = frozenset([1])
    FOLLOW_LBRACKET_in_intRange1788 = frozenset([97, 133])
    FOLLOW_number_in_intRange1793 = frozenset([27])
    FOLLOW_DOT_in_intRange1795 = frozenset([27])
    FOLLOW_DOT_in_intRange1798 = frozenset([97, 133])
    FOLLOW_number_in_intRange1803 = frozenset([55])
    FOLLOW_RBRACKET_in_intRange1805 = frozenset([1])
    FOLLOW_IDENT_in_identifierList1837 = frozenset([1, 60])
    FOLLOW_COMMA_in_identifierList1840 = frozenset([132])
    FOLLOW_IDENT_in_identifierList1843 = frozenset([1, 60])
    FOLLOW_IDENT_in_portSpec1871 = frozenset([20])
    FOLLOW_COLON_in_portSpec1873 = frozenset([21])
    FOLLOW_IN_in_portSpec1875 = frozenset([24])
    FOLLOW_EVENT_in_portSpec1877 = frozenset([25])
    FOLLOW_PORT_in_portSpec1879 = frozenset([8])
    FOLLOW_SEMICOLON_in_portSpec1881 = frozenset([1])
    FOLLOW_IDENT_in_portSpec1896 = frozenset([20])
    FOLLOW_COLON_in_portSpec1898 = frozenset([22])
    FOLLOW_OUT_in_portSpec1900 = frozenset([24])
    FOLLOW_EVENT_in_portSpec1902 = frozenset([25])
    FOLLOW_PORT_in_portSpec1904 = frozenset([8, 26])
    FOLLOW_NONBLOCKING_in_portSpec1907 = frozenset([8])
    FOLLOW_SEMICOLON_in_portSpec1911 = frozenset([1])
    FOLLOW_IDENT_in_portSpec1931 = frozenset([20])
    FOLLOW_COLON_in_portSpec1933 = frozenset([21])
    FOLLOW_IN_in_portSpec1935 = frozenset([14])
    FOLLOW_DATA_in_portSpec1937 = frozenset([25])
    FOLLOW_PORT_in_portSpec1939 = frozenset([54, 83, 84, 85, 86, 87, 88])
    FOLLOW_dataType_in_portSpec1941 = frozenset([8, 89])
    FOLLOW_initialization_in_portSpec1944 = frozenset([8])
    FOLLOW_SEMICOLON_in_portSpec1948 = frozenset([1])
    FOLLOW_IDENT_in_portSpec1970 = frozenset([20])
    FOLLOW_COLON_in_portSpec1972 = frozenset([22])
    FOLLOW_OUT_in_portSpec1974 = frozenset([14])
    FOLLOW_DATA_in_portSpec1976 = frozenset([25])
    FOLLOW_PORT_in_portSpec1978 = frozenset([54, 83, 84, 85, 86, 87, 88])
    FOLLOW_dataType_in_portSpec1980 = frozenset([8, 29, 30, 89])
    FOLLOW_initialization_in_portSpec1983 = frozenset([8, 29, 30])
    FOLLOW_OBSERVABLE_in_portSpec1988 = frozenset([8])
    FOLLOW_ALARM_in_portSpec1992 = frozenset([8])
    FOLLOW_SEMICOLON_in_portSpec1996 = frozenset([1])
    FOLLOW_IDENT_in_portSpec2026 = frozenset([20])
    FOLLOW_COLON_in_portSpec2028 = frozenset([62])
    FOLLOW_ERROR_in_portSpec2030 = frozenset([24])
    FOLLOW_EVENT_in_portSpec2032 = frozenset([25])
    FOLLOW_PORT_in_portSpec2034 = frozenset([8, 67])
    FOLLOW_POISSON_in_portSpec2037 = frozenset([133])
    FOLLOW_NUMBER_in_portSpec2039 = frozenset([8])
    FOLLOW_SEMICOLON_in_portSpec2043 = frozenset([1])
    FOLLOW_DEFAULT_in_initialization2072 = frozenset([97, 100, 101, 132, 133])
    FOLLOW_value_in_initialization2075 = frozenset([1])
    FOLLOW_TRUE_in_value2096 = frozenset([1])
    FOLLOW_FALSE_in_value2101 = frozenset([1])
    FOLLOW_number_in_value2106 = frozenset([1])
    FOLLOW_IDENT_in_value2111 = frozenset([1])
    FOLLOW_number_in_timeScaledNumber2122 = frozenset([90, 91, 92, 93, 94])
    FOLLOW_timeScale_in_timeScaledNumber2124 = frozenset([1])
    FOLLOW_number_in_timeScaledNumber2130 = frozenset([1])
    FOLLOW_MINUS_in_number2156 = frozenset([133])
    FOLLOW_NUMBER_in_number2159 = frozenset([1])
    FOLLOW_NUMBER_in_number2168 = frozenset([1])
    FOLLOW_IDENT_in_name2197 = frozenset([27])
    FOLLOW_DOT_in_name2199 = frozenset([132])
    FOLLOW_IDENT_in_name2201 = frozenset([1])
    FOLLOW_IDENT_in_uniqueNameOrIdentifier2226 = frozenset([20])
    FOLLOW_COLON_in_uniqueNameOrIdentifier2228 = frozenset([20])
    FOLLOW_COLON_in_uniqueNameOrIdentifier2230 = frozenset([132])
    FOLLOW_nameOrIdentifier_in_uniqueNameOrIdentifier2233 = frozenset([1])
    FOLLOW_nameOrIdentifier_in_uniqueNameOrIdentifier2250 = frozenset([1])
    FOLLOW_name_in_nameOrIdentifier2262 = frozenset([1])
    FOLLOW_IDENT_in_nameOrIdentifier2267 = frozenset([1])
    FOLLOW_IDENT_in_subcomponent2292 = frozenset([20])
    FOLLOW_COLON_in_subcomponent2294 = frozenset([11, 13, 15, 16, 17, 18, 19, 28])
    FOLLOW_componentCategory_in_subcomponent2296 = frozenset([132])
    FOLLOW_uniqueNameOrIdentifier_in_subcomponent2298 = frozenset([8, 21, 36, 37, 38])
    FOLLOW_binding_in_subcomponent2300 = frozenset([8, 21, 36, 37, 38])
    FOLLOW_inModes_in_subcomponent2303 = frozenset([8])
    FOLLOW_SEMICOLON_in_subcomponent2306 = frozenset([1])
    FOLLOW_IDENT_in_subcomponent2329 = frozenset([20])
    FOLLOW_COLON_in_subcomponent2331 = frozenset([14])
    FOLLOW_DATA_in_subcomponent2333 = frozenset([54, 83, 84, 85, 86, 87, 88])
    FOLLOW_dataType_in_subcomponent2335 = frozenset([8, 21, 29, 89])
    FOLLOW_initialization_in_subcomponent2337 = frozenset([8, 21, 29])
    FOLLOW_inModes_in_subcomponent2340 = frozenset([8, 29])
    FOLLOW_OBSERVABLE_in_subcomponent2343 = frozenset([8])
    FOLLOW_SEMICOLON_in_subcomponent2346 = frozenset([1])
    FOLLOW_STORED_in_binding2379 = frozenset([21])
    FOLLOW_IN_in_binding2382 = frozenset([132])
    FOLLOW_RUNNING_in_binding2387 = frozenset([23])
    FOLLOW_ON_in_binding2390 = frozenset([132])
    FOLLOW_ACCESSES_in_binding2395 = frozenset([132])
    FOLLOW_IDENT_in_binding2399 = frozenset([1])
    FOLLOW_EVENT_in_portConnection2424 = frozenset([25])
    FOLLOW_PORT_in_portConnection2426 = frozenset([132])
    FOLLOW_nameOrIdentifier_in_portConnection2428 = frozenset([39])
    FOLLOW_ARROW_in_portConnection2430 = frozenset([132])
    FOLLOW_nameOrIdentifier_in_portConnection2432 = frozenset([8, 21, 105])
    FOLLOW_inModes_in_portConnection2434 = frozenset([8, 105])
    FOLLOW_PASSIVE_in_portConnection2437 = frozenset([8])
    FOLLOW_SEMICOLON_in_portConnection2440 = frozenset([1])
    FOLLOW_DATA_in_portConnection2463 = frozenset([25])
    FOLLOW_PORT_in_portConnection2465 = frozenset([132])
    FOLLOW_nameOrIdentifier_in_portConnection2467 = frozenset([39])
    FOLLOW_ARROW_in_portConnection2469 = frozenset([132])
    FOLLOW_nameOrIdentifier_in_portConnection2471 = frozenset([8, 21])
    FOLLOW_inModes_in_portConnection2473 = frozenset([8])
    FOLLOW_SEMICOLON_in_portConnection2476 = frozenset([1])
    FOLLOW_nameOrIdentifier_in_flow2522 = frozenset([57])
    FOLLOW_ASSIGN_in_flow2524 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_flow2526 = frozenset([8, 21])
    FOLLOW_inModes_in_flow2531 = frozenset([8])
    FOLLOW_SEMICOLON_in_flow2535 = frozenset([1])
    FOLLOW_IDENT_in_mode2591 = frozenset([20])
    FOLLOW_COLON_in_mode2593 = frozenset([40, 41, 43, 62])
    FOLLOW_modeType_in_mode2595 = frozenset([43])
    FOLLOW_MODE_in_mode2597 = frozenset([8, 44, 45])
    FOLLOW_urgent_in_mode2608 = frozenset([8, 45])
    FOLLOW_WHILE_in_mode2620 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_invariant_in_mode2622 = frozenset([8])
    FOLLOW_SEMICOLON_in_mode2635 = frozenset([1])
    FOLLOW_URGENT_in_urgent2672 = frozenset([21])
    FOLLOW_IN_in_urgent2674 = frozenset([97, 133])
    FOLLOW_timeScaledNumber_in_urgent2676 = frozenset([1])
    FOLLOW_URGENT_in_urgent2689 = frozenset([21])
    FOLLOW_IN_in_urgent2691 = frozenset([133])
    FOLLOW_NUMBER_in_urgent2693 = frozenset([1])
    FOLLOW_INITIAL_in_modeType2713 = frozenset([1])
    FOLLOW_ACTIVATION_in_modeType2718 = frozenset([1])
    FOLLOW_ERROR_in_modeType2726 = frozenset([1])
    FOLLOW_atomicInvariant_in_invariant2759 = frozenset([1, 46])
    FOLLOW_AND_in_invariant2762 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_atomicInvariant_in_invariant2765 = frozenset([1, 46])
    FOLLOW_expression_in_atomicInvariant2779 = frozenset([1])
    FOLLOW_trajectoryEquation_in_atomicInvariant2784 = frozenset([1])
    FOLLOW_impExpression_in_expression2811 = frozenset([1])
    FOLLOW_expression_in_expressionsOnly2825 = frozenset([])
    FOLLOW_EOF_in_expressionsOnly2827 = frozenset([1])
    FOLLOW_iffExpression_in_impExpression2839 = frozenset([1, 79])
    FOLLOW_IMP_in_impExpression2842 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_iffExpression_in_impExpression2845 = frozenset([1, 79])
    FOLLOW_orExpression_in_iffExpression2858 = frozenset([1, 78])
    FOLLOW_IFF_in_iffExpression2861 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_orExpression_in_iffExpression2864 = frozenset([1, 78])
    FOLLOW_andExpression_in_orExpression2877 = frozenset([1, 75, 76, 77])
    FOLLOW_set_in_orExpression2880 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_andExpression_in_orExpression2889 = frozenset([1, 75, 76, 77])
    FOLLOW_compareExpression_in_andExpression2903 = frozenset([1, 46])
    FOLLOW_AND_in_andExpression2906 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_compareExpression_in_andExpression2909 = frozenset([1, 46])
    FOLLOW_relativeExpression_in_compareExpression2924 = frozenset([1, 81, 82])
    FOLLOW_set_in_compareExpression2930 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_relativeExpression_in_compareExpression2937 = frozenset([1, 81, 82])
    FOLLOW_addExpression_in_relativeExpression2951 = frozenset([1, 47, 48, 49, 50])
    FOLLOW_set_in_relativeExpression2957 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_addExpression_in_relativeExpression2968 = frozenset([1, 47, 48, 49, 50])
    FOLLOW_mulExpression_in_addExpression2981 = frozenset([1, 96, 97])
    FOLLOW_set_in_addExpression2987 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_mulExpression_in_addExpression2994 = frozenset([1, 96, 97])
    FOLLOW_timeExpression_in_mulExpression3007 = frozenset([1, 95, 98, 99])
    FOLLOW_set_in_mulExpression3013 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_timeExpression_in_mulExpression3022 = frozenset([1, 95, 98, 99])
    FOLLOW_unaryExpression_in_timeExpression3035 = frozenset([1, 90, 91, 92, 93, 94])
    FOLLOW_timeScale_in_timeExpression3038 = frozenset([1, 90, 91, 92, 93, 94])
    FOLLOW_NOT_in_unaryExpression3053 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_unaryExpression_in_unaryExpression3055 = frozenset([1])
    FOLLOW_MINUS_in_unaryExpression3070 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_unaryExpression_in_unaryExpression3072 = frozenset([1])
    FOLLOW_atomicExpression_in_unaryExpression3086 = frozenset([1])
    FOLLOW_number_in_atomicExpression3100 = frozenset([1])
    FOLLOW_atomicExpressionForParserExpressionsOnly_in_atomicExpression3108 = frozenset([1])
    FOLLOW_name_in_atomicExpression3116 = frozenset([1])
    FOLLOW_IDENT_in_atomicExpression3121 = frozenset([1])
    FOLLOW_set_in_atomicExpression3129 = frozenset([1])
    FOLLOW_LPAREN_in_atomicExpression3140 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_atomicExpression3143 = frozenset([59])
    FOLLOW_RPAREN_in_atomicExpression3145 = frozenset([1])
    FOLLOW_CASE_in_atomicExpression3154 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_atomicExpression3158 = frozenset([20])
    FOLLOW_COLON_in_atomicExpression3160 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_atomicExpression3163 = frozenset([8])
    FOLLOW_SEMICOLON_in_atomicExpression3165 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_atomicExpression3171 = frozenset([20])
    FOLLOW_COLON_in_atomicExpression3173 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_atomicExpression3176 = frozenset([52])
    FOLLOW_OTHERWISE_in_atomicExpression3179 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_atomicExpression3181 = frozenset([7])
    FOLLOW_END_in_atomicExpression3183 = frozenset([1])
    FOLLOW_ENUM_in_atomicExpressionForParserExpressionsOnly3201 = frozenset([20])
    FOLLOW_COLON_in_atomicExpressionForParserExpressionsOnly3204 = frozenset([132])
    FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3209 = frozenset([1])
    FOLLOW_MODE_in_atomicExpressionForParserExpressionsOnly3218 = frozenset([20])
    FOLLOW_COLON_in_atomicExpressionForParserExpressionsOnly3221 = frozenset([132])
    FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3226 = frozenset([1])
    FOLLOW_ERROR_in_atomicExpressionForParserExpressionsOnly3235 = frozenset([20])
    FOLLOW_COLON_in_atomicExpressionForParserExpressionsOnly3238 = frozenset([132])
    FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3243 = frozenset([1])
    FOLLOW_MODE_in_atomicExpressionForParserExpressionsOnly3256 = frozenset([1])
    FOLLOW_ERROR_in_atomicExpressionForParserExpressionsOnly3278 = frozenset([1])
    FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3307 = frozenset([1, 27])
    FOLLOW_DOT_in_atomicExpressionForParserExpressionsOnly3310 = frozenset([132])
    FOLLOW_IDENT_in_atomicExpressionForParserExpressionsOnly3315 = frozenset([1, 27])
    FOLLOW_DOT_in_atomicExpressionForParserExpressionsOnly3335 = frozenset([43, 62])
    FOLLOW_MODE_in_atomicExpressionForParserExpressionsOnly3341 = frozenset([1])
    FOLLOW_ERROR_in_atomicExpressionForParserExpressionsOnly3346 = frozenset([1])
    FOLLOW_IDENT_in_trajectoryEquation3367 = frozenset([80])
    FOLLOW_DERIVATIVE_in_trajectoryEquation3369 = frozenset([81])
    FOLLOW_EQ_in_trajectoryEquation3372 = frozenset([97, 133])
    FOLLOW_trajectoryExpression_in_trajectoryEquation3375 = frozenset([1])
    FOLLOW_number_in_trajectoryExpression3387 = frozenset([1, 103])
    FOLLOW_PER_in_trajectoryExpression3390 = frozenset([90, 91, 92, 93, 94])
    FOLLOW_timeScale_in_trajectoryExpression3392 = frozenset([1])
    FOLLOW_sourceMode_in_modeTransition3420 = frozenset([97])
    FOLLOW_MINUS_in_modeTransition3422 = frozenset([54])
    FOLLOW_LBRACKET_in_modeTransition3424 = frozenset([42, 53, 55, 56, 71, 72, 132])
    FOLLOW_modeTrigger_in_modeTransition3426 = frozenset([53, 55, 71, 72])
    FOLLOW_WHEN_in_modeTransition3430 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_modeGuard_in_modeTransition3432 = frozenset([53, 55, 72])
    FOLLOW_WITHIN_in_modeTransition3437 = frozenset([97, 133])
    FOLLOW_timeDelay_in_modeTransition3439 = frozenset([53, 55])
    FOLLOW_THEN_in_modeTransition3444 = frozenset([132])
    FOLLOW_modeEffect_in_modeTransition3446 = frozenset([55])
    FOLLOW_RBRACKET_in_modeTransition3450 = frozenset([39])
    FOLLOW_ARROW_in_modeTransition3452 = frozenset([132])
    FOLLOW_IDENT_in_modeTransition3454 = frozenset([8])
    FOLLOW_SEMICOLON_in_modeTransition3456 = frozenset([1])
    FOLLOW_IDENT_in_modeTransition3497 = frozenset([97])
    FOLLOW_MINUS_in_modeTransition3499 = frozenset([54])
    FOLLOW_LBRACKET_in_modeTransition3501 = frozenset([102])
    FOLLOW_PROB_in_modeTransition3503 = frozenset([133])
    FOLLOW_NUMBER_in_modeTransition3505 = frozenset([55])
    FOLLOW_RBRACKET_in_modeTransition3507 = frozenset([39])
    FOLLOW_ARROW_in_modeTransition3509 = frozenset([132])
    FOLLOW_IDENT_in_modeTransition3511 = frozenset([8])
    FOLLOW_SEMICOLON_in_modeTransition3513 = frozenset([1])
    FOLLOW_timeScaledNumber_in_timeDelay3548 = frozenset([73])
    FOLLOW_TO_in_timeDelay3550 = frozenset([97, 133])
    FOLLOW_timeScaledNumber_in_timeDelay3553 = frozenset([1])
    FOLLOW_set_in_sourceMode0 = frozenset([1])
    FOLLOW_nameOrIdentifierDisjunction_in_modeTrigger3594 = frozenset([1])
    FOLLOW_RESET_in_modeTrigger3599 = frozenset([1])
    FOLLOW_ATACTIVATION_in_modeTrigger3604 = frozenset([1])
    FOLLOW_nameOrIdentifier_in_nameOrIdentifierDisjunction3621 = frozenset([1, 75])
    FOLLOW_OR_in_nameOrIdentifierDisjunction3624 = frozenset([132])
    FOLLOW_nameOrIdentifier_in_nameOrIdentifierDisjunction3627 = frozenset([1, 75])
    FOLLOW_expression_in_modeGuard3644 = frozenset([1])
    FOLLOW_assignment_in_modeEffect3656 = frozenset([1, 8])
    FOLLOW_SEMICOLON_in_modeEffect3659 = frozenset([132])
    FOLLOW_assignment_in_modeEffect3662 = frozenset([1, 8])
    FOLLOW_modeEffect_in_effectsOnly3678 = frozenset([])
    FOLLOW_EOF_in_effectsOnly3680 = frozenset([1])
    FOLLOW_assignment_in_assignmentsOnly3696 = frozenset([])
    FOLLOW_EOF_in_assignmentsOnly3698 = frozenset([1])
    FOLLOW_IDENT_in_assignment3712 = frozenset([57])
    FOLLOW_ASSIGN_in_assignment3714 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_assignment3717 = frozenset([1])
    FOLLOW_name_in_assignment3725 = frozenset([57])
    FOLLOW_ASSIGN_in_assignment3727 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_assignment3730 = frozenset([1])
    FOLLOW_IN_in_inModes3742 = frozenset([34])
    FOLLOW_MODES_in_inModes3745 = frozenset([58])
    FOLLOW_LPAREN_in_inModes3748 = frozenset([132])
    FOLLOW_identifierList_in_inModes3751 = frozenset([59])
    FOLLOW_RPAREN_in_inModes3753 = frozenset([1])
    FOLLOW_errorTypeState_in_errorFeature3769 = frozenset([1])
    FOLLOW_errorPropagation_in_errorFeature3774 = frozenset([1])
    FOLLOW_IDENT_in_errorTypeState3796 = frozenset([20])
    FOLLOW_COLON_in_errorTypeState3798 = frozenset([40, 41, 62])
    FOLLOW_stateType_in_errorTypeState3800 = frozenset([61])
    FOLLOW_STATE_in_errorTypeState3802 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorTypeState3804 = frozenset([1])
    FOLLOW_set_in_stateType0 = frozenset([1])
    FOLLOW_inPropagation_in_errorPropagation3858 = frozenset([1])
    FOLLOW_outPropagation_in_errorPropagation3863 = frozenset([1])
    FOLLOW_IDENT_in_inPropagation3875 = frozenset([20])
    FOLLOW_COLON_in_inPropagation3877 = frozenset([21])
    FOLLOW_IN_in_inPropagation3879 = frozenset([62])
    FOLLOW_ERROR_in_inPropagation3881 = frozenset([64])
    FOLLOW_PROPAGATION_in_inPropagation3883 = frozenset([8])
    FOLLOW_SEMICOLON_in_inPropagation3885 = frozenset([1])
    FOLLOW_IDENT_in_outPropagation3907 = frozenset([20])
    FOLLOW_COLON_in_outPropagation3909 = frozenset([22])
    FOLLOW_OUT_in_outPropagation3911 = frozenset([62])
    FOLLOW_ERROR_in_outPropagation3913 = frozenset([64])
    FOLLOW_PROPAGATION_in_outPropagation3915 = frozenset([8])
    FOLLOW_SEMICOLON_in_outPropagation3917 = frozenset([1])
    FOLLOW_OCCURRENCE_in_occurrence3939 = frozenset([67])
    FOLLOW_distribution_in_occurrence3942 = frozenset([97, 133])
    FOLLOW_number_in_occurrence3944 = frozenset([1])
    FOLLOW_POISSON_in_distribution3956 = frozenset([1])
    FOLLOW_IDENT_in_errorEvent3980 = frozenset([20])
    FOLLOW_COLON_in_errorEvent3982 = frozenset([62])
    FOLLOW_ERROR_in_errorEvent3984 = frozenset([24])
    FOLLOW_EVENT_in_errorEvent3986 = frozenset([8, 65, 103])
    FOLLOW_occurrence_in_errorEvent3988 = frozenset([8, 103])
    FOLLOW_PER_in_errorEvent3992 = frozenset([90, 91, 92, 93, 94])
    FOLLOW_timeScale_in_errorEvent3994 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorEvent3998 = frozenset([1])
    FOLLOW_IDENT_in_errorClock4035 = frozenset([20])
    FOLLOW_COLON_in_errorClock4037 = frozenset([14])
    FOLLOW_DATA_in_errorClock4039 = frozenset([84])
    FOLLOW_CLOCK_in_errorClock4041 = frozenset([8, 90, 91, 92, 93, 94])
    FOLLOW_timeScale_in_errorClock4043 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorClock4046 = frozenset([1])
    FOLLOW_IDENT_in_errorState4082 = frozenset([20])
    FOLLOW_COLON_in_errorState4084 = frozenset([40, 41, 62])
    FOLLOW_stateType_in_errorState4086 = frozenset([61])
    FOLLOW_STATE_in_errorState4088 = frozenset([8, 44, 45])
    FOLLOW_urgent_in_errorState4090 = frozenset([8, 45])
    FOLLOW_WHILE_in_errorState4094 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_invariant_in_errorState4096 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorState4100 = frozenset([1])
    FOLLOW_sourceState_in_errorTransition4137 = frozenset([97])
    FOLLOW_MINUS_in_errorTransition4139 = frozenset([54])
    FOLLOW_LBRACKET_in_errorTransition4141 = frozenset([42, 56, 132])
    FOLLOW_errorTrigger_in_errorTransition4143 = frozenset([53, 55, 71, 72])
    FOLLOW_WHEN_in_errorTransition4146 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_modeGuard_in_errorTransition4148 = frozenset([53, 55, 72])
    FOLLOW_WITHIN_in_errorTransition4153 = frozenset([97, 133])
    FOLLOW_timeDelay_in_errorTransition4155 = frozenset([53, 55])
    FOLLOW_THEN_in_errorTransition4160 = frozenset([132])
    FOLLOW_modeEffect_in_errorTransition4162 = frozenset([55])
    FOLLOW_RBRACKET_in_errorTransition4166 = frozenset([39])
    FOLLOW_ARROW_in_errorTransition4168 = frozenset([132])
    FOLLOW_IDENT_in_errorTransition4170 = frozenset([8])
    FOLLOW_SEMICOLON_in_errorTransition4172 = frozenset([1])
    FOLLOW_set_in_sourceState0 = frozenset([1])
    FOLLOW_set_in_errorTrigger0 = frozenset([1])
    FOLLOW_declaration_in_synpred2_Slim1035 = frozenset([1])
    FOLLOW_declaration_in_synpred4_Slim1084 = frozenset([1])
    FOLLOW_declaration_in_synpred5_Slim1084 = frozenset([1, 4, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_declaration_in_synpred6_Slim1099 = frozenset([1])
    FOLLOW_declaration_in_synpred7_Slim1099 = frozenset([1, 4, 11, 13, 15, 16, 17, 18, 19, 28, 62])
    FOLLOW_componentType_in_synpred9_Slim1132 = frozenset([1])
    FOLLOW_componentImplementation_in_synpred10_Slim1140 = frozenset([1])
    FOLLOW_errorType_in_synpred11_Slim1148 = frozenset([1])
    FOLLOW_portSpec_in_synpred13_Slim1199 = frozenset([1])
    FOLLOW_portSpec_in_synpred14_Slim1199 = frozenset([1, 132])
    FOLLOW_URGENT_in_synpred98_Slim2672 = frozenset([21])
    FOLLOW_IN_in_synpred98_Slim2674 = frozenset([97, 133])
    FOLLOW_timeScaledNumber_in_synpred98_Slim2676 = frozenset([1])
    FOLLOW_ERROR_in_synpred101_Slim2726 = frozenset([1])
    FOLLOW_AND_in_synpred109_Slim2906 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_compareExpression_in_synpred109_Slim2909 = frozenset([1])
    FOLLOW_set_in_synpred111_Slim2930 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_relativeExpression_in_synpred111_Slim2937 = frozenset([1])
    FOLLOW_set_in_synpred115_Slim2957 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_addExpression_in_synpred115_Slim2968 = frozenset([1])
    FOLLOW_set_in_synpred117_Slim2987 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_mulExpression_in_synpred117_Slim2994 = frozenset([1])
    FOLLOW_set_in_synpred120_Slim3013 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_timeExpression_in_synpred120_Slim3022 = frozenset([1])
    FOLLOW_MINUS_in_synpred123_Slim3070 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_unaryExpression_in_synpred123_Slim3072 = frozenset([1])
    FOLLOW_number_in_synpred124_Slim3100 = frozenset([1])
    FOLLOW_atomicExpressionForParserExpressionsOnly_in_synpred125_Slim3108 = frozenset([1])
    FOLLOW_name_in_synpred126_Slim3116 = frozenset([1])
    FOLLOW_IDENT_in_synpred127_Slim3121 = frozenset([1])
    FOLLOW_set_in_synpred129_Slim3129 = frozenset([1])
    FOLLOW_expression_in_synpred131_Slim3158 = frozenset([20])
    FOLLOW_COLON_in_synpred131_Slim3160 = frozenset([43, 51, 58, 62, 74, 86, 97, 100, 101, 132, 133])
    FOLLOW_expression_in_synpred131_Slim3163 = frozenset([8])
    FOLLOW_SEMICOLON_in_synpred131_Slim3165 = frozenset([1])
    FOLLOW_MODE_in_synpred133_Slim3218 = frozenset([20])
    FOLLOW_COLON_in_synpred133_Slim3221 = frozenset([132])
    FOLLOW_IDENT_in_synpred133_Slim3226 = frozenset([1])
    FOLLOW_ERROR_in_synpred134_Slim3235 = frozenset([20])
    FOLLOW_COLON_in_synpred134_Slim3238 = frozenset([132])
    FOLLOW_IDENT_in_synpred134_Slim3243 = frozenset([1])
    FOLLOW_MODE_in_synpred135_Slim3256 = frozenset([1])
    FOLLOW_ERROR_in_synpred136_Slim3278 = frozenset([1])



def main(argv, stdin=sys.stdin, stdout=sys.stdout, stderr=sys.stderr):
    from antlr3.main import ParserMain
    main = ParserMain("SlimLexer", SlimParser)
    main.stdin = stdin
    main.stdout = stdout
    main.stderr = stderr
    main.execute(argv)


if __name__ == '__main__':
    main(sys.argv)
